<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

/**
 * Main Controller
 *
 * @package		Cobalt
 * @subpackage	com_cobalt
 * @since		6.0
 */
class CobaltController extends JController
{

	/**
	 * Method to display a view.
	 *
	 * @param	boolean			$cachable	If true, the view output will be cached
	 * @param	array			$urlparams	An array of safe url parameters and their variable types, for valid values see {@link JFilterInput::clean()}.
	 *
	 * @return	JController		This object to support chaining.
	 * @since	6.0
	 */
	public function display($cachable = false, $urlparams = false)
	{
		JRequest::setVar('view', JRequest::getWord('view', 'records'));
		
		if(!JComponentHelper::getParams('com_cobalt')->get('general_upload') && !( JRequest::getWord('view', 'records') == 'config'))		{
			JError::raiseWarning(400, JText::_('CUPLOADREQ'));
			$this->setRedirect('index.php?option=com_cobalt&view=config');
		}
		
		MRToolBar::addSubmenu(JRequest::getWord('view', 'records'));
		
		parent::display();
		return $this;
	}
}