<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

// No direct access
defined('_JEXEC') or die();

/**
 * Main Controller
 *
 * @package		Cobalt
 * @subpackage	com_cobalt
 * @since		6.0
 */
class CobaltControllerAjax extends JController
{

	public function loadfieldform()
	{
		echo JModel::getInstance('Field', 'CobaltModel')->getFieldForm(JRequest::getVar('field'));
		exit();
	}

	public function loadcommerce()
	{
		$gateway = JRequest::getVar('gateway');
		if($gateway == '')
		{
			echo ''; 
			exit();
		}
		
		$field = JModel::getInstance('Field', 'CobaltModel')->getItem(JRequest::getVar('fid'));
		
		$xml = JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'gateways' . DS . $gateway . DS . $gateway . '.xml';
		if(! JFile::exists($xml))
		{
			echo "File not found: {$xml}";
		}
		$out = array();
		
		$form = new JForm('params', array(
			'control' => 'params' 
		));
		
		$form->loadFile($xml);
		
		$out[] = MEFormHelper::renderGroup($form, ($field ? $field->params : array()), 'pay', FORM_STYLE_TABLE, FORM_SEPARATOR_NONE);
		
		echo implode(' ', $out);
		exit();
	}
	
	public function loadpacksection()
	{
		echo JModel::getInstance('Packsection', 'CobaltModel')->getSectionForm(JRequest::getVar('id'));
		exit();
	}
	
	public function loadsectiontypes()
	{
		$section_id = JRequest::getInt('section_id');
		$selected = JRequest::getVar('selected', array());
		if(!$section_id)
		{
			echo '';
			exit();
		}
		
		$section = ItemsStore::getSection($section_id);
		
		$params = new JRegistry($section->params);
		$db = JFactory::getDbo();
		$query = $db->getQuery ( true );
		
		$query->select ( 'id, name' );
		$query->from ( '#__js_res_types' );		
		$query->where ( 'published = 1' );
		$ids = implode(',', $params->get('general.type'));
		$query->where ( 'id IN (0'.($ids ? ','.$ids : '').')' );
		$db->setQuery($query);
		$list = $db->loadObjectList();
		if(empty($list))
		{
			echo '';
			exit();
		}
		foreach ($list as $val)
		{
		    $types[] = JHTML::_('select.option', $val->id, $val->name);
		}
		
		echo JHTML::_('select.options', $types, 'value', 'text', $selected);
		exit();
	}

}