<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die;

jimport('joomla.application.component.controlleradmin');


class CobaltControllerCategories extends JControllerAdmin
{
	/**
	 * Proxy for getModel
	 *
	 * @param	string	$name	The model name. Optional.
	 * @param	string	$prefix	The class prefix. Optional.
	 *
	 * @return	object	The model.
	 * @since	1.6
	 */
	
	public function delete()
	{
		parent::delete();
		
		$section = JTable::getInstance('Section', 'CobaltTable');
		$section->load(JRequest::getInt('section_id'));
		
		$db = JFactory::getDbo();
		$db->setQuery("SELECT COUNT(*) FROM #__js_res_categories WHERE section_id = ".JRequest::getInt('section_id'));
		
		$section->categories = $db->loadResult();
		$section->store();
	}
	
	public function __construct($config = array())
	{
		parent::__construct($config);
		$this->view_list .= '&section_id='.JRequest::getInt('section_id');
		
	}
	function getModel($name = 'Category', $prefix = 'CobaltModel', $config = array('ignore_request' => true))
	{
		$model = parent::getModel($name, $prefix, $config);
		return $model;
	}

	/**
	 * Rebuild the nested set tree.
	 *
	 * @return	bool	False on failure or error, true on success.
	 * @since	1.6
	 */
	public function rebuild()
	{
		JRequest::checkToken() or jexit(JText::_('JINVALID_TOKEN'));

		$section = JRequest::getInt('section_id');
		$this->setRedirect(JRoute::_('index.php?option=com_cobalt&view=categories&section_id='.$section, false));

		// Initialise variables.
		$model = $this->getModel();

		if ($model->rebuild()) {
			// Rebuild succeeded.
			$this->setMessage(JText::_('COM_COBALT_REBUILD_SUCCESS'));
			return true;
		} else {
			// Rebuild failed.
			$this->setMessage(JText::_('COM_COBALT_REBUILD_FAILURE'));
			return false;
		}
	}

	/**
	 * Save the manual order inputs from the categories list page.
	 *
	 * @return	void
	 * @since	1.6
	 */
	public function saveorder()
	{
		JRequest::checkToken() or jexit(JText::_('JINVALID_TOKEN'));

		// Get the arrays from the Request
		$order	= JRequest::getVar('order',	null, 'post', 'array');
		$originalOrder = explode(',', JRequest::getString('original_order_values'));
		
		// Make sure something has changed
		if (!($order === $originalOrder)) {
			parent::saveorder();
		} else {
			// Nothing to reorder
			$this->setRedirect(JRoute::_('index.php?option='.$this->option.'&view='.$this->view_list, false));
			return true;
		}
	}
	
	public function close()
	{
		$this->setRedirect(JRoute::_('index.php?option='.$this->option.'&view=sections', false));
	}
}