<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.application.component.controller');
jimport('joomla.application.component.controllerform');
jimport('joomla.utilities.simplexml');

require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'helpers'.DS.'templates.php';

class CobaltControllerTemplates extends JControllerForm
{
	public function __construct($config)
	{
		parent::__construct($config);
		$this->registerTask('saveclose', 'save');
	}
	public function install()
	{
		$app = JFactory::getApplication();
		$uri = JFactory::getURI();
		$uri->setVar('tab', JRequest::getVar('tab'));

		JRequest::checkToken() or die( 'Invalid Token');

		$model	= $this->getModel();

		if ($model->install()) {
			$cache = JFactory::getCache('mod_menu');
			$cache->clean();

			$app->enqueueMessage(JText::_('C_MSG_TMPLINSTALLOK'));
		}

		$app->redirect($uri->toString());
	}

	public function uninstall()
	{

		$app = JFactory::getApplication();
		$uri = JFactory::getURI();
		$uri->setVar('tab', JRequest::getVar('tab'));

		$tmpls = JRequest::getVar('cid', array(), 'post', 'array');

		JRequest::checkToken() or die( 'Invalid Token');

		foreach( $tmpls as $k => $tmpl ) {
			$matches = Array();
			preg_match ( "/^\[(.*)\]\,\[(.*)\]$/i", $tmpl, $matches );

			if( $matches[1] == 'default' ){
				JError::raiseWarning( 500, JText::_('C_MSG_DEAFULEUNINSTALL') );
				unset($tmpls[$k]);
			}
		}
		if(!$tmpls)
		{
			JError::raiseWarning(100, JText::_('C_MSG_CHOSETEMPL'));
			$app->redirect($uri->toString());
			return;
		}

		$model = $this->getModel();
		$model->uninstall($tmpls);
		$app->redirect($uri->toString(), JText::_('C_MSG_TMPLUNINSTALLOK'));
	}

	public function rename()
	{
		$this->copy('rename');
	}
	public function copy($func = 'copy')
	{

		$app = JFactory::getApplication();
		$uri = JFactory::getURI();
		$uri->setVar('tab', JRequest::getVar('tab'));

		JRequest::checkToken() or die( 'Invalid Token');

		$new_name = JRequest::getVar('tmplname');
		$tmpls = JRequest::getVar('cid', array(), 'post', 'array');

		$model = $this->getModel();

		if(!$model->$func($tmpls[0], $new_name)){
			JError::raiseWarning(100, ($func == 'copy' ? JText::_('C_MSG_TMPLCOPYFAIL') : JText::_('C_MSG_TMPLRENAMEFAIL')));
			$app->redirect($uri->toString());
		}

		$app->redirect($uri->toString(), ($func == 'copy' ? JText::_('C_MSG_TMPLCOPYOK') : JText::_('C_MSG_TMPLRENAMEOK')));
	}


	public function change_label()
	{

		JRequest::checkToken() or die( 'Invalid Token');

		$tmpls = JRequest::getVar('cid', array(), 'post', 'array');
		$uri = JFactory::getURI();
		$uri->setVar('tab', JRequest::getVar('tab'));
		$app = JFactory::getApplication();

		$matches = Array();
		preg_match ( "/^\[(.*)\]\,\[(.*)\]$/i", $tmpls[0], $matches );

		$new_name = JRequest::getVar('tmpl_name');
		if (!$new_name)
		{
			JError::raiseWarning(100, JText::_('C_MSG_TMPLNO_NONAMEENTER'));
			$app->redirect($uri->toString());
			return;
		}

		$file = JPATH_ROOT.DS.'components'.DS.'com_cobalt'.DS.'views'.DS.'records'.DS.'tmpl'.DS.'default_list_'.$matches[1].'.xml';

		$model = $this->getModel();
		if(!$model->change_name($file, $new_name))
		{
			JError::raiseWarning(100, JText::_('C_MSG_TMPLSAVEFAIL'));
			$app->redirect($uri->toString());
			return;
		}
		$app->enqueueMessage(JText::_('C_MSG_TMPLLABELCHANGEOK'));
		$app->redirect($uri->toString());
	}
	public function save()
	{
		$uri = JFactory::getURI();
		$app = JFactory::getApplication();
		$task = JRequest::getCmd('task');
		$type = JRequest::getVar('type');
		$name = JRequest::getVar('name');

		$regestry = new JRegistry();
		$regestry->loadArray(JRequest::getVar('jform', array(), 'post', 'array'));

		$file = MRtemplates::getTmplFile($type, $name);
		JFile::write($file.'.json',  $regestry->toString());

		$msg = JText::_('C_MSG_TMPLPARAMS_SAVEOK');
		$uri->setVar('tab', JRequest::getVar('tab'));
		switch ( $task ) {
			case 'saveclose':
				$uri->setVar('close', 1);
				$url = $uri->toString();
			case 'apply':
				$url = $uri->toString();
				break;
			case 'save':
			default:
				$url = 'index.php?option=com_cobalt&view=templates&tab='.JRequest::getVar('tab');
				break;
		}
		$app->redirect($url, $msg);
	}
	public function cancel()
	{
		$this->setRedirect('index.php?option=com_cobalt&view=templates&tab='.JRequest::getVar('tab'), JText::_('C_MSG_TMPLEDITCANCEL'));
		$this->redirect();
	}
}
?>