<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die;

/**
 * Toolbar helper. Helps to build toolbars and subnmenu bars
 *
 * @author Sergey
 * @package		Cobalt
 * @subpackage	com_cobalt
 *
 */
class MRToolBar extends JToolBarHelper
{
	public static function addSubmenu($vName = 'records')
	{
		JSubMenuHelper::addEntry(
			JText::_('XML_SUBMENU_RECORDS'),
			'index.php?option=com_cobalt&view=records',
			$vName == 'records'
		);
		JSubMenuHelper::addEntry(
			JText::_('XML_SUBMENU_SECTIONS'),
			'index.php?option=com_cobalt&view=sections',
			$vName == 'sections'
		);
		JSubMenuHelper::addEntry(
			JText::_('XML_SUBMENU_TYPES'),
			'index.php?option=com_cobalt&view=types',
			$vName == 'types'
		);
		JSubMenuHelper::addEntry(
			JText::_('XML_SUBMENU_VOTES'),
			'index.php?option=com_cobalt&view=votes',
			$vName == 'votes'
		);
		JSubMenuHelper::addEntry(
			JText::_('XML_SUBMENU_COMMENTS'),
			'index.php?option=com_cobalt&view=comments',
			$vName == 'comments'
		);
		JSubMenuHelper::addEntry(
			JText::_('XML_SUBMENU_TAGS'),
			'index.php?option=com_cobalt&view=tags',
			$vName == 'tags'
		);
		JSubMenuHelper::addEntry(
			JText::_('XML_SUBMENU_TEMPLATES'),
			'index.php?option=com_cobalt&view=templates',
			$vName == 'templates'
		);
		JSubMenuHelper::addEntry(
			JText::_('XML_SUBMENU_PACK'),
			'index.php?option=com_cobalt&view=packs',
			$vName == 'packs'
		);
		JSubMenuHelper::addEntry(
			JText::_('XML_SUBMENU_TOOLS'),
			'index.php?option=com_cobalt&view=tools',
			$vName == 'tools'
		);
		JSubMenuHelper::addEntry(
			JText::_('XML_SUBMENU_CONFIGURATION'),
			'index.php?option=com_cobalt&view=config',
			$vName == 'config'
		);
		JSubMenuHelper::addEntry(
			JText::_('XML_SUBMENU_SUPPORT'),
			'http://support.mintjoomla.com/en/cobalt-7.html',
			$vName == 'html'
		);
		JSubMenuHelper::addEntry(
			JText::_('XML_SUBMENU_ABOUT'),
			'index.php?option=com_cobalt&view=about',
			$vName == 'about'
		);
	}

	public static function helpW($url, $width, $height)
	{
		$text	= JText::_('C_TOOLBAR_HELP');
		$doTask	= "popupWindow('$url', '".JText::_('C_TOOLBAR_HELP', TRUE)."', $width, $height, 1)";

		$html	= "<a href=\"#\" onclick=\"$doTask\" class=\"toolbar\">\n";
		$html .= "<span class=\"icon-32-help\" title=\"$text\">\n";
		$html .= "</span>\n";
		$html	.= "$text\n";
		$html	.= "</a>\n";

		$bar = JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'help');
	}
	public static function mass()
	{
		$document = JFactory::getDocument();
		self::_prepareDoc();
		$document->addStyleDeclaration('
			.icon-32-mass {
				background: url('.JURI::root().'administrator/components/com_cobalt/images/toolbar/mass.png) no-repeat;
			}
		');

		$html = '';

		$html .= '<ul id="menumass" class="mermoomenu horizontal">
					<li>';
		$html .= 		'<a href="#" class="toolbar">';
		$html .= 			"<span class=\"icon-32-mass\" id=\"button_reset\" type=\"Standard\"></span>";
		$html .= 			JText::_('CMASS');
		$html .= 		"</a>";
		$html .= 		'<ul id="moosubmenu" style="visibility: hidden; top: 60px;">';
		$html .= 			'<li><a class="my_submenu" onclick="clickSubmenu(\'change_category\');">'.JText::_('C_TOOLBAR_MASSOP1').'</a></li>';
		$html .= 			'<li><a class="my_submenu" onclick="clickSubmenu(\'change_field\');">'.JText::_('C_TOOLBAR_MASSOP2').'</a></li>';
		$html .= 			'<li><a class="my_submenu" onclick="clickSubmenu(\'change_core\');">'.JText::_('C_TOOLBAR_MASSOP3').'</a></li>';
		$html .= 		'</ul>';
		$html .= '	</li>
				</ul>';

		$html .= '<script type="text/javascript">';
		$html .= "$('menumass').MooDropMenu({
					onOpen: function(el){
						el.fade('in')
					},
					onClose: function(el){
						el.fade('out');
					},
					onInitialize: function(el){
						el.fade('hide').set('tween', {duration:200});
					}
				});"
			;
		$html .= '</script>';
		$bar = JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'reset');
	}
	public static function emptyX()
	{
		$document = JFactory::getDocument();
		$document->addScript( JURI::root().'components/com_cobalt/library/js/dropdown.js');

		$html = '<a href="javascript:void(0);" onclick="javascript: emptyCategory();" class="toolbar"  id="reset_click" rel="reset_menu">';
		$html .= "<span class=\"icon-32-reset\" id=\"button_reset\" type=\"Standard\">";
		$html .= "</span>";
		$html .= JText::_('C_TOOLBAR_EMPTY');
		$html .= "</a>";

		$bar = JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'reset');
	}
	public static function reset()
	{
		$document = JFactory::getDocument();
		self::_prepareDoc();
		$document->addStyleDeclaration('
			.icon-32-reset {
				background: url('.JURI::root().'administrator/components/com_cobalt/images/toolbar/reset.png) no-repeat;
			}'
		);

		$html = '';

		$html .= '<ul id="menureset" class="mermoomenu horizontal">
					<li>';
		$html .= 		'<a href="#" class="toolbar">';
		$html .= 			"<span class=\"icon-32-reset\" id=\"button_reset\" type=\"Standard\"></span>";
		$html .= 			JText::_('CRESET');
		$html .= 		"</a>";
		$html .= 		'<ul id="moosubmenu" style="visibility: hidden; top: 60px;">';
		$html .= 			'<li><a class="my_submenu" onclick="clickSubmenu(\'records.reset_hits\');">'.JText::_('C_TOOLBAR_RESET_HITS').'</a></li>';
		$html .= 			'<li><a class="my_submenu" onclick="clickSubmenu(\'records.reset_com\');">'.JText::_('C_TOOLBAR_RESET_COOMENT').'</a></li>';
		$html .= 			'<li><a class="my_submenu" onclick="clickSubmenu(\'records.reset_vote\');">'.JText::_('C_TOOLBAR_RESET_RATING').'</a></li>';
		$html .= 			'<li><a class="my_submenu" onclick="clickSubmenu(\'records.reset_fav\');">'.JText::_('C_TOOLBAR_RESET_FAVORITE').'</a></li>';
		$html .= 			'<li><a class="my_submenu" onclick="clickSubmenu(\'records.reset_ctime\');">'.JText::_('C_TOOLBAR_RESET_CTIME').'</a></li>';
		$html .= 			'<li><a class="my_submenu" onclick="clickSubmenu(\'records.reset_mtime\');">'.JText::_('C_TOOLBAR_RESET_MTIME').'</a></li>';
		$html .= 			'<li><a class="my_submenu" onclick="clickSubmenu(\'records.reset_extime\');">'.JText::_('C_TOOLBAR_RESET_EXTIME').'</a></li>';
		$html .= 		'</ul>';
		$html .= '	</li>
				</ul>';

		$html .= '<script type="text/javascript">';
		$html .= "$('menureset').MooDropMenu({
					onOpen: function(el){
						el.fade('in')
					},
					onClose: function(el){
						el.fade('out');
					},
					onInitialize: function(el){
						el.fade('hide').set('tween', {duration:200});
					}
				});"
			;
		$html .= '</script>';
		$bar = JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'reset');
	}
	public static function close($contr, $string = 'Close')
	{
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript:" . "document.adminForm.filter_order.value=''; document.adminForm.controller.value='$contr'; " . "submitbutton('');\" class=\"toolbar\">";
		$html .= "<span class=\"icon-32-cancel\" type=\"Standard\">";
		$html .= "</span>";
		$html .= JText::_($string);
		$html .= "</a>";
		$bar = JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'close');
	}
	public static function edit($file)
	{
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript:" . "if(document.adminForm.boxchecked.value==0){alert('" . JText::_("CSELECTTODELETE")."');}" . "else{ResEdit('$file')}\" class=\"toolbar\">";
		$html .= "<span class=\"icon-32-edit\" type=\"Standard\">";
		$html .= "</span>";
		$html .= JText::_('C_TOOLBAR_EDIT');
		$html .= "</a>";

		$bar = JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'edit');
	}

	public static function delete($table, $trash = 0)
	{
		$document = JFactory::getDocument();

		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript:" .
		"if(document.adminForm.boxchecked.value==0){alert('" .
		"Please make a selection from the list to Delete');}" .
		"else{if(confirm('" . JText::_('C_TOOLBAR_CONFIRMDELET') .
		"')){ResDelete('$table', '$trash');}}\" class=\"toolbar\">";
		$html .= "<span class=\"icon-32-delete\" type=\"Standard\" id=\"bar_delete\">";
		$html .= "</span>";
		$html .= JText::_('C_TOOLBAR_DELETE');
		$html .= "</a>";

		$bar = JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'delete');
	}
	public static function fields()
	{
		$document = JFactory::getDocument();

		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript:" . "if(document.adminForm.boxchecked.value==0){alert('" .JText::_( "CSELECTTOASSCESSFIEL")."');}" . "else{document.adminForm.controller.value='field'; document.adminForm.filter_order.value=''; submitbutton();}\" class=\"toolbar\">";
		$html .= "<span class=\"icon-32-field\" type=\"Standard\" id=\"bar_delete\">";
		$html .= "</span>";
		$html .= JText::_('C_TOOLBAR_FIELDS');
		$html .= "</a>";

		$bar = JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'field');
	}

	/* public static function publish($table, $publish)
	{
		$document = JFactory::getDocument();

		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript:" . "if(document.adminForm.boxchecked.value==0){alert('" . JText::_("CSELECTTOPUBUNPUB"). "');}" . "else{ResPublish(" . ($publish ? 0 : 1) . ", '$table');}\" class=\"toolbar\">";
		$html .= "<span class=\"icon-32-" . (! $publish ? 'un' : null) . "publish\" type=\"Standard\" id=\"bar_publish$publish\">";
		$html .= "</span>";
		$html .= ! $publish ? JText::_('C_TOOLBAR_UNPUB') : JText::_('C_TOOLBAR_PUB');
		$html .= "</a>";

		$bar = JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'publish');
	} */
	public static function types()
	{
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: " . "document.adminForm.controller.value='type'; document.adminForm.filter_order.value=''; submitbutton();\" class=\"toolbar\">";
		$html .= "<span class=\"icon-32-types\" type=\"Standard\">";
		$html .= "</span>";
		$html .= JText::_('C_TOOLBAR_TYPES');
		$html .= "</a>";

		$bar = JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'types');
	}
	public static function category()
	{
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: " . "document.adminForm.controller.value='category'; document.adminForm.filter_order.value=''; submitbutton();\" class=\"toolbar\">";
		$html .= "<span class=\"icon-32-category\" type=\"Standard\">";
		$html .= "</span>";
		$html .= JText::_('C_TOOLBAR_CATS');
		$html .= "</a>";

		$bar = JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'category');
	}
	public static function records()
	{
		$html = "<a href=\"javascript:void(0);\" onclick=\"javascript: " . "document.adminForm.controller.value='record'; document.adminForm.filter_order.value=''; submitbutton();\" class=\"toolbar\">";
		$html .= "<span class=\"icon-32-record\" type=\"Standard\">";
		$html .= "</span>";
		$html .= JText::_('C_TOOLBAR_CONTENT');
		$html .= "</a>";

		$bar = JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'record');
	}
	public static function install()
	{
		$text	= JText::_('C_TOOLBAR_INSTALL');
		$doTask	= "slideinstall('ins')";

		$html	= "<a href=\"#\" onclick=\"$doTask\" class=\"toolbar\">\n";
		$html .= "<span class=\"icon-32-install\" title=\"$text\">\n";
		$html .= "</span>\n";
		$html	.= "$text\n";
		$html	.= "</a>\n";

		$bar = JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'install');
	}
	public static function cr()
	{
		$text	= JText::_('C_TOOLBAR_COPREN');
		$doTask	= "slideinstall('cr')";

		$html	= "<a href=\"#\" onclick=\"$doTask\" class=\"toolbar\">\n";
		$html .= "<span class=\"icon-32-cr\" title=\"$text\">\n";
		$html .= "</span>\n";
		$html	.= "$text\n";
		$html	.= "</a>\n";

		$bar = JToolBar::getInstance();
		$bar->appendButton('Custom', $html, 'cr');
	}
	private static function _prepareDoc()
	{
		static $loaded = false;

		if(!$loaded)
		{
			$document = JFactory::getDocument();
			$document->addScript(JURI::root().'media/mint/js/moodropmenu/MooDropMenu.js');
			$document->addStyleSheet(JURI::root().'media/mint/js/moodropmenu/MooDropMenu.css');
			$document->addStyleDeclaration('
				#moosubmenu li{
					height: 20px;
					padding-right: 4px;
					text-align: left;
				}
				#menureset ul, #menumass ul{
					background-color: #FFFFFF !important;
					border: 3px solid #e0e0e0;
					border-radius: 5px;
					-moz-border-radius: 3px;
					-webkit-border-radius: 3px;
					box-shadow: 1px 1px 8px #555;
				}
				.my_submenu {
					border: none !important;
					padding: 4px 5px 1px 2px !important;
					height: 16px !important;

					border-radius: 3px;
					-moz-border-radius: 3px;
					-webkit-border-radius: 3px;
				}
				.my_submenu:hover {
					text-decoration: none;
					background-color: #e0e0e0;
					color: black;
				}

			');

			$document->addScriptDeclaration('
				function clickSubmenu(task)
				{
					if(document.adminForm.boxchecked.value==0)
					{
						alert("'.Jtext::_('Please make a selection from the list').'");
					}
					else
					{
						document.adminForm.task.value = task;
						submitbutton();
					}
				}
			');
			$loaded = true;
		}
	}
}