<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die('Restricted access');

class JHTMLCobalt
{
	public static function sections()
	{
		static $result = null;
		
		if(is_array($result)) return $result;
		
		$db = JFactory::getDbo();
		
		$query = $db->getQuery(true);
		$query->select('id as value, name as text');
		$query->from('#__js_res_sections');
		$query->order('name ASC');
		$query->where('published = 1');
		
		$db->setQuery($query);
		$result = $db->loadObjectList();
		
		return $result;
	}
	
	
	public static function contenttypes()
	{
		static $result = null;
		
		if(is_array($result)) return $result;
		
		$db = JFactory::getDbo();
		
		$query = $db->getQuery(true);
		$query->select('`id` as value, `name` as text');
		$query->from('#__js_res_types');
		//$query->where("`element` LIKE 'filter_%'");
		
		$db->setQuery($query);
		$result = $db->loadObjectList();
		
		return $result;
	}
	public static function fieldtypes($select = false)
	{
		static $result = null;
		
		if(is_array($result)) return $result;
		
		JModel::addIncludePath(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_cobalt'.DS.'models');
		$model = JModel::getInstance('Fields', 'CobaltModel');
		
		$fields = $model->getFields();
		
		$result = array();
		if($select)
		{
			$result[] = JHtml::_('select.option', NULL, JText::_('CCELECTFIELDTYPE'));
		}
		$icon = JURI::root().'libraries/mint/forms/fields/cobalt';
		foreach ($fields AS $group_name => $group)
		{
			$result[] = JHtml::_('select.optgroup', $group_name);
			
			Foreach($group AS $field)
			{
				$result[] = JHtml::_('select.option', $field->file_name, $field->name);
			}
			
			$result[] = JHtml::_('select.optgroup', $group_name);
		}
		
		return $result;
	}
	
	public static function types($select = false, $filter = NULL, $key = 'key')
	{
		
		$out = array();
		
		JModel::addIncludePath(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_cobalt'.DS.'models');
		$tmodel = JModel::getInstance('Types', 'CobaltModel');
		$tmodel->setState('list.limit', 1000);
		
		$types = $tmodel->getItems();
		
		
		$model = JModel::getInstance('Fields', 'CobaltModel');
		$filter = str_replace("'", '"', $filter);
		$filter = preg_replace("/\"$/iU", '', $filter);
		$filter = preg_replace("/^\"/iU", '', $filter);
		$model->setState('fields.types', $filter);
		$model->setState('list.limit', 1000);
		//$model->setState('fields.type', 1);
		
		if($select)
		{
			$out[] = JHtml::_('select.option', NULL, JText::_('CSELECTFIELD'));
		}
		
		foreach ($types AS $t => $type)
		{
			$model->type_id = (int)$type->id;
			
			$fields = $model->getItems();
			
			if(!$fields) continue;
			
			$out[] = JHtml::_('select.optgroup', $type->name);
			foreach ($fields AS $field)
			{
				$out[] = JHtml::_('select.option', $field->{$key}, $field->label);
			}
			$out[] = JHtml::_('select.optgroup', $type->name);
		}
		
		return $out;
	}
	
	public static function recordtypes()
	{
		static $result = null;
		
		if(is_array($result)) return $result;
		
		$db = JFactory::getDbo();
		
		$query = $db->getQuery(true);
		$query->select('id AS value, name AS text');
		$query->from('#__js_res_types');
		$query->order('name');
		
		$db->setQuery($query);
		$result = $db->loadObjectList();
		
		return $result;
	}
}