<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.application.component.modeladmin');

class CobaltModelField extends JModelAdmin
{

	public function populateState($ordering = null, $direction = null)
	{
		$app = JFactory::getApplication('administrator');

		$type = $app->getUserStateFromRequest('com_cobalt.fields.fields.type', 'type_id', 0, 'int');
		$this->setState('fields.type', $type);

		parent::populateState($ordering = null, $direction = null);
	}

	public function getTable($type = 'Field', $prefix = 'CobaltTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}

	public function getFieldForm($field_type, $default = array())
	{
		$file = JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'fields' . DS . $field_type . DS . $field_type . '.xml';
		if(! JFile::exists($file))
		{
			echo "File not found: {$file}";
		}

		$lang = JFactory::getLanguage();
		$lang->load('com_cobalt_field_' . $field_type, JPATH_ROOT, 'en-GB');
		if($lang->getTag() !== 'en-GB')
		{
			$lang->load('com_cobalt_field_' . $field_type, $file, $lang->getTag(), TRUE);
		}

		$form = new JForm('params', array(
			'control' => 'params'
		));

		$form->loadFile($file, true, 'config');

		return MEFormHelper::renderGroup($form, $default, 'params', FORM_STYLE_TABLE, FORM_SEPARATOR_NONE);
	}

	public function getForm($data = array(), $loadData = true)
	{
		$app = JFactory::getApplication();

		$form = $this->loadForm('com_cobalt.field', 'field', array(
			'control' => 'jform',
			'load_data' => $loadData
		));
		if(empty($form))
		{
			return false;
		}
		return $form;
	}

	protected function loadFormData()
	{
		$data = JFactory::getApplication()->getUserState('com_cobalt.edit.field.data', array());

		if(empty($data))
		{
			$data = $this->getItem();
		}

		return $data;
	}

	public function getItem($pk = null)
	{
		if($item = parent::getItem($pk))
		{
			//print_r($item->params);


			if(! is_array($item->params))
			{
				//echo $item->params;
				$registry = new JRegistry();
				$registry->loadString($item->params);
				$item->params = $registry->toArray();
			}
		}

		if(JRequest::getInt('group'))
		{
			$item->group_id = JRequest::getInt('group');
		}

		return $item;
	}

	/*public function saveorder($pks = null, $order = null)
	{
		$model_groups = JModel::getInstance('Groups', 'CobaltModel');

		$items = $model_groups->getItems();
		$table = $this->getTable();

		foreach($items as $key => $item)
		{
			$table->reorder('group_id = ' . $item->id);
		}

		$table->reorder('group_id = 0  AND type_id = ' . JRequest::getVar('type_id'));

	}*/


	protected function getReorderConditions($table)
	{
		return array('group_id = ' . $table->group_id, 'type_id = ' . JRequest::getVar('type_id'));
	}

	protected function canDelete($record)
	{
		$user = JFactory::getUser();

		return $user->authorise('core.delete', 'com_cobalt.field.' . (int)$record->id);
	}

	protected function canEditState($record)
	{
		$user = JFactory::getUser();

		return $user->authorise('core.edit.state', 'com_cobalt.field.' . (int)$record->id);
	}
}