<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.application.component.modellist');

class CobaltModelPacks extends JModelList
{
	public function __construct($config = array())
	{
		if (empty ( $config ['filter_fields'] ))
		{
			$config ['filter_fields'] = array ('id', 'name', 'version', 'ctime', 'mtime', 'btime');
		}

		parent::__construct ( $config );
	}

	protected function getListQuery()
	{
		$db		= $this->getDbo();
		$query	= $db->getQuery(true);

		$query->select('p.*');
		$query->from('#__js_res_packs AS p');

		$query->select('count(ps.section_id) AS secnum');
		$query->leftJoin('#__js_res_packs_sections AS ps ON p.id = ps.pack_id');


		$orderCol	= $this->state->get('list.ordering', 'ctime');
		$orderDirn	= $this->state->get('list.direction', 'asc');
		$query->order($db->getEscaped($orderCol.' '.$orderDirn));
		$query->group('p.id');

		//echo nl2br(str_replace('#__','jos_',$query));
		return $query;
	}

	public function getItems()
	{
		$items = parent::getItems();
		settype($items, 'array');
		$path = JPATH_CACHE.DS;
		foreach ($items AS $item)
		{
			if(JFile::exists($path.'pack_'.$item->key.'.build.7.'.$item->version.'.zip'))
			{
				$item->download = '<a href="'.JURI::root().'/cache/pack_'.$item->key.'.build.7.'.$item->version.'.zip">'.JText::_('CDOWNLOAD').'</a>';
			}
			else
			{
				$item->download = JText::_('CNOBUILD');
			}
		}

		return $items;
	}
}
