<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.application.component.modeladmin');

class CobaltModelPacksection extends JModelAdmin
{

	public function getTable($type = 'Packs_sections', $prefix = 'CobaltTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}

	
	public function getForm($data = array(), $loadData = true)
	{
		$app = JFactory::getApplication();
		
		$form = $this->loadForm('com_cobalt.packsection', 'packsection', array('control' => 'jform', 'load_data' => $loadData));
		if(empty($form))
		{
			return false;
		}
		return $form;
	}

	protected function loadFormData()
	{
		$data = JFactory::getApplication()->getUserState('com_cobalt.packsection.edit.'.$this->getName().'.data', array());
		
		if(empty($data))
		{
			$data = $this->getItem();
		}
		
		return $data;
	}
	
	public function save($data)
	{
		return parent::save($data);	
	}
	
	protected function canDelete($record)
	{
		$user = JFactory::getUser();

		return $user->authorise('core.delete', 'com_cobalt.packsection.'.(int) $record->id);
	}
	
	protected function canEditState($record)
	{
		$user = JFactory::getUser();

		return $user->authorise('core.edit.state', 'com_cobalt.packsection.'.(int) $record->id);
	}
	
	public function populateState($ordering = null, $direction = null)
	{
		$app = JFactory::getApplication('administrator');
	
		$pack = $app->getUserStateFromRequest('com_cobalt.packsections.pack', 'pack_id', 0, 'int');
		$this->setState('pack', $pack);
	
		parent::populateState();
	}
	
	public function getSectionForm($section_id, $default = array())
	{
		JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_cobalt'.DS.'models');
		$file = JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_cobalt' . DS . 'xml' . DS . 'packtype.xml';
		if(! JFile::exists($file))
		{
			echo "File not found: {$file}";
		}
		$section = ItemsStore::getSection($section_id);
		
		if(!is_object($section->params))
		{
			$section->params = new JRegistry($section->params);
		}
		
		$types = $section->params->get('general.type');
		settype($types, 'array');
		
		$out = array();
		
		$out[] = JHtml::_('tabs.start', 'config-tabs-configuration', array('useCookie'=>1));
		foreach ($types as $type_id)
		{
			if(!$type_id)
			{
				continue;
			}
			$def = !empty($default['types'][$type_id]) ? $default['types'][$type_id] : array();
			$type = ItemsStore::getType($type_id);
			
			$out[] = JHtml::_('tabs.panel', $type->name, 'type-details');
			
			$form = new JForm('params', array(
					'control' => 'params[types]['.$type_id.']'
			));
			
			$form->loadFile($file, true, 'config');
			
			$out[] = MEFormHelper::renderFieldset($form, 'sp_type_templates', $def, null, 2, 1);
			$out[] = MEFormHelper::renderFieldset($form, 'sp_type_content', $def, null, 2, 1);
		}
		
		$out[] = JHtml::_('tabs.end');
		
		return implode('', $out);
	}
}