<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die('Restricted access');

// Include library dependencies
jimport('joomla.filter.input');

class CobaltTableRecord extends JTable
{
	public function __construct(&$db)
	{
		parent::__construct('#__js_res_record', 'id', $db);
		$this->_trackAssets = false;
	}

	protected function _getAssetName()
	{
		return 'com_cobalt.record.' . (int)$this->id;
	}

	protected function _getAssetTitle()
	{
		return $this->title;
	}


	/* public function reorder($catid, $clients, $order = "")
	{

		$query = 'SELECT r.id, rc.ordering, rc.id as rcid' . ' FROM #__js_res_record AS r ' . ' LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id' . ' WHERE r.client = \'' . $clients . '\' AND rc.ordering >= 0 AND rc.catid = ' . $catid . ' GROUP BY r.id ORDER BY rc.ordering ASC' . $order;
		$this->_db->setQuery($query);

		if (!($orders = $this->_db->loadObjectList()))
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		//print_r($orders);
		// compact the ordering numbers
		for($i = 0, $n = count($orders); $i < $n; $i ++)
		{
			if ($orders[$i]->ordering >= 0)
			{
				if ($orders[$i]->ordering != $i + 1)
				{
					$orders[$i]->ordering = $i + 1;
					$query = 'UPDATE #__js_res_record_category ' . ' SET ordering = ' . (int)$orders[$i]->ordering . ' WHERE id = ' . $this->_db->Quote($orders[$i]->rcid);
					//echo $query;
					$this->_db->setQuery($query);
					$this->_db->query();
				}
			}
		}

		return true;
	} */


	public function bind($array, $ignore = '')
	{
		if(isset($array['rules']) && is_array($array['rules']))
		{
			$rules = new JAccessRules($array['rules']);
		}
		else
		{
			$rules = new JAccessRules(array());
		}
		$this->setRules($rules);

		return parent::bind($array, $ignore);
	}

	public function onFollow()
	{
		$this->_db->setQuery("SELECT COUNT(*) FROM #__js_res_subscriptions WHERE record_id = ".$this->id);
		$this->_db->query();
		$this->subscriptions_num = $this->_db->loadResult();
		$this->store();
	}
	public function onBookmark()
	{
		$this->_db->setQuery("SELECT COUNT(*) FROM #__js_res_favorite WHERE record_id = ".$this->id);
		$this->_db->query();
		$this->favorite_num = $this->_db->loadResult();
		$this->store();
	}
	public function check($resave = false)
	{
		$isNew = (boolean)empty($this->id);
		$user = JFactory::getUser();

		if (trim($this->title) == '')
		{
			$this->setError('Your Content must contain a title.');
			return false;
		}
		if (!$this->client)
			$this->client = 'resource';
		if (!$this->ip)
			$this->ip = $_SERVER['REMOTE_ADDR'];

		if (!$this->langs)
		{
			$lang = JFactory::getLanguage();
			$this->langs = $lang->getTag();
		}

		if ($this->ctime == '' || $this->ctime == '0000-00-00 00:00:00')
		{
			$this->ctime = JFactory::getDate()->toSql();
		}

		if ($this->inittime == '' || $this->inittime == '0000-00-00 00:00:00')
		{
			$this->inittime = JFactory::getDate()->toSQL();
		}

		$this->mtime = JFactory::getDate()->toSQL();


		if (!$this->user_id)
		{
			$this->user_id = (int)$user->get('id');
		}

		if(JRequest::getInt('parent_id'))
		{
			$this->parent_id = JRequest::getInt('parent_id');
			$this->parent = JRequest::getVar('parent', 'com_cobalt');
		}

		$section = JModel::getInstance('Section', 'CobaltModel')->getItem(JRequest::getInt('section_id', $this->section_id));
		$type = JModel::getInstance('Form', 'CobaltModel')->getRecordType($this->type_id);
		$fields_list = JModel::getInstance('Fields', 'CobaltModel')->getFormFields($type->id);

		$post = JRequest::getVar('jform');

		$fields = @$post['fields'];
		settype($fields, 'array');

		$out = array();
		if($this->id)
		{
			$record = JTable::getInstance('Record', 'CobaltTable');
			$record->load($this->id);
			$out = json_decode($record->fields, TRUE);
		}

		$out_fieldsdata = array();
		$task = JRequest::getVar('task');

		foreach($fields_list as $field)
		{

			if($task == 'save2copy' || $task == 'copy')
			{
				$value = $field->onCopy(@$fields[$field->id], $this, $type, $section);
			}
			else
			{
				// MJTODO check value overwrite
				$value = CensorHelper::cleanText(@$fields[$field->id]);
			}

			if ((!$this->id && in_array($field->params->get('core.field_submit_access'), $user->getAuthorisedViewLevels())) ||
				($this->id && in_array($field->params->get('core.field_edit_access'), $user->getAuthorisedViewLevels())))
			{
				$out[$field->id] = $field->onPrepareSave($value, $this, $type, $section);
			}

			if ($field->params->get('core.searchable'))
			{
				$data = $field->onPrepareFullTextSearch($value, $this, $type, $section);
				if (is_array($data))
				{
					$data = implode(', ', $data);
				}
				$out_fieldsdata[$field->id] = $data;
			}

		}
		$this->fields = json_encode($out);

		$categories = @$post['category'];
		if (!is_array($categories))
			$categories = explode(',', $categories);
		ArrayHelper::clean_r($categories);

		$model_categories = JModel::getInstance('Category', 'CobaltModel');

		$out_categories = array();

		foreach($categories as $category)
		{
			$cat = $model_categories->getItem($category);
			$out_categories[$category] = $cat->title;
		}
		ArrayHelper::clean_r($out_categories);
		$this->categories = json_encode($out_categories);

		if (!$out_categories && $section->categories && !$type->params->get('submission.first_category', 0) && in_array($type->params->get('submission.allow_category', 1), $user->getAuthorisedViewLevels()))
		{
			$this->setError(JText::_('C_MSG_SELECTCATEGORY'));
			return false;
		}

		if(!array_key_exists('published', $post))
		{
			$this->published = 1;
		}
		
		if ($isNew)
		{
			if (!isset($post['access']))
			{
				$this->access = $type->params->get('submission.access', 1);
			}
			if($type->params->get('submission.autopublish', 1) == 0)
			{
				$this->published = 0;
				JError::raiseNotice(1, JText::_('CNEWARTICLEAPPROVE'));
			}

			if (!isset($post['extime']) && $type->params->get('submission.default_expire', 0) > 0)
			{
				$this->extime = JFactory::getDate('+ ' . $type->params->get('submission.default_expire') . ' DAY')->toMySQL();
			}
		}
		else
		{
			if($type->params->get('submission.edit_autopublish', 1) == 0)
			{
				JError::raiseNotice(1, JText::_('CEDITARTICLEAPPROVE'));
				$this->published = 0;
			}
		}

		if ($type->params->get('properties.item_title') == 2)
		{
			$title = $type->params->get('properties.item_title_composite', 'Please set composite title mask in type parameters');

			preg_match_all('/.*?\[(\d+)\].*?/i', $title, $matches);
			if(isset($matches[1]))
			{
				foreach($out as $id => $value)
				{
					if(!in_array($id, $matches[1]))
					{
						continue;
					}
					if(is_array($value))
					{
						$value = implode(', ', $value);
					}
					$title = str_replace("[{$id}]", $value, $title);
				}
			}
			$title = str_replace(array('[USER]'), array(CCommunityHelper::getName($this->user_id, $section, TRUE)), $title);
			$this->title = $title;
		}


		$this->title = CensorHelper::cleanText($this->title);
		if($type->params->get('properties.item_title_limit', 0))
		{
			if(strlen($this->title) > $type->params->get('properties.item_title_limit', 0))
			{
				$this->setError(JText::sprintf('C_MSG_TITLETOLONG', $type->params->get('properties.item_title_limit', 0)));
				return FALSE;
			}
		}

		$this->meta_descr = CensorHelper::cleanText($this->meta_descr);
		$this->meta_key = CensorHelper::cleanText($this->meta_key);

		if($type->params->get('properties.item_title_unique'))
		{
			$sql = "SELECT id from #__js_res_record WHERE title = '{$this->title}' AND id NOT IN(".(int)@$this->id.")";
			$this->_db->setQuery($sql);
			if($this->_db->loadResult())
			{
				$this->setError(JText::_('C_MSG_TITLEEXISTS'));
				return FALSE;
			}
		}


		if($section->params->get('more.search_title'))
		{
			$out_fieldsdata[] = $this->title;
		}
		if($section->params->get('more.search_name'))
		{
			$out_fieldsdata[] = $user->get('name');
			$out_fieldsdata[] = $user->get('username');
		}
		if($section->params->get('more.search_email'))
		{
			$out_fieldsdata[] = $user->get('email');
		}

		$this->fieldsdata = strip_tags(implode(', ', $out_fieldsdata));

		if ($this->getErrors())
		{
			return false;
		}

		$this->title = trim($this->title);


		if (!$this->alias || ($task == 'save2copy' || $task == 'copy'))
		{
			$this->alias = $this->title;
		}

		if (!$this->alias)
		{
			$this->alias = JFactory::getDate()->format('Y-m-d-H-i-s');
		}

		$this->alias = JApplication::stringURLSafe(strip_tags(CensorHelper::cleanText($this->alias)));

		return true;
	}
}
?>
