<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined( '_JEXEC' ) or die( 'Restricted access');

/**
* @package JCommerce
*/
class CobaltTableRecord_values extends JTable
{

	public function __construct(&$_db)
	{
		parent::__construct('#__js_res_record_values', 'id', $_db);
	}

	public function bind($array, $ignore = '')
	{
		$params = JRequest::getVar('params', array(), 'post', 'array');
		if($params)
		{
			$registry = new JRegistry();
			$registry->loadArray($params);
			$array['params'] = (string)$registry;
		}
		
		//$this->key = 'k'.md5($array['label'].'-'.$array['field_type']);

		return parent::bind($array, $ignore);
	}

	public function check()
	{
		if(trim($this->field_label) == '')
		{
			$this->setError(JText::_('CNOLABEL'));
			return false;
		}
		
		if(!$this->ip)
		{
			$this->ip = $_SERVER['REMOTE_ADDR'];
		}
		
		if($this->ctime == '' || $this->ctime == '0000-00-00 00:00:00')
		{
			$this->ctime = JFactory::getDate()->toMySQL();
		}
		
		return true;
	}
	public function clean($record_id, $ids)
	{
		$query = $this->_db->getQuery(true);
		$query->delete();
		$query->from($this->_tbl);
		$query->where('record_id = '.$record_id);
		if($ids)
		{
			$query->where('field_id IN ('.implode(',', $ids).')');
		}
		$this->_db->setQuery($query);
		$this->_db->query();

		return true;
	}
}
?>
