<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined ( '_JEXEC' ) or die ( 'Restricted access');

jimport ( 'joomla.application.component.view');
jimport ( 'joomla.filesystem.folder');

JHTML::_ ( 'behavior.modal', 'a.modal');

class CobaltViewComments extends JView {
	
	public function display($tpl = null) {
		
		JHtml::_('behavior.tooltip');
		
		$uri = JFactory::getURI();
		$this->action = $uri->toString();
		
		$this->state = $this->get('State');
		$this->items = $this->get('Items');
		$this->pagination = $this->get('Pagination');
		
		// Check for errors.
		if(count($errors = $this->get('Errors')))
		{
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}
		
		$this->addToolbar();
		
		parent::display($tpl);

		
	}
	
	function prepareItems(&$items) {
		foreach ( $items as $key => $item ) {
			if (JFolder::exists ( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_juser' )) {
				$item->user_href = JURI::root () . 'administrator/index.php?option=com_juser&view=user&task=edit&cid[]=' . $item->userid;
			} else {
				$item->user_href = JURI::root () . 'administrator/index.php?option=com_user&view=user&task=edit&cid[]=' . $item->userid;
			}
			
			$items [$key] = $item;
		}
	
	}
	
	protected function addToolbar()
	{
		MRToolBar::title(JText::_('CCOMMENTS' ), 'comments.png');
		JToolBarHelper::editListX('comment.edit');
		JToolBarHelper::divider();
		JToolBarHelper::publishList('comments.publish');
		JToolBarHelper::unpublishList('comments.unpublish');
		JToolBarHelper::divider();
		JToolBarHelper::deleteList('', 'comments.delete','Delete');
  		//MRToolBar::helpW('http://help.mintjoomla.com/cobalt/index.html?comments.htm', 1000, 500);
	}

}