<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();
jimport('joomla.application.component.view');
/**
 * View to edit a weblink.
 *
 * @package		Cobalt
 * @subpackage	com_cobalt
 * @since		6.0
 */
class CobaltViewRecords extends JView
{

	protected $state;

	protected $item;

	protected $form;

	public function display($tpl = null)
	{
		JHtml::_('behavior.tooltip');

		$uri = JFactory::getURI();
		//var_dump($uri);
		$this->action = $uri->toString();

		$this->state = $this->get('State');
		$this->items = $this->get('Items');
		$this->pagination = $this->get('Pagination');

		if(is_array($this->items))
		{
			foreach ($this->items AS $item)
			{
				$item->categories = json_decode($item->categories);
			}
		}
		$this->sections = $this->get('Sections');
		$this->types = $this->get('Types');

		// Check for errors.
		if(count($errors = $this->get('Errors')))
		{
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}
		$doc = JFactory::getDocument();
		$doc->addStyleDeclaration('
			.icon-32-featured{
				 background-image: url("'.JURI::root().'administrator/components/com_cobalt/images/toolbar/featured.png");
			}
			.icon-32-unfeatured{
				 background-image: url("'.JURI::root().'administrator/components/com_cobalt/images/toolbar/unfeatured.png");
			}
		');
		$this->addToolbar();
		parent::display($tpl);
	}

	/**
	 * Add the page title and toolbar.
	 */
	protected function addToolbar()
	{
		JToolBarHelper::title(JText::_('XML_TOOLBAR_TITLE_RECORDS'), 'generic.png');
		JToolBarHelper::unarchiveList('records.unpublish');
		JToolBarHelper::archiveList('records.archive');
		JToolBarHelper::divider();
		JToolBarHelper::publishList('records.publish');
		JToolBarHelper::unpublishList('records.unpublish');
		JToolBarHelper::divider();
		JToolBarHelper::custom('records.featured', 'featured', '', 'CFEATURE', true);
		JToolBarHelper::custom('records.unfeatured', 'unfeatured', '', 'CUNFEATURE', true);
		JToolBarHelper::divider();
		JToolBarHelper::custom('records.copy', 'copy.png', 'copy.png', 'CCOPY', true);
		MRToolBar::reset();
// 		MRToolBar::mass();
		JToolBarHelper::divider();
		JToolBarHelper::deleteList(JText::_('C_TOOLBAR_CONFIRMDELET'), 'records.delete','Delete');
		//MRToolBar::helpW('http://help.mintjoomla.com/cobalt/index.html?content.htm', 1000, 500);
	}
}
