<?php 
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.application.component.view');
jimport('joomla.client.helper');

require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'helpers'.DS.'templates.php';

/**
 * View information about cobalt.
 *
 * @package		Cobalt
 * @subpackage	com_cobalt
 * @since		6.0
 */
class CobaltViewTemplates extends JView
{
	public function display( $tpl = null )
	{
		if(($this->getLayout() == 'form') || (JRequest::getVar('layout') == 'form')){
			$this->display_form();
			return;
		}

		$app = JFactory::getApplication();

		$this->addToolbar('list');

		$this->config = JComponentHelper::getParams('com_cobalt');

		$document = JFactory::getDocument();
		//$document->addScript(JURI::root().'components/com_cobalt/library/js/felixrating.js');

		$uri	= JFactory::getURI();
		$this->action = $uri->toString();

		$this->items      = $this->get('Form');
		$this->ftp = JClientHelper::setCredentialsFromRequest('ftp');
		parent::display($tpl);
	}

	public function display_form( $tpl = null )
	{

		$this->addToolbar('form');
		JRequest::setVar('hidemsainmenu', 1);
		//$model = JModel::getInstance('Subtmpls', 'ResModel');
		$tmpl = JRequest::getVar('cid', array());
		$tmpl = $tmpl[0];

		preg_match ( "/^\[(.*)\]\,\[(.*)\]$/i", $tmpl, $matches);
		$this->name = $matches[1];
		$this->type = $matches[2];

		$file_png = MRtemplates::getTmplFile($matches[2], $matches[1].'.png');
		$this->img_path = '';
		if(JFile::exists($file_png))
		{
			$img_path = MRtemplates::getTmplImgSrc($matches[2], $matches[1]);
			$this->img_path = $img_path;
		}
		$file_ini = MRtemplates::getTmplFile($matches[2], $matches[1].'.json');
		$file_xml = MRtemplates::getTmplFile($matches[2], $matches[1].'.xml');
		$this->location = str_replace(JPATH_ROOT, '', str_replace('.xml', '.php', $file_xml));

		$ini = JFile::exists($file_ini) ? JFile::read( $file_ini ) : '';
		$model = $this->getModel();
		$this->xml_data = $model->parseXMLTemplateFile($file_xml);

		$this->form = JForm::getInstance('com_cobalt.form', $file_xml, array('control' => 'jform'));
		$this->params_groups = array('tmpl_params' => 'Properties',
		'tmpl_core' => 'Core'
		);

		$params = new JRegistry();
		$params->loadString($ini);
		$this->params = $params;

		$uri  = JFactory::getURI();
		$this->action = $uri->toString();
		$this->close = JRequest::getInt('close', 0);

		$this->buttons['save'] = '<input type="button" onclick="javascript:Joomla.submitbutton(\'templates.apply\')" value="'.JText::_('CSAVE').'">';
		$this->buttons['saveclose'] = '<input type="button" onclick="javascript:Joomla.submitbutton(\'templates.saveclose\')" value="'.JText::_('CSAVECLOSE').'">';
		$this->buttons['close'] = '<input type="button" onclick="window.parent.SqueezeBox.close();" value="'.JText::_('CCLOSE').'">';

		parent::display($tpl);
	}

	private function addToolbar($type)
	{
		switch ($type)
		{
			case 'list':
				JToolBarHelper::title(JText::_('CTEMPLATMANAGER' ), 'thememanager.png');
				JToolBarHelper::deleteList('', 'templates.uninstall', 'Uninstall');
				MRToolBar::install();
				MRToolBar::cr();
				//MRToolBar::helpW('http://help.mintjoomla.com/cobalt/index.html?templates2.htm', 1000, 500);
			break;

			case 'form':
				JToolBarHelper::title(JText::_('CEDITTEMPLATE' ), 'thememanager.png');
				JToolBarHelper::apply('templates.apply');
				JToolBarHelper::save('templates.save');
				JToolBarHelper::cancel('templates.cancel');
			break;

			case 'list':
			break;

		}
	}
}
?>