<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.application.component.view');
class CobaltViewType extends JView
{

	protected $state;

	protected $item;

	protected $form;

	/**
	 * Display the view
	 */
	public function display($tpl = null)
	{
		JHtmlBehavior::framework();
		
		$this->state = $this->get('State');
		$this->item = $this->get('Item');
		$this->form = $this->get('Form');
		
		$params = new JForm('params', array('control' => 'params'));
		$params->loadFile(JPATH_COMPONENT_ADMINISTRATOR.DS.'xml'.DS.'type.xml');
		$this->params_form = $params;
		
		$this->params_groups = array('properties' => JText::_('FS_GENERAL'), 
		'submission' => JText::_('FS_SUBMISPARAMS'), 
		'comments' => JText::_('FS_COMMPARAMS'), 
		'emerald' => JText::_('FS_EMERALDINTEGRATE')
		);
		
		// Check for errors.
		if(count($errors = $this->get('Errors')))
		{
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}
		
		$document = JFactory::getDocument();
        $document->addScript(JURI::root().'administrator/components/com_cobalt/library/js/tmplselect.js');
       
		
		$this->addToolbar();
		parent::display($tpl);
	}

	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addToolbar()
	{
		JRequest::setVar('hidemainmenu', true);
		
		$user		= JFactory::getUser();
		$isNew		= ($this->item->id == 0);
		$checkedOut	= !($this->item->checked_out == 0 || $this->item->checked_out == $user->get('id'));
		
		JToolBarHelper::title(($isNew ? JText::_('CNEWTYPE') : JText::_('CEDITTYPE')), ($isNew ? 'type_new.png' : 'type_edit.png'));
		
		if (!$checkedOut){ 
			JToolBarHelper::apply('type.apply', 'JTOOLBAR_APPLY');
			JToolBarHelper::save('type.save', 'JTOOLBAR_SAVE');
			JToolBarHelper::custom('type.save2new', 'save-new.png', 'save-new_f2.png', 'JTOOLBAR_SAVE_AND_NEW', false);
			if(!$isNew) JToolBarHelper::custom('type.save2copy', 'save-copy.png', 'save-copy_f2.png', 'JTOOLBAR_SAVE_AS_COPY', false);
		}
		JToolBarHelper::cancel('type.cancel', 'JTOOLBAR_CANCEL');
		//MRToolBar::helpW('http://help.mintjoomla.com/cobalt/index.html?filters.htm', 1000, 500);
		JToolBarHelper::divider();
	}
}
