<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die('Restricted access');

$user	= JFactory::getUser();
$userId	= $user->get('id');

$listOrder	= $this->escape($this->state->get('list.ordering'));
$listDirn	= $this->escape($this->state->get('list.direction'));
?>

<style type="text/css">
  .icon-48-votes {
    background: url(components/com_cobalt/images/titles/votes.png) no-repeat;
  }
</style>

<form action="<?php echo $this->action ?>" method="post" name="adminForm">
	<fieldset id="filter-bar">
		<div class="filter-search fltlft">
			<label class="filter-search-lbl" for="filter_search"><?php echo JText::_('JSEARCH_FILTER_LABEL'); ?></label>
			<input type="text" style="margin-left: 5px;" name="filter_search" id="filter_search" value="<?php echo $this->state->get('filter.search'); ?>" />
			<button type="submit"><?php echo JText::_('JSEARCH_FILTER_SUBMIT'); ?></button>
			<button type="button" onclick="document.id('filter_search').value='';this.form.submit();"><?php echo JText::_('JSEARCH_FILTER_CLEAR'); ?></button>
		</div>
		<div class="filter-select fltrt">

			<select name="filter_type" class="inputbox" onchange="this.form.submit()">
				<option value=""><?php echo JText::_('CFILERVOTETYPE');?></option>
				<?php echo JHtml::_('select.options', JHtml::_('votes.types'), 'value', 'text', $this->state->get('filter.type'));?>
			</select>

			<select name="filter_votes" class="inputbox" onchange="this.form.submit()">
				<option value=""><?php echo JText::_('CFILTERVOTE');?></option>
				<?php echo JHtml::_('select.options', JHtml::_('votes.values'), 'value', 'text', $this->state->get('filter.votes'));?>
			</select>

			<select name="filter_section" class="inputbox" onchange="this.form.submit()">
				<option value=""><?php echo JText::_('CFILTERSECTION');?></option>
				<?php echo JHtml::_('select.options', JHtml::_('cobalt.sections'), 'value', 'text', $this->state->get('filter.section'));?>
			</select>
		</div>
	</fieldset>
	<div class="clr"> </div>


	<table class="adminlist">
		<thead>
			<tr>
				<th width="1%">
					<?php echo JText::_('CNUM'); ?>
				</th>
				<th width="1%">
					<input type="checkbox" name="toggle" value="" onclick="checkAll(this);" />
				</th>
				<th width="1%" nowrap="nowrap">
					<?php echo JHTML::_('grid.sort',  'CVOTE', 'a.vote',     $listDirn, $listOrder ); ?>
				</th>
				<th width="1%" nowrap="nowrap">
					<?php echo JHTML::_('grid.sort',  'CTYPE', 'a.ref_type',     $listDirn, $listOrder ); ?>
				</th>
				<th class="title">
					<?php echo JHTML::_('grid.sort',  'CARTICLE', 'r.title',   $listDirn, $listOrder ); ?>
				</th>
				<th width="10%">
					<?php echo JHTML::_('grid.sort',  'CUSER', 'u.username',$listDirn, $listOrder  ); ?>
				</th>
				<th width="8%" nowrap="nowrap">
					<?php echo JHTML::_('grid.sort',  'CVOTED', 'a.ctime',   $listDirn, $listOrder  ); ?>
				</th>
				<th width="1%" nowrap="nowrap">
					<?php echo JHTML::_('grid.sort',  'ID',    'a.id',      $listDirn, $listOrder  ); ?>
				</th>
				</tr>
		</thead>
		<tfoot>
			<tr>
				<td colspan="8">
					<?php echo $this->pagination->getListFooter(); ?>
				</td>
			</tr>
		</tfoot>

		<tbody>
		<?php foreach ($this->items as $i => $item) :?>
			<tr class="row<?php echo $i % 2; ?>">
				<td><?php echo $this->pagination->getRowOffset( $i ); ?></td>
				<td><?php echo JHTML::_('grid.id', $i, $item->id ); ?></td>
				<td><?php echo $item->vote?></td>
				<td><?php echo $item->ref_type?></td>
				<td><a href="javascript:void(0);" onclick="document.getElementById('filter_search').value='record:<?php echo $item->record_id; ?>'; document.adminForm.submit();"><?php echo $item->record?></a></td>
				<td width="5%" nowrap="nowrap">
					<?php
					$user = JFactory::getUser($item->user_id);
					$link = 'index.php?option=com_users&task=edit&cid[]='.$user->get('id');
					if(is_dir(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_juser'))
						$link = 'index.php?option=com_juser&task=edit&cid[]='.$user->get('id');
					?>
					<?php if($user->get('username')):?>
							<?php echo JHtml::link('javascript:void(0);', $user->get('username'), array('title' => JText::_('CFILTERBYUISER'), 'onclick' => 'document.getElementById(\'filter_search\').value=\'user:'.$item->user_id.'\'; document.adminForm.submit();'))?>
							<?php //echo JHtml::_('ip.block_user', $item->user_id, $item->id);?>
					<?php else:?>
						<?php echo (!empty($item->name) ? $item->name  ." ({$item->email}) " : Jtext::_('CANONYMOUS'))?>
					<?php endif;?>

					<?php if($item->ip): ?>
						<div>
							<?php echo JHtml::_('ip.country', $item->ip);?>
							<?php echo JHTML::link('javascript:void(0);' ,$item->ip, array('title' => JText::_('CFILTERBYIP'), 'onclick' => 'document.getElementById(\'filter_search\').value=\'ip:'.$item->ip.'\'; document.adminForm.submit();')); ?>
							<?php //echo JHtml::_('ip.block_ip', $item->ip, $item->id);?>
						</div>
					<?php endif; ?>
				</td>

				<td align="center"><?php $data = new JDate( $item->ctime ); echo $data->toFormat( JText::_('CDATE1' ) ); ?></td>

				<td align="center"><?php echo $item->id; ?></td>
			</tr>
		<?php endforeach; ?>
		</tbody>
	</table>

	<input type="hidden" name="task" value="" />
	<input type="hidden" name="boxchecked" value="0" />
	<input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>" />
	<input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>" />
	<?php echo JHtml::_('form.token'); ?>
</form>