<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();
require_once JPATH_ROOT.DS.'components/com_cobalt/library/php/fields/cobaltfield.php';

class JFormFieldCBoolean extends CFormField
{
	public function getInput()
	{
		$document = JFactory::getDocument();
		$path = JURI::root().'components/com_cobalt/fields/boolean/';
		$document->addStyleSheet($path.'boolean.css');
		$document->addScript($path.'boolean.js');
		
		return $this->_display_input();		
	}
	
	public function onFilterWornLabel($section)
	{
		$value = $this->value;
		
		$label = $this->params->get('params.'.$value);
		$icon = $this->params->get('params.icon_'.$value, ($value == 'true' ? 'tick.png' : 'cross.png'));
		$icon = JHtml::image(JURI::root().'media/mint/icons/16/'.$icon, $label, array('align' => 'absmiddle'));

		switch($this->params->get('params.view_what', 'both'))
		{
			case 'label': $value = $label; break;
			case 'icon': $value = $icon; break;
			default: $value = $icon.' '.$label;
		}
		return $value;
	}
	public function onFilterWhere($section, &$query)
	{	
		if($this->value) 
		{

			if($this->params->get('params.no_value') == 0 || $this->value == 'true')
			{
				$ids = $this->getIds("SELECT record_id FROM `#__js_res_record_values` 
					WHERE field_value + 0 = ".($this->value == 'true' ? 1 : -1)." 
					AND section_id = {$section->id} 
					AND field_key = '{$this->key}'");
				
				$sql = implode(',', $ids);
				
				$query->where("r.id IN ({$sql})");
			}
			elseif($this->params->get('params.no_value') == 1 && $this->value == 'false')
			{
				$ids = $this->getIds("SELECT record_id FROM `#__js_res_record_values` 
					WHERE field_value + 0 = 1
					AND section_id = {$section->id} 
					AND field_key = '{$this->key}'");
				
				$sql = implode(',', $ids);
				
				$query->where("r.id NOT IN ({$sql})");
			}
		
			return true;
		}
	}
	public function onRenderFilter($section, $module = false)
	{
		$document = JFactory::getDocument();
		
		$label['true'] = $this->params->get('params.true');
		$label['false'] = $this->params->get('params.false');
		$icon = array();
		$icon['true'] = JHtml::image(JURI::root().'media/mint/icons/16/'.$this->params->get('params.icon_true', 'tick.png'), $label, array('align' => 'absmiddle'));
		$icon['false'] = JHtml::image(JURI::root().'media/mint/icons/16/'.$this->params->get('params.icon_false', 'cross.png'), $label, array('align' => 'absmiddle'));
		

		switch($this->params->get('params.view_what', 'both'))
		{
			case 'both': $label['true'] = $icon['true']. ' '. $label['true'];
						$label['false'] = $icon['false']. ' '. $label['false']; 
						break;
			case 'icon': $label['true'] = $icon['true'];
						$label['false'] = $icon['false']; break;
			
		}
		
		$nums= array();
		if ($this->params->get('params.filter_show_number', 1))
		{
			$db = JFactory::getDbo();
			$query = $db->getQuery(TRUE);
			$q1 = "SELECT count(record_id) as num 
				FROM `#__js_res_record_values` 
				WHERE section_id = '{$section->id}' AND field_key = '{$this->key}' 
				AND field_value = '1' GROUP BY field_value";			
			$db->setQuery($q1);
			if($nums[1] = $db->loadResult())
			{
				$label['true'] .= " ({$nums[1]})"; 
			}
			
			if($this->params->get('params.no_value') == 0)
			{
				$q0 = "SELECT count(record_id) as num 
				FROM `#__js_res_record_values` 
				WHERE section_id = '{$section->id}' AND field_key = '{$this->key}' 
				AND field_value = '-1' GROUP BY field_value";
			}
			else
			{
				$sql = "SELECT record_id FROM `#__js_res_record_values` 
					WHERE field_value = '1'
					AND section_id = {$section->id} 
					AND field_key = '{$this->key}'";
				$q0 = "SELECT COUNT(r.id) as num 
					FROM `#__js_res_record` AS r 
					WHERE r.section_id = '{$section->id}' 
					AND r.published = 1 AND r.hidden = 0 AND r.id NOT IN ($sql)";
			}

			$db->setQuery($q0);
			if($nums[0] = $db->loadResult())
			{
				$label['false'] .= " ({$nums[0]})";
			}
		}
		
		$this->labelvalue = $label;
		
		return $this->_display_filter($section, $module);
		
		
	}
	
	public function onPrepareFullTextSearch($value, $record, $type, $section)
	{
		return;
	}
	
	public function onPrepareSave($value, $record, $type, $section)
	{
		return (int)($value ? 1 : -1); 
	}
	
	public function onRenderFull($record, $type, $section)
	{		
		return $this->_render('full', $record, $type, $section);
	}
	
	public function onRenderList($record, $type, $section)
	{
		return $this->_render('list', $record, $type, $section);
	}
	
	private function _render($client, $record, $type, $section )
	{
		if($this->value == 1)
			$value = 'true';
		else if($this->value == -1)
			$value = 'false';
		else
			return;
		
		

		$label = $this->params->get('params.'.$value);
		
		if($this->params->get('params.filter_enable')) 
		{
			$tip = ($this->params->get('params.filter_tip') ? JText::sprintf($this->params->get('params.filter_tip'), '<b>'.$this->label.'</b>', '<b>'.$label.'</b>') : NULL);
			switch ($this->params->get('params.filter_linkage'))
			{
				case 1:
					$label = FilterHelper::filterLink('filter_'.$this->key, $value, $label, $this->type_id, $tip, $section);
					break;
					
				case 2:
					$label .= ' '.FilterHelper::filterButton('filter_'.$this->key, $value, $this->type_id, $tip, $section, $this->params->get('params.filter_icon', 'funnel-small.png'));
					break;
			}
		}
		
		$icon = $this->params->get('params.icon_'.$value);
		if($icon)
		{
			$icon = JHtml::image(JURI::root().'media/mint/icons/16/'.$icon, strip_tags($label), array('align' => 'absmiddle'));
		}	

		switch($this->params->get('params.view_what', 'both'))
		{
			case 'label': 
				$out = $label; 
			break;
			
			case 'icon': 
				$out = $icon;
			break;

			default: 
				$out = $icon.' '.$label;
		}

		$this->print = $out;
		
		return $this->_display_output($client, $record, $type, $section);
	} 
}
	