<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

$class = ' class="' . $this->params->get('core.field_class', 'inputbox') . '"';
$style = 'width: ' . $this->params->get('params.width', '220') . 'px';
?>

<?php if ($this->params->get('params.total_limit')):?>
	<div class="small"><?php echo JText::sprintf('F_OPTIONSLIMIT', $this->params->get('params.total_limit'));?></div>
<?php endif; ?>

<ul class="elements-list" id="form_field_list_<?php echo $this->id;?>">
	<?php 
	foreach($this->values as $key => $line):
		if(is_string($line))
			$val = explode($this->params->get('params.color_separator', "^"), $line);
		$sel = '';
		$s = $style;
		if (isset($val[1]))
		{
			$s .= ';color: ' . $val[1];
		}
		$text = is_string($line) ? $line : $line->text;
		if ($this->value && in_array($text, $this->value))
		{
			$sel = ' checked="checked"';
		}
		if($this->params->get('params.sql_source'))
		{
			$value = $line->id;
			$text = $line->text;
		}
		else
		{
			$value = htmlspecialchars($line, ENT_COMPAT, 'UTF-8');
			$text = JText::_($val[0]);
		}
	?>
	<li style="<?php echo $s;?>" class="list-element">
		<input type="checkbox" class="<?php echo $class;?>" value="<?php echo $value;?>" name="jform[fields][<?php echo $this->id;?>][]" id="field_<?php echo $this->id;?>_<?php echo $key;?>" 
			<?php echo $sel;?> onClick="countFieldValues(this, <?php echo $this->id;?>, <?php echo $this->params->get('params.total_limit', 0);?>, 'checkbox')"/>
		<label for="field_<?php echo $this->id;?>_<?php echo $key;?>"><?php echo $text;?></label>
	</li>
	<?php endforeach;?>
	</ul>
	
<?php if (in_array($this->params->get('params.add_value', 2), $this->user->getAuthorisedViewLevels()) && !$this->params->get('params.sql_source')):?>
		<?php 
		JFactory::getDocument()->addScript(JURI::root() . 'media/mint/js/GrowingInput.js');?>
		<div style="clear:both"></div>
		<div class="variant-container" id="variant_<?php echo $this->id;?>">
			<a class="small" id="show_variant_link_<?php echo $this->id;?>" 
				rel="{field_type:'<?php echo $this->type;?>', id:<?php echo $this->id;?>, inputtype:'checkbox', width:<?php echo $this->params->get('params.width', '220');?>, limit:<?php echo $this->params->get('params.total_limit', 0);?>, max_size:0}" 
				href="javascript:void(0)" onclick="showAddForm(this)"><?php echo JText::_($this->params->get('params.user_value_label', 'Your variant'));?></a>
			</div>
		<div style="clear:both"></div>
<?php endif;?>