<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die;
require_once JPATH_ROOT.DS.'components/com_cobalt/library/php/fields/cobaltrelate.php';

require_once JPATH_ROOT.DS.'components'.DS.'com_cobalt'.DS.'api.php';

class JFormFieldCChild extends CFormFieldRelate
{
	public function getInput()
	{
		$name = "jform[fields][$this->id]";

		ArrayHelper::clean_r($this->value);
		if(JRequest::getInt('fand'))
		{
			$this->value[] = JRequest::getInt('fand');
			$this->params->set('params.input_mode', 10);
		}

		$this->inputvalue = $this->_render_input($this->params->get('params.input_mode'),  $name, $this->params->get('params.parent_section'), $this->params->get('params.parent_type'), $this->params->get('params.multi_parent'));

		return $this->_display_input();
	}

	public function onFilterWhere($section, &$query)
	{
		ArrayHelper::clean_r($this->value);
		$ids = $this->getIds("SELECT record_id FROM #__js_res_record_values WHERE field_value IN(".implode(',', $this->value).") AND field_id = {$this->id}");
		$query->where("r.id IN(".implode(',', $ids).")");

		return TRUE;
	}

	public function onRenderFilter($section, $module = false)
	{
		$name = "filters[{$this->key}]";
		ArrayHelper::clean_r($this->value);
		$limit = $this->params->get('params.multi_limit', 0);
		$this->params->set('params.multi_limit', 100);

		$this->filter = $this->_render_input($this->params->get('params.filter_style'),  $name,
			$this->params->get('params.parent_section'), $this->params->get('params.parent_type'));


		return $this->_display_filter($section, $module);

		$this->params->set('params.multi_limit', $limit);
	}


	public function onFilterWornLabel($section)
	{
		$db = JFactory::getDbo();

		$query = $db->getQuery(TRUE);
		$query->from('#__js_res_record');
		$query->select('title');
		$query->where('id IN ('.implode(',', $this->value).')');
		$db->setQuery($query);
		$array = $db->loadResultArray();
		return implode(', ', $array);
	}

	public function onStoreValues($record){
		return $this->value;
	}
	public function onRenderFull($record, $type, $section)
	{
		return $this->_render('full', $record, $this->id, $this->params->get('params.parent_type'),
			$this->params->get('params.parent_section'), 'show_parents');
	}
	public function onRenderList($record, $type, $section)
	{
		return $this->_render('list', $record, $this->id, $this->params->get('params.parent_type'),
			$this->params->get('params.parent_section'), 'show_parents');
	}
	public function onGetList($params)
	{
		$db = JFactory::getDbo();
		$user = JFactory::getUser();

		$query = $db->getQuery(TRUE);
		$query->select('id, title, null, title');
		$query->from('#__js_res_record');
		$query->where('published = 1');
		$query->where('hidden = 0');
		$query->where('section_id = '.$this->params->get('params.parent_section'));
		$query->where('type_id = '.$this->params->get('params.parent_type'));

		if(!in_array($this->params->get('params.strict_to_user'), $user->getAuthorisedViewLevels()))
		{
			if($this->params->get('params.strict_to_user_mode') > 1)
			{
				$record = JTable::getInstance('Record', 'CobaltTable');
				$record->load($params['record_id']);
				$user_id = $record->user_id;
				if(!$user_id && $this->params->get('params.strict_to_user_mode') == 3)
				{
					$user_id = $user->get('id');
				}
			}
			else
			{
				$user_id = $user->get('id');
			}
			$query->where('user_id = '.($user_id ? $user_id : 1));
		}

		$db->setQuery($query);
// 		echo $db->getQuery();
		return $db->loadRowList();
	}
}
