<?php
/**
 * @copyright	Copyright (C) 2005 - 2012 MintJoomla. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

// No direct access.
defined('_JEXEC') or die;

jimport('joomla.html.pagination');
jimport('joomla.utilities.utility');

class plgContentCobalt extends JPlugin
{
	
	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		$this->loadLanguage();
	}

	/**
	 * @param	string	The context of the content being passed to the plugin.
	 * @param	object	The article object.  Note $article->text is also available
	 * @param	object	The article params
	 * @param	int		The 'page' number
	 *
	 * @return	void
	 * @since	1.6
	 */
	public function onContentPrepare($context, &$row, &$params, $page = 0)
	{
		$canProceed = $context == 'com_content.article';
		if (!$canProceed) {
			return;
		}

		if(!preg_match('/{cobalt-discussion}/iU', $row->text))
		{
			return;
		}

		if(! $this->params->get('type_id') || ! $this->params->get('section_id'))
		{
			JError::raiseNotice(500, 'Not all parameters set in plugin to display discussions');
			return;
		}

		$out = array();
		require_once JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'library' . DS . 'php' . DS . 'helper.php';
		include_once JPATH_ROOT. DIRECTORY_SEPARATOR .'components'. DIRECTORY_SEPARATOR .'com_cobalt'. DIRECTORY_SEPARATOR .'api.php';
		
		$document = JFactory::getDocument();
		$document->addScript(JURI::root().'media/mint/js/moodropmenu/MooDropMenu.js');
		$document->addStyleSheet(JURI::root().'media/mint/js/moodropmenu/MooDropMenu.css');


		if($this->params->get('rating'))
		{
			$db = JFactory::getDbo();
			$query = $db->getQuery(true);
			$query->select("AVG(votes_result)");
			$query->from("#__js_res_record");
			$query->where("parent_id = ".$row->id);
			$query->where("parent = 'com_content'");
			$db->setQuery($query);

			$result = $db->loadResult();
			$out[] = '<div id="rating-block" class="pull-right fltrgt">Total rating: '.RatingHelp::loadRating($this->params->get('rating_tmpl', 'default'), $result, 0, 0, 'ItemRatingCallBack', 0, 0).'</div>';

		}

		$out[] = '<h2>' . $this->params->get('title') . '</h2>';

		$descr = $this->params->get('descr');
		if($descr)
		{
			if(strlen($descr) == strlen(strip_tags($descr)))
			{
				$descr = "<p>{$descr}</p>";
			}
			$out[] = $descr;
		}


		$stype = ItemsStore::getType($this->params->get('type_id'));
		$section = ItemsStore::getSection($this->params->get('section_id'));
		$user = JFactory::getUser();

		JRequest::setVar('parent_id', $row->id);
		JRequest::setVar('parent', 'com_content');

		$api = new CobaltApi();
		$result = $api->records($section->id, 'children', $this->params->get('orderby'), array($stype->id), NULL, $this->params->get('defcat', 0), $this->params->get('limit', 5), $this->params->get('tmpl'));
		$out[] = $result['html'];

		JRequest::setVar('parent', 0);
		JRequest::setVar('parent_id', 0);

		if(in_array($stype->params->get('submission.submission'), $user->getAuthorisedViewLevels()))
		{
			$return = urlencode(base64_encode(JFactory::getURI()->toString()));
			$url = 'index.php?option=com_cobalt&view=form&section_id=' . $section->id;
			$url .= '&type_id=' . $stype->id . ':' . JApplication::stringURLSafe($stype->name);
			$url .= '&defcat_id='.$this->params->get('defcat', 0);
			$url .= '&parent_id='.$row->id;
			$url .= '&parent=com_content';
			$url .= '&return=' . base64_encode(JFactory::getURI());
			$out[] = '<a class="btn btn-primary btn-large" href="' . JRoute::_($url) . '">' . $this->params->get('button') . '</a>';
		}

		$out[] = "<br />";

		$row->text = str_replace('{cobalt-discussion}', implode("\n", $out), $row->text);

		return true;
	}
}
