<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die;
require_once JPATH_ROOT.DS.'components/com_cobalt/library/php/fields/cobaltfield.php';


class JFormFieldCDigits extends CFormField
{
	protected $type = 'Digits';

	public function getInput()
	{
		$document = JFactory::getDocument();
		$document->addScript(JURI::root().'components/com_cobalt/fields/digits/digits.js');

		return $this->_display_input();
	}

	public function onJSValidate()
	{
		$text = addslashes(JText::sprintf('F_FORMATINCORRECT', $this->label));
		$js = '';
		if ($this->required)
		{
			$js .= "\n\t\tif($('field_{$this->id}').value == ''){hfid.push({$this->id}); isValid = false; errorText.push('" . addslashes(JText::sprintf('CFIELDREQUIRED', $this->label)) . "');}";
		}
		return $js .= "\n\t\tvalue = $('field_{$this->id}').value; ereg = /^[\d\.]*$/; if(!value.match(ereg)) { isValid = false; errorText.push('{$text}'); hfid.push({$this->id});}";
	}

	public function onPrepareSave($value, $record, $type, $section)
	{
		$filter = JFilterInput::getInstance();
		return $filter->clean($value);
	}

	public function onFilterWornLabel($section)
	{
		$value = $this->value;
		settype($value, 'array');
		return  JText::sprintf($this->params->get('params.filter_worn', 'P_BETWEEN'),
			'<b>'.$this->params->get('params.prepend').number_format($value['min'], $this->params->get('params.decimals_num', 0), $this->params->get('params.dseparator', '.'), $this->params->get('params.separator', ',')).$this->params->get('params.append').'</b>',
			'<b>'.$this->params->get('params.prepend').number_format($value['max'], $this->params->get('params.decimals_num', 0), $this->params->get('params.dseparator', '.'), $this->params->get('params.separator', ',')).$this->params->get('params.append').'</b>');
	}

	public function onFilterWhere($section, &$query)
	{
		$value = $this->value;
		settype($value, 'array');
		ArrayHelper::trim_r($value);

		if(!isset($value['min']) || !isset($value['max']))
		{
			return NULL;
		}

		if($value['min'] == $value['max'])
		{
			return NULL;
		}

		$ids = $this->getIds("SELECT record_id FROM #__js_res_record_values
			WHERE (field_value + 0 BETWEEN {$value['min']} AND {$value['max']})
			  AND section_id = {$section->id}
			  AND field_key = '{$this->key}'");
		$query->where("r.id IN(".implode(',', $ids).")");

		return TRUE;
	}


	public function onRenderFilter($section, $module = false)
	{
		$params = new JRegistry();
		$params->loadArray($this->value);
		$this->value = $params;

		static $data = array();
		
		if(!isset($data[$this->key]))
		{
			$db = JFactory::getDbo();
			$query = $db->getQuery(TRUE);
			$query->select('MAX(field_value + 0) as max, MIN(field_value + 0) as min');
			$query->from('#__js_res_record_values');
			$query->where("section_id = {$section->id}");
			$query->where("`field_key` = '{$this->key}'");
			$db->setQuery($query);

			$data[$this->key] = $db->loadObject();
		}

		$this->data = $data[$this->key];

		return $this->_display_filter($section, $module);
	}


	public function onRenderFull($record, $type, $section)
	{
		return $this->_render('full', $record, $type, $section);
	}

	public function onRenderList($record, $type, $section)
	{
		return $this->_render('list', $record, $type, $section);
	}

	private function _render($client, $record, $type, $section )
	{
		if(!$this->value) return NULL;

		return $this->_display_output($client, $record, $type, $section);
	}
}
