<?php
/**
 * @copyright      Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license        GNU General Public License version 2 or later; see LICENSE.txt
 */

// no direct access
defined('_JEXEC') or die();

jimport('joomla.plugin.plugin');
jimport('joomla.application.component.model');
jimport('database.table');
require_once JPATH_ROOT . '/components/com_emerald/api.php';

class plgSystemEcommTools extends JPlugin
{

	function onAfterInitialise()
	{
		if(JFactory::getApplication()->isAdmin())
		{
			return;
		}

		$login = $this->params->get('login');
		$key   = $this->params->get('key');
		$con   = $this->params->get('conversion');
		$con   = explode("\n", str_replace("\r", "", $con));
		foreach($con as $cond)
		{
			if(!trim($cond))
			{
				continue;
			}
			$array                 = explode("**", $cond);
			$conversion[$array[0]] = $array[1];
		}

		if(!$login || !$key || !$conversion)
		{
			JError::raiseWarning(100, 'Вы активировали интегрицию EcommTools и Emerald но не настроили ее. Пожалуйста или отключите этот плагин или зайдите в настнойки и заполните нужные поля.');

			return;
		}

		$post = $_POST;


		if(empty($post['action']) || $post['action'] != 'paidorder' || empty($post['email']) || empty($post['orderid']) || empty($post['hash']) || empty($post['items']))
		{
			return;
		}
		$this->_log("secret: " . $login);
		$this->_log("conversion: " . print_r($conversion, TRUE));
		$this->_log("post: " . print_r($post, TRUE));

		$key_hash = md5($post['action'] . $login . $key . $post['orderid']);

		if($key_hash != $post['hash'])
		{
			$this->_log("Does not match");
			echo 'What?!!! Back off!' . $key_hash;
			JFactory::getApplication()->close();

			return;
		}


		$name  = $post['name'];
		$email = $post['email'];
		$items = $post['items'];

		settype($items, 'array');

		$db = JFactory::getDbo();
		require_once (JPATH_ROOT.'/administrator/components/com_emerald/controllers/cnf.php');
		EmeraldControllerCnf::initialyze();
		require_once (JPATH_ROOT.'/administrator/components/com_emerald/helpers/emerald.php');
		JTable::addIncludePath(JPATH_ROOT.'/administrator/components/com_emerald/tables');
		JModel::addIncludePath(JPATH_ROOT.DS.'/components/com_emerald/models');

		foreach($items as $item)
		{
			$parts       = explode('-', $item);
			$item        = array();
			$item['id']  = $parts[0];
			$item['sum'] = @$parts[2];
			$this->_log("item: " . print_r($item, TRUE));

			if(empty($conversion[$item['id']]))
			{
				continue;
			}


			$plans = explode(',', $conversion[$item['id']]);
			foreach($plans as $plan_id)
			{
				$plan_id = (int)$plan_id;
				if(!$plan_id)
				{
					continue;
				}

				$db->setQuery("SELECT * FROM #__jcs_plans WHERE id = " . $plan_id);
				$plan = $db->loadObject();
				if(!$plan)
				{
					continue;
				}

				$user = $this->_getUser($email);

				JTable::addIncludePath(JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_emerald' . DS . 'tables');
				JModel::addIncludePath(JPATH_ROOT . DS . 'components' . DS . 'com_emerald' . DS . 'models');
				$model = JModel::getInstance('Plans', 'EmeraldModel');

				$res = array(
					'gateway'    => 'Ecomtools',
					'sid'        => $plan_id,
					'gateway_id' => $post['orderid'] . ':' . $item['id'],
					'user_id'    => $user->id,
					'price'      => $item['sum'],
					'email'      => $user->email,
					'pay'        => 'success',
					'published'  => 1
				);

				$this->_log("plan: " . $plan_id);

				if($model->store($res))
				{
					$this->_log("\nsubscribe: " . print_r($res, TRUE));
					$model->grantPlans($res);
					$model->deactivatePlans($plan_id, $res);

					EmeraldHelper::alertUser($res, $plan->alert_admin);
				}
				else
				{
					$this->_log('Could not save.');
				}
			}
		}
		$this->_close('Nothing');

	}

	private function _getUser($email)
	{
		$db = JFactory::getDbo();
		$db->setQuery("SELECT * FROM #__users WHERE email = '{$email}'");
		$user = $db->loadObject();

		if(!$user)
		{
			$user_login       = substr($email, 0, strpos($email, '@'));
			$data['username'] = $user_login;

			$post = $_POST;
			$name  = $post['name'];

			if($this->params->get('username') == 1)
			{
				$data['username'] = $email;
			}
			else
			{
				$db->setQuery("SELECT id FROM #__users WHERE username = '" . $db->escape($user_login) . "'");
				$id = $db->loadResult();
				if(!empty($id))
				{
					$data['username'] = $user_login . '-' . strtolower(substr(md5(time()), 0, 3));
				}
			}

			$pwd = substr(md5($email . $name . time()), 0, 6);

			$data['password1'] = $pwd;
			$data['password2'] = $pwd;
			$data['name']      = $name;
			$data['email1']    = $email;
			$data['email2']    = $email;

			JFactory::getLanguage()->load('com_users');

			JModelLegacy::addIncludePath(JPATH_ROOT . '/components/com_users/models');
			$model  = JModelLegacy::getInstance('Registration', 'UsersModel');
			$return = $model->register($data);

			$this->_log("new user: " . print_r($data, TRUE));

			//$db->setQuery("UPDATE #__users SET `block` = 0, `activation` = '' WHERE email = '{$email}'");
			//$db->query();

		}

		$db->setQuery("SELECT * FROM #__users WHERE email = '{$email}'");
		$user = $db->loadObject();

		return $user;
	}

	private function _log($msg)
	{
		if(!$this->params->get('log', 1))
		{
			return;
		}
		error_log("\n" . $msg, 3, JPATH_ROOT . '/logs/log.txt');
	}

	private function _close($msg)
	{
		echo json_encode(
			array(
				'message' => $msg
			)
		);
		JFactory::getApplication()->close();
	}
}
