<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();
jimport('mint.recaptchalib');
jimport('joomla.mail.helper');
require_once JPATH_ROOT.DS.'components/com_cobalt/library/php/fields/cobaltfield.php';

class JFormFieldCEmail extends CFormField
{

	public function getInput()
	{
		$document = JFactory::getDocument();
		$document->addScript(JURI::root() . 'components/com_cobalt/fields/email/email.js');
		$user = JFactory::getUser();

		if ($this->params->get('params.enter_mail', 1) && in_array($this->params->get('params.enter_mail', 1), $user->getAuthorisedViewLevels()))
		{
			if (!$this->value && $user->get('id') && !JRequest::getInt('id'))
			{
				$this->value = $user->get('email');
			}

			return $this->_display_input();
		}
	}

	public function onJSValidate()
	{
		$js = '';
		if ($this->required)
		{
			$js .= "\n\t\tif($('field_{$this->id}').value == ''){hfid.push({$this->id}); isValid = false; errorText.push('" . addslashes(JText::sprintf('CFIELDREQUIRED', $this->label)) . "');}";
		}
		$js .= "\n\t\t if( $('field_{$this->id}').value != '' && !EmailCheck($('field_{$this->id}').value) ) {hfid.push({$this->id}); isValid = false; errorText.push('" . addslashes(JText::sprintf('E_ENTEREDINCORRECT', $this->label) ). "');}";
		return $js;
	}

	public function validate($value, $record, $type, $section)
	{
		if ($value && !JMailHelper::isEmailAddress($value))
		{
			$this->setError(JText::sprintf('E_ENTEREDINCORRECT', $this->label));
			return FALSE;
		}
		return parent::validate($value, $record, $type, $section);
	}

	public function onPrepareSave($value, $record, $type, $section)
	{
		$value = filter_var($value, FILTER_SANITIZE_EMAIL);
		return $value;
	}

	public function onStoreValues($record)
	{
		$this->value = filter_var($this->value, FILTER_SANITIZE_EMAIL);
		return $this->value;
	}

	public function onFilterWornLabel($section)
	{
		return JHtml::_('content.prepare', $this->value);
	}

	public function onFilterWhere($section, &$query)
	{
		$ids = $this->getIds("SELECT record_id FROM #__js_res_record_values WHERE field_value = '{$this->value}' AND section_id = {$section->id} AND field_key = '{$this->key}'");
		$query->where("r.id IN(".implode(',', $ids).")");

		return true;
	}

	public function onRenderFilter($section, $module = false)
	{

		$document = JFactory::getDocument();
		$document->addStyleSheet(JURI::root() . 'components/com_cobalt/fields/email/email.css');
		$document->addScript(JURI::root() . 'components/com_cobalt/fields/email/email.js');

		return $this->_display_filter($section, $module);
	}

	public function onPrepareFullTextSearch($value, $record, $type, $section)
	{
		return $value;
	}

	public function onRenderFull($record, $type, $section)
	{
		return $this->_render('full', $record, $type, $section);
	}

	public function onRenderList($record, $type, $section)
	{
		return $this->_render('list', $record, $type, $section);
	}

	private function _render($client, $record, $type, $section )
	{
		global $app;
		$params = $this->params;
		$document = JFactory::getDocument();
		$uri = JFactory::getURI();

		$document->addScript(JURI::root() . 'media/mint/js/mediabox/mediaboxAdv.js');
		$document->addStyleSheet(JURI::root() . 'components/com_cobalt/fields/email/email.css');
		$document->addStyleSheet(JURI::root() . 'media/mint/js/mediabox/mediaboxAdv-' . JString::ucfirst($params->get('params.theme', 'dark')) . '.css');

		$this->author = JFactory::getUser($record->user_id);
		$this->user = JFactory::getUser();
		$this->url = $uri->toString();

		return $this->_display_output($client, $record, $type, $section);

	}

	public function _sendEmail($post, $record)
	{
		$user = JFactory::getUser();
		$config = JFactory::getConfig();

		$_from = $config->getValue('config.mailfrom');
		$_name = $config->getValue('config.fromname');

		$data = $post['email'][$this->id];
		$data['captcha'] = JRequest::getVar('recaptcha_response_field');

		if ($user->id)
		{
			if (!$this->params->get('params.change_name_from', 1))
				$data['name'] = $user->get('name');
			if (!$this->params->get('params.change_email_from', 1))
				$data['email_from'] = $user->get('email');
		}

		if (!$user->id && $this->params->get('params.show_captcha', 1))
		{
			if ($data['captcha'] == '' && !$user->get('id'))
			{
				JError::raiseWarning(400, JText::_('E_SECURITYCODENOTENTERED'));
				return false;
			}
			else
			{
				jimport('mint.recaptchalib');
				$conf = JComponentHelper::getParams('com_cobalt');

				$privatekey = $conf->get('recaptcha_private_key');
				$resp = recaptcha_check_answer($privatekey, $_SERVER["REMOTE_ADDR"], JRequest::getVar("recaptcha_challenge_field"), JRequest::getVar("recaptcha_response_field"));

				if (!$resp->is_valid)
				{
					JError::raiseWarning(400, JText::_('E_SECURITYCODEINCORRECT'));
					return false;
				}
			}
		}

		$table_row = '<tr><td>%s:</td><td>%s</td></tr>';

		$body[] = sprintf($table_row, JText::_('E_URL'), JRoute::_(Url::record($record), true, -1));
		$body[] = sprintf($table_row, JText::_('E_TITLE'), $record->title);
		$body[] = sprintf($table_row, JText::_('E_FROM'), $data['name'] . ' (' . $data['email_from'] . ')');
		$body[] = sprintf($table_row, JText::_('E_MSG'), nl2br($data['body']));

		if ($schema = $this->params->get('params.additional_fields') && isset($data['add_field']))
		{
			$fields = $data['add_field'];
			settype($fields, 'array');

			$schema = $this->params->get('params.additional_fields');
			$add_fields_info = explode("\n", str_replace("\r", '', $schema));
			//var_dump($add_fields_info);
			foreach($add_fields_info as $f)
			{
				if (!trim($f))
					continue;

				$field_info = explode('::', $f);
				if (count($field_info) > 2)
				{
					$body[] = sprintf($table_row, JText::_(trim($field_info[2])), (is_array($fields[$field_info[1]]) ? implode(',', $fields[$field_info[1]]) : nl2br($fields[$field_info[1]])));
				}
			}
		}
		$body = '<table width="100%" cellpadding="2" cellspacing="2">' . implode("\n", $body) . '</table>';

		//echo $body; exit;


		$name = NULL;
		switch ($this->params->get('params.to', 1))
		{
			case 1 :
				if (!$this->value)
				{
					JError::raiseWarning(400, JText::_('E_EMAILNOTENTERED'));
					return false;
				}
				$email = $this->value;

				break;
			case 2 :
				$email = $_from;
				$name = $_name;
				break;
			case 3 :
				if (!$record->user_id)
				{
					JError::raiseWarning(400, JText::_('E_ARTICLEANONYMOUSE'));
					return false;
				}
				$author = JFactory::getUser($record->user_id);
				$email = $author->get('email');
				$name = $author->get('name');
				break;
			case 4 :
				if (!$data['email_to'])
				{
					JError::raiseWarning(400, JText::_('E_SENDTONOTENTERED'));
					return;
				}
				$email = $data['email_to'];
				break;
			case 5 :
				$email = trim($this->params->get('params.custom'));
				if (empty($email))
				{
					JError::raiseWarning(400, JText::_('E_EMAILNOTENTERED'));
					return false;
				}
				break;

			default :
				break;
		}
		if (!JMailHelper::isEmailAddress($email))
		{
			JError::raiseWarning(400, JText::_('E_SENDTOINCORRENT'));
			return;
		}

		$mail = JFactory::getMailer();
		$mail->AddAddress($email);

		if ($data['name'] == '')
		{
			JError::raiseWarning(400, JText::_('E_SENDERNAMENOTENTERED'));
			return;
		}
		if ($data['email_from'] == '')
		{
			JError::raiseWarning(400, JText::_('E_SENDERMAILNOTENTERED'));
			return;
		}
		if (!JMailHelper::isEmailAddress($data['email_from']))
		{
			JError::raiseWarning(400, JText::_('E_SENDERMAILINCORRENT'));
			return;
		}

		$copy_send_msg = '';
		if ($this->params->get('params.copy_to_sender', 1) && $data['copy_to_sender'])
		{
			$mail->AddCC($data['email_from']);
		}

		if ($this->params->get('params.cc', 0) && $data['cc'] != '')
		{
			$emails = explode(',', $data['cc']);
			if ($emails && count($emails) > 0)
			{
				foreach($emails as $e)
				{
					$mail->AddCC($e);
				}
			}
		}

		if ($this->params->get('params.subject_style', 1) == 1 && $data['subject'] == '')
		{
			JError::raiseWarning(400, JText::_('E_SUBJNOTENTERED'));
			return;
		}
		elseif ($this->params->get('params.subject_style', 1) == 0)
		{
			$data['subject'] = JText::_($this->params->get('params.subject', 'No subject set in email field'));
		}

		$files = JRequest::get('FILES');
		if ($aname = $files['email_' . $this->id]['name'])
		{
			$ext = JFile::getExt($aname);
			$formats = explode(",", $this->params->get('params.formats'));
			ArrayHelper::clean_r($formats);
			if (!in_array(strtolower($ext), $formats))
			{
				JError::raiseWarning(400, JText::_('E_WRONGATTACHEXT'));
				return false;
			}
			if (JFile::exists($files['email_' . $this->id]['tmp_name']))
			{
				JFile::copy($files['email_' . $this->id]['tmp_name'], JPATH_CACHE . DS . $aname);
				$mail->addAttachment(JPATH_CACHE . DS . $aname);
			}
		}

		$reply[0] = $data['email_from'];
		$reply[1] = $data['name'];

		if (!$reply)
		{
			$reply[0] = $_from;
			$reply[1] = $_name;
		}
		$sender[0] = $_from;
		$sender[1] = $_name;

		$mail->setSender($sender);
		$mail->addReplyTo($reply);
		$mail->isHTML(true);
		$mail->setBody(JMailHelper::cleanBody($body));
		$mail->setSubject(JMailHelper::cleanSubject($data['subject']));

		if (!$mail->Send())
		{
			JError::raiseWarning(400, JText::_('E_ERRSEND'));
			return false;
		}

		return true;
	}

	public function _getForm($record, $section)
	{
		global $app;

		$author = JFactory::getUser($record->user_id);
		$user = JFactory::getUser();
		$params = $this->params;

		$out[] = '<style>
		body, body div {max-width:'.$this->params->get('params.width').'px !important; backgroung: #fff;}
		table { border-collapse: separate;}tr, td { border: 0px;}</style>';

		if ($post = JRequest::get('POST'))
		{
			if ($this->_sendEmail($post, $record))
			{
				JError::raiseNotice(100, JText::_('E_MAILSENT'));
				$js = '<script type="text/javascript">
				setTimeout(parent.window.Mediabox.close(), 1500);
					</script>';
				return $js;
			}
			else
			return implode($out);
			$default = $post['email'][$this->id];
		}
		settype($default, 'array');
		$data = new JRegistry();
		$data->loadArray($default);

		$show_emailto = in_array($this->params->get('params.view_mail', 1), $user->getAuthorisedViewLevels());

		$out[] = '<form method="post" enctype="multipart/form-data">
		<table border="0" cellpadding="5" cellspacing="2"  width="100%">';

		$pattern = '<tr><td width="1%%" nowrap="nowrap" >' . JText::_('E_SENDTO') . ':</td><td>%s</td></tr>';
		switch ($params->get('params.to'))
		{
			case 1 :
				if ($show_emailto)
					$out[] = sprintf($pattern, JHtml::_('content.prepare', $this->value));
				break;
			case 2 :
				$out[] = sprintf($pattern, JText::_('E_ADMIN') . ($show_emailto ? '(' . $app->getCfg('mailfrom') . ')' : ''));
				break;
			case 3 :
				$out[] = sprintf($pattern, $author->get('name') . ($show_emailto ? ' (' . $author->get('email') . ')' : ''));
				break;
			case 4 :
				$out[] = sprintf($pattern, '<input type="text" style="width:99%" required="required" class="inputbox" name="email[' . $this->id . '][email_to]" value="' . $data->get('email_to') . '" size="' . $params->get('params.size', 40) . '" />');
				break;
			case 5 :
				if ($show_emailto)
					$out[] = sprintf($pattern, $params->get('params.custom'));
				break;

			default :
				break;
		}

		if ($params->get('params.change_name_from', 1) || !$user->id)
		{
			$pattern = '<tr><td width="1%%" nowrap="nowrap">' . JText::_('E_YOURNAME') . '</td><td><input required="required" class="inputbox" type="text" name="email[' . $this->id . '][name]"  value="%s" size="' . $params->get('params.size', 40) . '" /></td></tr>';
			$out[] = sprintf($pattern, $data->get('name', $user->get('name')));
		}

		if ($params->get('params.change_email_from', 1) || !$user->id)
		{
			$pattern = '<tr><td width="1%%" nowrap="nowrap">' . JText::_('E_YOURMAIL') . '</td><td><input required="required" class="inputbox" type="text" name="email[' . $this->id . '][email_from]"  value="%s" size="' . $params->get('params.size', 40) . '" /></td></tr>';
			$out[] = sprintf($pattern, $data->get('email_from', $user->get('email')));
		}

		if ($params->get('params.cc'))
		{
			$out[] = sprintf('<tr><td width="1%%" nowrap="nowrap">%s:</td><td><input class="inputbox" type="text" style="%s;" name="email[%d][cc]" value="%s" /></td></tr>', JText::_('E_COPY'), 'width:99%', $this->id, $data->get('cc'));
		}

		if ($params->get('params.subject_style', 0) == 1)
		{
			$out[] = sprintf('<tr><td width="1%%" nowrap="nowrap">%s:</td><td><input type="text" class="inputbox" style="%s;"  name="email[%d][subject]" value="%s" /></td></tr>', JText::_('E_SUBJ'), 'width:99%', $this->id, $data->get('subject', $params->get('params.subject')));
		}
		elseif ($params->get('params.subject_style', 0) == 2)
		{
			$pre_subject_values = explode("\n", trim($params->get('params.pre_subject_val')));
			if (count($pre_subject_values))
			{
				$select_list = '<select name="email[' . $this->id . '][subject]" style="width: 99%;" class="inputbox">';
				foreach($pre_subject_values as $value)
				{
					$selected = ($value == $data->get('subject')) ? 'selected="selected"' : "";
					$value = trim($value);
					$select_list .= '<option value="' . $value . '" ' . $selected . '>' . $value . '</option>';
				}
				$select_list .= "</select>";
				$out[] = sprintf('<tr><td width="1%%" nowrap="nowrap">%s:</td><td>%s</td></tr>', JText::_('E_SUBJ'), $select_list);
			}
		}
		if ($params->get('params.show_body', 1))
		{

			$style = 'max-height:' . $params->get('params.grow_max_height', 200) . 'px;';
			$style .= ' height:' . $params->get('params.grow_min_height', 50) . 'px;';
			$style .= ' width: 95%;';

			$out[] = sprintf('<tr valign="top"><td width="1%%" nowrap="nowrap">%s:</td><td><textarea id="%s" style="%s;"  ' . 'name="email[%d][body]" rows="7" class="inputbox">%s</textarea></td></tr>', JText::_('E_MSG'), 'email_body' . $this->id, $style, $this->id, $data->get('body', $params->get('params.body')));
			JFactory::getDocument()->addScript(JURI::root() . 'media/mint/js/AutoGrow.js');
			$out[] = '<script type="text/javascript">
				new AutoGrow($("email_body' . $this->id . '"));
				</script>';
		}

		$schema = explode("\n", str_replace("\r", '', $params->get('params.additional_fields', '')));
		ArrayHelper::clean_r($schema);

		if ($schema)
		{
			foreach($schema as $f)
			{
				$field_info = explode('::', $f);

				if (count($field_info) > 2)
				{
					switch (trim($field_info[0]))
					{ //type
						case 'text' :
							$out[] = '<tr><td >' . JText::_($field_info[2]) . ':</td><td>
	        	                <input class="inputbox" type="' . trim($field_info[0]) . '"
	        	                	name="email[' . $this->id . '][add_field][' . trim($field_info[1]) . ']"
	        	                	value="' . @trim($data->get('add_field.' . $field_info[1])) . '"
	        	                	style="width:99%" />
	        	                	</td></tr>';
							break;
						case 'radio' :
							$out[] = '<tr><td >' . JText::_($field_info[2]) . ':</td><td>';
							if (isset($field_info[3]))
							{
								$values = explode('|', $field_info[3]);
								foreach($values as $val)
								{
									$out[] = '<input class="inputbox" type="' . trim($field_info[0]) . '"
    	        	                	name="email[' . $this->id . '][add_field][' . trim($field_info[1]) . ']" ' . @trim($field_info[4]) . '
    	        	                	value="' . trim($val) . '" ' . (($data->get('add_field.' . $field_info[1]) == $val) ? 'checked ' : '') . '> ' . $val . ' ';
								}
							}
							else
							{
								$out[] = '<input class="inputbox" type="' . trim($field_info[0]) . '"
    	        	                	name="email[' . $this->id . '][add_field][' . trim($field_info[1]) . ']" ' . @trim($field_info[4]) . '
    	        	                	value="' . trim($field_info[1]) . '" ' . ($data->get('add_field.' . $field_info[1]) ? 'checked' : '') . '> ' . $field_info[1] . ' ';
							}
							$out[] = '</td></tr>';

							break;
						case 'checkbox' :
							$out[] = '<tr><td>' . JText::_($field_info[2]) . ':</td><td>';
							if (isset($field_info[3]))
							{
								$values = explode('|', $field_info[3]);
								foreach($values as $val)
								{
									$out[] = '<input class="inputbox" type="' . trim($field_info[0]) . '"
    	        	                	name="email[' . $this->id . '][add_field][' . trim($field_info[1]) . '][]" ' . @$field_info[4] . '
    	        	                	value="' . trim($val) . '" ' . (in_array($val, $data->get('add_field.' . $field_info[1], array())) ? 'checked ' : '') . '> ' . $val . ' ';
								}
							}
							else
							{
								$out[] = '<input class="inputbox" type="' . trim($field_info[0]) . '"
    	        	                	name="email[' . $this->id . '][add_field][' . trim($field_info[1]) . '][]" ' . @$field_info[4] . '
    	        	                	value="' . trim($field_info[1]) . '" ' . ($data->get('add_field.' . $field_info[1]) ? 'checked' : '') . '> ' . $field_info[1] . ' ';
							}
							$out[] = '</td></tr>';
							break;
						case 'select' :
							$out[] = '<tr><td>' . JText::_($field_info[2]) . ':</td><td>';
							if (isset($field_info[3]))
							{
								$values = explode('|', $field_info[3]);
								$out[] = '<select class="inputbox" name="email[' . $this->id . '][add_field][' . $field_info[1] . '][]" ' . @$field_info[4];
								foreach($values as $val)
								{
									$out[] = '<option ' . ((in_array($val, $data->get('add_field.' . $field_info[1], array()))) ? 'selected=selected ' : '') . '>' . $val . '</option>';
								}
							}
							else
							{
								$out[] = '<input class="inputbox" type="' . trim($field_info[0]) . '"
    	        	                	name="email[' . $this->id . '][add_field][' . trim($field_info[1]) . '][]" ' . @$field_info[4] . '
    	        	                	value="' . trim($field_info[1]) . '" ' . ($data->get('add_field.' . $field_info[1]) ? 'checked' : '') . '>' . $field_info[1];
							}
							$out[] = '</td></tr>';
							break;
						case 'textarea' :
							$out[] = '<tr><td>' . JText::_($field_info[2]) . ':</td><td>
	        	                <textarea class="inputbox" name="email[' . $this->id . '][add_field][' . $field_info[1] . ']" style="width:99%">' . $data->get('add_field.' . $field_info[1]) . '</textarea></td></tr>';
							break;
					}
				}
			}
		}
		if ($params->get('params.attachment'))
		{
			$out[] = sprintf('<tr valign="top"><td >%s:</td>
				<td><input type="file" ' . 'name="email_%d" style="width:%s" /><br><span class="small">%s: %s</span></td></tr>', JText::_('E_ATTACH'), $this->id, $params->get('params.size', '100%'), JText::_('E_ALLOWEDEXT'), $params->get('params.formats'));
		}
		if ($params->get('params.copy_to_sender', 1))
		{
			$out[] = '
			<tr valign="top">
					<td>' . JText::_('E_SENDCOPY') . '</td>
					<td>
					<input type="radio" name="email[' . $this->id . '][copy_to_sender]" value="0" ' . (($data->get('copy_to_sender') == 0) ? 'checked' : '') . '> ' . JText::_('No') . '
					<input type="radio" name="email[' . $this->id . '][copy_to_sender]" value="1" ' . (($data->get('copy_to_sender') == 1) ? 'checked' : '') . '> ' . JText::_('Yes') . '
					</td>
				</tr>';
		}

		if ($params->get('params.show_captcha', 1) && !$user->id)
		{
			$conf = JComponentHelper::getParams('com_cobalt');

			$lang = JFactory::getLanguage()->getLocale();
			$lang = $lang[4];
			$supported_langs = array('en', 'nl', 'fr', 'de', 'pt', 'ru', 'tr', 'es');

			if (!in_array($lang, $supported_langs))
			{
				$lang = $conf->get('recaptcha_lang', 'en');
			}
			$html = '
					<script type="text/javascript">
					 var RecaptchaOptions = {
					    theme : \'' . $conf->get('recaptcha_theme', 'clean') . '\',
					    lang : \'' . $lang . '\'
					 };
					 </script>
				';
			$html .= recaptcha_get_html($conf->get('recaptcha_public_key'));
			$out[] = '
				<tr valign="top">
					<td>' . JText::_('E_CAPTCHA') . '</td>
					<td>' . $html . '</td>
				</tr>';
		}

		$out[] = sprintf('<tr><td></td>
				<td><input type="submit" id="mailSubmit%d" name="submit_%d" value="%s" class="button" />
				</td></tr>', $this->id, $this->id, $params->get('params.button', JText::_('E_SEND')));

		$out[] = '</table></form>';

		return implode($out);
	}

	public function onFilterData($post)
	{
		$phone = $post['term'];
		$where = "field_value like '%$phone%' AND type_id = '{$this->type_id}' AND section_id = '{$post['section']}' AND field_type = '{$post['field']}'";
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select("*, COUNT(record_id) as num");
		$query->from('#__js_res_record_values');
		$query->where($where);
		$query->group('field_value');
		$db->setQuery($query);
		$result = $db->loadObjectList();
		$data = array();
		foreach($result as $k => $val)
		{
			$data[$k]->html = $val->field_value . ($this->params->get('params.filter_show_number') ? " ({$val->num})" : '');
			$data[$k]->label = $val->field_value;
			$data[$k]->value = $val->field_value;

		}
		return $data;
	}
}

