<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();
?>

<?php
$this->record = $record;
$this->_init();

$width = $this->params->get('params.thumbs_list_width', 100);
$height = $this->params->get('params.thumbs_list_height', 100);
$quality = $this->params->get('params.thumbs_list_quality', 80);
$random = $this->params->get('params.thumbs_list_random', 1);
$stretch = $this->params->get('params.thumbs_list_stretch', 0);
$mode = $this->params->get('params.thumbs_list_mode', 1);

$full_width = $this->params->get('params.full_width', 100);
$full_height = $this->params->get('params.full_height', 100);
$full_quality = $this->params->get('params.full_quality', 80);
$full_stretch = $this->params->get('params.full_stretch', 0);

$allow_comments = $this->params->get('params.allow_comments', 0);
$allow_info = $this->params->get('params.allow_info', 0);

$subfolder = $this->params->get('params.subfolder', $this->field_type);

JFactory::getDocument()->addStyleSheet(JURI::root() . 'components/com_cobalt/fields/gallery/gallerybox/thumb-themes/' . $this->params->get('params.thumbs_list_theme', 'default.css'));
JFactory::getDocument()->addStyleDeclaration(".mainwrap-list{
 	            width:{$width}px;
 	            height:{$height}px;
	        }");
$ids = array_keys($this->value);
if ($random)
{
	shuffle($ids);
}

$rel = 'quickbox' . $this->id . '_' . $this->record->id;
if ($this->params->get('params.show_mode', 'gallerybox') == 'gallerybox')
{
	$rel = 'gallerybox' . $this->id . '_' . $this->record->id;
	$ids = array_slice($ids, 0, 3);
}
if ($this->params->get('params.quickbox_click', 0) == 1)
{
	$rel = '';
}

$patern_img = '<div class="image-wrapper-thumb" style="background-image:url(\'%s\');"><a id="%s" title="%s" href="%s" rel="' . $rel . '"><img class="image-element" src="%s" border="0" /></a></div>';
$out = array();
$out2 = array();
$i = 0;
foreach($ids as $index => $id)
{
	$file = $this->value[$id];
	
	$date = $this->resizer->getDate($file['filename']);
	
	if (!JFolder::exists($this->path . $date . DS))
	{
		JFolder::create($this->path . $date . DS, 0777);
		JFile::write($this->path . $date . DS . 'index.html', $index = '<html><body></body></html>');
	}
	$new_name = md5($file['filename'] . 'list' . $width . $height . $quality . $mode . $stretch) . '.' . $file['ext'];
	$img = $this->path . $date . DS . $new_name;
	if (!JFile::exists($img))
	{
		$this->resizer->stretch_if_smaller = $stretch;
		$this->resizer->quality = $quality;
		$this->resizer->setImage(JComponentHelper::getParams('com_cobalt')->get('general_upload') . DS . $subfolder . DS . $file['fullpath']);
		switch ($mode)
		{
			case 1 :
				$this->resizer->resize_crop($width, $height, $img);
				break;
			case 2 :
				$this->resizer->resize_fit($width, $height, $img);
				break;
			case 3 :
				$this->resizer->resize($width, $height, $img);
				break;
			case 4 :
				$this->resizer->resizeByWidth($width, $img);
				break;
			case 5 :
				$this->resizer->resizeByHeight($height, $img);
				break;
			case 6 :
				$this->resizer->resize_limitwh($width, $height, $img);
				break;
		}
	}
	
	$url = sprintf('%s/thumbs_cache/%s/%s', $this->url, $date, $new_name);
	
	$key = md5($file['filename'] . 'full' . $full_width . $full_height . $full_quality . $full_stretch);
	$new_name_full = $key . '.' . $file['ext'];
	$img_full = $this->path . $date . DS . $new_name_full;
	if (!JFile::exists($img_full))
	{
		$this->resizer->stretch_if_smaller = $full_stretch;
		$this->resizer->quality = $full_quality;
		$this->resizer->setImage(JComponentHelper::getParams('com_cobalt')->get('general_upload') . DS . $subfolder . DS . $date . DS . $file['filename']);
		$this->resizer->resize_limitwh($full_width, $full_height, $img_full);
	}
	
	$url_to_original = sprintf('%s/thumbs_cache/%s/%s', $this->url, $date, $new_name_full);
	if ($this->params->get('params.count_views'))
	{
		$url_to_original = sprintf('%sindex.php?option=com_cobalt&task=files.show&id=%d&file_key=%s&no_html=1', JURI::root(), $file['id'], $key);
	}
	if ($this->params->get('params.quickbox_click', 0) == 1)
	{
		$url_to_original = JRoute::_($this->record->url);
	}
	
	$i ++;
	if ($this->params->get('params.show_mode', 'gallerybox') != 'gallerybox' && $i > 3)
	{
		if ($this->params->get('params.quickbox_click', 0) == 1)
		{
			break;
		}
		$out2[] = sprintf($patern_img, $url, $index, ($file['title'] ? $file['title'] : $file['realname']), $url_to_original, $url);
	}
	else
	{
		$out[] = sprintf($patern_img, $url, $index, ($file['title'] ? $file['title'] : $file['realname']), $url_to_original, $url);
	}
}

$class = $this->params->get('core.field_class', false);
?>

<div style="width:<?php echo $width;?>px;height:<?php echo $height;?>px;" class="mainwrap-list<?php echo ($class ? ' ' . $class : '');?>">
	<?php echo implode('', $out);?>
</div>

<?php if ($this->params->get('params.show_mode', 'gallerybox') != 'gallerybox') : ?>
	<div style="display:none;"><?php echo implode('', $out2);?></div>
<?php endif; ?>

<?php 
JFactory::getDocument()->addScriptDeclaration("
	    window.addEvent('domready', function()
	    {
	    	var divs = $$('div.mainwrap-list');
	    	divs.each(function(el)
	    	{
	    		el.addEvent('mouseover', function()
	    		{
				    var thumbs = el.getElements('div');
				    if(thumbs[0]) thumbs[0].addClass('image-wrapper-over1');
				    if(thumbs[1]) thumbs[1].addClass('image-wrapper-over2');
				    if(thumbs[2]) thumbs[2].addClass('image-wrapper-over3');
			    });
			    el.addEvent('mouseout', function()
			    {
				    var thumbs = el.getElements('div');
				    if(thumbs[0]) thumbs[0].removeClass('image-wrapper-over1');
				    if(thumbs[1]) thumbs[1].removeClass('image-wrapper-over2');
				    if(thumbs[2]) thumbs[2].removeClass('image-wrapper-over3');
			    });
	    
	    	});
	    });");
?>