<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

$default = new JRegistry($this->value);
$distance = false;
echo JHtml::_('sliders.start','type-sliders', array('useCookie'=>1));
if (in_array($this->params->get('params.filter_distance', 0), $this->user->getAuthorisedViewLevels())
	&& in_array($this->params->get('params.map_marker'), $this->user->getAuthorisedViewLevels())):

	$distance = true;
	JFactory::getDocument()->addScript('http://maps.googleapis.com/maps/api/js?key=' . $this->params->get('params.map_key') . '&sensor=true');
	JFactory::getDocument()->addScript('http://j.maxmind.com/app/geoip.js');


	$list = array();
	$list[] = JHTML::_('select.option', 'km', JText::_("G_KM"), 'value', 'text');
	$list[] = JHTML::_('select.option', 'm', JText::_('G_M'), 'value', 'text');
	$list = JHtml::_('select.genericlist', $list, "filters[{$this->key}][dist_type]", '', 'value', 'text', $default->get('dist_type', 'km'));
	$radius = ($default->get('radius') ? $default->get('radius') : $this->params->get('params.filter_radius', 20));

	echo JHtml::_('sliders.panel', JText::_('G_DISTANCEFILTERMSG'), 'map-f');
	?>
	<div style="margin: 15px 0px">
		<?php echo JText::_('G_DISTANCERADIUS');?>
		<input type="text" name="filters[<?php echo $this->key;?>][radius]" onkeyup="setCircleRadius()" value="<?php echo (int)$radius;?>" size="10" id="filters<?php echo $this->key;?>radius">
		<select  onchange="setCircleRadius()" name="filters[<?php echo $this->key;?>][dist_type]" id="filters<?php echo $this->key;?>dist_type">
			<option value="km" <?php echo ($default->get('dist_type', 'km') == 'km' ? 'selected' : null);?>><?php echo JText::_('G_KM');?></option>
			<option value="m" <?php echo ($default->get('dist_type', 'km') == 'm' ? 'selected' : null);?>><?php echo JText::_('G_M');?></option>
		</select>
		<input type="button" class="button" value="<?php echo JText::_('G_SET');?>"	onclick="setCircleRadius()">

		<button class="map-button button" type="button" id="cur_loc"
			onclick="currpos()"><?php echo JText::_('G_MARKERCURRENTLOCATION');?></button>
	</div>

	<div id="map_canvas_<?php echo $this->id;?>" style="width:<?php echo $this->params->get('params.map_width', '100%');?>; height:<?php echo $this->params->get('params.map_height', '200px');?>; margin:15px 0px">

</div>
<p class="small"><?php echo JText::_('G_DRAGMARKER');?></p>
<?php echo $this->_input_f('position', 'lat', 'hidden');?>
<?php echo $this->_input_f('position', 'lng', 'hidden');?>
<?php echo $this->_input_f('position', 'zoom', 'hidden');?>

<?php echo $this->_input_f('bounds', 'sw_lat', 'hidden');?>
<?php echo $this->_input_f('bounds', 'sw_lng', 'hidden');?>
<?php echo $this->_input_f('bounds', 'ne_lat', 'hidden');?>
<?php echo $this->_input_f('bounds', 'ne_lng', 'hidden');?>

<?php echo $this->_input_f('position', 'address', 'hidden');?>

<script type="text/javascript">
	var fLatlng = null;
	var Fgeocoder = new google.maps.Geocoder();
	var Fmap = new google.maps.Map($('map_canvas_<?php echo $this->id;?>'), {mapTypeId: google.maps.MapTypeId.ROADMAP});

	var Fmarker = new google.maps.Marker({
		'position' : fLatlng,
		'map' : Fmap,
		'cursor' : 'move',
		'draggable' : true
	});

	getFInitialPosition();

	//Add a Circle overlay to the map.
	var Fcircle = new google.maps.Circle({
		map: Fmap,
		radius: <?php echo ($radius * ($default->get('dist_type', 'km') == 'km' ? 1000 : 1));?>,
		fillColor: '#000000',
		fillOpacity: 0.2,
		strokeColor: '#000000',
		strokeOpacity: 0.5,
		strokeWeight: 1
	});
	Fcircle.bindTo('center', Fmarker, 'position');
	Fmap.fitBounds(Fcircle.getBounds());

	google.maps.event.addListener(Fmap, 'click', function(event) {
		$('cur_loc').removeProperty('disabled').setStyle('background', '');
		Fmarker.setPosition(event.latLng);
		setHiddenPosition(event.latLng);
		setCircleRadius () ;
	});

	google.maps.event.addListener(Fmap, 'zoom_changed', function(event) {
		$('f_position_zoom').value = Fmap.getZoom();
	});

	google.maps.event.addListener(Fmarker, 'drag', function(event) {
	});
	google.maps.event.addListener(Fmarker, 'dragend', function(event) {
		$('cur_loc').removeProperty('disabled').setStyle('background', '');
		setHiddenPosition(event.latLng);
		setCircleRadius();
	});

	function getFInitialPosition()
	{
		fLatlng = new google.maps.LatLng(<?php echo $default->get('position.lat', $this->params->get('params.map_lat', '42.293564192170095'));?>, <?php echo $default->get('position.lng', $this->params->get('params.map_lng', '-33.33983659744263'));?>);

		var szoom = <?php echo $default->get('position.zoom', $this->params->get('params.map_zoom', 2));?>;
		<?php if(!$default->get('position.lat') && !$default->get('position.lng')):?>
			if(geoip_latitude() && geoip_longitude())
			{
				fLatlng = new google.maps.LatLng(geoip_latitude(), geoip_longitude());
			}
			else if(geoip_country_name() || geoip_city())
			{
				var ipad = [];
				if(geoip_city())
				{
					ipad.push(geoip_city());
				}
				if(geoip_region_name())
				{
					ipad.push(geoip_region_name());
				}
				if(geoip_country_name())
				{
					ipad.push(geoip_country_name());
				}
				if(geoip_postal_code())
				{
					ipad.push(geoip_postal_code());
				}
				geocoder.geocode({ 'address': ipad.join(', ')}, function(results, status) {
					if (status == google.maps.GeocoderStatus.OK) {
						console.log(results[0].geometry.location.lat());
						fLatlng = new google.maps.LatLng(results[0].geometry.location.lat(), results[0].geometry.location.lng());
						Fmap.setCenter(fLatlng);
						Fmarker.setPosition(fLatlng);
					}
				});
			}
			szoom = 7;
		<?php endif;?>
		Fmap.setZoom(szoom);
		Fmap.setCenter(fLatlng);
		Fmarker.setPosition(fLatlng);
	}
		var Fgl;

	function setCircleRadius()
	{
		Fmarker.setVisible(true);
		Fcircle.setVisible(true);

		var value = $('filters<?php echo $this->key;?>radius').value.toInt();

		if($('filters<?php echo $this->key;?>dist_type').value == 'km')
		{
			value = value * 1000;
		}

		Fcircle.setOptions({
			fillColor: '#000000',
			fillOpacity: 0.3,
			strokeColor: '#000000',
			strokeOpacity: 0.8,
			strokeWeight: 2
		});
		Fcircle.setRadius( value );
		var bounds = Fcircle.getBounds();

 		$('f_bounds_sw_lng').value = bounds.getSouthWest().lng();
 		$('f_bounds_sw_lat').value = bounds.getSouthWest().lat();
 		$('f_bounds_ne_lng').value = bounds.getNorthEast().lng();
 		$('f_bounds_ne_lat').value = bounds.getNorthEast().lat();

		Fmap.fitBounds(bounds);

		Fgeocoder.geocode({'latLng': Fmap.getCenter()}, function(results, status) {
			if (status == google.maps.GeocoderStatus.OK) {
				$('f_position_address').value = ($('filters<?php echo $this->key;?>dist_type').value == 'm') ? results[0].formatted_address : results[2].formatted_address;
			}
		});

		resetMarker();
		resetCountry();
	}

	function setHiddenPosition(latlong)
	{
		$('f_position_lat').value = latlong.lat();
		$('f_position_lng').value = latlong.lng();
		$('f_position_zoom').value = Fmap.getZoom();
	}

	function currpos()
	{
		$('cur_loc').set('disabled', 'disabled').setStyle('background', 'url("<?php echo JURI::root();?>media/mint/js/mooupload/imgs/load_bg_blue.gif")');
		Fgl.getCurrentPosition(displayPosition, displayError);
	}

	function displayPosition(position) {
		latlong = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
		Fmarker.setPosition(latlong);
		Fmap.setCenter(latlong);
		Fmap.setZoom(15);
		setHiddenPosition(latlong);
		$('cur_loc').removeProperty('disabled').setStyle('background', '');
	}

	function displayError(positionError) {
	 	alert('Browser not supported');
		$('cur_loc').removeProperty('disabled').setStyle('background', '');
		$('cur_loc').setStyle('display', 'none');
	}

	try {
		if (typeof navigator.geolocation === 'undefined'){
			Fgl = google.gears.factory.create('beta.geolocation');
		} else {
			Fgl = navigator.geolocation;
		}
	} catch(e) {}

	if (!Fgl) {
		$('cur_loc').setStyle('display', 'none');
	}
</script>
<?php endif; ?>

<?php if (in_array($this->params->get('params.filter_address', 0), $this->user->getAuthorisedViewLevels()) && $this->params->get('params.address.country.show')) : ?>
	<?php 	echo JHtml::_('sliders.panel', JText::_('G_FILTERBYADDRESS'), 'addr-f');?>
	<div style="margin: 15px 0px" id="filter<?php echo $this->key;?>">
		<?php echo $this->_getChilds(array('index' => 'country', 'section_id' => $section->id));?>
		<?php if (!empty($this->value['country'])) :?>
			<?php $list = $this->_getChilds(array('index' => 'state', 'section_id' => $section->id, 'value' => $this->value['country'], 'country' => $this->value['country']));?>
			<?php if ($list != ' '): ?>
				<span id="state<?php echo $this->key;?>"><?php echo $list;?></span>
			<?php endif;?>
		<?php endif;?>
		<?php if (!empty($this->value['state'])):
			$list = $this->_getChilds(array('country' => @$this->value['country'], 'index' => 'city', 'section_id' => $section->id, 'value' => @$this->value['state']));
			if ($list != ' '):?>
				<span id="city<?php echo $this->key;?>"><?php echo $list;?></span>
			<?php endif;?>
		<?php endif; ?>
	</div>
	<div style="clear: both;"></div>
	<script type="text/javascript">
		function getChilds(val, child)
		{
			var fid = '<?php echo $this->key ?>';

			resetMap();
			resetMarker();

			if(!child) return;

			if($(child + fid) && val == 0)
			{
				$(child + fid).destroy();
				return;
			}

			if (child == 'state' && $('city' + fid) && $('filters' + fid + 'country').value == 0)
			{
				$('city' + fid).destroy();
				return;
			}

			new Request.JSON({
				url : '<?php echo JURI::root();?>index.php?option=com_cobalt&task=ajax.field_call&no_html=1',
				method : 'post',
				autoCancel : true,
				data : {
					field_id : <?php echo $this->id; ?>,
					func : '_getChilds',
					field : 'geo',
					value : val,
					country : ($('filters' + fid + 'country') == undefined ? 0 : $('filters' + fid + 'country').value),
					index : child,
					section_id : <?php echo $section->id; ?>,
					ajax : true
				},
				onComplete : function(json)
				{

					if(json == undefined)
					{
						return;
					}

					if (!json.success)
					{
						alert(json.error);
						return;
					}
					if ($(child + fid))
						$(child + fid).destroy();
					if (child == 'state' && $('city' + fid))
						$('city' + fid).destroy();
					var sp = new Element('span', {
						id : child + fid
					});
					sp.set('html', json.result);
					$('filter' + fid).grab(sp);
				}
			}).send();
		};
	</script>
<?php endif; ?>

<?php if(count($this->markers) > 1): ?>
	<?php 	echo JHtml::_('sliders.panel', JText::_('G_FILTERBYMARKER'), 'mark-f');?>
	<style>
	.filter-marker {
		cursor: pointer;
	}
	.filter-marker.active {
		border:2px solid grey;
	}
	</style>
	<div style="margin: 15px 0px">
		<?php echo $this->_input_f('marker', 'name', 'hidden');?>
		<?php foreach ($this->markers AS $marker):?>
			<img id="mrk-<?php echo md5($marker);?>" class="filter-marker<?php if($default->get('marker.name') == $marker){$active = $marker; echo ' active';}?>" onclick="filterMarker(this, '<?php echo $marker;?>')" class="hasTip" title="<?php echo $this->_getMarkerName($marker)?>" src="<?php echo JURI::root()?>components/com_cobalt/fields/geo/markers/<?php echo $this->params->get('params.map_icon_src', 'custom');?>/<?php echo $marker;?>" >
		<?php endforeach;?>
	</div>
	<script>
		function filterMarker(el, file)
		{
			$$('img.active').removeClass('active');
			el.addClass('active');
			$('f_marker_name').value = file;
			resetMap();
			resetCountry();
		}
	</script>
<?php endif;?>
<?php echo JHtml::_('sliders.end');?>
<script>
	function resetMarker()
	{
		if($('f_marker_name'))
		{
			$('f_marker_name').value = '';
			$$('img.active').removeClass('active');
		}
	}

	function resetMap()
	{
		if($('filters<?php echo $this->key;?>radius'))
		{
			$('f_bounds_sw_lng').value = '';
 			$('f_bounds_sw_lat').value = '';
 			$('f_bounds_ne_lng').value = '';
 			$('f_bounds_ne_lat').value = '';
		}

		if(Fcircle)
		{
			Fcircle.setOptions({
				fillColor: '#000000',
				fillOpacity: 0.2,
				strokeColor: '#000000',
				strokeOpacity: 0.5,
				strokeWeight: 1
			});
		}
	}
	function resetCountry()
	{

		if($('filters<?php echo $this->key;?>country'))
		{
			$('filters<?php echo $this->key;?>country').value = 0;
			if ($('state<?php echo $this->key;?>'))
			{
				$('state<?php echo $this->key;?>').destroy();
			}
			if ($('city<?php echo $this->key;?>'))
			{
				$('city<?php echo $this->key;?>').destroy();
			}
		}
		if ($('filters<?php echo $this->key;?>state'))
		{
			$('filters<?php echo $this->key;?>state').value = 0;
			if ($('city<?php echo $this->key;?>'))
			{
				$('city<?php echo $this->key;?>').destroy();
			}
		}
		if ($('filters<?php echo $this->key;?>city'))
		{
			$('city<?php echo $this->key;?>').value = 0;
		}
	}
</script>
