<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();
$contacts = $links = $link_list = $contact_list = $adr_list = array();
?>
<style>
.marker-icon {
	display: block;
	float: left;
	text-decoration: none;
	margin-right: 8px;
	padding: 2px;

}
</style>
<?php if(in_array($this->params->get('params.adr_enter'), $this->user->getAuthorisedViewLevels())):?>
	<?php
	$format = '<li class="adrlist-%s" style="width:%s%%">%s<br />%s</li>';
	$address = $this->getAddressFields();
	foreach($address as $name => $adr)
	{
		if(! $this->params->get('params.address.' . $name . '.show', 1))
		{
			continue;
		}
		$input = $this->_input('address', $name);
		$adr_list[$name] = sprintf($format, $name, $adr['width'], $this->_label('address', $name, $adr['label']), $input);
	}
	?>
	<?php if($adr_list):?>
<h5><?php echo JText::_("G_ADDRESS");?></h5>
<ul class="address-list"><?php echo implode(' ', $adr_list);?></ul>
<?php endif;?>

	<?php
	$format = '<tr><td nowrap="nowrap" width="1%%">%s %s</td><td>%s</td></tr>';
	$links = $this->getAditionalinks();
	$contacts = $this->getAditionalFields();

	foreach($contacts as $name => $contact)
	{
		if(! $this->params->get('params.contacts.' . $name . '.show', 1))
		{
			continue;
		}
		$input = $this->_input('contacts', $name);
		$group = 'contacts';
		if($contact['label'] == JText::_('G_SKYPE'))
		{
			$contact['icon'] = JURI::root() . 'components/com_cobalt/fields/geo/icons/skype.png';
		}
		$contact_list[] = sprintf($format, JHtml::image($contact['icon'], $contact['label']), $this->_label('contacts', $name, $contact['label']), $input);
	}
	?>
	<?php if($contact_list):?>
<h5><?php echo JText::_("G_INSTANTCONTACTS");?></h5>
<table class="category" width="99%"><?php echo implode(' ', $contact_list);?></table>
<?php endif;?>

	<?php
	foreach($links as $name => $link)
	{
		if(! $this->params->get('params.links.' . $name . '.show', 1))
		{
			continue;
		}
		$input = $this->_input('links', $name);
		$link_list[] = sprintf($format, JHtml::image($link['icon'], $link['label']), $this->_label('links', $name, $link['label']), $input);
	}
	?>
	<?php if($link_list):?>
<h5><?php echo JText::_("G_LINKS");?></h5>
<table class="category" width="99%"><?php echo implode(' ', $link_list);?></table>
<?php endif; ?>

<?php endif;?>

<?php if(in_array($this->params->get('params.map_marker'), $this->user->getAuthorisedViewLevels())):?>
	<?php
	JFactory::getDocument()->addScript('http://maps.googleapis.com/maps/api/js?key=' . $this->params->get('params.map_key') . '&sensor=true');
	JFactory::getDocument()->addScript('http://j.maxmind.com/app/geoip.js');
	$default = new JRegistry($this->value);
	?>
<div style="clear: both"></div>
<h5><?php echo JText::_('G_MAP');?></h5>
<p>
	<button class="map-button" type="button" id="adr_loc"
		onclick="addrespos()"><?php echo JText::_('G_MARKERFROMADDRESS');?></button>
	<button class="map-button" type="button" id="cur_loc"
		onclick="currpos()"><?php echo JText::_('G_MARKERCURRENTLOCATION');?></button>
</p>
<div id="map_canvas_<?php echo $this->id;?>" style="width:<?php echo $this->params->get('params.map_width', '100%');?>; height:<?php echo $this->params->get('params.map_height', '200px');?>"></div>
<p class="small"><?php echo JText::_('G_DRAGMARKER');?></p>
<?php echo $this->_input('position', 'lat', 'hidden');?>
<?php echo $this->_input('position', 'lng', 'hidden');?>
<?php echo $this->_input('position', 'zoom', 'hidden');?>

<?php
	$dir = JPATH_ROOT.DS.'components'.DS.'com_cobalt'.DS.'fields'.DS.'geo'.DS.'markers'.DS.$this->params->get('params.map_icon_src', 'custom');
	$path = 'components/com_cobalt/fields/geo/markers/'.$this->params->get('params.map_icon_src', 'custom').'/';
?>

<?php if(in_array($this->params->get('params.map_whoicon'), $this->user->getAuthorisedViewLevels())):?>
	<h5><?php echo JText::_('G_MARKER');?></h5>
	<?php echo $this->_input('position', 'marker', 'hidden');?>
	<div style="max-height:120px;width:100%;overflow-x:hidden;overflow-y:scroll">
		<?php
		$format = '<a class="marker-icon" href="javascript:void(0)" onclick="setMapMarker%d(\'%s\')">%s %s</a>';
		if (is_dir($dir)) {
			if ($dh = opendir($dir)) {
				while (($file = readdir($dh)) !== false) {
					$ext = strtolower(substr($file, strrpos($file, '.')+1));
					if($ext == 'png' || $ext == 'gif')
					{
						$img = JHTML::image(JURI::root().$path.$file, JText::_('CICONCLICKINSERT'), array('align' => 'absmiddle'));
						echo sprintf($format, $this->id, $file, $img, $this->_getMarkerName($file));
					}

				}
				closedir($dh);
			}
		}
		?>
	</div>
<?php endif;?>

<script type="text/javascript">
		<?php if(count($adr_list) <= 0): ?>
		$('adr_loc').setStyle('display', 'none');
		<?php endif;?>
		var myLatlng = null;
		var geocoder = new google.maps.Geocoder();
		var map = new google.maps.Map($('map_canvas_<?php echo $this->id;?>'), {mapTypeId: google.maps.MapTypeId.ROADMAP});

		var marker = new google.maps.Marker({
			'position' : myLatlng,
			'map' : map,
			'cursor' : 'move',
			'draggable' : true
		});

		getInitialPosition();

		<?php if(substr($this->params->get('params.map_style'), -5) == '.json') : ?>
			var mapStyle = <?php echo JFile::read(JPATH_ROOT . DS . 'components/com_cobalt/library/js/mapstyles/' . $this->params->get('params.map_style'));?>;
			map.setOptions({styles: mapStyle});
		<?php endif; ?>


		$('cur_loc').removeProperty('disabled').setStyle('background', '');
		$('adr_loc').removeProperty('disabled').setStyle('background', '');

		google.maps.event.addListener(map, 'click', function(event) {
			$('cur_loc').removeProperty('disabled').setStyle('background', '');
			$('adr_loc').removeProperty('disabled').setStyle('background', '');
			marker.setPosition(event.latLng);
			setHiddenPosition(event.latLng);
		});

		google.maps.event.addListener(map, 'zoom_changed', function(event) {
			$('f<?php echo $this->id; ?>_position_zoom').value = map.getZoom();
		});

		google.maps.event.addListener(marker, 'drag', function(event) {
			$('cur_loc').removeProperty('disabled').setStyle('background', '');
			$('adr_loc').removeProperty('disabled').setStyle('background', '');
			setHiddenPosition(event.latLng);
		});

		var gl;

		function setMapMarker<?php echo $this->id;?>(file)
		{
			$('f<?php echo $this->id; ?>_position_marker').value = file;
			setDefaultMarker(file);
		}

		function setDefaultMarker(file)
		{
			var msize = new google.maps.Size(32, 37);
			var mpoint = new google.maps.Point(16, 37);
			var markerIcon = new google.maps.MarkerImage('<?php echo JURI::root().$path;?>' + file, msize, new google.maps.Point(0,0), mpoint);

			marker.setIcon(markerIcon);
		}

		function setHiddenPosition(latlong)
		{
			$('f<?php echo $this->id; ?>_position_lat').value = latlong.lat();
			$('f<?php echo $this->id; ?>_position_lng').value = latlong.lng();
			$('f<?php echo $this->id; ?>_position_zoom').value = map.getZoom();
		}

		function getInitialPosition()
		{
			myLatlng = new google.maps.LatLng(<?php echo $default->get('position.lat', $this->params->get('params.map_lat', '42.293564192170095'));?>, <?php echo $default->get('position.lng', $this->params->get('params.map_lng', '-33.33983659744263'));?>);
			map.setCenter(myLatlng);

			var szoom = <?php echo $default->get('position.zoom', $this->params->get('params.map_zoom', 2));?>;
			<?php if(!$default->get('position.lat') && !$default->get('position.lng')):?>
				if(geoip_latitude() && geoip_longitude())
				{
					myLatlng = new google.maps.LatLng(geoip_latitude(), geoip_longitude());
					map.setCenter(myLatlng);
				}
				else if(geoip_country_name() || geoip_city())
				{
					var ipad = [];
					if(geoip_city())
					{
						ipad.push(geoip_city());
					}
					if(geoip_region_name())
					{
						ipad.push(geoip_region_name());
					}
					if(geoip_country_name())
					{
						ipad.push(geoip_country_name());
					}
					if(geoip_postal_code())
					{
						ipad.push(geoip_postal_code());
					}
					geocoder.geocode({ 'address': ipad.join(', ')}, function(results, status) {
						if (status == google.maps.GeocoderStatus.OK) {
							console.log(results[0].geometry.location.lat());
							myLatlng = new google.maps.LatLng(results[0].geometry.location.lat(), results[0].geometry.location.lng());
							map.setCenter(myLatlng);
							marker.setPosition(myLatlng);
						}
					});
				}
				szoom = 7;
			<?php endif;?>
			map.setZoom(szoom);
			marker.setPosition(myLatlng);
		}
		function addrespos()
		{
			$('cur_loc').removeProperty('disabled').setStyle('background', '');
			$('adr_loc').set('disabled', 'disabled').setStyle('background', 'url("<?php JURI::root();?>media/mint/js/mooupload/imgs/load_bg_blue.gif")');
			var address = [];
			<?php if(isset($adr_list['address1'])):?>
			if($('f<?php echo $this->id; ?>_address_address1').value)
			{
				address.push($('f<?php echo $this->id; ?>_address_address1').value);
			}
			<?php endif;?>
			<?php if(isset($adr_list['city'])) : ?>
			if($('f<?php echo $this->id; ?>_address_city').value)
			{
				address.push($('f<?php echo $this->id; ?>_address_city').value);
			}
			<?php endif; ?>
			<?php if(isset($adr_list['state'])): ?>
			if($('f<?php echo $this->id; ?>_address_state').value)
			{
				address.push($('f<?php echo $this->id; ?>_address_state').value);
			}
			<?php endif;?>
			<?php if(isset($adr_list['zip'])):?>
			if($('f<?php echo $this->id; ?>_address_zip').value)
			{
				address.push($('f<?php echo $this->id; ?>_address_zip').value);
			}
			<?php endif; ?>
			<?php if(isset($adr_list['country'])):?>
			if($('f<?php echo $this->id; ?>_address_country').value)
			{
				address.push($('f<?php echo $this->id; ?>_address_country').value);
			}
			<?php endif; ?>
			if(!address.join(''))
			{
				alert("<?php echo addslashes(JText::_('G_ENTERADDRESS'));?>");
				$('adr_loc').removeProperty('disabled').setStyle('background', '');
				return;
			}

			geocoder.geocode({ 'address': address.join(', ')}, function(results, status) {
				if (status == google.maps.GeocoderStatus.OK) {
					marker.setPosition(results[0].geometry.location);
					map.setCenter(results[0].geometry.location);
					map.setZoom(15);
					setHiddenPosition(results[0].geometry.location);
				} else {
					alert("<?php echo addslashes(JText::_('G_GEONOTSUCCESSFUL'));?> " + status);
				}
				$('adr_loc').removeProperty('disabled').setStyle('background', '');
			});

		}

		function currpos()
		{
			$('adr_loc').removeProperty('disabled').setStyle('background', '');
			$('cur_loc').set('disabled', 'disabled').setStyle('background', 'url("<?php echo JURI::root();?>media/mint/js/mooupload/imgs/load_bg_blue.gif")');
			gl.getCurrentPosition(displayPosition, displayError);
		}

		function displayPosition(position) {
			latlong = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
			console.log(latlong.lat());
			marker.setPosition(latlong);
			map.setCenter(latlong);
			map.setZoom(15);
			setHiddenPosition(latlong);
			$('cur_loc').removeProperty('disabled').setStyle('background', '');
		}

		function displayError(error) {
			switch(error.code) {
				case error.TIMEOUT:
					doFallback();
					gl.getCurrentPosition(displayPosition, displayError);
				break;
			};
		 	//alert(error.message);
		 	alert('Browser not supported');
			$('cur_loc').removeProperty('disabled').setStyle('background', '');
			$('cur_loc').setStyle('display', 'none');
		}

		try {
			gl = navigator.geolocation;
		} catch(e) {}

		if (!gl) {
			$('cur_loc').setStyle('display', 'none');
		}
		<?php if($default->get('position.marker')):?>
		setDefaultMarker('<?php echo $default->get('position.marker');?>');
		<?php endif;?>
	 </script>
<?php endif;?>