<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();
require_once JPATH_ROOT.DS.'components/com_cobalt/library/php/fields/cobaltfield.php';

class JFormFieldCImage extends CFormField
{
	static $_loaded = false;

	public function getInput()
	{
		$params = $this->params;
		$user = JFactory::getUser();
		$doc = JFactory::getDocument();
		JHtml::_('behavior.modal');
		$this->directory = str_replace('\\', '/', $params->get('params.directory', 'images')).'/';

		if(is_string($this->value))
		{
			$this->value = json_decode($this->value, true);
			if(!is_array($this->value))
			{
				settype($this->value, 'array');
			}
		}
		return $this->_display_input();
	}

	public function onJSValidate()
	{
	}

	public function validate($value, $record, $type, $section)
	{
		return parent::validate($value, $record, $type, $section);
	}

	public function onStoreValues($record)
	{
		return array();
	}
	public function onPrepareSave($value, $record, $type, $section)
	{
		if ($value)
		{
			$value = json_encode($value);
			return $value;
		}
	}

	public function onRenderFull($record, $type, $section)
	{
		$user = JFactory::getUser();
		if (!$this->value)
			return;

		$value = json_decode($this->value, true);
		if (!$value)
			return;
		$out = null;
		$directory = str_replace('\\', '/', $this->params->get('params.directory', 'images')).'/';

		if($this->params->get('params.select_type', 0))
		{
			$directory = '';
		}

		if(!$value['image'] && $this->params->get('params.default_img', 0))
		{
			$directory = '';
			$value['image'] = str_replace('\\', '/', $this->params->get('params.default_img'));
		}

		if ($value['image'])
		{
			$this->value = $value;

			$this->directory = $directory;
			return $this->_display_output('full', $record, $type, $section);
		}
		return;

	}

	public function onRenderList($record, $type, $section)
	{
		$value = $this->value;
		if(is_string($value))
		{
			$value = json_decode($value, true);
		}
		if (!isset($value['image']) || !$value['image'])
		{
			return;
		}

		$user = JFactory::getUser();
		$out = null;

		$directory = str_replace('\\', '/', $this->params->get('params.directory', 'images')).'/';

		if($this->params->get('params.select_type', 0))
		{
			$directory = '';
		}

		$this->value = $value;
		$this->directory = $directory;
		return $this->_display_output('list', $record, $type, $section);

	}
}
