<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();
?>

<?php

$value = $this->value;

$size = $this->params->get('params.full_mode', 0);
if ($size)
{
	$width = $this->params->get('params.thumbs_width', 100);
	$height = $this->params->get('params.thumbs_height', 100);
	$quality = $this->params->get('params.thumbs_quality', 80);
	$stretch = $this->params->get('params.thumbs_stretch', 0);
	$mode = $this->params->get('params.thumbs_mode', 1);
	
	jimport('mint.resizeimage');
	$this->resizer = new JS_Image_Resizer();
	$this->path = JComponentHelper::getParams('com_cobalt')->get('general_upload') . DS . 'thumbs_cache' . DS . 'image' . DS;
	if (!JFolder::exists($this->path))
	{
		JFolder::create($this->path, 0777);
		JFile::write($this->path . DS . 'index.html', $index = '<html><body></body></html>');
	}
	$root = JPath::clean(JComponentHelper::getParams('com_cobalt')->get('general_upload'));
	$url = str_replace(JPATH_ROOT, '', $root);
	$url = str_replace("\\", '/', $url);
	$url = preg_replace('#^\/#iU', '', $url);
	$this->url = JURI::root() . str_replace("//", "/", $url);
	
	$ext = JFile::getExt($value['image']);
	$new_name = md5($value['image'] . 'image' . $width . $height . $mode . $quality . $stretch . $this->id) . '.' . $ext;
	$img = $this->path . DS . $new_name;
	
	if (!JFile::exists($img))
	{
		$this->resizer->stretch_if_smaller = $stretch;
		$this->resizer->quality = $quality;
		$this->resizer->setImage(JPATH_ROOT . DS . $value['image']);
		switch ($mode)
		{
			case 1 :
				$this->resizer->resize_crop($width, $height, $img);
				break;
			case 2 :
				$this->resizer->resize_fit($width, $height, $img);
				break;
			case 3 :
				$this->resizer->resize($width, $height, $img);
				break;
			case 4 :
				$this->resizer->resizeByWidth($width, $img);
				break;
			case 5 :
				$this->resizer->resizeByHeight($height, $img);
				break;
			case 6 :
				$this->resizer->resize_limitwh($width, $height, $img);
				break;
		}
	}
	$url = sprintf('%s/thumbs_cache/image/%s', $this->url, $new_name);
}
else
{
	$value['image'] = str_replace(DS, '/', $value['image']);
	$url = JURI::base() . $value['image'];
}

$doc = JFactory::getDocument();
$doc->addStyleSheet(JURI::root() . 'components/com_cobalt/fields/image/css/image.css');
$html_img = JHTML::image($url, $value['image_title'], array('hspace' => $this->params->get('params.img_hspace'), 'vspace' => $this->params->get('params.img_vspace'), 'title' => $value['image_title'], 'class' => $this->params->get('core.field_class')));
?>

<?php if ($this->params->get('params.allow_caption', 0)) : ?>
	<table class="imageTable <?php echo $this->params->get('core.field_class', '');?>">
		<tr>
			<td><?php echo $html_img;?></td>
		</tr>
		<tr>
			<td><?php echo $value['image_title'];?></td>
		</tr>
	</table>
<?php else : ?>
	<?php echo $html_img;?>
<?php endif; ?>