<?php
/**
 * @package AkeebaBackup
 * @copyright Copyright (c)2009-2012 Nicholas K. Dionysopoulos
 * @license GNU General Public License version 3, or later
 *
 */
defined('_JEXEC') or die();

jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

class Com_CobaltInstallerScript
{

	// $type Installation type (install, update, discover_install)
	public function preflight($type, $parent)
	{
		if(in_array($type, array(
			'install', 
			'discover_install'
		)))
		{
			$this->_cleanAssets();
			$this->_cleanExtensions();
			$this->_cleanMenu();
		}
		else
		{
			$this->_bugfixCantBuildAdminMenus();
		}
		
		// Only allow to install on Joomla! 2.5.0 or later
		return version_compare(JVERSION, '2.5.0', 'ge');
	}

	function postflight($type, $parent)
	{
		$db = JFactory::getDbo();
		
		$query = $db->getQuery(true);
		$query->update('#__extensions');
		$query->set('enabled = 1');
		$query->where("`folder` = 'mint'");
		$query->where("`type` = 'plugin'");
		
		$db->setQuery($query);
		$db->query();
		
		$query = $db->getQuery(true);
		$query->update('#__extensions');
		$query->set('enabled = 1');
		$query->where("`element` LIKE '%mod_cobalt_'");
		$query->where("`type` = 'module'");
		
		$db->setQuery($query);
		$db->query();
	}

	function uninstall($parent)
	{
		$this->_cleanAssets();
		$this->_cleanExtensions();
		$this->_cleanMenu();
	}

	private function _cleanExtensions()
	{
		$db = JFactory::getDbo();
		
		$query = $db->getQuery(true);
		$query->delete('#__extensions')->where($db->qn('element') . ' = ' . $db->q('com_cobalt'));
		$db->setQuery($query);
		$db->query();
	
	}

	private function _cleanMenu()
	{
		$db = JFactory::getDbo();
		
		$query = $db->getQuery(true);
		$query->delete('#__menu')
			->where($db->qn('type') . ' = ' . $db->q('component'))
			->where($db->qn('menutype') . ' = ' . $db->q('main'))
			->where($db->qn('link') . ' LIKE ' . $db->q('index.php?option=com_cobalt%'));
		$db->setQuery($query);
		$db->query();
	}

	private function _cleanAssets()
	{
		$db = JFactory::getDbo();
		
		$query = $db->getQuery(true);
		$query->delete('#__assets')->where($db->qn('name') . ' = ' . $db->q('com_cobalt'));
		$db->setQuery($query);
		$db->query();
	}

	/**
	 * Joomla! 1.6+ bugfix for "Can not build admin menus"
	 */
	private function _bugfixCantBuildAdminMenus()
	{
		$db = JFactory::getDbo();
		
		// If there are multiple #__extensions record, keep one of them
		$query = $db->getQuery(true);
		$query->select('extension_id')
			->from('#__extensions')
			->where($db->qn('element') . ' = ' . $db->q('com_cobalt'));
		$db->setQuery($query);
		$ids = $db->loadColumn();
		if(count($ids) > 1)
		{
			asort($ids);
			$extension_id = array_shift($ids); // Keep the oldest id
			
			$query = $db->getQuery(true);
			$query->delete('#__extensions')->where($db->qn('extension_id') . ' != ' . $db->q($extension_id));
			
			$db->setQuery($query);
			$db->query();
		}
		
		// If there are multiple assets records, delete all except the oldest one
		$query = $db->getQuery(true);
		$query->select('id')
			->from('#__assets')
			->where($db->qn('name') . ' = ' . $db->q('com_cobalt'));
		$db->setQuery($query);
		$ids = $db->loadObjectList();
		if(count($ids) > 1)
		{
			asort($ids);
			$asset_id = array_shift($ids); // Keep the oldest id
			
			$query = $db->getQuery(true);
			$query->delete('#__assets')->where($db->qn('id') . ' != ' . $db->q($asset_id));
			
			$db->setQuery($query);
			$db->query();
		}
		
		$this->_cleanMenu();
	}
}