<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();
require_once JPATH_ROOT . DS . 'components/com_cobalt/library/php/fields/cobaltselectable.php';

class JFormFieldCListautocomplete extends CFormFieldSelectable
{

	public function getInput()
	{
		if (!is_array($this->value))
		{
			$this->value = explode(',', $this->value);
		}
		if ($this->params->get('params.sql_source'))
		{
			/*$db = JFactory::getDbo();
			$db->setQuery($this->params->get('params.sql'));
			$list = $db->loadObjectList();*/
			$list = array();
		}
		else
		{
			$list = explode("\n", str_replace("\r", "", $this->params->get('params.values', '')));
			$list = array_values($list);
			settype($list, 'array');
		}
		foreach($list as $k => &$item)
		{
			if (is_string($item))
				$c = explode('^', $item);
			
			if (isset($c[1]))
			{
				if (in_array($item, $this->value))
				{
					$key = array_search($item, $this->value);
					$this->value[$key] = JHtml::_('mrelements.autocompleteitem', "<b style=\"color:{$c[1]}\">".JText::_($c[0])."</b>", $item);
				}
				
				$item = JHtml::_('mrelements.autocompleteitem', "<b style=\"color:{$c[1]}\">".JText::_($c[0])."</b>", $item);
				continue;
			}
			
			if ($this->params->get('params.sql_source'))
			{
				$list[$k]->html = $list[$k]->render = $list[$k]->plain = $item->text;
				unset($list[$k]->text);
			
			}
			else
			{
				$item = $c[0];
			}
		
		}
		$options['max_width'] = $this->params->get('params.max_width', 400);
		$options['min_width'] = $this->params->get('params.min_width', 300);
		$options['coma_separate'] = $this->params->get('params.coma_separate', 0);
		$options['only_values'] = $this->params->get('params.only_values', 0);
		$options['min_length'] = $this->params->get('params.min_length', 1);
		$options['max_result'] = $this->params->get('params.max_result', 10);
		$options['case_sensitive'] = $this->params->get('params.case_sensitive', 0);
		$options['highlight'] = $this->params->get('params.highlight', 1);
		$options['max_items'] = $this->params->get('params.max_items', 0);
		$options['unique'] = $this->params->get('params.unique', 0);
		
		if ($this->params->get('params.sql_source'))
		{
			$options['ajax_url'] = 'index.php?option=com_cobalt&task=ajax.field_call&no_html=1';
			$options['ajax_data'] = "field_id: {$this->id}, func: 'onGetSqlValues', field: 'listautocomplete'";
		}

		if($this->isnew && $this->params->get('params.default_val'))
		{
			$this->value[] = $this->params->get('params.default_val');
		}

		
		$this->inputvalue = JHtml::_('mrelements.listautocomplete', "jform[fields][{$this->id}]", "field_" . $this->id, $this->value, $list, $options);
		return $this->_display_input();
	}

	public function onJSValidate()
	{
		if ($this->required)
		{
			$text = addslashes(JText::sprintf("CFIELDREQUIRED", $this->label));
			return "\n\t\tif(!$('field_{$this->id}').value){isValid = false; errorText.push('{$text}'); hfid.push({$this->id});}";
		}
	}

	public function validate($value, $record, $type, $section)
	{
		$count = explode(',', $value);
		if ($this->params->get('params.max_items', 0) && (count($count) > $this->params->get('params.max_items')))
		{
			$this->setError(JText::sprintf("L_ITEMSLIMITMSG", $this->label));
			return FALSE;
		}
		
		return parent::validate($value, $record, $type, $section);
	}

	public function onGetSqlValues($post)
	{
		$db = JFactory::getDbo();
		$db->setQuery($this->params->get('params.sql'));
		$list = $db->loadObjectList();
		foreach ($list as $k => $item)
		{
			$out[]= array($item->id, $item->text, $item->text, $item->text);
		}
		return $out;
	}
	
}
