<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('JPATH_PLATFORM') or die;

require_once JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_cobalt'.DS.'helpers'.DS.'templates.php';

jimport('joomla.html.html');
jimport('joomla.form.formfield');
JFormHelper::loadFieldClass('list');

class JFormFieldMersubtmpls extends JFormFieldList
{

	protected $type = 'Mersubtmpls';

	protected function getInput()
	{
		jimport( 'joomla.filesystem.folder' );
		jimport( 'joomla.filesystem.file'   );
		
		$document = JFactory::getDocument();
		$document->addScript(JURI::root().'administrator/components/com_cobalt/library/js/tmplselect.js');

		$tmpltype	    = $this->element['tmpltype'];
		$invite_label   = $this->element['invite_label'];
		$tmpl_select    	= $this->element['tmpl_select'];
		$multi    	= $this->element['multi'];

		if($multi) $multi = 'size="5" multiple="multiple"';
		$options = array();
		if((string)$this->element['select'] == '1')
		{
			$options[] =  JHTML::_('select.option', '', JText::_('CSELECTTEMPLATE'));
		}
		
		$options = array_merge($options, $this->getTmplObjectList( $tmpltype ));
		
		if($opts = $this->getOptions())
		{
		    if(!is_array($opts)) settype($opts, 'array');
		    foreach ($opts as $val)
		    {
		        $optn[] =  JHTML::_('select.option', strtolower($val), JText::_($val));
		    }
		    $options = array_merge($opts, $options);
		}

		$default = '';
		if($this->value)
		{
		    $img = '<img src="'.JURI::root().'administrator/components/com_cobalt/images/gear.png" border="0" valign="absmiddle"> ';
    	    if(!is_array($this->value))
    	    {
	    		$default = '&nbsp;<a rel="{handler: \'iframe\', size: {x: 800, y: 400} }" title="'.JText::_('CEDITTEMPLATESSETTINGS').'"
	    			onclick="return false;"
	    			href="index.php?option=com_cobalt&amp;view=templates&amp;layout=form&amp;cid[]=['.$this->value.'],['.$tmpltype.']&amp;tab=param-page0&amp;tmpl=component"
	    			title="'.$this->value.'"
	    			class="modal">'
	    		.$img
	    		//.$this->value
	    		.'</a>';
    	    }
    		else
    		{
    		    foreach ($this->value as $val)
        		   $default[] = '&nbsp;<a rel="{handler: \'iframe\', size: {x: 800, y: 400} }" title="'.JText::_('CEDITTEMPLATESSETTINGS').'"
        		   	onclick="return false;"
        		   	href="index.php?option=com_cobalt&amp;view=templates&amp;layout=form&amp;cid[]=['.$val.'],['.$tmpltype.']&amp;tab=param-page0&amp;tmpl=component"
        		   	title="'.$val.'"
        		   	class="modal">'
        		   .$img
        		   .$val
        		   .'</a>';
        		$default = implode('<br>', $default);
    		}
		}
		$javascript = ' onchange="addTmplEditLink(this.value, \''.$tmpltype.'\', this.id, \''.$this->element['multi'].'\')"';

		$doc = JFactory::getDocument();
		$doc->addScriptDeclaration(" var JURI_ROOT = '".JURI::root()."';\n");

		/*$out = '<table cellpading="0" border="0" cellspacing="0">
			<tr valign="top"><td width="80px">';
		$out .= JHTML::_('select.genericlist',  $options, $this->name.($multi ? '[]' : NULL), 'class="inputbox" '.$multi.$javascript, 'value', 'text', $this->value, "{$this->name}");
		$out .= '</td>
			<td><div id="'.str_replace(array(']', '['), '', $this->name).'_link">
			'.$default.'
		</div></td></tr></table>';*/
		$pattern  = '<div style="float:left">%s</div>';
		$pattern2 = '<div style="float:left"><div id="%s_link">%s</div></div>';
		$out = sprintf($pattern, JHTML::_('select.genericlist',  $options, $this->name.($multi ? '[]' : NULL), 'class="inputbox" '.$multi.$javascript, 'value', 'text', $this->value, "{$this->name}"));
		$out .= sprintf($pattern2, str_replace(array(']', '['), '', $this->name), $default);

		return $out;
	}

	function getTmplObjectList ($type)
	{
		$result = array();
		
		$layouts_path = MRtemplates::getTmplPath($type);
		$tmpl_mask = MRtemplates::getTmplMask($type);
		
		$files = JFolder::files($layouts_path, $tmpl_mask['index_file']);
		$exclude = explode(',', $this->element['exclude']);
		
		foreach ($files as $key => $file) {
			$tmplname = preg_replace($tmpl_mask['ident'], '', $file);
			if(in_array($tmplname, $exclude))
			{
				continue;
			}
			$result[] = JHTML::_('select.option', $tmplname, $tmplname);
		}
		
		return $result;
	}
}