<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();
require_once JPATH_ROOT.DS.'components/com_cobalt/library/php/fields/cobaltfield.php';
jimport('joomla.database.tablenested');

class JFormFieldCMultilevelselect extends CFormField
{

	public function getInput()
	{
		$params = $this->params;
		$doc = JFactory::getDocument();
		$user = JFactory::getUser();
		
		if($this->value && !is_array($this->value[0]))
		{
			$value = $this->value;
			$val = array();
			foreach ($value as $item)
			{
				$el = explode(';', $item);
				$item = array();
				foreach ($el as $level)
				{
					$level = explode(':', $level);
					$item[$level[0]] = $level[1];
				} 
				$val[] = $item;
			}
			$this->value = $val;
		}
		$this->labels = $params->get('params.labels');
		
		return $this->_display_input();		
	}

	public function onJSValidate()
	{
		$js = "\n\t\t" . 'var field = $$("[name^=\"jform[fields][' . $this->id . ']\"]");';
		if($this->required)
		{
			$js .= "\n\t\tif(!count(field){hfid.push({$this->id}); isValid = false; errorText.push('" . JText::sprintf("CFIELDREQUIRED", $this->label) . "');}";
		}
		if($this->params->get('params.total_limit'))
		{
			$js .= "\n\t\tif(selected > " . $this->params->get('params.total_limit') . ") {hfid.push({$this->id}); isValid = false; errorText.push('" . JText::sprintf("F_OPTIONSLIMIT", $this->params->get('params.total_limit')) . "');}";
		}
		return $js;
	}

	public function validate($value, $record, $type, $section)
	{
		if($this->params->get('params.total_limit'))
		{
			if(count($value) > $this->params->get('params.total_limit'))
			{
				$this->setError(JText::sprintf("F_VALUESLIMIT", $this->params->get('params.total_limit'), $this->label));
			}
		}
		
		return parent::validate($value, $record, $type, $section);
	}
	public function onPrepareFullTextSearch($value, $record, $type, $section)
	{
		$val = array();
		foreach ($value as $item)
		{
			$el = explode(';', $item);
			foreach ($el as $level)
			{
				$level = explode(':', $level);
				$val[] = $level[1];
			}
		}
		$val = array_unique($val);
		return implode(', ', $val);
	}

	public function onPrepareSave($value, $record, $type, $section)
	{
		$val = array();
		foreach ($value as $item)
		{
			$el = explode(';', $item);
			$item = array();
			foreach ($el as $level)
			{
				$level = explode(':', $level);
				$item[$level[0]] = $level[1];
			} 
			$val[] = $item;
		}
		return $val;
	}
	
	public function onStoreValues($record)
	{
		$ids = array();
		foreach ($this->value as $item)
		{
			$ids = array_merge($ids, array_keys($item));
		}
		return $ids;
	}
	
	
	public function onFilterWornLabel($section)
	{
		$value = $this->value;
		
		if(is_string($value))
		{
			$id = array($value); 
			$label = $this->_getParents($value, 'name');
		}
		else
		{
			foreach ($value as $k => $id)
			{
				if($id == -1)
					unset($value[$k]);					
			}			
			$label = $this->_getItem($value, 'name');
		}
		$value = implode($this->params->get('params.separator', ' '), $label);
		return $value;
	}

	public function onFilterWhere($section, &$query)
	{
		$value = $this->value;
		
		if (!$value)
		{
			return NULL;
		}
			
		settype($value, 'array');
		if($value[0] == -1) return ;
		
		foreach ($value as $i => $val)
		{
			if($val == -1)
				unset($value[$i]);
		}
		
		$value = array_reverse($value);
		
		$ids = $this->getIds("SELECT record_id FROM #__js_res_record_values WHERE field_value = '{$value[0]}' AND section_id = {$section->id} AND field_key = '{$this->key}'");
		
		$query->where("r.id IN(".implode(', ', $ids).")");
		
		return true;
	}
	
	public function onRenderFilter($section, $module = false)
	{
		if(is_string($this->value))
		{
			$id = array($this->value); 
			if($parent = $this->_getParents($this->value, 'id'))
				$id = $parent;
		}
		else
		$id = $this->value;
		
		$this->values = $id; 
		$this->labels = $this->params->get('params.labels');
		
		
		return $this->_display_filter($section, $module);
	}
	
	
 	public function onRenderFull($record, $type, $section)
	{
		return $this->_getValues('full',$record, $type, $section);
	}

	public function onRenderList($record, $type, $section)
	{
		return $this->_getValues('list', $record, $type, $section);
	}
	
	private function _getValues($client, $record, $type, $section)
	{
		$labels = explode("\n", $this->params->get('params.labels'));
		ArrayHelper::clean_r($labels);
		
		$this->labels = $labels;
		return $this->_display_output($client, $record, $type, $section);
	}
	
	public function _getItem($id, $column = '*')
	{
		$db = JFactory::getDbo();
		$query = "SELECT $column FROM #__js_res_field_miltilevelselect WHERE id ".(is_array($id) ? "IN (".implode(', ', $id).")" : "= '$id'");
		$db->setQuery($query);
		if($column == '*')
		return $db->loadObjectList();
		else
		return $db->loadColumn();
		
	}
	
	public function _getList($post)
	{
		$level = (int)$post['level'];
		$parent_id = (int)$post['parent_id'];
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select("p.*");

		$query->select("(SELECT COUNT(id) FROM #__js_res_field_miltilevelselect as n WHERE n.parent_id = p.id) as childs_num");
		$query->from("#__js_res_field_miltilevelselect p");
		$query->where("p.field_id = '{$this->id}'");
		if($parent_id)
			$query->where("p.parent_id = {$parent_id}"); 
		
		//if($level) 
		//	$query->where("p.level = {$level}"); 
		switch ($this->params->get('params.sort', 2))
		{
			case 1: $sort = "id ASC"; break;
			case 2: $sort = "name ASC"; break;
			case 3: $sort = "name DESC"; break;
		}
		$query->order($sort);
		
		if(!empty($post['filter']) && $this->params->get('params.filter_show_number'))
		{
			$query->select("(SELECT count(*) FROM `#__js_res_record_values` WHERE field_key = '{$this->key}' AND field_value = p.id) as record_num");
		}
		$db->setQuery($query);
		$items = $db->loadObjectList();
		if(!empty($post['filter']) && $this->params->get('params.filter_show_number'))
		{
			foreach ($items as $key => $value) {
				if($value->record_num == 0) {
					unset($items[$key]);
				}
			}
		}
		return $items;
	}
	
	public function _drawList($post)
	{
		$items = $this->_getList($post);
	
		
		$user = JFactory::getUser();
		$labels = explode("\n", $this->params->get('params.labels'));
		ArrayHelper::clean_r($labels);
		$required = $this->params->get('params.min_levels_req');
		
		$add_new = false;
		if(in_array($this->params->get('params.add_value', 2), $user->getAuthorisedViewLevels()))
		{
			$add_new = true;
		}
		
		if((!$add_new || isset($post['filter'])) && !count($items)) return ' ';
		
		$js = 'if(allowed'.$this->id.' && allowed'.$this->id.' > '.$post['level'].') mlsGetChilds'.$this->id.'(this.value, '.($post['level'] + 1).');';
		
		$class = ' class="' . $this->params->get('core.field_class', 'inputbox') . ($this->required ? ' required' : NULL) . '"';
		
		
		$index = $post['level'] - 1;
		
		$opt = array();
		$opt[] = JHtml::_('select.option', '-1', (isset($labels[$index]) ? JText::_($labels[$index]) : JText::_('MLS_SELECTVALUE')));
		foreach ($items as $item)
		{
			$opt[] = JHtml::_('select.option', $item->id, $item->name.(!empty($post['filter']) && $this->params->get('params.filter_show_number') ? " ({$item->record_num})" : NULL));
		}
		if($add_new && !isset($post['filter']))
		{
			$opt[] = JHtml::_('select.option', '0', JText::_($this->params->get('params.user_value_label', 'MLS_USERVALUE')));
			$js = 'if(this.value == 0) {mlsDrawInput'.$this->id.'('.$this->id.', '.$post['level'].', '.$post['parent_id'].');} else {if(allowed'.$this->id.' && allowed'.$this->id.' > '.$post['level'].') mlsGetChilds'.$this->id.'(this.value, '.($post['level'] + 1).')}';
		}
		
		$level = '';
		if(!isset($post['filter']) && $required && $post['level'] <= $required)
		{
			$level .= JHtml::image(JURI::root().'media/mint/icons/16/asterisk-small.png', JText::_('MLS_LEVELREQUIRED'), 'align="absmiddle" class="hasTip" title="::'.JText::_('MLS_LEVELREQUIRED').'"');
		}
		$name = 'fields['.$this->id.'][levels][]';
		if(isset($post['filter']) && $post['filter'])
			$name = 'filters['.$this->key.'][]';
		$level .= JHtml::_('select.genericlist', $opt, $name, 'onchange="'.$js.'"', 'value', 'text', 
			(isset($post['selected']) ? $post['selected'] : ''), 'mls-'.$this->id.'-level'.$post['level']);
		
		if(isset($post['selected']) && $post['selected'])
		{
			$level .= '<script type="text/javascript">
			mlsGetChilds'.$this->id.'('.$post['selected'].', '.($post['level'] + 1).');
			</script>';
		}
		return $level;
	}
	
	public function _getConstructor($record = null, $section = null)
	{
		$items = $this->_getList(array('level' => false, 'parent_id' => false));
		$rows = array();
		foreach ($items as $item)
		{
			$rows[$item->parent_id][] =  $item;
		}
		$rows = $this->_sort($rows, 1);
		$result = $this->_getChilds($rows);				
		
		$img_add = JURI::root().'media/mint/icons/16/plus-button.png';
		$img_edit = JURI::root().'media/mint/icons/16/pencil.png';
		$img_del = JURI::root().'media/mint/icons/16/cross-button.png';
		
		$level = 1;
		$parent_id = 0;
		
		$file = dirname(__FILE__).DS.'tmpl_form'.DS.'constructor.php';
		ob_start();
		include $file;
		$content = ob_get_contents();
		ob_end_clean();
		
		return $content;
	}
	
	private function _sort($array, $parent_id = 0)
	{
		$out = array();
		if (isset($array[$parent_id]) && count($array[$parent_id]))
		{
			foreach ( $array[$parent_id] as $item )
			{
				$item->children = array();
				if (isset($array[$item->id]))
				{
					$item->children = $this->_sort($array, $item->id);
				}
				$out[] = $item;
			}
		}
		return $out;
	}
	
	private function _getParents($id, $column = '*')
	{
		static $result = array();
		
		if(isset($result[$id.$column]))
		{
			return $result[$id.$column];
		}
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('parent.'.$column);
		$query->from('#__js_res_field_miltilevelselect AS c, #__js_res_field_miltilevelselect AS parent');
		$query->where('c.lft BETWEEN parent.lft AND parent.rgt');
		$query->where('c.id = ' . $id);
		$query->where('parent.field_id = c.field_id');
		$query->order('parent.lft ASC');
		
	
		$db->setQuery($query);
		//echo str_replace('#_', 'jos', $query);
		$result[$id.$column] = $db->loadColumn();
		
		return $result[$id.$column];
	}
	
	
	private function _getChilds($rows)
	{
		$out = array();
		$img_add = JURI::root().'media/mint/icons/16/plus-button.png';
		$img_edit = JURI::root().'media/mint/icons/16/pencil.png';
		$img_del = JURI::root().'media/mint/icons/16/cross-button.png';
		foreach ($rows as $row)
		{ 
			$out[] = '<li id="row'.$row->id.'"><span id="item'.$row->id.'">'.$row->name.'</span>';
			$out[] = JHtml::image($img_add, JText::_('MLS_ADDCHILD'), 'align="absmiddle" onclick="mls_input('.($row->level + 1).', '.$row->id.')"');
			$out[] = JHtml::image($img_edit, JText::_('MLS_EDIT'), 'align="absmiddle" onclick="mls_edit('.$row->id.')"');
			$out[] = JHtml::image($img_del, JText::_('MLS_DELETE'), 'align="absmiddle" onclick="mls_delete('.$row->id.')"');
			$out[] = '<ul id="parent'.$row->id.'" class="mls_list">';
			if(isset($row->children) && count($row->children))
			{
				$result = $this->_getChilds($row->children);	
				$out[] = implode(' ', $result); 
			}
			$out[] = '</ul>';
			$out[] = '</li>';
		}
		return $out;
	}
	
	public function _savenew($post)
	{
		$db = JFactory::getDbo();
		$row = new JTableNested('#__js_res_field_miltilevelselect', 'id', $db);
		$post['field_id'] = $this->id;
		$names = explode("\n", str_replace("\r", '', $post['name']));
		ArrayHelper::clean_r($names);
		
		foreach ($names as $name)
		{
			$post['name'] = $name;
			$row->bind($post);
			$row->check();
			$row->setLocation($row->parent_id, 'last-child');
			$row->store();
			
			$ids[$row->id]['id'] = $row->id;
			$ids[$row->id]['name'] = $name;
			
			$row->reset();
			$row->id = null;
		}
		
		return $ids;
	}
	
	public function _edit($post)
	{
		$query = "UPDATE #__js_res_field_miltilevelselect SET name='{$post['value']}' WHERE id='{$post['id']}'";
		$db = JFactory::getDbo();
		$db->setQuery($query);
		$db->query();
		return true;
	}
	
	public function _delete($post)
	{
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select("n.id");
		$query->from('#__js_res_field_miltilevelselect AS n');		
		$query->from('#__js_res_field_miltilevelselect AS parent');
		$query->where('parent.id = ' . $post['id']);
		$query->where('n.lft BETWEEN parent.lft AND parent.rgt');
		$db->setQuery($query);
		$ids = $db->loadColumn();
		$sql = "DELETE FROM #__js_res_field_miltilevelselect WHERE id IN (".implode(',', $ids).")";
		$db->setQuery($sql);
		$db->query();
		return $ids;
	}

}
