<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();
?>
<style>
body {
	overflow: auto;
}
#mls_tree .mls_list {
	margin: 0px !important;
	font-size: 12px;
}
#mls_tree .mls_list li {
	background-color:#fff;
	margin: 0px;
	list-style-type: none;
	display:block;
	padding:5px;
}
#mls_tree .mls_list li:nth-child(2n+1) {
	background-color:#f0f0f0;
}
#mls_tree .mls_list ul{
	padding: 0 0 0 15px;
}
#mls_tree .mls_list img {
	margin: 0px;
}

#parent1 {
	padding:0px !important;
}
textarea {
	margin-top:5px !important;
}
span.hint {
	font-size:10px;
}
</style>

<div id="mls_tree">
	<?php echo JText::_('MLS_ROOT'); ?>
	<img src="<?php echo $img_add?>" align="absmiddle" onclick="mls_input(<?php echo $level?>, 1)" alt="<?php echo JText::_('MLS_ADDCHILD') ?>">
	<ul id="parent1" class="mls_list">
		<?php echo implode(' ', $result); ?>
	</ul>
</div>

<script type="text/javascript">
function mls_input(level, parent_id)
{
	if($("mls_inputvalue"))
	{
		$("mls_inputvalue").destroy();
		$("span-hint").destroy();
	}

	var add = new Element ("textarea", {id: "mls_inputvalue", style:'width:100%', rows:5});
	$("parent" + parent_id).grab(add, "before");
	$("parent" + parent_id).grab(new Element('span', {"class":'hint', id:'span-hint'}).set('html', 'Ctrl+Enter to save, separate values by new line'), "before");
	add.setSelectionRange(0, 0);
	add.focus();
	add.addEvent("keydown", function (event) {
		if(event.code == 13 && event.event.ctrlKey)
		{
			var value = $("mls_inputvalue").value;
			var req = new Request.JSON({
				url: "<?php echo JURI::root(TRUE) ?>/index.php?option=com_cobalt&task=ajax.field_call&no_html=1",
				method:"post",
				autoCancel:true,
				data:{
					field_id: <?php echo $this->id ?>,
					func: "_savenew",
					field: "multilevelselect",
					record_id: null,
					name: value,
					level: level,
					parent_id: parent_id
					},
				onComplete: function(json) {
					if(!json.success)
        			{
        				alert(json.error);
        				return;
        			}
					$("mls_inputvalue").destroy();
					$("span-hint").destroy();
					Object.each(json.result, function(el){
						var li = new Element ("li", {id: "row" + el.id});
						var html = ' <img src="<?php echo $img_add?>" title="<?php echo JText::_('MLS_ADDCHILD')?>" align="absmiddle" onclick="mls_input(' + (level+1) + ', ' + el.id + ')" />';
						html += ' <img src="<?php echo $img_edit?>" title="<?php echo JText::_('MLS_EDIT')?>" align="absmiddle" onclick="mls_edit(' + el.id + ')" />';
						html += ' <img src="<?php echo $img_del?>" title="<?php echo JText::_('MLS_DELETE')?>" align="absmiddle" onclick="mls_delete(' + el.id + ')" />';
						html += ' <ul id="parent' + el.id + '" class="mls_list"></ul>';
						value = ' <span id="item'+ el.id +'">'+ el.name +'</span>';
						li.set("html", value + html);
						$("parent"+parent_id).grab(li, "bottom");
					});
				}
			}).send();
		}
	});
}

function mls_edit(id)
{
	var txt = $("item"+id).get("text");
	$("item"+id).set("html", "<input type=\"text\" id=\"mls_edit\" value=\""+txt+"\" onkeypress=\"if(event.keyCode == 13) {mls_editvalue(this.value, "+id+");}\" onblur=\"mls_editvalue(this.value, "+id+");\">");
	$("mls_edit").setSelectionRange(txt.length,txt.length);
	$("mls_edit").focus();
}

function mls_editvalue(value, id)
{
	var req = new Request.JSON({
		url: "<?php echo JURI::root(TRUE) ?>/index.php?option=com_cobalt&task=ajax.field_call&no_html=1",
		method:"post",
		autoCancel:true,
		data:{
			field_id: <?php echo $this->id ?>,
			func: "_edit",
			field: "multilevelselect",
			record_id: null,
			value: value,
			id: id
		},
		onComplete: function(json) {
			if(!json.success)
			{
				alert(json.error);
				return;
			}
			$("item"+id).set("html", value);
		}
	}).send();
}

function mls_delete(id)
{
	if($("delete_icon"))
	{
		$("delete_icon").destroy();
	}
	var im = new Element ("img", {src: "<?php echo JURI::root(TRUE) ?>/components/com_cobalt/images/load.gif", id: "delete_icon"});
	$("parent"+id).grab(im, "before");
	var req = new Request.JSON({
		url: "<?php echo JURI::root(TRUE) ?>/index.php?option=com_cobalt&task=ajax.field_call&no_html=1",
		method:"post",
		autoCancel:true,
		data:{
			field_id: <?php echo $this->id ?>,
			func: "_delete",
			field: "multilevelselect",
			record_id: null,
			id: id
		},
		onComplete: function(json) {
			if(!json.success)
			{
				alert(json.error);
				return;
			}

			Array.each(json.result, function (item) {
				if($("row"+item))
				{
					$("row"+item).destroy();
				}
			});

			if($("delete_icon"))
			{
				$("delete_icon").destroy();
			}
		}
	}).send();
}
</script>
