<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();
require_once JPATH_ROOT . DS . 'components/com_cobalt/library/php/fields/cobaltselectable.php';

class JFormFieldCMultiselect extends CFormFieldSelectable
{

	public function getInput()
	{
		$params = $this->params;
		$doc = JFactory::getDocument();
		$this->user = JFactory::getUser();
		
		$values = array();
		if($params->get('params.sql_source'))
		{
			$db = JFactory::getDbo();
			$db->setQuery($params->get('params.sql', "SELECT 1 AS value, 'No sql query entered' AS text"));
			$values = $db->loadObjectList();
		}
		else
		{
			$values = explode("\n", $params->get('params.values'));
			ArrayHelper::clean_r($values);
			
			settype($this->value, 'array');
			$diff = array_diff($this->value, $values);
			if(count($diff))
			{
				$values = array_merge($values, $diff);
			}
			ArrayHelper::clean_r($values);
			
			if($params->get('params.sort') == 2) asort($values);
			if($params->get('params.sort') == 3) rsort($values);
		}
		$this->values = $values;
		
		if($this->isnew && $this->params->get('params.default_val'))
		{
			$this->value[] = $this->params->get('params.default_val');
		}

		return $this->_display_input();
	}

	public function onJSValidate()
	{
		$js = "\n\t\t" . 'var field = $$("[name^=\"jform[fields][' . $this->id . ']\"]");
		var selected = 0;
		Array.each(field[0].options, function(opt, index){
			if(opt.selected)
			selected ++;
		});
		';
		if($this->required)
		{
			$js .= "\n\t\tif(!selected){hfid.push({$this->id}); isValid = false; errorText.push('" . addslashes(JText::sprintf("CFIELDREQUIRED", $this->label)) . "');}";
		}
		if($this->params->get('params.total_limit'))
		{
			$js .= "\n\t\tif(selected > " . $this->params->get('params.total_limit') . ") {hfid.push({$this->id}); isValid = false; errorText.push('" . addslashes(JText::sprintf("F_OPTIONSLIMIT", $this->params->get('params.total_limit'))) . "');}";
		}
		return $js;
	}

	public function validate($value, $record, $type, $section)
	{
		if($this->params->get('params.total_limit'))
		{
			if(count($value) > $this->params->get('params.total_limit'))
			{
				$this->setError(JText::sprintf("F_VALUESLIMIT", $this->params->get('params.total_limit'), $this->label));
			}
		}
		
		return parent::validate($value, $record, $type, $section);
	}

}
