<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die;
require_once JPATH_ROOT.DS.'components/com_cobalt/library/php/fields/cobaltrelate.php';


require_once JPATH_ROOT.DS.'components'.DS.'com_cobalt'.DS.'api.php';

class JFormFieldCParent extends CFormFieldRelate
{
	public function getInput()
	{
		$name = "jform[fields][$this->id]";

		ArrayHelper::clean_r($this->value);
		if(JRequest::getInt('fand', 0))
		{
			$this->value[] = JRequest::getInt('fand', 0);
			$this->params->set('params.input_mode', 10);
		}

		if(JRequest::getInt('id', 0))
		{
			$sql = "SELECT record_id FROM `#__js_res_record_values` WHERE field_value = ".JRequest::getInt('id', 0)." AND field_id = ".$this->params->get('params.child_field');
			$db = JFactory::getDbo();
			$db->setQuery($sql);
			$default = $db->loadColumn();
			settype($this->value, 'array');
			settype($default, 'array');
			$this->value = array_merge($this->value, $default);
		}
		$this->value = array_unique($this->value);


		$this->inputvalue = $this->_render_input($this->params->get('params.input_mode'), $name, $this->params->get('params.child_section'),
			JModel::getInstance('Fields', 'CobaltModel')->getFieldTypeId($this->params->get('params.child_field')));

		return $this->_display_input();
	}

	public function onStoreValues($record)
	{

		$db = JFactory::getDbo();
		$db->setQuery('DELETE FROM `#__js_res_record_values` WHERE record_id = '.$record['id'].' AND field_id = '.$this->id);
		$db->query();

		$table = JTable::getInstance('Record_values', 'CobaltTable');

		$field = JTable::getInstance('Field', 'CobaltTable');
		$field->load($this->params->get('params.child_field'));

		$save['field_type'] = $field->field_type;
		$save['field_label'] = $field->label;
		$save['field_key'] = 'k'.md5($field->label.'-'.$field->field_type);
		$save['field_id'] = $field->id;
		$save['section_id'] = $this->params->get('params.child_section');
		$save['category_id'] = 0;
		$save['params'] = '';
		$save['type_id'] = $field->type_id;
		$save['field_value'] = trim($record['id']);
		$save['user_id'] = JFactory::getUser()->get('id');

		$db->setQuery('DELETE FROM `#__js_res_record_values` WHERE field_value = '.$record['id'].' AND field_id = '.$field->id);
		$db->query();

		settype($this->value, 'array');

		foreach ($this->value AS $value)
		{
			if(!$value) continue;

			$save['record_id'] = trim($value);
			//var_dump($save);
			$table->load($save);
			if($table->id)
			{
				//var_dump($table->id);
			}
			else
			{
				$table->save($save);
			}
			$table->reset();
			$table->id = NULL;
		}
	}


	public function onRenderFilter($section, $module = false)
	{
		$name = "filters[{$this->key}]";
		ArrayHelper::clean_r($this->value);

		$limit = $this->params->get('params.multi_limit', 0);
		$this->params->set('params.multi_limit', 100);

		$this->filter = $this->_render_input($this->params->get('params.filter_style'),  $name,
			$this->params->get('params.child_section'),
			JModel::getInstance('Fields', 'CobaltModel')->getFieldTypeId($this->params->get('params.child_field')));

		return $this->_display_filter($section, $module);
		$this->params->set('params.multi_limit', $limit);
	}

	public function onFilterWhere($section, &$query)
	{
		ArrayHelper::clean_r($this->value);
		$field_id = $this->params->get('params.child_field');

		$ids = $this->getIds("SELECT field_value FROM #__js_res_record_values WHERE record_id IN(".implode(',', $this->value).") AND field_id = {$field_id}");
		$query->where("r.id IN(".implode(',', $ids).")");
		return TRUE;
	}

	public function onFilterWornLabel($section)
	{
		$db = JFactory::getDbo();

		$query = $db->getQuery(TRUE);
		$query->from('#__js_res_record');
		$query->select('title');
		$query->where('id IN ('.implode(',', $this->value).')');
		$db->setQuery($query);
		$array = $db->loadResultArray();
		return implode(', ', $array);
	}


	public function onRenderFull($record, $type, $section)
	{
		return $this->_render('full', $record, $this->params->get('params.child_field'),
			JModel::getInstance('Fields', 'CobaltModel')->getFieldTypeId((int)$this->params->get('params.child_field', 0)),
			$this->params->get('params.child_section'), 'show_children');
	}
	public function onRenderList($record, $type, $section)
	{
		return $this->_render('list', $record, $this->params->get('params.child_field'),
			JModel::getInstance('Fields', 'CobaltModel')->getFieldTypeId((int)$this->params->get('params.child_field', 0)),
			$this->params->get('params.child_section'), 'show_children');
	}

	public function onGetList($params)
	{
		$db = JFactory::getDbo();
		$user = JFactory::getUser();

		$name = "jform[fields][$this->id]";
		$attribs = $html = '';

		$query = $db->getQuery(TRUE);
		$query->select('id, title, null, title');
		$query->from('#__js_res_record');
		$query->where('published = 1');
		$query->where('hidden = 0');
		$query->where('section_id = '.$this->params->get('params.child_section'));
		$query->where('type_id IN (SELECT type_id FROM #__js_res_fields WHERE `id` = '.(int)$this->params->get('params.child_field').')');
		if(!in_array($this->params->get('params.strict_to_user'), $user->getAuthorisedViewLevels()))
		{
			if($this->params->get('params.strict_to_user_mode') > 1)
			{
				$record = JTable::getInstance('Record', 'CobaltTable');
				$record->load($params['record_id']);
				$user_id = $record->user_id;
				if(!$user_id && $this->params->get('params.strict_to_user_mode') == 3)
				{
					$user_id = $user->get('id');
				}
			}
			else
			{
				$user_id = $user->get('id');
			}

			$query->where('user_id = '.($user_id ? $user_id : 1));
		}


		$db->setQuery($query);
		return $db->loadRowList();
	}
}
