<?php

/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

require_once JPATH_ROOT . DS . 'components/com_cobalt/library/php/commerce/mintpay.php';

class MintPayPaypal extends MintPayAbstract
{

	public function button($field)
	{
		
		$user = JFactory::getUser();
		$options = $field->params;
		$return = new stdClass();
		
		if ($user->get('id') && $user->get('id') == $options->get('params.skip_for') )
		{
			return;
		}
		
		//settype($field->pay, 'array');
		$pay = new JRegistry((array)@$field->pay);
		$af = array();
		$pp_amount = $options->get('amount', $options->get('pay.default_amount', 0));
		$pp_email = $pay->get('business', $options->get('pay.business'));
		$pp_discount = $pay->get('default_discount', $options->get('pay.default_discount', 0));
		$pp_tax = $pay->get('default_tax', $options->get('pay.default_tax', 0));
		$pp_cur = $pay->get('default_currency', $options->get('pay.default_currency', 'USD'));
		$pp_shipping = $pay->get('shipping', $options->get('pay.shipping', 1));
		
		
		if (!$pp_email)
		{
			$return->button = sprintf('<p>%s</p>', JText::_('PP_NOEMAIL'));
			return $return;
		}
		
				
		$return->tax = 0;
		$return->topay = 0;
		$return->discount = 0;
		$return->amount = $this->_price($pp_amount, $pp_cur);;
		if($pp_tax)
		{
			$return->tax = ($options->get('pay.tax_type', 'tax_rate') == 'tax_rate' ? $pp_tax.'%' : $this->_price($pp_tax, $pp_cur));
		}
		
		if ($pp_discount)
		{
			if ($options->get('pay.discount_type', 'discount_rate') == 'discount_rate')
			{
				$return->topay = $this->_price(($pp_amount - ($pp_amount * ($pp_discount / 100))), $pp_cur);
				$return->discount = "$pp_discount%";
			}
			else
			{
				$return->topay = $this->_price(($pp_amount - $pp_discount), $pp_cur);
				$return->discount = $this->_price($pp_discount);
			}
		}
		if (!$user->get('id'))
		{
			$return->button = sprintf('<button type="button" class="buy-button" onclick="alert(\'%s\')">%s</button>', JText::_('Please, login to buy now'), JText::_('Buy Now'));
			return $return;
		}
		
		$url = JFactory::getURI();
		$url->setVar('rid', $field->record->id);
		$url->setVar('fid', $field->id);
		
		
		$out[] = '<form action="https://www.' . ($field->params->get('pay.sandbox') ? 'sandbox.' : NULL) . 'paypal.com/us/cgi-bin/webscr" method="post">';
		$out[] = $this->_hidden('cmd', '_xclick');
		$out[] = $this->_hidden('charset', 'utf-8');
		$out[] = $this->_hidden('business', $pp_email);
		
		$out[] = $this->_hidden('currency_code', $pp_cur);
		$out[] = $this->_hidden($options->get('pay.discount_type', 'discount_rate'), $pp_discount);
		$out[] = $this->_hidden($options->get('pay.tax_type', 'tax_rate'), $pp_tax);
		
		$out[] = $this->_hidden('item_name', $options->get('item_name'));
		
		if ($field->params->get('pay.allow_amount'))
		{
			$af[] = JText::_('CAMOUNT') . ' <input type="text" size="2" name="amount" value="' . $pp_amount . '" />';
		}
		else
		{
			$out[] = $this->_hidden('amount', $pp_amount);
		}
		if ($field->params->get('pay.allow_count'))
		{
			$af[] = JText::_('PP_QNT') . ' <input type="text" size="2" name="quantity" value="' . $options->get('pay.default_count', 1) . '" />';
		}
		else
		{
			$out[] = $this->_hidden('quantity', $options->get('pay.default_count', 1));
		}
		
		$out[] = implode("\n", $af);
		
		$url->setVar('result', 'cancel');
		$out[] = $this->_hidden('cancel_return', $url->toString());
		
		$ipn = JURI::root() . 'index.php?option=com_cobalt&task=field.call&func=onReceivePayment&field_id=' . $field->id . '&record_id=' . $field->record->id;
		
		$out[] = $this->_hidden('rm', 2);
		
		if ($options->get('pay.ipn'))
		{
			$url->setVar('result', 'return');
			$out[] = $this->_hidden('return', $url->toString());
			$out[] = $this->_hidden('notify_url', $ipn);
		}
		else
		{
			$out[] = $this->_hidden('return', $ipn);
		}
		
		$url->delVar('return');
		$url->delVar('result');
		$url->delVar('rid');
		$url->delVar('fid');
		
		$out[] = $this->_hidden('custom', $user->get('id'));
		$out[] = $this->_hidden('first_name', $user->get('name'));
		$out[] = $this->_hidden('email', $user->get('email'));
		$out[] = $this->_hidden('invoice', "{$field->record->id}::{$field->id}::" . time());
		
		$part = explode('-', JFactory::getLanguage()->getTag());
		$out[] = $this->_hidden('lc', strtoupper($part[0]));
		$out[] = $this->_hidden('no_shipping', $pp_shipping);
		
		$opt = $options->get('options', array());
		$i = 0;
		foreach($opt as $k => $file)
		{
			// paypal supports not more than 9 options.
			if ($k > 9)
				break;
			$out[] = $this->_hidden('on' . $i, $k);
			$out[] = $this->_hidden('os' . $i ++, $file);
		}
		
		$out[] = sprintf('<button class="buy-button">%s</button>', JText::_('Buy Now'));
		$out[] = '</form>';
		$return->button = implode("\n", $out);
		return $return;
	
	}

	public function form($field)
	{
		$user = JFactory::getUser();
		
		$value = $field->pay;
		settype($value, 'array');
		$default = new JRegistry($value);
		
		$params = $field->params;
		
		$form = $this->load_form('paypal', $field->id);
		
		$out[JText::_('CPRICE')] = '<input class="inputbox" type="text" size="4" name="jform[fields][' . $field->id . '][pay][amount]" value="' . $default->get('amount') . '"/> ';
		
		if (in_array($params->get('pay.allow_currency'), $user->getAuthorisedViewLevels()))
		{
			$out[JText::_('CPRICE')] .= $form->getInput('default_currency', 'pay', $default->get('default_currency', $params->get('pay.default_currency')));
		}
		else
		{
			$out[JText::_('CPRICE')] .= $params->get('pay.default_currency');
		}
		
		if (in_array($params->get('pay.allow_email'), $user->getAuthorisedViewLevels()))
		{
			$out[JText::_('PP_EMAIL')] = $form->getInput('business', 'pay', $default->get('business', $params->get('pay.business', $user->get('email'))));
		}
		
		if (in_array($params->get('pay.allow_discount'), $user->getAuthorisedViewLevels()))
		{
			$out[JText::_('CDISCOUNT')] = $form->getInput('default_discount', 'pay', $default->get('default_discount', $params->get('pay.default_discount')));
			$out[JText::_('CDISCOUNT')] .= ($params->get('pay.discount_type') == 'discount_rate' ? ' 0.001 - 100 %' : ' Fixed flat amount');
		}
		
		if (in_array($params->get('pay.allow_tax_rate'), $user->getAuthorisedViewLevels()))
		{
			$out[JText::_('CTAX')] = $form->getInput('default_tax', 'pay', $default->get('default_tax', $params->get('pay.default_tax')));
			$out[JText::_('CTAX')] .= ($params->get('pay.tax_type') == 'tax_rate' ? ' 0.001 - 100 %' : ' Fixed flat amount');
		}
		
		return $this->render_form($out);
	}

	public function receive($field, $post, $record)
	{
		$this->log('start transaction receive', $post);
		$this->log('URL', JFactory::getURI()->toString());

		$accept = new JRegistry($post);
		if ($field->params->get('pay.ipn'))
		{
			$this->log('IPN recieved. Start check.');
			if (!$this->_IPNcheck($field, $post))
			{
				JError::raiseWarning(403, 'cannot verify order');
				$this->log('cannot verify order');
				return;
			}
		
		}
		else
		{
			$this->log('PDT recieved. Start check.');
			if (!$field->params->get('pay.authcode'))
			{
				JError::raiseWarning(403, 'PDT identity toked is not set');
				$this->log('PDT identity toked is not set');
				return FALSE;
			}
			
			if (FALSE == ($data = $this->_PDTcheck($field, JRequest::getVar('tx', $accept->get('tx')), $field->params->get('pay.authcode'))))
			{
				JError::raiseWarning(403, 'cannot verify order');
				$this->log('cannot verify order');
				return;
			}
			$accept = new JRegistry($data);
		}
		
		$reasons = array('adjustment_reversal' => 'Reversal of an adjustment', 'buyer-complaint' => 'A reversal has occurred on this transaction due to a complaint about the transaction from your customer.', 'chargeback' => 'A reversal has occurred on this transaction due to a chargeback by your customer.', 'chargeback_reimbursement' => 'Reimbursement for a chargeback', 'chargeback_settlement' => 'Settlement of a chargeback', 'guarantee' => 'A reversal has occurred on this transaction due to your customer triggering a money-back guarantee.', 'other' => 'Non-specified reason.', 'refund' => 'A reversal has occurred on this transaction because you have given the customer a refund.');
		
		$out['gateway'] = 'PayPal';
		$out['gateway_id'] = $accept->get('txn_id', $accept->get('tx'));
		$out['user_id'] = $accept->get('custom', $accept->get('cm'));
		$out['amount'] = $accept->get('mc_gross', $accept->get('amount'));
		$out['currency'] = $accept->get('mc_currency');
		$out['name'] = $accept->get('item_name');
		
		// 1 - cancel
		// 2 - fail
		// 3 - pending|wait
		// 4 - refund
		// 5 - completed
		

		switch ($accept->get('txn_type'))
		{
			case "web_accept" :
				
				$app = JFactory::getApplication();
				
				switch ($accept->get('payment_status'))
				{
					case 'Denied' :
					case 'Expired' :
					case 'Failed' :
					case 'Voided' :
						$out['status'] = 2;
						JError::raiseWarning(403, JText::_('PP_PAYMENTFAIL'));
						break;
					
					case 'Pending' :
						$out['status'] = 3;
						$out['comment'] = $accept->get('pending_reason');
						$app->enqueueMessage(JText::_('PP_PAYSUCCBUT'));
						break;
					
					case 'Canceled_Reversal' :
					case 'Reversed' :
					case 'Refunded' :
						$out['status'] = 4;
						$out['comment'] = $reasons[$accept->get('reason_code')];
						JError::raiseWarning(403, JText::_('PP_REFUND'));
						break;
					
					case 'Created' :
					case 'Processed' :
					case 'Completed' :
						$out['status'] = 5;
						$app->enqueueMessage(JText::_('PP_PAYOK'));
						break;
				}
				$this->log('transaction prepared', $out);
				$this->new_order($out, $record, $field);
				$this->log("transaction finish!\n\n\n\n", $out);
				
				break;
			
			case "new_case" :
				$this->log('case raised cancel order');
				$out['status'] = 1;
				$out['comment'] = JText::_('PP_DISPUTSTART');
				$this->new_order($out, $record, $field);
				break;
			
			case "adjustment" :
				$this->log('case resolved confirm order');
				$out['status'] = 5;
				$out['comment'] = JText::_('PP_DISPUTRSOLV');
				$this->new_order($out, $record, $field);
				break;
		
		}
		
		return $out;
	}

	private function _PDTcheck($field, $tx, $auth)
	{
		$request = curl_init();
		curl_setopt_array($request, array(CURLOPT_URL => 'https://www.' . ($field->params->get('pay.sandbox') ? 'sandbox.' : NULL) . 'paypal.com/cgi-bin/webscr', CURLOPT_POST => TRUE, CURLOPT_POSTFIELDS => http_build_query(array('cmd' => '_notify-synch', 'tx' => $tx, 'at' => $auth)), CURLOPT_RETURNTRANSFER => TRUE, CURLOPT_HEADER => FALSE, CURLOPT_SSL_VERIFYPEER => FALSE, CURLOPT_CAINFO => 'cacert.pem'));
		
		$response = curl_exec($request);
		$status = curl_getinfo($request, CURLINFO_HTTP_CODE);
		curl_close($request);
		
		$this->log('send CURL confirm');
		
		if ($status == 200 and strpos($response, 'SUCCESS') === 0)
		{
			$response = substr($response, 7);
			$response = urldecode($response);
			
			preg_match_all('/^([^=\s]++)=(.*+)/m', $response, $m, PREG_PATTERN_ORDER);
			$response = array_combine($m[1], $m[2]);
			
			// Fix character encoding if different from UTF-8 (in my case)
			if (isset($response['charset']) and strtoupper($response['charset']) !== 'UTF-8')
			{
				foreach($response as $key => &$value)
				{
					$value = mb_convert_encoding($value, 'UTF-8', $response['charset']);
				}
				$response['charset_original'] = $response['charset'];
				$response['charset'] = 'UTF-8';
			}
			
			$this->log('transaction success and return', $response);
			ksort($response);
			
			return $response;
		}
		
		$this->log('transaction fail', $response);
		return FALSE;
		
	/* $req = 'cmd=_notify-synch';
		
		$tx_token = $_GET['tx'];
		$auth_token = "GX_sTf5bW3wxRfFEbgofs88nQxvMQ7nsI8m21rzNESnl_79ccFTWj2aPgQ0";
		$req .= "&tx=$tx_token&at=$auth_token";
		
		$header .= "POST /cgi-bin/webscr HTTP/1.0\r\n";
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";
		$fp = fsockopen('www.paypal.com', 80, $errno, $errstr, 30);
		// $fp = fsockopen ('ssl://www.paypal.com', 443, $errno, $errstr, 30);
		$this->log('start open socket');
		
		if(! $fp)
		{
			$this->log('open socket fail');
			return FALSE;
		}
		
		fputs($fp, $header . $req);
		$res = '';
		$headerdone = false;
		while(! feof($fp))
		{
			$line = fgets($fp, 1024);
			if(strcmp($line, "\r\n") == 0)
			{
				$headerdone = true;
			}
			elseif($headerdone)
			{
				$res .= $line;
			}
		}
		
		$lines = explode("\n", $res);
		if(strcmp($lines[0], "SUCCESS") == 0)
		{
			$this->log('transaction success ' . $post['txn_id']);
			return TRUE;
		}
		elseif(strcmp($lines[0], "FAIL") == 0)
		{}
		$this->log('identifier not found', $lines);
		return FALSE;
		fclose($fp); */
	}

	private function _IPNcheck($field, $post)
	{
		$post['cmd'] = '_notify-validate';

		$request = curl_init();
		curl_setopt_array($request, array(
			CURLOPT_URL => 'https://www.' . ($field->params->get('pay.sandbox') ? 'sandbox.' : NULL) . 'paypal.com/cgi-bin/webscr', 
			CURLOPT_POST => 1, 
			CURLOPT_POSTFIELDS => http_build_query($post), 
			CURLOPT_RETURNTRANSFER => 1, 
			CURLOPT_HEADER => 0, 
			CURLOPT_SSL_VERIFYPEER => FALSE, 
			CURLOPT_CAINFO => 'cacert.pem',
			CURLOPT_HTTPHEADER => array("Content-Type: application/x-www-form-urlencoded", "Content-Length: " . strlen(http_build_query($post))),
			CURLOPT_TIMEOUT => 30
		));
		
		$this->log('send CURL confirm');

		$response = curl_exec($request);
		$status = curl_getinfo($request, CURLINFO_HTTP_CODE);
		curl_close($request);
		
		if (strpos($response, "VERIFIED")!==false) 
		{
			$this->log('transaction verified ' . $response .' - '. $post['txn_id']);
			return TRUE;
		}
		else
		{
			$this->log('transaction verification invalid '. $response);
			return FALSE;
		}

		/*$req = 'cmd=_notify-validate';
		foreach($post as $key => $value)
		{
			$value = urlencode(stripslashes($value));
			$req .= "&$key=$value";
		}
		$header  ="POST /cgi-bin/webscr HTTP/1.1\r\n"; 
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n"; 
		$header .= "Host: 'www.paypal.com\r\n"; 
		$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";
		
		$url = 'www.' . ($field->params->get('pay.sandbox') ? 'sandbox.' : NULL) . 'paypal.com';
		$fp = fsockopen($url, 80, $errno, $errstr, 30);
		$this->log('check open socket');
		
		jimport('joomla.filesystem.file');
		if (!$fp)
		{
			$this->log('open socket fail');
			return FALSE;
		}
		$this->log('open socket success', $url);
		
		fputs($fp, $header . $req);
		while ( !feof($fp) )
		{
			$res = fgets($fp, 1024);
			
			if (strcmp($res, "VERIFIED") == 0)
			{
				$this->log('transaction verified ' . $post['txn_id']);
				return TRUE;
			}
			elseif (strcmp($res, "INVALID") == 0)
			{
				$this->log('transaction verification invalid');
				return FALSE;
			}
		}
		$this->log('identifier not found', $res);
		return FALSE;
		fclose($fp);*/
	}
}
?>