<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();
require_once JPATH_ROOT.DS.'components/com_cobalt/library/php/fields/cobaltupload.php';
require_once JPATH_ROOT.DS.'components/com_cobalt/library/php/fields/cobaltcommerce.php';
require_once JPATH_ROOT.DS.'components/com_cobalt/library/php/commerce/mintpay.php';

class JFormFieldCPayvoucher extends CFormField
{

	function __construct($field, $default)
	{
		parent::__construct($field, $default);
		$this->gateway = MintPay::getInstance($this->id, $this->params->get('params.default_gateway'), $this->params->get('params.log'));
	}

	public function getInput()
	{
		$this->pay = @$this->value['pay'];
		$this->value = @$this->value['vouchers'];
				
		$this->text = htmlspecialchars(stripslashes($this->value), ENT_QUOTES, 'UTF-8');
		
		if($this->gateway)
		{
			$this->gateway_form = $this->gateway->form($this);
		}
		else
		{
			$this->gateway_form = JText::sprintf('CGATEWAYNOTFOUND', '');
		}
		return $this->_display_input();
		
	}

	public function onReceivePayment($post, $record, &$controller)
	{
		if(!$this->gateway)
		{
			return;
		}
		$order = $this->gateway->receive($this, $post, $record);
		
		if(!$this->gateway->table->params && ($this->gateway->table->status == 5 || $this->gateway->table->status == 3))
		{
			$fields = json_decode($record->fields, TRUE);
			//$this->gateway->log('fields', $fields);
			
			$vouchers = explode("\n", $fields[$this->id]['vouchers']);
			$voucher = array_shift($vouchers);
			
			//$this->gateway->log('voucher', $voucher);
			
			settype($vouchers, 'array');
			$fields[$this->id]['vouchers'] = implode("\n", $vouchers);
			
			$table = JTable::getInstance('Record', 'CobaltTable');
			$table->load($record->id);
			$table->fields = json_encode($fields);
			$table->store();
			
			$this->gateway->table->params = $voucher;
			$this->gateway->table->store();
		}
		
		JFactory::getApplication()->enqueueMessage(JText::_('PV_SUCCESSFULPURCHASED').' '.$voucher);
		
		$controller->setRedirect(JRoute::_(Url::record($record), FALSE));
	}

	private function _renderbutton($client, $record, $type, $section)
	{
		if(!$this->gateway)
		{
			return;
		}
		
		$this->record = $record;
		$this->section = $section;
		
		$user = JFactory::getUser();
		ArrayHelper::clean_r($this->value);
		if(!$this->value)
		{
			return ;
		}
		$vnum = explode("\n", @$this->value['vouchers']);
		ArrayHelper::clean_r($vnum);
		$this->vnum = count($vnum);
		
		$order = $this->gateway->get_order($user->get('id'), $this->record->id, $this->id);
		$order = isset($order->id) ? $order : false;
		if($order)
		{
			$this->order_table = $this->gateway->order_render($client, $order, $this);
		}
		$this->order = $order;
		
		$this->pay = @$this->value['pay'];
		$this->button = false;
		if($this->params->get('params.single') == 0 && $vnum)
		{
			$this->params->set('amount', @$this->value['pay']['amount']);
			$this->params->set('item_name', JText::sprintf($this->params->get('params.item_name', 'PV_VOUCHER'), $this->record->title));
			$this->button = $this->gateway->button($this);
		}
		
		$this->user = $user;
		
		return $this->_display_output($client, $record, $type, $section);
		
	}


	public function onOrderList($order, $record)
	{
		if(!$order->params)
		{
			return;
		}
		
		$out[] = '<div>';
		if($order->status == 3)
		{
			$out[] = JText::_('PV_ORDERNOTCONFIRMED');
		}
		elseif($order->status == 5) 
		{
			$out[] = $order->params;
		}
		else 
		{
			$out[] = JText::_('PV_ORDERREFUNDEDORFAILED');
		}
		$out[] = '</div>';
		
		return implode(" ", $out);
	}
	public function onRenderFull($record, $type, $section)
	{
		return $this->_renderbutton('full', $record, $type, $section);

	}

	public function onRenderList($record, $type, $section)
	{
		return $this->_renderbutton('list', $record, $type, $section);

	}

	public function validate($value, $record, $type, $section)
	{
		$this->_crean_vouchers($value);
		return parent::validate($value, $record, $type, $section);
	}
	public function onPrepareSave($value, $record, $type, $section)
	{
		$this->_crean_vouchers($value);
		return $value;
	}

	public function onStoreValues($record)
	{
		return array();
	}
	
	private function _crean_vouchers(&$value)
	{
		$values = explode("\n", str_replace("\r", "", $value['vouchers']));
		ArrayHelper::clean_r($values);
		$value['vouchers'] = implode("\n", $values);
	}
}
