<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

$class = ' class="' . $this->params->get('core.field_class', 'inputbox') . ($this->required ? ' required' : NULL) . '"';
$required = $this->required ? 'required="true" ' : NULL;
$style = 'width: ' . $this->params->get('params.width', '220') . 'px';

?>

<ul class="elements-list" id="form_field_list_<?php echo $this->id;?>">

<?php 
$selected = ($this->value ? $this->value : $this->params->get('params.selected'));

foreach($this->values as $key => $line): 
	if(is_string($line))
		$val = explode($this->params->get('params.color_separator', "^"), $line);
	$sel = '';
	
	$s = $style;
	if (isset($val[1]))
	{
		$s .= ';color: ' . $val[1];
	}
	
	if($this->params->get('params.sql_source')) :
		if($this->value && in_array($line->text, $this->value))
			$sel = ' checked="checked"';
		?>
		<li style="<?php echo $s;?>" class="list-element">
			<input type="radio" class="<?php echo $class;?>" value="<?php echo $line->id;?>" name="jform[fields][<?php echo $this->id;?>]" 
				id="field_<?php echo $this->id;?>_<?php echo $key;?>" <?php echo $required.$sel;?> />
			<label for="field_<?php echo $this->id;?>_<?php echo $key;?>"><?php echo $line->text;?></label>
		</li>
	<?php else : 
		if ($line == $selected)
		{
			$sel = ' checked="checked"';
		}
		?>
		<li style="<?php echo $s;?>" class="list-element">
			<input type="radio" class="<?php echo $class;?>" value="<?php echo htmlspecialchars($line, ENT_COMPAT, 'UTF-8');?>" 
				name="jform[fields][<?php echo $this->id;?>]" id="field_<?php echo $this->id;?>_<?php echo $key;?>" <?php echo $required.$sel;?>  />
			<label for="field_<?php echo $this->id;?>_<?php echo $key;?>"><?php echo JText::_($val[0]);?></label>
		</li>
		<?php 
	endif;
endforeach;
?>
</ul>

<?php if (in_array($this->params->get('params.add_value', 2), $this->user->getAuthorisedViewLevels()) && !$this->params->get('params.sql_source')):?>
		<?php 
		JFactory::getDocument()->addScript(JURI::root() . 'media/mint/js/GrowingInput.js');?>
		<div style="clear:both"></div>
		<div class="variant-container" id="variant_<?php echo $this->id;?>">
			<a class="small" id="show_variant_link_<?php echo $this->id;?>" 
				rel="{field_type:'<?php echo $this->type;?>', id:<?php echo $this->id;?>, inputtype:'radio', width:<?php echo $this->params->get('params.width', '220');?>, limit: 1, max_size: 0}" 
				href="javascript:void(0)" onclick="showAddForm(this)"><?php echo JText::_($this->params->get('params.user_value_label', 'Your variant'));?></a>
			</div>
		<div style="clear:both"></div>
<?php endif;?>