<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die;
require_once JPATH_ROOT.DS.'components/com_cobalt/library/php/fields/cobaltrelate.php';

require_once JPATH_ROOT.DS.'components'.DS.'com_cobalt'.DS.'api.php';

class JFormFieldCReadmore extends CFormFieldRelate
{
	public function getInput()
	{
		$name = "jform[fields][$this->id]";
		ArrayHelper::clean_r($this->value);

		$this->inputvalue = $this->_render_input($this->params->get('params.input_mode'), $name, JRequest::getInt('section_id'), $this->_getTypes());

		return $this->_display_input();
	}

	public function onRenderFull($record, $type, $section)
	{
		JRequest::setVar('_rmfid', $this->id);
		JRequest::setVar('_rmrid', $record->id);
		JRequest::setVar('_rmstrict', $this->params->get('params.strict'));

		$api = new CobaltApi();
		$this->content = $api->records($section->id, 'show_related', $this->params->get('params.orderby', 'r.ctime DESC'),
			0, null, $this->params->get('params.cat_id', 0), $this->params->get('params.multi_limit', 10),
			$this->params->get('params.template', 'default')
		);

		return $this->_display_output('full', $record, $type, $section);

	}

	public function onRenderList($record, $type, $section)
	{
		return NULL;
	}

	public function onGetList($params)
	{
		$db = JFactory::getDbo();
		$section_id = JRequest::getInt('section_id');


		$query = $db->getQuery(TRUE);
		$query->select('id, title, null, title');
		$query->from('#__js_res_record');
		$query->where('published = 1');
		$query->where('hidden = 0');
		$query->where('section_id = '.$section_id);
		$query->where('type_id IN ('. implode(',', $this->_getTypes()) .')');
		if($this->params->get('params.user_strict'))
		{
			$user_id = JFactory::getUser()->get('id');
			$query->where('user_id = '.($user_id ? $user_id : 1));
		}
		$db->setQuery($query);
		return $db->loadRowList();
	}

	private function _getTypes()
	{
		$types = $this->params->get('params.type');
		$types[] = JModel::getInstance('Fields', 'CobaltModel')->getFieldTypeId($this->id);
		ArrayHelper::clean_r($types);
		JArrayHelper::toInteger($types);

		return $types;
	}
}
