<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

jimport('joomla.application.component.model');
jimport('joomla.application.component.modeladmin');
jimport('joomla.application.component.modellist');

class CobaltApi
{

	function __construct()
	{
		$document = JFactory::getDocument();
		$document->addScript(JURI::root() . 'components/com_cobalt/library/js/main.js');
		$document->addScript(JURI::root() . 'components/com_cobalt/library/js/felixrating.js');
		if(JFile::exists(JPATH_COMPONENT . DS . 'library' . DS . 'css' . DS . 'custom.css'))
		{
			$document->addStyleSheet(JURI::root() . 'components/com_cobalt/library/css/custom.css');
		}
		else
		{
			$document->addStyleSheet(JURI::root() . 'components/com_cobalt/library/css/style.css');
		}

		JTable::addIncludePath(JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_cobalt' . DS . 'tables');
		JModel::addIncludePath(JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'models');

		require_once JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'library' . DS . 'php' . DS . 'helper.php';
		require_once JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'models' . DS . 'record.php';
		require_once JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'views' . DS . 'records' . DS . 'view.html.php';

		$lang = JFactory::getLanguage();
		$lang->load('com_cobalt', JPATH_ROOT);
	}

	/**
	 *
	 * @param int $section_id
	 * @param string $view_what
	 * @param string $order
	 * @param int $type_ids
	 * @param int $user_id  No user must be NULL, otherwise 0 would be Guest
	 * @param int $cat_id
	 * @param int $limit
	 * @param string $tpl
	 * @return html
	 */

	public function records($section_id, $view_what, $order, $type_ids = array(), $user_id = NULL, $cat_id = 0, $limit = 5, $tpl = 'default')
	{
		$content = array(
			'total' => 0,
			'html' => NULL
		);

		$this->section = ItemsStore::getSection($section_id);

		if(!$this->section->id)
		{
			JError::raiseNotice(404, 'Section not found');
			return;
		}

		$app = JFactory::getApplication();
		$this->appParams = $app->getParams();

		RatingHelp::loadRecord();

		$orders = explode(' ', $this->section->params->get('general.orderby'));

		$this->section->params->set('general.section_home_items', 2);
		$this->section->params->set('general.orderby', $order);
		$this->section->params->set('general.featured_first', 0);

		$order = explode(' ', $order);

		$back_sid = JRequest::getVar('section_id');
		$back_vw = JRequest::getVar('view_what');
		$back_cat = JRequest::getVar('force_cat_id');
		$back_ord = JRequest::getVar('filter_order');
		$back_orddr = JRequest::getVar('filter_order_Dir');
		$back_type = JRequest::getVar('filter_type');
		$back_user = JRequest::getVar('user_id');
		$back_uc = JRequest::getVar('ucat_id');
		$back_c = JRequest::getVar('cat_id');
		$back_limit = JRequest::getVar('limit', NULL);


		$state_limit = $app->getUserState('global.list.limit', 20);
		$state_ord = $app->getUserState('com_cobalt.records'.$section_id.'.ordercol', @$orders[0]);
		$state_ordd = $app->getUserState('com_cobalt.records'.$section_id.'.orderdirn', @$orders[1]);

		JRequest::setVar('section_id', $section_id);
		JRequest::setVar('view_what', $view_what);
		JRequest::setVar('force_cat_id', $cat_id);
		JRequest::setVar('filter_order', $order[0]);
		JRequest::setVar('filter_order_Dir', $order[1]);
		JRequest::setVar('user_id', $user_id);
		JRequest::setVar('ucat_id', 0);
		JRequest::setVar('cat_id', $cat_id);
		JRequest::setVar('limit', $limit);
		$app->setUserState('global.list.limit', $limit);

		$sortable = CobaltModelRecord::$sortable;
		$records = JModel::getInstance('Records', 'CobaltModel');
		$records->section = $this->section;
		$records->_filtersWhere = false;
		$records->_navigation = false;
		$records->getState(null);

		$records->setState('records.section_id', $this->section->id);
		$records->setState('records.type', $type_ids);
		$items = $records->getItems();

		foreach($items as $key => $item)
		{
			$items[$key] = JModel::getInstance('Record', 'CobaltModel')->_prepareItem($item, 'list');
		}

		$view = new CobaltViewRecords();
		$this->total_fields_keys = $view->_fieldsSummary($items);
		$this->items = $items;
		$this->user = JFactory::getUser();

		$this->submission_types = $records->getSubmissionTypes();
		$this->total_types = $records->getTypes();
		$this->fields_keys_by_id = $records->getKeys($this->section);
		CobaltModelRecord::$sortable = $sortable;
		$this->_setuptemplate($tpl);

		if($items)
		{
			ob_start();
			include JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'views' . DS . 'records' . DS . 'tmpl' . DS . 'default_list_' . $tpl . '.php';
			$content['html'] = ob_get_contents();
			ob_end_clean();
			$content['total'] = count($items);
			$content['list'] = $items;
		}
		JRequest::setVar('section_id', $back_sid);
		JRequest::setVar('view_what', $back_vw);
		JRequest::setVar('force_cat_id', $back_cat);
		JRequest::setVar('filter_order', $back_ord);
		JRequest::setVar('filter_order_Dir', $back_orddr);
		JRequest::setVar('user_id', $back_user);
		JRequest::setVar('ucat_id', $back_uc);
		JRequest::setVar('cat_id', $back_c);
		JRequest::setVar('limit', $back_limit);

		$app->setUserState('global.list.limit', $state_limit);
		$app->setUserState('com_cobalt.records'.$section_id.'.ordercol', $state_ord);
		$app->setUserState('com_cobalt.records'.$section_id.'.orderdirn', $state_ordd);

		return $content;
	}

	private function _setuptemplate($tpl = NULL)
	{
		if($tpl)
		{
			$name = $tpl;
		}
		else
		{
			$list_templates = $this->section->params->get('general.tmpl_list', 'default');
			settype($list_templates, 'array');
			$name = $list_templates[0];
		}
		$dir = JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'views' . DS . 'records' . DS . 'tmpl' . DS;

		if(! JFile::exists("{$dir}default_list_{$name}.php"))
		{
			$name = 'default';
		}

		$file = "{$dir}default_list_{$name}.json";
		if(JFile::exists($file))
		{
			$file = JFile::read($file);
		}
		else
		{
			$file = array();
			JError::raiseNotice(404, JText::_('CPLSEDITTEMPLATE_LI'));
		}
		$lparams = new JRegistry($file);
		$tmpl_params['list'] = $lparams;

		$file = "{$dir}default_list_{$name}.css";
		if(JFile::exists($file))
		{
			JFactory::getDocument()->addStyleSheet(JURI::root() . 'components/com_cobalt/views/records/tmpl/default_list_' . $name . '.css');
		}

		$this->list_template = $name;
		$this->tmpl_params = $tmpl_params;
	}
}