<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.application.component.controlleradmin');

class CobaltControllerAjax extends JControllerAdmin
{
	public function trackcomment()
	{
		$jinput = JFactory::getApplication()->input;
		$record_id = JRequest::getInt('record_id');
	
		if(!$record_id) return;
	
		$record = ItemsStore::getRecord($record_id);
	
		CEventsHelper::notify('record', CEventsHelper::_COMMENT_NEW,
		$record->id, $record->section_id, 0, 0, 0, array());
		
		$user = JFactory::getUser();
		if($user->get('id'))
		{
			CSubscriptionsHelper::subscribe_record($record->id);
		}
	}
	
	public function checkuser()
	{
		$jinput = JFactory::getApplication()->input;
		$user = JRequest::getVar('user');
		
		if(!$user)
		{
			echo AjaxHelper::error(JText::_('AJAX_ENTERUSERNAMEOREMAILORID'));
			return;
		}
		
		$user_id = 0;
		if(preg_match("/^[0-9]*$/iU", $user))
		{
			$user_id = JFactory::getUser($user)->get('id');
		}
		
		$db = JFactory::getDbo();
		
		if(JMailHelper::isEmailAddress($user))
		{
			$db->setQuery("SELECT id FROM #__users WHERE email = ".$db->quote($user));
			$user_id = $db->loadResult();
		}
		
		if(!$user_id)
		{
			$db->setQuery("SELECT id FROM #__users WHERE username = ".$db->quote($user));
			$user_id = $db->loadResult();
		}
		
		if(!$user_id)
		{
			$db->setQuery("SELECT id FROM #__users WHERE name = ".$db->quote($user));
			$user_id = $db->loadResult();
		}
		
		if(!$user_id)
		{
			echo AjaxHelper::error(JText::_('AJAX_USERNOTFOUND'));
			return;
		}
		
		$out = array('success' => 1, 'result' => $user_id);
		AjaxHelper::send($out);
	}
	public function status()
	{
		$jinput = JFactory::getApplication()->input;
		
		$order = JTable::getInstance('Sales', 'CobaltTable');
		$order->load(JRequest::getInt('order_id'));
		
		if (!$order->id)
		{
			echo AjaxHelper::error(JText::_('AJAX_CANNOTLOADORDER'));
			return;
		}
		
		$order->status = JRequest::getInt('status');
		$order->store();
		
		JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . 'tables' . DS . 'field.php');
		$field = JTable::getInstance('Field', 'CobaltTable');
		$field->load($order->field_id);
		$field->params = new JRegistry($field->params);
		
		if($field->params->get('params.order_updated'))
		{
			CEventsHelper::notify('record', 'order_updated', $order->record_id, $order->section_id, 0, 0, $order->field_id, $order, 2, $order->user_id);
		}
		
		$out = array('success' => 1);
		AjaxHelper::send($out);
	}

	public function follow()
	{
		$jinput = JFactory::getApplication()->input;
		
		$user = JFactory::getUser();
		if (!$user->get('id'))
		{
			echo AjaxHelper::error(JText::_('AJAX_PLEASELOGIN'));
			return;
		}
		$data = array('user_id' => $user->get('id'), 'record_id' => JRequest::getInt('record_id'));
		
		$table = JTable::getInstance('Subscription', 'CobaltTable');
		$table->load($data);
		
		$record = JTable::getInstance('Record', 'CobaltTable');
		$record->load(JRequest::getInt('record_id'));
		
		if ($table->id)
		{
			//$table->delete();
			$state = 0;
			$text = JText::_('CMSG_CLICKTOFOLLOW');
			CSubscriptionsHelper::unsubscribe_record(JRequest::getInt('record_id'));
		}
		else
		{
			/* $data['section_id'] = JRequest::getInt('section_id');
			$data['type'] = 'record';
			$data['type_id'] = $record->type_id;
			$data['ctime'] = JFactory::getDate()->toSql();
			$table->reset();
			$table->bind($data);
			
			if(!$table->store())
			{
				echo AjaxHelper::error(JText::_($table->getError());
				return;
			} */
			$state = 1;
			$text = JText::_('CMSG_CLICKTOUNFOLLOW');
			CSubscriptionsHelper::subscribe_record(JRequest::getInt('record_id'));
		}
		
		$record->onFollow();
		
		$out = array('success' => 1, 'state' => $state, 'title' => $text);
		
		AjaxHelper::send($out);
	}

	public function bookmark()
	{
		$jinput = JFactory::getApplication()->input;
		
		$user = JFactory::getUser();
		if (!$user->get('id'))
		{
			echo AjaxHelper::error(JText::_('AJAX_PLEASELOGIN'));
			return;
		}
		
		$record = JTable::getInstance('Record', 'CobaltTable');
		$record->load(JRequest::getInt('record_id'));
		
		$data = array('user_id' => $user->get('id'), 'record_id' => JRequest::getInt('record_id'));
		$table = JTable::getInstance('Favorites', 'CobaltTable');
		$table->load($data);
		
		if ($table->id)
		{
			$table->delete();
			$state = 0;
			$text = JText::_('CMSG_ADDBOOKMARK');
		}
		else
		{
			$data['section_id'] = JRequest::getInt('section_id');
			$data['ctime'] = JFactory::getDate()->toSql();
			$table->reset();
			$table->bind($data);
			if (!$table->store())
			{
				echo AjaxHelper::error(JText::_($table->getError()));
				return;
			}
			$state = 1;
			$text = JText::_('CMSG_REMOVEBOOKMARK');
			
			$data = $record->getProperties();
			
			CEventsHelper::notify('record', CEventsHelper::_RECORD_BOOKMARKED, JRequest::getInt('record_id'), JRequest::getInt('section_id'), 0, 0, 0, $data);
		}
		
		$record->onBookmark();
		
		$out = array('success' => 1, 'state' => $state, 'title' => $text);
		
		AjaxHelper::send($out);
	}

	public function removeucicon()
	{
		$jinput = JFactory::getApplication()->input;
		
		$file = JRequest::getVar('file');
		$id = JRequest::getVar('id');
		$user = JFactory::getUser();
		$fullpath = JPATH_ROOT . DS . 'images' . DS . 'usercategories' . DS . $user->get('id') . DS . $file;
		if (JFile::exists($fullpath))
		{
			if (JFile::delete($fullpath))
			{
				$db = JFactory::getDbo();
				$db->setQuery('UPDATE #__js_res_category_user SET icon = "" WHERE id = ' . $id);
				$db->query();
				$out = array('success' => 1, 'result' => 'true');
			}
		}
		else
		{
			$out = array('success' => 0, 'error' => JText::_('CFILENOTEXISTS'));
		}
		
		AjaxHelper::send($out);
	}

	public function category_childs()
	{
		$jinput = JFactory::getApplication()->input;
		
		$cat_model = JModel::getInstance('Category', 'CobaltModel');
		$cats_model = JModel::getInstance('Categories', 'CobaltModel');
		
		$level = JRequest::getInt('level');
		$category = $cat_model->getItem(JRequest::getInt('cat_id'));
		$cats_model->section = $category->section_id;
		$cats_model->parent_id = $category->id;
		$cats_model->order = JRequest::getVar('order', 'c.lft ASC');
		$cats_model->levels = 1;
		$cats_model->all = 0;
		$cats_model->nums = 1;
		$categories = $cats_model->getItems();
		/*$db = JFactory::getDbo();
		$user = JFactory::getUser();
		$model = JModel::getInstance('Section', 'CobaltModel');
		$section = $model->getItem($category->section_id);
		$section->params = new JRegistry($section->params);
		foreach($categories as $k => $item)
		{		
			$sql = $db->getQuery(true);
			$sql->select('count(*)');
			$sql->from('#__js_res_record');
			$sql->where('published = 1');
			$sql->where('hidden = 0');
			$sql->where('section_id = ' . $section->id);
			$sql->where("categories LIKE '%" . $item->id . "%' ");
			
			if (!in_array($section->params->get('general.show_future_records'), $user->getAuthorisedViewLevels()))
			{
				$sql->where("ctime < " . $db->quote(JFactory::getDate()->toSql()));
			}
			
			if (!in_array($section->params->get('general.show_past_records'), $user->getAuthorisedViewLevels()))
			{
				$sql->where("(extime = '0000-00-00 00:00:00' OR extime > '" . JFactory::getDate()->toSql() . "')");
			}
			$db->setQuery($sql);
			$categories[$k]->nums_current = $db->loadResult();
		}*/
		$out = array('success' => 1, 'result' => $categories);
		AjaxHelper::send($out);
	}

	public function section_categories()
	{
		$jinput = JFactory::getApplication()->input;
		
		$cat_model = JModel::getInstance('Category', 'CobaltModel');
		$cats_model = JModel::getInstance('Categories', 'CobaltModel');
		
		$section_id = JRequest::getInt('section_id');
		// 		$category = $cat_model->getItem(JRequest::getInt('cat_id'));
		$cats_model->section = $section_id;
		$cats_model->parent_id = 1;
		$cats_model->order = JRequest::getVar('order', 'c.lft ASC');
		$cats_model->levels = 0;
		$cats_model->all = 0;
		$categories = $cats_model->getItems();
		
		$out = array('success' => 1, 'result' => $categories);
		AjaxHelper::send($out);
	}

	public function remove_tag()
	{
		$jinput = JFactory::getApplication()->input;
		
		$tag_id = JRequest::getInt('tid');
		$table = JTable::getInstance('Taghistory', 'CobaltTable');
		$table->load(array('tag_id' => $tag_id, 'record_id' => JRequest::getInt('rid')));
		$table->delete();
		$record = JTable::getInstance('Record', 'CobaltTable');
		$record->load(JRequest::getInt('rid'));
		$rtags = ($record->tags != '') ? json_decode($record->tags, 1) : array();
		unset($rtags[$tag_id]);
		$record->tags = json_encode($rtags);
		$record->store();
		echo json_encode(array('success' => '1'));
	}

	public function add_tags()
	{
		$jinput = JFactory::getApplication()->input;
		
		$user = JFactory::getUser();
		$tags = JRequest::getVar('tags');
		
		$tags = str_replace(', ', ',', $tags);
		$tags = explode(',', $tags);
		
		$tag_table = JTable::getInstance('Tags', 'CobaltTable');
		$taghist_table = JTable::getInstance('Taghistory', 'CobaltTable');
		
		$record = JTable::getInstance('Record', 'CobaltTable');
		$record->load(JRequest::getInt('rid'));
		$rtags = ($record->tags != '') ? json_decode($record->tags, 1) : array();
		
		$out = $data = array();
		
		$data['record_id'] = $record->id;
		$data['section_id'] = $record->section_id;
		
		$i = 0;
		
		foreach($tags as $tag)
		{
			if (count($rtags) >= JRequest::getInt('max'))
				break;
			$tag_table->reset();
			$tag_table->id = null;
			
			$tag_table->load(array('tag' => $tag));
			if (!$tag_table->id)
			{
				$tag_table->save(array('tag' => $tag));
			}
			$data['tag_id'] = $tag_table->id;
			$taghist_table->reset();
			$taghist_table->id = null;
			$taghist_table->load($data);
			if (!$taghist_table->id)
			{
				$data['user_id'] = $user->id;
				$taghist_table->save($data);
			}
			@$out[$i]->id = @$tag_table->id;
			$out[$i]->tag = $tag_table->tag;
			$rtags[$tag_table->id] = $tag_table->tag;
			$i ++;
		}
		
		$record->tags = json_encode($rtags);
		$record->store();
		
		$data = $record->getProperties();
		
		CEventsHelper::notify('record', CEventsHelper::_RECORD_TAGGED, $record->id, $record->section_id, 0, 0, 0, $data);
		
		$out = array('success' => 1, 'result' => $out);
		AjaxHelper::send($out);
	
	}

	public function field_call()
	{
		$jinput = JFactory::getApplication()->input;

        $func = JRequest::getVar('func');
        $id = JRequest::getInt('field_id');
        $record_id = JRequest::getInt('record_id');
        $params = JRequest::get('POST');

        if (!$id)
        {
            echo AjaxHelper::error(JText::_('AJAX_NOFIELDID'));
            return;
        }

        if (!$func)
        {
            echo AjaxHelper::error(JText::_('AJAX_NOFUNCNAME'));
            return;
        }

        JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . 'tables' . DS . 'field.php');
        $field_table = JTable::getInstance('Field', 'CobaltTable');
        $field_table->load($id);

        $field = $field_table->field_type;
        if (!$field)
        {
            echo AjaxHelper::error(JText::_('AJAX_NOFIELDNAME'));
            return;
        }

        $field_path = JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'fields' . DS . $field . DS . $field . '.php';
        $classname = 'JFormFieldC' . ucfirst($field);

        if ($field == 'upload')
        {
            $field_path = JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'library' . DS . 'php' . DS . 'fields' . DS . 'cobaltupload.php';
            $classname = 'CFormFieldUpload';
        }

        if (!JFile::exists($field_path))
        {
            echo AjaxHelper::error(JText::_('AJAX_FIELDNOTFOUND'));
            return;
        }

        require_once $field_path;

		$default = array();
		$record = NULL;
		if ($record_id)
		{
			$record_model = JModel::getInstance('Record', 'CobaltModel');
			$record = $record_model->getItem($record_id);
			$values = json_decode($record->fields, TRUE);
			$default = @$values[$id];
		}
		
		if (!class_exists($classname))
		{
			echo AjaxHelper::error(JText::_('CCLASSNOTFOUND'));
			return;
		}
		
		$fieldclass = new $classname($field_table, $default);
		
		if (!method_exists($fieldclass, $func))
		{
			echo AjaxHelper::error(JText::_('AJAX_METHODNOTFOUND'));
			return;
		}
		
		$result = $fieldclass->$func($params, $record);
		
		if ($fieldclass->getErrors())
		{
			echo AjaxHelper::error(JText::_($fieldclass->getError()));
			return;
		}
		
		if ($result)
		{
			$out = array('success' => 1, 'result' => $result);
			
			AjaxHelper::send($out);
		}
	}

	public function mark_notification()
	{
		$jinput = JFactory::getApplication()->input;
		
		$id = JRequest::getVar('id');
		$section_id = JRequest::getInt('section_id');
		
		if ($id == 'all')
		{
			$user = JFactory::getUser();
			$db = JFactory::getDbo();
			$query = $db->getQuery(true);
			$query->update('#__js_res_notifications');
			$query->set('notified = 1');
			$query->where('user_id = ' . $user->id);
			if ($section_id)
				$query->where('section_id = ' . $section_id);
			$db->setQuery($query);
			$db->query();
			if ($db->getErrors())
			{
				echo AjaxHelper::error(JText::_($db->getError()));
				return;
			}
		}
		else
		{
			$table = JTable::getInstance('Notification', 'CobaltTable');
			$table->load($id);
			$table->notified = 1;
			$table->store();
			if ($table->getErrors())
			{
				echo AjaxHelper::error(JText::_($table->getError()));
				return;
			}
		}
		echo json_encode(array('success' => '1'));
	}

	public function remove_notification()
	{
		$jinput = JFactory::getApplication()->input;
		
		$id = JRequest::getVar('id');
		$section_id = JRequest::getInt('id');
		
		if ($id == 'all')
		{
			$user = JFactory::getUser();
			$db = JFactory::getDbo();
			$query = $db->getQuery(true);
			$query->delete();
			$query->from('#__js_res_notifications');
			$query->where('user_id = ' . $user->id);
			if ($section_id)
				$query->where('section_id = ' . $section_id);
			$db->setQuery($query);
			$db->query();
			if ($db->getErrors())
			{
				echo AjaxHelper::error(JText::_($db->getError()));
				return;
			}
		}
		else
		{
			$table = JTable::getInstance('Notification', 'CobaltTable');
			$table->load($id);
			$table->delete();
			if ($table->getErrors())
			{
				echo AjaxHelper::error(JText::_($table->getError()));
				return;
			}
		}
		echo json_encode(array('success' => '1'));
	}

	public function get_notifications()
	{
		$jinput = JFactory::getApplication()->input;
		
		$ids = JRequest::getVar('exist');
		$section_id = JRequest::getVar('section_id');
		$user = JFactory::getUser();
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('*');
		$query->from('#__js_res_notifications');
		$query->where('user_id = ' . $user->id);
		$query->where('notified = 0');
		if ($section_id)
		{
			if (!is_array($section_id))
				settype($section_id, 'array');
			$query->where('ref_2 IN (' . implode(', ', $section_id) . ')');
		}
		if (count($ids))
			$query->where('id NOT IN (' . implode(', ', $ids) . ')');
		$query->order('ctime DESC');
		$db->setQuery($query);
		if (!$result = $db->loadObjectList())
		{
			echo AjaxHelper::error(JText::_($db->getError()));
			return " ";
		}
		$list = array();
		$k = 0;
		foreach($result as $i => $item)
		{
			$list[$i] = new stdClass();
			$list[$i]->id = $item->id;
			$list[$i]->html = CEventsHelper::get_notification($item);
		}
		echo json_encode(array('success' => '1', 'result' => $list));
	}
}
