<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.application.component.controllerform');

class CobaltControllerComment extends JControllerForm
{

	public function save($key = null, $urlVar = null)
	{
		$jinput = JFactory::getApplication()->input;
		
		$this->view_list = 'record';
		$this->view_item = 'record';
		
		$form = JRequest::getVar('jform', array(), 'post', 'array');
		
		$user = JFactory::getUser();
		$record = JModel::getInstance('Record', 'CobaltModel')->getItem($form['record_id']);
		$section = JModel::getInstance('Section', 'CobaltModel')->getItem($record->section_id);
		$type = JModel::getInstance('Form', 'CobaltModel')->getRecordType($record->type_id);
		
		CEmeraldHelper::allowType('comment', $type, $user->id, $section, true);
		if ($form['id'])
		{
			$this->view_list = 'comment';
			$this->view_item = 'comment';
			JRequest::setVar('id', $form['id']);
		}
		else
			JRequest::setVar('id', 0);
		parent::save($key, $urlVar);
	}

	public function postSaveHook(JModel &$model, $validData = array())
	{
		$jinput = JFactory::getApplication()->input;
		
		$record = JTable::getInstance('Record', 'CobaltTable');
		$record->load($validData['record_id']);
		$validData['record'] = $record->getProperties();
		
		
		if (JRequest::getInt('is_new'))
		{
			CEventsHelper::notify('record', CEventsHelper::_COMMENT_NEW, $validData['record_id'], $jinput->getInt('section_id'), $jinput->getInt('cat_id'), $model->getState('comment.id'), 0, $validData);
		}
		else if (JRequest::getInt('is_edited'))
		{
			CEventsHelper::notify('record', CEventsHelper::_COMMENT_EDITED, $validData['record_id'], $jinput->getInt('section_id'), $jinput->getInt('cat_id'), $model->getState('comment.id'), 0, $validData);
		}
		else
		{
			if ($validData['parent_id'])
			{
				$comment = JTable::getInstance('Comments', 'CobaltTable');
				$comment->load($validData['parent_id']);
				
				if ($comment->user_id)
				{
					CEventsHelper::notify('record', CEventsHelper::_COMMENT_REPLY, $validData['record_id'], $jinput->getInt('section_id'), $jinput->getInt('cat_id'), $validData['parent_id'], 0, $validData, 2, $comment->user_id);
				}
			}
		}
		
		if ($jinput->getInt('subscribe'))
		{
			CSubscriptionsHelper::subscribe_record($validData['record_id']);
		}
		
		$type = JModel::getInstance('Form', 'CobaltModel')->getRecordType($validData['record']['type_id']);
		CEmeraldHelper::countLimit('type', 'comment', $type, $validData['user_id']);
		
		$model_record = JModel::getInstance('Record', 'CobaltModel');
		$model_record->onComment($validData['record_id']);
	}

	public function cancel($key = null)
	{
		$this->view_list = 'records';
		parent::cancel($key);
	}

	protected function allowSave($data = array(), $key = 'id')
	{
		return TRUE;
	}

	protected function allowAdd($data = array())
	{
		$user = JFactory::getUser();
		$allow = $user->authorise('core.create', 'com_cobalt.comment');
		
		if ($allow === null)
		{
			return parent::allowAdd($data);
		}
		else
		{
			return $allow;
		}
	}

	protected function allowEdit($data = array(), $key = 'id')
	{
		return JFactory::getUser()->authorise('core.edit', 'com_cobalt.comment');
	}

	protected function getRedirectToItemAppend($recordId = null, $urlVar = 'id')
	{
		return $this->getRedirectToListAppend($recordId = null, $urlVar = 'id');
	}

	protected function getRedirectToListAppend($recordId = null, $urlVar = 'id')
	{
		$jinput = JFactory::getApplication()->input;
		
		$tmpl = JRequest::getCmd('tmpl');
		$post_jform = JRequest::getVar('jform');
		$record_id = $post_jform['record_id'];
		//		$secton_id		= JRequest::getCmd('section_id');
		$itemId = JRequest::getInt('Itemid');
		if ($this->view_item == 'comment')
		{
			$record_id = $post_jform['id'];
		}
		$append = '';
		
		if ($tmpl)
		{
			$append .= '&tmpl=' . $tmpl;
		}
		
		//		if ($type_id) {
		//			$append .= '&type_id='.$type_id;
		//		}
		//
		//		if ($secton_id) {
		//			$append .= '&section_id='.$secton_id;
		//		}
		

		if ($record_id)
		{
			$append .= '&id=' . $record_id;
		}
		
		if ($itemId)
		{
			$append .= '&Itemid=' . $itemId;
		}
		
		return $append;
	}

}