<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die;

jimport('joomla.application.component.controlleradmin');

class CobaltControllerComments extends JControllerAdmin
{
	public function getModel($type = 'Comment', $prefix = 'CobaltModel', $config = array())
	{
		return JModel::getInstance($type, $prefix, $config);
	}
	
	public function delete()
	{
		$jinput = JFactory::getApplication()->input;
		$cid	= JRequest::getVar('cid', array(), '', 'array');
		JArrayHelper::toInteger($cid);
		
		$comment = JTable::getInstance('Comments', 'CobaltTable');
		$comment->load($cid[0]);
		
		parent::delete();
		
		$model_record = JModel::getInstance('Record', 'CobaltModel');
		$model_record->onComment(JRequest::getVar('record_id'));
		
		$url = 'index.php?option=com_cobalt&view=record';
		$url .= $this->getRedirectToListAppend();
		$this->setRedirect($url);
		if($comment->user_id)
		{
			$record = JTable::getInstance('Record', 'CobaltTable');
			$record->load(JRequest::getInt('record_id'));
			
			$data = $comment->getProperties();
			$data['record'] = $record->getProperties();
			
			CEventsHelper::notify('record', CEventsHelper::_COMMENT_DELETED, JRequest::getVar('record_id'), JRequest::getVar('section_id'), 0, 0, 0, $data, 2, $comment->user_id);
		}
	}
	
	public function publish()
	{
	    parent::publish();
	    $jinput = JFactory::getApplication()->input;
	    
	    $url = 'index.php?option=com_cobalt&view=record';
		$url .= $this->getRedirectToListAppend();
		$this->setRedirect(JRoute::_($url));
		
		$task 	= $this->getTask();
		
		$cid	= JRequest::getVar('cid', array(), '', 'array');
		JArrayHelper::toInteger($cid);
		
		$comment = JTable::getInstance('Comments', 'CobaltTable');
		$comment->load($cid[0]);
		
		$data = $comment->getProperties();
		
		$record = JTable::getInstance('Record', 'CobaltTable');
		$record->load($comment->record_id);
			
		$data = $comment->getProperties();
		$data['record'] = $record->getProperties();
		
		if($comment->user_id)
		{
			CEventsHelper::notify('record', ($task == 'publish' ? CEventsHelper::_COMMENT_APPROVED : CEventsHelper::_COMMENT_UNPUBLISHED), JRequest::getVar('record_id'), JRequest::getVar('section_id'), 0, ($task == 'publish' ? $comment->id  : 0), 0, $data, 2, $comment->user_id);
		}
	}
	
	protected function getRedirectToItemAppend($recordId = null, $urlVar = 'id')
	{
		return $this->getRedirectToListAppend($recordId = null, $urlVar = 'id');
	}
	
	protected function getRedirectToListAppend($recordId = null, $urlVar = 'id')
	{
		$jinput = JFactory::getApplication()->input;
		
		$tmpl = JRequest::getCmd('tmpl');
		$record_id	= JRequest::getVar('record_id');
		$section_id	= JRequest::getVar('section_id');
		$cat_id	= JRequest::getVar('cat_id');
		$ucat_id	= JRequest::getVar('ucat_id');
		
		$append		= '';

		if ($tmpl) {
			$append .= '&tmpl='.$tmpl;
		}
		
		if ($record_id) {
			$append .= '&id='.$record_id;
		}
		if ($section_id) {
			$append .= '&section_id='.$section_id;
		}
		if ($cat_id) {
			$append .= '&cat_id='.$cat_id;
		}
		if ($ucat_id) {
			$append .= '&ucat_id='.$ucat_id;
		}
		
		return $append;
	}
	
}