<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.application.component.controlleradmin');

class CobaltControllerCron extends JControllerAdmin
{
	
	public function cleanFiles()
	{
		$db = JFactory::getDBO();
		
		$sql = "SELECT * FROM #__js_res_files WHERE record_id NOT IN (SELECT r.id FROM #__js_res_record AS r) OR saved = 0";
		$db->setQuery($sql);
		$files = $db->loadObjectList('id');
		$files_ids = array_keys($files);
		$cobalt_params = JComponentHelper::getParams('com_cobalt');
		
		if(!empty($files_ids))
		{
			$field_table = JTable::getInstance('Field', 'CobaltTable');
		
			foreach ($files AS $file)
			{
				$field_table->load($file->field_id);
				$field_params = new JRegistry($field_table->params);
				$subfolder = $field_params->get('params.subfolder', $field_table->field_type);
				$part = explode("_", $file->filename);
				unlink(JPATH_ROOT.DS.$cobalt_params->get('general_upload').DS.$subfolder.DS.date($cobalt_params->get('folder_format'), $part[0]).DS.$file->filename);
			}
		
			$sql = "DELETE FROM #__js_res_files WHERE id IN (".implode(',', $files_ids).")";
			$db->setQuery($sql);
			$db->query();
		}
		
		$files_in_folder = JFolder::files(JPATH_ROOT.DS.$cobalt_params->get('general_upload'), '.', TRUE, TRUE,
				array('.svn', 'CVS', '.DS_Store', '__MACOSX', 'index.html'), array('^\..*', '.*~', '^thumbs_cache*', '^avatars*'));
		
		$sql = "SELECT filename FROM #__js_res_files";
		$db->setQuery($sql);
		$files_in_db = $db->loadResultArray();
		
		if(!empty($files_in_folder))
		{
			foreach ($files_in_folder as $file) {
				if(!in_array(JFile::getName($file), $files_in_db))
				{
					JFile::delete($file);
				}
			}
		}
		
		exit();
	}
	
	public function sendAlert()
	{
		$this->_sendDaijest(1);
		$this->_sendDaijest(2);
		$this->_sendDaijest(3);
		$this->_sendDaijest(4);
		$this->_sendDaijest(5);
		
		exit();
	}
	
	private function _sendDaijest($type)
	{
		$db = JFactory::getDbo();
		
		switch($type)
		{
			case 1:
				$period = '1 MINUTE';
			break;
			case 2:
				$period = '1 DAY';
			break;
			case 3:
				$period = '1 WEEK';
			break;
			case 4:
				$period = '1 MONTH';
			break;
			case 5:
				$period = '3 MONTH';
			break;
		}
		
		$sql = "SELECT id, email FROM #__users WHERE block = 0 AND id IN(SELECT user_id FROM #__js_res_subscription_params WHERE subscribe = 1 AND schedule = $type AND last_send < NOW() - INTERVAL $period)";
		$db->setQuery($sql);
		$users = $db->loadObjectList('id');
		
		if(!empty($users))
		{
			$user_ids = array_keys($users);
			
			$sql = "SELECT * FROM #__js_res_notifications WHERE user_id IN (".implode(',', $user_ids).") AND alerted = 0 ORDER BY id DESC";
			$db->setQuery($sql);
			$notes = $db->loadObjectList();
			
			if($notes)
			{
				$config = JFactory::getConfig();
				$sorted_notes = array();
				foreach($notes as $note)
				{
					if(!is_object($note->params))
					{
						$note->params = new JRegistry($note->params);
					}
					$sorted_notes[$note->user_id][] = $note;
				}
				
				$main = JText::_('ALERTMAIN');
				$msg = JText::_('ALERTDAIJEST');
				$text_pattern = JString::str_ireplace('[MESSAGE_BODY]', $msg, $main);
				$uri = JFactory::getURI();
				$link = '<a href="'.$uri->root().'%s">%s</a>';
				foreach ($sorted_notes as $user_id => $notes)
				{
					$num = 0;
					$note_ids = $list = array();
					foreach ($notes as $key => $note) 
					{
						$num ++;

						$record = JTable::getInstance('Record', 'CobaltTable');
						$record->load($note->ref_1);

						if(empty($record->id))
						{
							$db->setQuery("DELETE FROM #__js_res_notifications WHERE id = $note->id");
							$db->query();
							continue;
						}

						$list[] = sprintf('<br/>'.str_repeat('&nbsp;', 4)."* %s <br/>".str_repeat('&nbsp;', 12), JText::_('ALERT_EVENT_'.strtoupper($note->type)).'&nbsp;&nbsp;&nbsp;'.JFactory::getDate($note->ctime)->format('d M Y H:i'));
						switch($note->type)
						{
							case 'comment_new':
							case 'comment_rated':
							case 'comment_approved':
							case 'comment_reply':
								$list[] = sprintf($link, Url::record($record).'#comment'.$note->ref_4, $note->params->get('record.title').'<br/>');
								$comment = strip_tags($note->params->get('comment'));
								if(JString::strlen($comment) > 50)
								{
									$comment = JString::substr($comment, 0, 50).'...';
								}
								$list[] = sprintf(str_repeat('&nbsp;', 12)." %s ", JText::_('CCOMMENT').': '.$comment.'<br/>');
								
								break;
								
							case 'comment_deleted':
								$list[] = sprintf($link, Url::record($record), $note->params->get('record.title').'<br/>');
								$comment = strip_tags($note->params->get('comment'));
								$list[] = sprintf(str_repeat('&nbsp;', 12)." %s ", JText::_('CCOMMENT').': '.$comment.'<br/>');
								
								break;
								
							case 'record_approved':
							case 'record_new':
							case 'record_edited':
							case 'record_rated':
							case 'record_expired':
							case 'record_featured_expired':
							case 'record_bookmarked':
							case 'record_tagged':
							case 'record_featured':
							case 'record_extended':
							case 'record_unpublished':
								$list[] = sprintf($link, Url::record($record), $note->params->get('record.title').'<br/>');
								
								break;
								
							case 'record_deleted':
								$list[] = $note->params->get('record.title').'<br/>';
								
								break;
						}
						
						$note_ids[] = $note->id;
					}
					$subject = JText::sprintf('ALERT_SUBJECT_DAIJEST_' . $type, $num).' '.$config->get('sitename');
					$text = JString::str_ireplace('[EVENTS]', implode("", $list), $text_pattern);
					$text = str_replace(array(
							'[BRAND]', '[USER]', '[NUM]'
					), array(
							$config->get('sitename'), JFactory::getUser($user_id)->get('name'),  $num
					), $text);
					
					$result = JFactory::getMailer()->sendMail($config->get('mailfrom'), $config->get('fromname'), JFactory::getUser($user_id)->get('email'), $subject, $text, true);
					
					if($result)
					{
						$sql = "UPDATE #__js_res_notifications SET alerted = 1 WHERE id IN (".implode(',', $note_ids).")";
						$db->setQuery($sql);
						$db->query();
						
						$sql = "UPDATE #__js_res_subscription_params SET last_send = NOW() WHERE user_id = {$user_id}";
						$db->setQuery($sql);
						$db->query();
						
					}
				}
			}
		}
	}
}