<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.application.component.controlleradmin');

class CobaltControllerField extends JControllerAdmin
{
	public function call()
	{
		$jinput = JFactory::getApplication()->input;
		
		$func  = JRequest::getVar('func');
		$field_id = JRequest::getInt('field_id');
		$record_id = JRequest::getInt('record_id');
		$params = JRequest::get('POST');
		$params_get = JRequest::get('GET');
		 
		//error_log("[Start POST] ".print_r($params), 3, JPATH_ROOT.DS.'logs'.DS.'log_field.txt');
		//error_log("\n\n[Start GET] ".print_r(JRequest::get())."\n\n", 3, JPATH_ROOT.DS.'logs'.DS.'log_field.txt');
		
		if(!$field_id)
		{
			JError::raiseError(500, JText::_('CERRNOFILEID'));
			return;
		}
		
		JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . '/tables');
		$field_table = JTable::getInstance('Field', 'CobaltTable');
		$field_table->load($field_id);
		
		if(!$field_table->id)
		{
			JError::raiseError(500, JText::_('CERRNOFILED'));
			return;
		}
		
		
		$field_path =  JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'fields' . DS . $field_table->field_type . DS . $field_table->field_type . '.php';
		if(!JFile::exists($field_path))
		{
			JError::raiseError(500, JText::_('CERRNOFILEHDD'));
			return;
		}
		
		if(!$func)
		{
			JError::raiseError(500, JText::_('AJAX_NOFUNCNAME'));
			return;
		}
		
		require_once  $field_path;
		
		
		$default = array();
		$record = NULL;
		if($record_id)
		{
			$record_model = JModel::getInstance('Record', 'CobaltModel');
			$record = $record_model->getItem($record_id);
			$values = json_decode($record->fields, TRUE);
			$default = @$values[$id];
		}
		
		
		$classname = 'JFormFieldC' . ucfirst($field_table->field_type);
		if(!class_exists($classname))
		{
			JError::raiseError(500, JText::_('CCLASSNOTFOUND'));
			return ;
		}
		
		$fieldclass = new $classname($field_table, $default);
		
		if(!method_exists($fieldclass, $func))
		{
			JError::raiseError(500, JText::_('AJAX_METHODNOTFOUND'));
			return ;
		}
		$result = $fieldclass->$func($params, $record, $this, (count($params) ? null : $params_get) );
		
		if($fieldclass->getErrors())
		{
			JError::raiseError(500, $fieldclass->getError());
			return;
		}
	}
}