<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.application.component.controlleradmin');
jimport('mint.resizeimage');

class CobaltControllerFiles extends JControllerAdmin
{

	public function reindex()
	{
		$section_id = 1;
		$field_id = 2;

		$db = JFactory::getDbo();

		$db->setQuery("SELECT id, fields FROM #__js_res_record WHERE section_id = " . $section_id);
		$records = $db->loadObjectList();

		foreach($records as $record)
		{
			$data = json_decode($record->fields, TRUE);
			$db->setQuery("SELECT id, filename, realname, ext, size, title, description, width, height, fullpath, params
			FROM #__js_res_files
			WHERE record_id = {$record->id} AND field_id = {$field_id}");

			$data[$field_id] = $db->loadAssocList();
			$data = json_encode($data);

			$db->setQuery("UPDATE #__js_res_record SET fields = '{$data}' WHERE id = " . $record->id);
			$db->query();
		}
	}

	public function download()
	{
		$jinput = JFactory::getApplication()->input;

		$return = base64_decode(JRequest::getVar('return'));
		$params = JComponentHelper::getParams('com_cobalt');

		$files = JTable::getInstance('Files', 'CobaltTable');
		if($id = JRequest::getVar('id', 0))
		{
			$files->load($id);
		}
		else
		{
			$files->load(array(
				'filename' => JRequest::getVar('file')
			));
		}
		$field_id = JRequest::getInt('fid');
		if(! $field_id)
		{
			JError::raiseWarning(403, JText::_('CERRNOFILEID'));
			$this->setRedirect($return);
			return;
		}

		JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . 'tables' . DS . 'field.php');
		$field_table = JTable::getInstance('Field', 'CobaltTable');
		$field_table->load($field_id);
		if(! $field_table->id)
		{
			JError::raiseWarning(403, JText::_('CERRNOFILED'));
			$this->setRedirect($return);
			return;
		}
		$field_params = new JRegistry($field_table->params);
		$subfolder = $field_params->get('params.subfolder', $files->ext);

		$field_path = JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'fields' . DS . $field_table->field_type . DS . $field_table->field_type . '.php';
		if(! JFile::exists($field_path))
		{
			JError::raiseWarning(403, JText::_('CERRNOFILEDFILE'));
			$this->setRedirect($return);
			return;
		}

		$record_id = JRequest::getInt('rid');
		if(! $record_id)
		{
			JError::raiseWarning(403, JText::_('CERRNORECORDID'));
			$this->setRedirect($return);
			return;
		}

		$record_model = JModel::getInstance('Record', 'CobaltModel');
		$record = $record_model->getItem($record_id);
		if(! $record->id)
		{
			JError::raiseWarning(403, JText::_('CERRNORECORD'));
			$this->setRedirect($return);
			return;
		}
		$values = json_decode($record->fields, TRUE);
		$default = @$values[$field_id];

		require_once $field_path;

		$classname = 'JFormFieldC' . ucfirst($field_table->field_type);

		if(! class_exists($classname))
		{
			JError::raiseWarning(403, JText::_('CCLASSNOTFOUND') . ': ' . $classname);
			$this->setRedirect($return);
			return;
		}

		$fieldclass = new $classname($field_table, $default);

		if(! method_exists($fieldclass, 'onBeforeDownload'))
		{
			JError::raiseWarning(403, JText::_('CERRCANNOTPROCESSFILE'));
			$this->setRedirect($return);
			return;
		}

		$fidx = JRequest::getVar('fidx', 0);
		$fieldclass->onBeforeDownload($record, $fidx, $id);

		if($fieldclass->getErrors())
		{
			//var_dump($fieldclass->getErrors(), $return); exit;
			JError::raiseWarning(403, implode("</li><li>", $fieldclass->getErrors()));
			$this->setRedirect($return);
			return;
		}

		if(! $files->id)
		{
			$value = $fieldclass->__get('value');
			$fileslist = (array)(isset($value['files']) ? $value['files'] : $value);
			if(! $fileslist)
			{
				JError::raiseWarning(403, JText::_('CERRNOFILEHDD'));
				$this->setRedirect($return);
				return;
			}
			if(count($fileslist) > 1)
			{
				$zip_filename = JPATH_CACHE . DS . strtolower(sprintf('UNPACK_FIRST_%s.zip', $record->title));
				$zipper = new ZipArchive();
				$zipper->open($zip_filename, ZIPARCHIVE::CREATE);

				foreach($fileslist as $file)
				{
					$add = JPath::clean(JPATH_ROOT . DS . $params->get('general_upload') . DS . $subfolder . DS . $file['fullpath']);
					$zipper->addFile($add, $file['realname']);
				}

				$zipper->close();

				$files->realname = basename($zip_filename);
				$files->size = filesize($zip_filename);

				$download_file = $zip_filename;
			}
			else
			{
				$files = array_shift($fileslist);
				$download_file = JPATH_ROOT . DS . $params->get('general_upload') . DS . $subfolder . DS . $files->fullpath;
			}
		}
		else
		{
			if(! JFile::exists(JPATH_ROOT . DS . $params->get('general_upload') . DS . $subfolder . DS . $files->fullpath))
			{
				JError::raiseWarning(403, JText::_('CERRNOFILEHDD'));
				$this->setRedirect($return);
				return;
			}
			$download_file = JPATH_ROOT . DS . $params->get('general_upload') . DS . $subfolder . DS . $files->fullpath;
		}

		$browser = $_SERVER['HTTP_USER_AGENT'];

		if(@ereg('Opera(/| )([0-9].[0-9]{1,2})', $browser))
		{
			$browser = 'OPERA';
		}
		elseif(@ereg('MSIE ([0-9].[0-9]{1,2})', $browser))
		{
			$browser = 'IE';
		}
		elseif(@ereg('OmniWeb/([0-9].[0-9]{1,2})', $browser))
		{
			$browser = 'OMNIWEB';
		}
		elseif(@ereg('(Konqueror/)(.*)', $browser))
		{
			$browser = 'KONQUEROR';
		}
		elseif(@ereg('Mozilla/([0-9].[0-9]{1,2})', $browser))
		{
			$browser = 'MOZILLA';
		}
		else
		{
			$browser = 'OTHER';
		}

		header('Content-Type: ' . (($browser == 'IE' || $browser == 'OPERA') ? 'application/octetstream' : 'application/octet-stream'));
		header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');
		header('Content-Transfer-Encoding: binary');
		header('Content-Length: ' . $files->size);
		header('Content-Encoding: none');
		header('Content-Disposition: attachment; filename="' . $files->realname . '"');
		header('Cache-Control: no-cache, must-revalidate');
		header('Pragma: no-cache');

		if($browser == 'IE')
		{
			header('Cache-Control: must-revalidate, post-check=0, pre-check=0', TRUE);
			header('Pragma: public', TRUE);
		}


		$this->_readfileChunked($download_file);

		$files->hit();
		exit();
	}

	function _readfileChunked($filename) {
		$chunksize = 1*(1024*1024); // how many bytes per chunk
		$handle = fopen($filename, 'rb');
		while (!feof($handle)) {
			$buffer = fread($handle, $chunksize);
			echo $buffer;
			ob_flush();
			flush();
		}
		return fclose($handle);
	}


	public function download_attach()
	{
		$jinput = JFactory::getApplication()->input;

		$params = JComponentHelper::getParams('com_cobalt');

		$files = JTable::getInstance('Files', 'CobaltTable');
		if($id = JRequest::getVar('id', 0))
		{
			$files->load($id);
		}
		if(! $files->id)
		{
			JError::raiseWarning(403, JText::_('CERRNOFILEID'));
			return;
		}

		if(! JFile::exists(JPATH_ROOT . DS . $params->get('general_upload') . DS . $files->ext . DS . $files->fullpath))
		{
			JError::raiseWarning(403, JText::_('CERRNOFILEHDD'));
			return;
		}
		$download_file = JPATH_ROOT . DS . $params->get('general_upload') . DS . $files->ext . DS . $files->fullpath;

		$browser = $_SERVER['HTTP_USER_AGENT'];

		if(@ereg('Opera(/| )([0-9].[0-9]{1,2})', $browser))
		{
			$browser = 'OPERA';
		}
		elseif(@ereg('MSIE ([0-9].[0-9]{1,2})', $browser))
		{
			$browser = 'IE';
		}
		elseif(@ereg('OmniWeb/([0-9].[0-9]{1,2})', $browser))
		{
			$browser = 'OMNIWEB';
		}
		elseif(@ereg('(Konqueror/)(.*)', $browser))
		{
			$browser = 'KONQUEROR';
		}
		elseif(@ereg('Mozilla/([0-9].[0-9]{1,2})', $browser))
		{
			$browser = 'MOZILLA';
		}
		else
		{
			$browser = 'OTHER';
		}

		header('Content-Type: '. (($browser == 'IE' || $browser == 'OPERA') ? 'application/octetstream' : 'application/octet-stream'));
		header('Expires: '. gmdate('D, d M Y H:i:s') . ' GMT');
		header('Content-Transfer-Encoding: binary');
		header('Content-Length: '. $files->size);
		header('Content-Encoding: none');
		header('Content-Disposition: attachment; filename="' . $files->realname . '"');
		header('Cache-Control: no-cache, must-revalidate');
		header('Pragma: no-cache');

		if($browser == 'IE')
		{
			header('Cache-Control: must-revalidate, post-check=0, pre-check=0', TRUE);
			header('Pragma: public', TRUE);
		}

		$this->_readfileChunked($download_file);

		$files->hit();
	}

	public function upload()
	{
		$jinput = JFactory::getApplication()->input;
		require_once JPATH_ROOT . DS . 'media' . DS . 'mint' . DS . 'js' . DS . 'mooupload' . DS . 'mooupload.php';

		$upload = new Mooupload();
		$response = $upload->upload();
		if($response['finish'])
		{
			$user = JFactory::getUser();
			$params = JComponentHelper::getParams('com_cobalt');

			$time = substr($response['upload_name'], 0, strpos($response['upload_name'], '_'));
			$date = date($params->get('folder_format', 'Y-m'), $time);
			$ext = strtolower(JFile::getExt($response['upload_name']));

			$subfolder = $ext;
			if($field_id = JRequest::getInt('field_id'))
			{
				$field = JTable::getInstance('Field', 'CobaltTable');
				$field->load($field_id);
				$field->params = new JRegistry($field->params);
				$subfolder = $field->params->get('params.subfolder', $field->field_type);
			}

			$dest = JPATH_ROOT . DS . $params->get('general_upload') . DS . $subfolder . DS;
			$index = '<html><body></body></html>';
			if(! JFolder::exists($dest))
			{
				JFolder::create($dest, 0777);
				JFile::write($dest . DS . 'index.html', $index);
			}

			$dest .= $date . DS;
			if(! JFolder::exists($dest))
			{

				JFolder::create($dest, 0777);
				JFile::write($dest . DS . 'index.html', $index);
			}

			$copied = JFile::copy(JPATH_ROOT . DS . 'tmp' . DS . $response['upload_name'], $dest . JFile::stripExt($response['upload_name']) . '.' . $ext);

			$root = JPath::clean(JPATH_ROOT . DS . $params->get('general_upload'));
			$url = str_replace(JPATH_ROOT . DS, '', $root);
			$url = str_replace("\\", '/', $url);
			$url = JURI::root() . str_replace("//", "/", $url . '/' . $subfolder . '/' . $date . '/' . $response['upload_name']);

			$data = array(
				'id' => NULL,
				'filename' => JFile::stripExt($response['upload_name']) . '.' . $ext,
				'realname' => urldecode($response['name']),
				'section_id' => JRequest::getInt('section_id'),
				'record_id' => JRequest::getInt('record_id'),
				'type_id' => JRequest::getInt('type_id'),
				'field_id' => JRequest::getInt('field_id'),
				'ext' => $ext,
				'fullpath' => JPath::clean($date . DS . JFile::stripExt($response['upload_name']) . '.' . $ext, '/'),
				'size' => $response['size']
			);

			if(in_array(strtolower($ext), array(
				'jpg',
				'jpeg',
				'png',
				'gif',
				'bmp'
			)))
			{
				$session = JFactory::getSession();
				$width = $session->get('width', false, JRequest::getVar('key'));
				$height = $session->get('height', false, JRequest::getVar('key'));

				if($width && $height)
				{
					$resizer = new JS_Image_Resizer($dest . $response['upload_name']);
					$resizer->resize_limitwh($width, $height, $dest . $response['upload_name']);
					$resizer->close();

					@chmod($dest . $response['upload_name'], 0644);
				}

				$size = @getimagesize(JPath::clean($dest . $response['upload_name']));

				if($size && ! empty($size))
				{
					$data['width'] = $size[0];
					$data['height'] = $size[1];
				}

				if(function_exists('exif_read_data') && in_array(strtolower($ext), array(
					'jpg',
					'jpeg',
					'ttf'
				)))
				{
					$metadata = @exif_read_data(JPath::clean(JPATH_ROOT . DS . 'tmp' . DS . $response['upload_name']));
					$data['params'] = json_encode($metadata);
				}

			}

			if(in_array(strtolower($ext), array(
				'mp3'
			)))
			{
				$data['params'] = $this->_getID3(JPath::clean(JPATH_ROOT . DS . 'tmp' . DS . $response['upload_name']));
			}

			$data['size'] = filesize($dest . $response['upload_name']);
			$table = JTable::getInstance('Files', 'CobaltTable');
			$table->save($data);
			$response['row_id'] = $table->id;
			if($copied)
			{
				JFile::delete(JPATH_ROOT . DS . 'tmp' . DS . $response['upload_name']);
			}
		}

		JResponse::setHeader('Cache-Control', 'no-cache, must-revalidate');
		JResponse::setHeader('Expires', 'Mon, 26 Jul 1997 05:00:00 GMT');
		JResponse::setHeader('Content-type', 'application/json');
		AjaxHelper::send($response);
	}

	public function uploadremove()
	{

		$jinput = JFactory::getApplication()->input;

		$filename = JRequest::getVar('filename');

		$files_table = JTable::getInstance('Files', 'CobaltTable');
		$field_table = JTable::getInstance('Field', 'CobaltTable');
		$record_table = JTable::getInstance('Record', 'CobaltTable');

		$files_table->load(array(
			'filename' => $filename
		));

		$field_table->load($files_table->field_id);
		$field_params = new JRegistry($field_table->params);

		$params = JComponentHelper::getParams('com_cobalt');
		// 		$time = substr($filename, 0, strpos($filename, '_'));
		// 		$date = date($params->get('folder_format'), $time);
		$ext = JFile::getExt($filename);
		$id = str_replace('.' . $ext, '', $filename);

		$subfolder = $field_params->get('params.subfolder', $field_table->field_type);
		$full_file_path = JPATH_ROOT . DS . $params->get('general_upload') . DS . $subfolder . DS . $files_table->fullpath;
		if(JFile::exists($full_file_path))
		{
			if(JFile::delete($full_file_path))
			{
				$out = array(
					'success' => 1
				);
			}
			else
			{
				$out = array(
					'success' => 0
				);
			}
		}
		else
		{
			$out = array(
				'success' => 2
			);
		}
		$out['id'] = $id;
		if($out['success'] > 0)
		{
			if($files_table->id)
			{
				$files_table->delete();
			}

			if($files_table->record_id)
			{
				$record_table->load($files_table->record_id);
				$fields = json_decode($record_table->fields, true);

				if(isset($fields[$field_table->id]))
				{
					$files = &$fields[$field_table->id];
					if(isset($fields[$field_table->id]['files']))
					{
						$files = &$fields[$field_table->id]['files'];
					}
					if(isset($fields[$field_table->id]['uploads']))
					{
						$files = &$fields[$field_table->id]['uploads'];
					}

					foreach($files as $key => &$file)
					{
						if($file['id'] == $files_table->id)
						{
							unset($files[$key]);
							break;
						}
					}

					$record_table->fields = json_encode($fields);
					$record_table->store();
				}
			}
		}

		AjaxHelper::send($out);
	}

	public function show()
	{
		$jinput = JFactory::getApplication()->input;

		$files = JTable::getInstance('Files', 'CobaltTable');
		if($id = JRequest::getVar('id', 0))
		{
			$files->load($id);
		}
		if(! $files->id)
		{
			$thumb = JPATH_ROOT . DS . 'media' . DS . 'mint' . DS . 'images' . DS . 'notfound.jpg';
		}
		else
		{
			$files->views += 1;
			$files->store();

			$data = explode('_', $files->filename);
			$params = JComponentHelper::getParams('com_cobalt');
			$thumb_name = JRequest::getVar('file_key');
			$thumb = JPATH_ROOT . DS . JComponentHelper::getParams('com_cobalt')->get('general_upload') . DS . 'thumbs_cache' . DS . date($params->get('folder_format', 'Y-m'), $data[0]) . DS . $thumb_name . '.' . $files->ext;

			if(! JFile::exists($thumb))
			{
				$thumb = JPATH_ROOT . DS . 'media' . DS . 'mint' . DS . 'images' . DS . 'notfound.jpg';
			}
		}

		if(strtolower($files->ext) == 'jpg')
		{
			$files->ext = 'jpeg';
		}
		JResponse::clearHeaders();
		header("Content-Type: image/" . strtolower($files->ext));
		header('Expires: ' . gmdate('D, d M Y H:i:s', time() + 200000) . ' GMT');
		header("Pragma: public"); // required
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");

		echo readfile($thumb);
		exit();
	}

	private function _getID3($mp3)
	{
		$genre_arr = array(
			"Blues",
			"Classic Rock",
			"Country",
			"Dance",
			"Disco",
			"Funk",
			"Grunge",
			"Hip-Hop",
			"Jazz",
			"Metal",
			"New Age",
			"Oldies",
			"Other",
			"Pop",
			"R&B",
			"Rap",
			"Reggae",
			"Rock",
			"Techno",
			"Industrial",
			"Alternative",
			"Ska",
			"Death Metal",
			"Pranks",
			"Soundtrack",
			"Euro-Techno",
			"Ambient",
			"Trip-Hop",
			"Vocal",
			"Jazz+Funk",
			"Fusion",
			"Trance",
			"Classical",
			"Instrumental",
			"Acid",
			"House",
			"Game",
			"Sound Clip",
			"Gospel",
			"Noise",
			"AlternRock",
			"Bass",
			"Soul",
			"Punk",
			"Space",
			"Meditative",
			"Instrumental Pop",
			"Instrumental Rock",
			"Ethnic",
			"Gothic",
			"Darkwave",
			"Techno-Industrial",
			"Electronic",
			"Pop-Folk",
			"Eurodance",
			"Dream",
			"Southern Rock",
			"Comedy",
			"Cult",
			"Gangsta",
			"Top 40",
			"Christian Rap",
			"Pop/Funk",
			"Jungle",
			"Native American",
			"Cabaret",
			"New Wave",
			"Psychadelic",
			"Rave",
			"Showtunes",
			"Trailer",
			"Lo-Fi",
			"Tribal",
			"Acid Punk",
			"Acid Jazz",
			"Polka",
			"Retro",
			"Musical",
			"Rock & Roll",
			"Hard Rock",
			"Folk",
			"Folk-Rock",
			"National Folk",
			"Swing",
			"Fast Fusion",
			"Bebob",
			"Latin",
			"Revival",
			"Celtic",
			"Bluegrass",
			"Avantgarde",
			"Gothic Rock",
			"Progressive Rock",
			"Psychedelic Rock",
			"Symphonic Rock",
			"Slow Rock",
			"Big Band",
			"Chorus",
			"Easy Listening",
			"Acoustic",
			"Humour",
			"Speech",
			"Chanson",
			"Opera",
			"Chamber Music",
			"Sonata",
			"Symphony",
			"Booty Bass",
			"Primus",
			"Porn Groove",
			"Satire",
			"Slow Jam",
			"Club",
			"Tango",
			"Samba",
			"Folklore",
			"Ballad",
			"Power Ballad",
			"Rhythmic Soul",
			"Freestyle",
			"Duet",
			"Punk Rock",
			"Drum Solo",
			"Acapella",
			"Euro-House",
			"Dance Hall"
		);

		$filesize = filesize($mp3);
		$file = fopen($mp3, "r");
		fseek($file, - 128, SEEK_END);

		$tag = fread($file, 3);

		$data = array();
		if($tag == "TAG")
		{
			$data["song"] = trim(fread($file, 30));
			$data["artist"] = trim(fread($file, 30));
			$data["album"] = trim(fread($file, 30));
			$data["year"] = trim(fread($file, 4));
			$data["comment"] = trim(fread($file, 30));
			$id = ord(trim(fread($file, 1)));
			$data["genre"] = '';
			if(isset($genre_arr[$id]))
			{
				$data["genre"] = $genre_arr[$id];
			}

		}
		fclose($file);
		return $data;
	}
}
