<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.application.component.controllerform');

class CobaltControllerForm extends JControllerForm
{

	public function save($key = null, $urlVar = null)
	{
		$jinput = JFactory::getApplication()->input;

		$this->view_list = 'records';
		$record = JRequest::getVar('jform', array(), 'post', 'array');
		$user = JFactory::getUser();
		$section = ItemsStore::getSection($record['section_id']);
		$type = ItemsStore::getType($record['type_id']);

		CEmeraldHelper::allowType(($record['id'] ? 'edit' : 'submit'), $type, (! empty($record['user_id']) ? $record['user_id'] : $user->id), $section, true);

		$app = JFactory::getApplication();
		if(!$app->getUserState('com_cobalt.edit.form.id'))
		{
			$app->setUserState('com_cobalt.edit.form.id',  $record['id']);
		}

		parent::save($key, $urlVar);

	}

	public function postSaveHook(JModel &$model, $validData = array())
	{
		$jinput = JFactory::getApplication()->input;
		$jform = JRequest::getVar('jform', array(), 'post', 'array');
// 		echo "<pre>jform ";
// 		print_r($jform);
// 		echo "</pre>";
		$db = JFactory::getDbo();
		$user = JFactory::getUser();
		$fileds_model = JModel::getInstance('Fields', 'CobaltModel');
		$record_id = $model->getState('form.id');
		//$validData['id'] = $record_id;
		$new = $model->getState('form.new');
		$fields = $fileds_model->getFormFields($validData['type_id'], $record_id, FALSE);
		$table = JTable::getInstance('Record_values', 'CobaltTable');

		$type = ItemsStore::getType($validData['type_id']);
		$section = ItemsStore::getSection($validData['section_id']);

		$method = $jform['id'] ? 'edit' : 'submit';
		foreach($fields as $key => $field)
		{
			if(! $validData['id'])
			{
				if(! in_array($field->params->get('core.field_submit_access'), $user->getAuthorisedViewLevels()))
				{
					unset($fields[$key]);
					continue;
				}
			}
			else
			{
				if(! in_array($field->params->get('core.field_edit_access'), $user->getAuthorisedViewLevels()))
				{
					unset($fields[$key]);
					continue;
				}
			}

			if(! CEmeraldHelper::allowField($method, $field, $user->id, $section))
			{
				if($field->params->get('emerald.field_' . $method . '_subscription'))
				{
					unset($fields[$key]);
					continue;
				}
			}

			$ids[] = $field->id;
		}

		$table->clean($record_id, $ids);

		$save = array(
			'record_id' => $record_id,
			'user_id' => (int)@$validData['user_id'],
			'type_id' => $validData['type_id'],
			'section_id' => $validData['section_id'],
			'category_id' => 0,
			'params' => '',
			'ip' => $_SERVER['REMOTE_ADDR'],
			'ctime' => JFactory::getDate()->toSql()
		);

		// if it isNew record valid data haven't id put it in as new_id to get record id in onStoreValues
		// but why not to put it to ID and not check anything in store value?
		$validData['id'] = $record_id;

		foreach($fields as $field)
		{
			$values = $field->onStoreValues($validData);
			settype($values, 'array');

			$save['field_type'] = $field->type;
			$save['field_label'] = $field->label;
			$save['field_key'] = 'k' . md5($field->label . '-' . $field->type);

			foreach($values as $key => $value)
			{
				$save['value_index'] = $key;
				$save['field_id'] = $field->id;
				if(is_array($value) || is_object($value))
				{
					$value = json_encode(CensorHelper::cleanText($value));
				}

				$save['field_value'] = trim(CensorHelper::cleanText($value));

				if(!$save['field_value']) continue;

				$table->bind($save);
				$table->store();
				$table->reset();
				$table->id = NULL;
			}

			CEmeraldHelper::countLimit('field', $method, $field, $user->id);
		}

		if($section->categories)
		{
			$categories = @$validData['category'];

			if(! $categories && JRequest::getInt('cat_id'))
			{
				$categories[] = JRequest::getInt('cat_id');
			}
			ArrayHelper::clean_r($categories);
			JArrayHelper::toInteger($categories);

			// category limit check. We have to see if selected categories
			// are in alloed categories. And if no category selected, set
			// category from the limit.
			if($type->params->get('category_limit.category'))
			{
				// Get categories IDS
				$cats = $type->params->get('category_limit.category');
				ArrayHelper::clean_r($cats);
				JArrayHelper::toInteger($cats);

				// if it is all node, get all coresponding IDs.
				if($type->params->get('category_limit.category_limit_mode') == 1)
				{
					$query = $db->getQuery(true);

					$query->select("c.id");
					$query->from('#__js_res_categories AS c');
					$query->where('c.section_id = ' . $section->id);
					$query->where('c.published = 1');
					//$query->where('c.level <= 10');

					foreach($cats as $cat)
					{
						$sql = "SELECT level, lft, rgt FROM `#__js_res_categories` WHERE id = {$cat}";
						$db->setQuery($sql);
						$parent = $db->loadObject();

						$where[] = "c.lft BETWEEN {$parent->lft} AND {$parent->rgt}";

					}
					$query->where("((".implode(') OR (', $where)."))");

					$db->setQuery($query);
					$add_cats = $db->loadColumn();
					ArrayHelper::clean_r($add_cats);
					JArrayHelper::toInteger($add_cats);

					$cats = array_merge($cats, $add_cats);
					$cats = array_unique($cats);
					ArrayHelper::clean_r($cats);
					JArrayHelper::toInteger($cats);
				}

				// if it is disallow mode, get allowed categories or inverse IDs.
				if($type->params->get('category_limit.allow') == 0 && $cats)
				{
					$sql = "SELECT id FROM `#__js_res_categories` WHERE id NOT IN (" . implode(',', $cats) . ") AND section_id = {$section->id}";
					$db->setQuery($sql);
					$cats = $db->loadColumn();
					ArrayHelper::clean_r($cats);
					JArrayHelper::toInteger($cats);
				}

				foreach($categories as $k => $category)
				{
					if((int)$category == 0)
					{
						continue;
					}
					if(!in_array($category, $cats))
					{
						unset($categories[$k]);
					}
				}

				if(!$categories && $cats)
				{
					$categories[] = array_shift($cats);
				}
			}

			if($categories)
			{
				settype($categories, 'array');

				$model_categories = JModel::getInstance('Categories', 'CobaltModel');
				$table_category = JTable::getInstance('Record_category', 'CobaltTable');

				$cids = array(0);
				foreach($categories as $category)
				{
					if((int)$category == 0)
					{
						continue;
					}

					$array = array(
						'catid' => $category,
						'record_id' => $record_id
					);
					$table_category->load($array);
					$array['section_id'] = $validData['section_id'];

					if($table_category->id)
					{
						//$array['id'] = $table_category->id;
					}
					else
					{
						$array['id'] = NULL;
					}

					//$table_category->bind($array);
					$table_category->save($array);
					$cids[] = $table_category->catid;

					$table_category->reset();
					$table_category->id = NULL;

				}

				if($cids)
				{
					$sql = 'DELETE FROM #__js_res_record_category WHERE record_id = ' . $record_id . ' AND catid NOT IN (' . implode(',', $cids) . ')';
					$db->setQuery($sql);
					$db->query();
				}
			}
		}

		$tags = array();
		if(isset($validData['tags']) && $validData['tags'] != '') $tags = explode(',', $validData['tags']);

		ArrayHelper::clean_r($tags);
		ArrayHelper::trim_r($tags);
		$tags = array_unique($tags);


		$tag_table = JTable::getInstance('Tags', 'CobaltTable');
		$taghist_table = JTable::getInstance('Taghistory', 'CobaltTable');

		$out = $data = $rtags = array();

		$data['record_id'] = $record_id;
		$data['section_id'] = $validData['section_id'];
		$data['user_id'] = (int)@$validData['user_id'];

		$i = 0;
		foreach($tags as $tag)
		{
			if($tag == '')
			{
				continue;
			}
			if($type->params->get('general.item_tags_max', 25) && $i > $type->params->get('general.item_tags_max', 25))
			{
				break;
			}

			$tag_table->reset();
			$tag_table->id = null;
			$tag_table->load(array(
				'tag' => $tag
			));
			if(! $tag_table->id)
			{
				$tag_table->save(array(
					'tag' => $tag
				));
			}

			$data['tag_id'] = $out[] = $tag_table->id;
			$taghist_table->reset();
			$taghist_table->id = null;
			$taghist_table->load($data);
			if(! $taghist_table->id)
			{
				$taghist_table->save($data);
			}
			$rtags[$tag_table->id] = $tag_table->tag;
			$i ++;
		}

		$record = JTable::getInstance('Record', 'CobaltTable');
		$record->load($record_id);
		$record->tags = count($rtags) ? json_encode($rtags) : '';
		$record->store();

		ArrayHelper::clean_r($out);

		if((boolean)$out)
		{
			$sql = 'DELETE FROM #__js_res_tags_history WHERE record_id = ' . $record_id . ' AND tag_id NOT IN (' . implode(',', $out) . ')';
			$db->setQuery($sql);
			$db->query();
		}

		if(! $new) //$validData['id']
		{
			CEventsHelper::notify('record', CEventsHelper::_RECORD_EDITED, $record->id, $record->section_id, 0, 0, 0, $record->getProperties());
		}
		else
		{

			CEventsHelper::notify('category', CEventsHelper::_RECORD_NEW, $record->id, $record->section_id, 0, 0, 0, $record->getProperties());

			// event on parent or child added
			if(JRequest::getInt('fand') && JRequest::getInt('field_id'))
			{
				$field = JTable::getInstance('Field', 'CobaltTable');
				$field->load(JRequest::getInt('field_id'));
				$field->params = new JRegistry($field->params);

				$fand = JTable::getInstance('Record', 'CobaltTable');
				$fand->load(JRequest::getInt('fand'));

				$fand->added = $record;
				$data = $fand->getProperties();

				CEventsHelper::notify('record', $field->field_type . '_new', $fand->id, $fand->section_id, 0, 0, JRequest::getInt('field_id'), $data, $field->params->get('params.notify_add'));
			}
		}

		CEmeraldHelper::countLimit('type', $method, $type, @$validData['user_id']);

		CSubscriptionsHelper::subscribe_record($record_id);

		if($this->getTask() == 'save')
		{

			switch($type->params->get('submission.redirect'))
			{
				case 1:
					$url = Url::records($section->id);
				break;

				case 2:
					$url = Url::record($record_id);
				break;

				case 3:
					$url = $type->params->get('submission.redirect_url');
				break;
			}

			$ret = urldecode(JRequest::getVar('return'));
			$ret = base64_decode(preg_replace("/=*$/", '', $ret));
			if(! JURI::isInternal($ret))
			{
				$ret = '';
			}
			$type = $model->getRecordType($this->type_id);

			if(($record->parent_id || $type->params->get('submission.redirect') == 1 || JRequest::getVar('fand') || !$new) && $ret)
			{
				$url = $ret;
			}

			$this->setRedirect($url);
		}
	}

	public function cancel($key = null)
	{
		$jinput = JFactory::getApplication()->input;

		$return = urldecode(JRequest::getVar('return'));
		$return = base64_decode($return);
		if(! JURI::isInternal($return))
		{
			$return = '';
		}

		if($return)
		{
			$result = parent::cancel($key);
			$this->setRedirect($return);
			return $result;
		}
		else
		{
			$this->view_list = 'records';
			parent::cancel($key);
		}
	}

	protected function allowSave($data = array(), $key = 'id')
	{
		return TRUE;
	}

	protected function allowAdd($data = array(), $key = 'id')
	{
		$user = JFactory::getUser();
		$allow = $user->authorise('core.create', 'com_cobalt.record');

		if($allow === null)
		{
			return parent::allowAdd($data);
		}
		else
		{
			return $allow;
		}
	}

	protected function allowEdit($data = array(), $key = 'id')
	{
		return JFactory::getUser()->authorise('core.edit', 'com_cobalt.record');
	}

	protected function getRedirectTolistAppend()
	{
		$jinput = JFactory::getApplication()->input;

		$post = JRequest::getVar('jform', array(), 'post');
		$modal = JRequest::getInt('modal');

		$secton_id = JRequest::getCmd('section_id', $post['section_id']);
		$category_id = JRequest::getCmd('cat_id', @$post['category'][0]);

		$append = '';

		if($secton_id)
		{
			$append .= '&section_id=' . $secton_id;
		}

		if($category_id)
		{
			$append .= '&cat_id=' . $category_id;
		}

		if($modal)
		{
			$append .= '&modal=' . $modal;
		}
		return $append;

	}

	protected function getRedirectToItemAppend($recordId = null, $urlVar = 'id')
	{
		$jinput = JFactory::getApplication()->input;

		$tmpl = JRequest::getCmd('tmpl');
		$type_id = JRequest::getCmd('type_id');
		$secton_id = JRequest::getCmd('section_id');
		$itemId = JRequest::getInt('Itemid');
		$modal = JRequest::getInt('modal');
		$return = $this->getReturnPage();
		$category_id = JRequest::getCmd('cat_id', @$post['category'][0]);
		$append = '';

		if($tmpl)
		{
			$append .= '&tmpl=' . $tmpl;
		}

		if($type_id)
		{
			$append .= '&type_id=' . $type_id;
		}

		if($secton_id)
		{
			$append .= "&section_id=" . $secton_id;
		}

		if($recordId)
		{
			$append .= '&' . $urlVar . '=' . $recordId;
		}

		if($category_id)
		{
			$append .= '&cat_id=' . $category_id;
		}

		if($modal)
		{
			$append .= '&modal=' . $modal;
		}

		if($itemId)
		{
			$append .= '&Itemid=' . $itemId;
		}

		if($return)
		{
			$append .= '&return=' . base64_encode($return);
		}
		return $append;
	}

	protected function getReturnPage()
	{
		$jinput = JFactory::getApplication()->input;

		$return = JRequest::getVar('return', null, 'default', 'base64');

		if(empty($return) || ! JUri::isInternal(base64_decode($return)))
		{
			return JURI::base();
		}
		else
		{
			return base64_decode($return);
		}
	}
}