<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.application.component.controllerform');

class CobaltControllerModerator extends JControllerForm
{

	protected function allowSave($data = array())
	{
		return TRUE;
	}

	protected function allowAdd($data = array())
	{
		return true;
		$user = JFactory::getUser();
		$allow = $user->authorise('core.create', 'com_cobalt.moderator');
		
		if($allow === null)
		{
			return parent::allowAdd($data);
		}
		else
		{
			return $allow;
		}
	}

	protected function allowEdit($data = array(), $key = 'id')
	{
		return true;
		$recordId = (int)isset($data[$key]) ? $data[$key] : 0;
		$asset = 'com_cobalt.moderator.' . $recordId;
		
		// Check general edit permission first.
		if(JFactory::getUser()->authorise('core.edit', $asset))
		{
			return true;
		}
	}

	protected function getRedirectToItemAppend($recordId = null, $urlVar = 'id')
	{
		$jinput = JFactory::getApplication()->input;
		$tmpl = JRequest::getCmd('tmpl');
		$secton_id = JRequest::getCmd('section_id');
		$itemId = JRequest::getInt('Itemid');
		$return = $this->getReturnPage();
		
		$append = '';
		
		if($tmpl)
		{
			$append .= '&tmpl=' . $tmpl;
		}
		
		if($secton_id)
		{
			$append .= '&section_id=' . $secton_id;
		}
		
		if($recordId)
		{
			$append .= '&' . $urlVar . '=' . $recordId;
		}
		
		if($itemId)
		{
			$append .= '&Itemid=' . $itemId;
		}
		
		if($return)
		{
			$append .= '&return=' . base64_encode($return);
		}
		
		return $append;
	}

	protected function getRedirectToListAppend($recordId = null, $urlVar = 'id')
	{
		$jinput = JFactory::getApplication()->input;
		
		$tmpl = JRequest::getCmd('tmpl');
		$secton_id = JRequest::getCmd('section_id');
		$itemId = JRequest::getInt('Itemid');
		
		$append = '';
		
		if($tmpl)
		{
			$append .= '&tmpl=' . $tmpl;
		}
		
		if($secton_id)
		{
			$append .= '&section_id=' . $secton_id;
		}
		
		if($itemId)
		{
			$append .= '&Itemid=' . $itemId;
		}
		
		return $append;
	}

	protected function getReturnPage()
	{
		$jinput = JFactory::getApplication()->input;
		
		$return = JRequest::getVar('return', null, 'default', 'base64');
		
		if(! empty($return) || JUri::isInternal(base64_decode($return)))
		{
			return base64_decode($return);
		}
		
		return false;
	}

	protected function postSaveHook(JModel &$model, $validData = array())
	{
		$jinput = JFactory::getApplication()->input;
		
		if(JRequest::getCmd('task') == 'save')
		{
			$return = JRequest::getVar('return', '', 'method', 'base64');
			$return = base64_decode($return);
			if(! JURI::isInternal($return))
			{
				$return = '';
			}
			
			if($return)
			{
				$this->setRedirect($return);
				return TRUE;
			}
		}
	}

}