<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.application.component.controlleradmin');

class CobaltControllerRecords extends JControllerAdmin
{

	public function getModel($type = 'Record', $prefix = 'CobaltModel', $config = array())
	{
		return JModel::getInstance($type, $prefix, $config);
	}

	public function commentsdisable()
	{
		$jinput = JFactory::getApplication()->input;

		if(! $this->_checkAccess('CommentBlock', $jinput->getInt('id')))
		{
			return;
		}

		$params = new JRegistry();
		$params->loadJSON($this->record->params);
		$params->set('comments.comments_access_post', 0);

		$this->record->params = $params->toString();
		$this->record->store();

		$this->_finish(JText::_('CMSG_COMMENTDISAB'));
	}

	public function commentsenable()
	{
		$jinput = JFactory::getApplication()->input;

		if(! $this->_checkAccess('CommentBlock', $jinput->getInt('id')))
		{
			return;
		}

		$params = new JRegistry();
		$params->loadJSON($this->record->params);
		$params->set('comments.comments_access_post', $this->type->params->get('comments.comments_access_post'));

		$this->record->params = $params->toString();
		$this->record->store();

		$this->_finish(JText::_('CMSG_COMMMENAD'));
	}

	public function prolong()
	{
		$jinput = JFactory::getApplication()->input;

		if(! $this->_checkAccess('Extend', $jinput->getInt('id')))
		{
			return;
		}
		$user = JFactory::getUser();
		CEmeraldHelper::allowType('extend', $this->type, $user->id, $this->section, true);

		$this->record->extime = JFactory::getDate("+" . $this->type->params->get('properties.default_extend', 10) . ' day')->toSql();
		$this->record->store();

		$data = $this->record->getProperties();
		CEventsHelper::notify('record', CEventsHelper::_RECORD_EXTENDED, $this->record->id, $this->record->section_id, 0, 0, 0, $data);

		CEmeraldHelper::countLimit('type', 'extend', $this->type, $user->id);

		$this->_finish(JText::sprintf('CMSG_RECEXTENDED', $this->type->params->get('properties.default_extend', 10)));
	}

	public function shide()
	{
		$jinput = JFactory::getApplication()->input;

		if(! $this->_checkAccess('Hide', $jinput->getInt('id')))
		{
			return;
		}

		$this->record->hidden = 1;
		$this->record->store();

		$this->_finish(JText::_('CMSG_RECHIDDEN'));
	}

	public function sunhide()
	{
		$jinput = JFactory::getApplication()->input;

		if(! $this->_checkAccess('Hide', $jinput->getInt('id')))
		{
			return;
		}

		$this->record->hidden = 0;
		$this->record->store();

		$this->_finish(JText::_('CMSG_RECUNHIDDEN'));
	}

	public function sfeatured()
	{
		$jinput = JFactory::getApplication()->input;

		if(! $this->_checkAccess('Featured', $jinput->getInt('id')))
		{
			return;
		}
		$user = JFactory::getUser();

		if(!CEmeraldHelper::allowType('feature', $this->type, $user->id, $this->section, true))
		{
			return;
		}

		$this->record->featured = 1;
		$this->record->ftime = JFactory::getDate("+" . $this->type->params->get('emerald.type_feature_subscription_time', 10) . ' day')->toSql();
		$this->record->store();

		$data = $this->record->getProperties();
		CEventsHelper::notify('record', CEventsHelper::_RECORD_FEATURED, $this->record->id, $this->record->section_id, 0, 0, 0, $data);

		CEmeraldHelper::countLimit('type', 'feature', $this->type, $user->id);

		$this->_finish(JText::sprintf('CMSG_RECFEATUREDOK', $this->type->params->get('emerald.type_feature_subscription_time', 10)));

	}

	public function sunpub()
	{
		$jinput = JFactory::getApplication()->input;

		if(! $this->_checkAccess('Publish', $jinput->getInt('id')))
		{
			return;
		}

		$this->record->published = 0;
		$this->record->store();

		if($this->record->user_id)
		{
			$data = $this->record->getProperties();
			CEventsHelper::notify('record', CEventsHelper::_RECORD_UNPUBLISHED, $this->record->id, $this->record->section_id, 0, 0, 0, $data, 2, $this->record->user_id);
		}

		$this->_finish(JText::_('CMSG_RECUNPUBOK'));
	}

	public function spub()
	{
		$jinput = JFactory::getApplication()->input;

		if(! $this->_checkAccess('Publish', $jinput->getInt('id')))
		{
			return;
		}

		$this->record->published = 1;
		$this->record->store();

		if($this->record->user_id)
		{
			$data = $this->record->getProperties();
			CEventsHelper::notify('record', CEventsHelper::_RECORD_APPROVED, $this->record->id, $this->record->section_id, 0, 0, 0, $data, 2, $this->record->user_id);
		}
		$this->_finish(JText::_('CMSG_RECPUBOK'));
	}

	public function sarchive()
	{
		$jinput = JFactory::getApplication()->input;

		if(! $this->_checkAccess('Archive', $jinput->getInt('id')))
		{
			return;
		}

		$this->record->archive = 1;
		$this->record->store();

		$this->_finish(JText::_('CMSG_RECARCHIVEOK'));

	}

	public function delete()
	{
		$jinput = JFactory::getApplication()->input;

		if(! $this->_checkAccess('Delete', $jinput->getInt('id')))
		{
			return;
		}

		if(!$this->record->delete())
		{
			JError::raiseNotice(400, 'Cannot delete, something is wrong');
			return;
		}


		$db = JFactory::getDbo();

		$db->setQuery("DELETE FROM #__js_res_comments WHERE record_id = ".$jinput->getInt('id'));
		$db->query();

		$db->setQuery("DELETE FROM #__js_res_favorite WHERE record_id = ".$jinput->getInt('id'));
		$db->query();

		$db->setQuery("SELECT * FROM #__js_res_files WHERE record_id = ".$jinput->getInt('id'));
		$files = $db->loadObjectList('id');

		if(!empty($files))
		{
			$field_table = JTable::getInstance('Field', 'CobaltTable');
			$cobalt_params = JComponentHelper::getParams('com_cobalt');

			foreach ($files AS $file)
			{
				$field_table->load($file->field_id);
				$field_params = new JRegistry($field_table->params);
				$subfolder = $field_params->get('params.subfolder', $field_table->field_type);
				if(JFile::exists(JPATH_ROOT.DS.$cobalt_params->get('general_upload').DS.$subfolder.DS.$file->fullpath))
				{
					unlink(JPATH_ROOT.DS.$cobalt_params->get('general_upload').DS.$subfolder.DS.$file->fullpath);
				}
			}

			$db->setQuery("DELETE FROM #__js_res_files WHERE id IN (".implode(',', array_keys($files)).")");
			$db->query();
		}

		$db->setQuery("DELETE FROM #__js_res_hits WHERE record_id = ".$jinput->getInt('id'));
		$db->query();

		$db->setQuery("DELETE FROM #__js_res_record_category WHERE record_id = ".$jinput->getInt('id'));
		$db->query();

		$db->setQuery("DELETE FROM #__js_res_record_values WHERE record_id = ".$jinput->getInt('id'));
		$db->query();

		$db->setQuery("DELETE FROM #__js_res_subscriptions WHERE record_id = ".$jinput->getInt('id'));
		$db->query();

		$db->setQuery("DELETE FROM #__js_res_tags_history WHERE record_id = ".$jinput->getInt('id'));
		$db->query();

		$db->setQuery("DELETE FROM #__js_res_vote WHERE ref_id = ".$jinput->getInt('id'));
		$db->query();

		$db->setQuery("DELETE FROM #__js_res_notifications WHERE ref_1 = ".$jinput->getInt('id'));
		$db->query();


		if($this->record->user_id)
		{
			$data = $this->record->getProperties();
			//CEventsHelper::notify('record', CEventsHelper::_RECORD_DELETED, $this->record->id, $this->record->section_id, 0, 0, 0, $data, 2, $this->record->user_id);
		}

		$this->_finish(JText::_('CMSG_RECDELETEDOK'));

	}

	public function markread()
	{
		$jinput = JFactory::getApplication()->input;

		$app = JFactory::getApplication();
		$user = JFactory::getUser();

		$db = JFactory::getDbo();
		$db->setQuery("DELETE FROM #__js_res_notifications WHERE user_id = " . $user->get('id') . ' AND ref_2 = ' . $jinput->getInt('section_id'));
		$db->query();

		$app->enqueueMessage(JText::_('EVENT_CLEAR'));

		if($jinput->getInt('section_id'))
		{
			$section = ItemsStore::getSection($jinput->getInt('section_id'));
			$url = Url::records($section);
		}
		else
		{
			$url = $this->_getUrl();
		}
		$this->setRedirect(JRoute::_($url, FALSE));
	}

	private function _finish($msg)
	{
		$jinput = JFactory::getApplication()->input;

		$app = JFactory::getApplication();
		$app->enqueueMessage($msg);

		$url = base64_decode(urldecode($jinput->getBase64('return')));
		$this->setRedirect(JRoute::_($url, FALSE));
	}

	private function _checkAccess($control, $id)
	{
		$this->record = JTable::getInstance('Record', 'CobaltTable');
		$this->record->load($id);

		$this->record;

		if(!$this->record->id)
		{
			JError::raiseError(403, JText::_('No record found'));
			return false;
		}

		$params = new JRegistry();
		$params->loadJSON($this->record->params);
		$this->record->params = $params;

		$this->type = JModel::getInstance('Form', 'CobaltModel')->getRecordType($this->record->type_id);
		$this->section = JModel::getInstance('Section', 'CobaltModel')->getItem($this->record->section_id);

		$control = 'allow' . $control;

		if(!MECAccess::$control($this->record, $this->type, $this->section))
		{
			JError::raiseError(403, JText::_('CERRNOACTIONACCESS'));
			return FALSE;
		}

		return TRUE;
	}


	public function cleanall()
	{
		$jinput = JFactory::getApplication()->input;

		$app = JFactory::getApplication();
		$key = FilterHelper::key();

		$sec_model = JModel::getInstance('Section', 'CobaltModel');
		$section = $sec_model->getItem($jinput->getInt('section_id'));

		$rec_model = JModel::getInstance('Records', 'CobaltModel');
		$rec_model->section = $section;
		$list = $rec_model->getResetFilters();
		foreach($list as $filter)
		{
			echo $filter->key;
			$app->setUserState('com_cobalt.section' . $key . '.filter_' . $filter->key, '');
		}

		$app->setUserState('com_cobalt.section' . $key . '.filter_search', '');
		$app->setUserState('com_cobalt.section' . $key . '.filter_type', '');
		$app->setUserState('com_cobalt.section' . $key . '.filter_tag', '');
		$app->setUserState('com_cobalt.section' . $key . '.filter_user', '');
		$app->setUserState('com_cobalt.section' . $key . '.filter_alpha', '');
		$app->setUserState('com_cobalt.section' . $key . '.filter_cat', '');

		$app->enqueueMessage(JText::_('CMSG_FILTERCLEANALL'));
		$url = $this->_getUrl();
		$this->setRedirect(JRoute::_($url, FALSE));
	}

	public function clean()
	{
		$jinput = JFactory::getApplication()->input;

		$key = FilterHelper::key();
		$app = JFactory::getApplication();
		$clean = $jinput->get('clean', array(), 'post');

		foreach($clean as $name => $val)
		{
			if($val)
			{
				$app->setUserState('com_cobalt.section' . $key . '.' . $name, NULL);
			}
		}

		$url = $this->_getUrl();
		$this->setRedirect(JRoute::_($url, FALSE));
	}

	public function filters()
	{
		$jinput = JFactory::getApplication()->input;

		$key = FilterHelper::key();
		$db = JFactory::getDbo();
		$app = JFactory::getApplication();
		$filters = $jinput->get('filters', array(), 'post');

		$sec_model = JModel::getInstance('Section', 'CobaltModel');
		$section = $sec_model->getItem($jinput->getInt('section_id', 0));

		$app->setUserState('com_cobalt.records'.$section->id.'.limitstart', 0);
		$app->setUserState('com_cobalt.section' . $key . '.filter_search', 	$jinput->get('filter_search', null,  'string'));

		$app->setUserState('com_cobalt.section' . $key . '.filter_type', @$filters['type']);
		unset($filters['type']);

		$tags = @$filters['tags'];
		unset($filters['tags']);
		if(! is_array($tags))
		{
			$tags = explode(',', $tags);

			ArrayHelper::clean_r($tags);
			JArrayHelper::toInteger($tags);
		}
		$app->setUserState('com_cobalt.section' . $key . '.filter_tag', $tags);

		$users = @$filters['users'];
		unset($filters['users']);
		if(!is_array($users))
		{
			$users = explode(',', $users);

			ArrayHelper::clean_r($users);
			JArrayHelper::toInteger($users);
		}
		$app->setUserState('com_cobalt.section' . $key . '.filter_user', $users);

		$cats = @$filters['cats'];
		unset($filters['cats']);
		if(! is_array($cats))
		{
			$cats = explode(',', $cats);

			ArrayHelper::clean_r($cats);
			JArrayHelper::toInteger($cats);
		}
		$app->setUserState('com_cobalt.section' . $key . '.filter_cat', $cats);

		settype($filters, 'array');

		$rec_model = JModel::getInstance('Records', 'CobaltModel');
		$rec_model->section = $section;
		$list = $rec_model->getFilters();
		$store = array();
		foreach($list as $fkey => $filter)
		{
			$app->setUserState('com_cobalt.section' . $key . '.filter_' . $fkey, @$filters[$fkey]);
			if($filters)
			{
				$store[$filter->key] = $filter;
			}
		}

		$url = $this->_getUrl();
		$this->setRedirect(JRoute::_($url, FALSE));
	}

	public function filter()
	{
		$jinput = JFactory::getApplication()->input;

		$names = JRequest::getVar('filter_name', array(), 'default', 'array');
		$vals = JRequest::getVar('filter_val', array(), 'default', 'array');


		foreach($names as $k => $name)
		{
			$key = FilterHelper::key();

			//JError::raiseNotice(100, $key);

			if($name == 'filter_tpl')
			{
				$key = $jinput->getInt('section_id');
				if($jinput->getInt('cat_id'))
				{
					$category = ItemsStore::getCategory($jinput->getInt('cat_id'));
					$t = $category->params->get('tmpl_list');
					ArrayHelper::clean_r($t);
					if($t)
					{
						$key .= '-'.$jinput->getInt('cat_id');
					}
				}

				$oldname = JFactory::getApplication()->getUserState('com_cobalt.section'.$key.'.filter_tpl', 'default');
				if($oldname != $vals[$k])
				{
					$dir = JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'views' . DS . 'records' . DS . 'tmpl' . DS;
					if(!JFile::exists("{$dir}default_list_{$vals[$k]}.php"))
					{
						$vals[$k] = 'default';
					}
					$file = "{$dir}default_list_{$vals[$k]}.json";
					if(JFile::exists($file))
					{
						$content = JFile::read($file);
					}
					else
					{
						$content = array();
						JError::raiseNotice(404, JText::_('CPLSEDITTEMPLATE_LI'));
					}
					$lparams = new JRegistry($content);
					JFactory::getApplication()->setUserState('global.list.limit', $lparams->get('tmpl_core.item_limit_default', 20) );
				}
			}
			//JError::raiseNotice(111, 'com_cobalt.section'.$key.'.filter_tpl.'.$vals[$k]);
			JFactory::getApplication()->setUserState('com_cobalt.section' . $key . '.' . $name, $vals[$k]);
		}
		JFactory::getApplication()->setUserState('com_cobalt.records' . $jinput->getInt('section_id'). '.limitstart', 0);

		$url = $this->_getUrl();
 		$this->setRedirect(JRoute::_($url, FALSE));
	}

	private function _getUrl()
	{
		$jinput = JFactory::getApplication()->input;

		$url = 'index.php?option=com_cobalt&view=records';
		if($s = $jinput->getInt('section_id'))
		{
			$url .= '&section_id=' . $s;
		}
		if($c = $jinput->getInt('cat_id'))
		{
			$url .= '&cat_id=' . $c;
		}
		if($c = $jinput->getInt('ucat_id'))
		{
			$url .= '&ucat_id=' . $c;
		}
		$u = $jinput->getInt('user_id');
		/*if(!is_null($u))
		{
			$u = (int)$u;
		}*/
		if($u || $u === 0)
		{
			$url .= '&user_id=' . $u;
		}
		if($v = $jinput->getString('view_what'))
		{
			$url .= '&view_what=' . $v;
		}

		return $url;
	}
}
