<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.application.component.controllerform');

class CobaltControllerUsercategory extends JControllerForm
{

	public function __construct()
	{
		parent::__construct();
		$this->view_list = 'categories';
		$this->view_item = 'category';
	}

	public function add()
	{
		$jinput = JFactory::getApplication()->input;
		
		$user = JFactory::getUser();
		$db = JFactory::getDbo();
		$sql = "SELECT count(id) FROM #__js_res_category_user WHERE user_id=" . $user->get('id') . ' AND section_id =' . JRequest::getInt('section_id');
		$db->setQuery($sql);
		$result = $db->loadResult();
		
		$section = ItemsStore::getSection(JRequest::getInt('section_id'));
		
		if($result >= $section->params->get('personalize.pcat_limit') && $section->params->get('personalize.pcat_limit'))
		{
			JError::raiseWarning(403, JText::_('CMSG_YOU_REACHMAX') . ' ' . $section->params->get('personalize.pcat_limit'));
			$this->setRedirect(JRoute::_('index.php?option=com_cobalt&view=categories&section_id' . JRequest::getInt('section_id')));
			return;
		}
		parent::add();
	}

	protected function allowSave($data = array())
	{
		return TRUE;
	}

	protected function allowAdd($data = array())
	{
		return true;
		$user = JFactory::getUser();
		$allow = $user->authorise('core.create', 'com_cobalt.usercategory');
		
		if($allow === null)
		{
			return parent::allowAdd($data);
		}
		else
		{
			return $allow;
		}
	}

	protected function allowEdit($data = array(), $key = 'id')
	{
		return JFactory::getUser()->authorise('core.edit', 'com_cobalt.userscategory');
	}

	protected function getRedirectToItemAppend($recordId = null, $urlVar = 'id')
	{
		$jinput = JFactory::getApplication()->input;
		
		$tmpl = JRequest::getCmd('tmpl');
		$secton_id = JRequest::getCmd('section_id');
		$itemId = JRequest::getInt('Itemid');
		$return = $this->getReturnPage();
		
		$append = '';
		
		if($tmpl)
		{
			$append .= '&tmpl=' . $tmpl;
		}
		
		if($secton_id)
		{
			$append .= '&section_id=' . $secton_id;
		}
		
		if($recordId)
		{
			$append .= '&' . $urlVar . '=' . $recordId;
		}
		
		if($itemId)
		{
			$append .= '&Itemid=' . $itemId;
		}
		
		if($return)
		{
			$append .= '&return=' . base64_encode($return);
		}
		
		return $append;
	}

	protected function getRedirectToListAppend($recordId = null, $urlVar = 'id')
	{
		$jinput = JFactory::getApplication()->input;
		
		$tmpl = JRequest::getCmd('tmpl');
		$secton_id = JRequest::getCmd('section_id');
		$itemId = JRequest::getInt('Itemid');
		
		$append = '';
		
		if($tmpl)
		{
			$append .= '&tmpl=' . $tmpl;
		}
		
		if($secton_id)
		{
			$append .= '&section_id=' . $secton_id;
		}
		
		if($itemId)
		{
			$append .= '&Itemid=' . $itemId;
		}
		
		return $append;
	}

	protected function getReturnPage()
	{
		$jinput = JFactory::getApplication()->input;
		
		$return = JRequest::getVar('return', null, 'default', 'base64');
		
		if(! empty($return) || JUri::isInternal(base64_decode($return)))
		{
			return base64_decode($return);
		}
		
		return false;
	}

	public function postSaveHook(JModel &$model, $validData = array())
	{
		$jinput = JFactory::getApplication()->input;
		
		$files = JRequest::get('FILES');
		
		if(! empty($files['jform']['name']['icon']))
		{
			$user = JFactory::getUser();
			$id = $model->getState($this->context . '.id');
			$path = JPATH_ROOT . DS . 'images' . DS . 'usercategories' . DS . $user->get('id') . DS;
			$ext = JFile::getExt($files['jform']['name']['icon']);
			if(! JFolder::exists($path))
			{
				JFolder::create($path, 0777);
				JFile::write($path . DS . 'index.html', @$a);
			}
			
			if(JFile::upload($files['jform']['tmp_name']['icon'], $path . $id . '.' . $ext))
			{
				jimport('mint.resizeimage');
				$app = JFactory::getApplication();
				$section_id = $app->getUserStateFromRequest('com_cobalt.usercategories.section_id', 'section_id', null, 'int');
				
				$category_model = JModel::getInstance('Section', 'CobaltModel');
				$item_cat = $category_model->getItem($section_id);
				
				$resizer = new JS_Image_Resizer($path . $id . '.' . $ext);
				if($resizer->error())
				{
					JError::raiseWarning(240, JText::_('CMSG_CANNOTCREATEIMG') . $resizer->error());
					return false;
				}
				
				$resizer->resize_limitwh($item_cat->params->get('personalize.pcat_icon_w', 100), $item_cat->params->get('personalize.pcat_icon_h', 100), $path . $id . '.' . $ext);
				$resizer->close();
				
				@chmod($path . $id . '.' . $ext, 0644);
				
				$db = JFactory::getDbo();
				$db->setQuery('UPDATE #__js_res_category_user SET icon = "' . $id . '.' . $ext . '" WHERE id = ' . $id);
				$db->query();
			}
		}
		
		if($this->getTask() == 'save')
		{
			$return = JRequest::getVar('return', '', 'post', 'base64');
			$return = base64_decode($return);
			if(! JURI::isInternal($return))
			{
				$return = '';
			}
			
			if($return)
			{
				$this->setRedirect($return);
				return TRUE;
			}
		}
	}

}