<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

class MintPayAbstract
{

	var $log = FALSE;

	/**
	 *
	 * @var JTable
	 */
	var $table = FALSE;

	function __construct()
	{
		$this->table = JTable::getInstance('Sales', 'CobaltTable');
	}

	public function button($field)
	{}

	public function render_form($el)
	{
		
		$handle = '<tr><td class="priceblock-label">%s:</td><td>%s</td></tr>';
		$tr = array();

		foreach ($el AS $lbl => $input)
		{
			$tr[] = sprintf($handle, $lbl, $input);
		}

		return sprintf('<div class="priceblock"><table>%s</table></div>', implode("\n", $tr));
	}
	public function load_form($provider, $id)
	{
		$xml = JPATH_COMPONENT.DS.'gateways'.DS.$provider.DS.$provider.'.xml';
		if(!JFile::exists($xml))
		{
			echo JText::_('CFILENOTFOUND').": {$xml}";
		}
		$out = array();

		$form = new JForm('jform', array('control' => "jform[fields][{$id}]"));
		$form->loadFile($xml);

		return $form;
	}

	public function _notify($n, $payment, $record, $field, $only)
	{
		if($field->params->get('params.'.$n))
		{
			CEventsHelper::notify('field', $n, $record->id, $record->section_id, 0, 0, $field->id, $payment, 2, $only);
		}
	}
	public function receive($field, $post, $record)
	{

	}

	public function log($msg, $add = NULL)
	{
		if($this->log == FALSE)
		{
			return;
		}

		$folder = JPATH_ROOT.DS.'logs'.DS.$this->provider;

		if(!JFolder::exists($folder))
		{
			JFolder::create($folder, 0777);
			JFile::write($folder.DS.'index.html', $index = ' ');
		}
		if(is_array($add))
		{
			$add = print_r($add, TRUE);
		}
		

		$line = sprintf("[%s]: %s %s\n", JFactory::getDate()->toISO8601(), $msg, ($add ? "\n{$add}" : NULL));

		error_log($line, 3, $folder.DS.'log.txt');

	}

	public function new_order($data, $record, $field)
	{
		if(!$data['gateway_id']) return ;
		$data['ctime'] = JFactory::getDate()->toSql();
		$data['mtime'] = JFactory::getDate()->toSql();
		$data['record_id'] = $record->id;
		$data['saler_id'] = $record->user_id;
		$data['section_id'] = $record->section_id;
		$data['type_id'] = $record->type_id;
		$data['field_id'] = $field->id;
		
		$array = array('user_id' => $data['user_id'], 'gateway_id' => $data['gateway_id']);

		$this->table->reset();
		$this->table->load($array);

		if(!$this->table->id)
		{
			$this->table->save($data);
			$this->_notify(CEventsHelper::_FIELDS_PAY_NEW_SALE, $data, $record, $field, $this->table->saler_id);
			return;
		}

		$this->table->mtime = JFactory::getDate()->toSql();
		if($this->table->status != $data['status'])
		{
			$this->table->status = $data['status'];
		}
		
		if($data['comment'])
		{
			$this->table->comment = $data['comment'];
		}
		
		$this->table->store();

		CSubscriptionsHelper::subscribe_record($data['record_id']);
		
		$this->_notify(CEventsHelper::_FIELDS_PAY_STATUS_CHANGE, $data, $record, $field, $data['user_id']);
	}
	public function get_order($user_id, $record_id, $field_id)
	{
		$this->table->reset();
		$this->table->id = NULL;
		$array = compact('user_id', 'record_id', 'field_id');
		$this->table->load($array);
		if($this->table->id)
		{
			$array = $this->table->getProperties();
			return JArrayHelper::toObject($array);
		}
		
		return new stdClass();
	}

	public function update_order($data, $record, $field, $comment = NULL)
	{
		$array = array('user_id' => $data['user_id'], 'gateway_id' => $data['gateway_id']);

		$this->table->reset();
		$this->table->load($array);
		$data['mtime'] = JFactory::getDate()->toSql();

		if(!$this->table->id)
		{
			return;
		}

		$this->table->status = $data['status'];
		if($comment)
		{
			$this->table->comment = $comment;
		}
		$this->table->store();

		$this->_notify(CEventsHelper::_FIELDS_PAY_STATUS_CHANGE, $data, $record, $field, $data['user_id']);
	}

	public function order_render($client, $order, $field)
	{
		if(empty($order->id))
		{
			return NULL;
		}
		if(!in_array($field->params->get('params.show_order'), array(3, $client)))
		{
			return NULL;
		}
		if(JRequest::getCmd('view') != 'record' && JRequest::getCmd('view') != 'records')
		{
			return NULL;
		}

		$out[] = '<h4>'.JText::_($field->params->get('params.purchase_title', 'You have already purchased this product')).'</h4>';

		if($field->params->get('params.all_orders_link'))
		{
			$out[] = '<div><p class="readon"><a href="'.JRoute::_('index.php?option=com_cobalt&view=elements&layout=buyer&filter_section='.JRequest::getInt('section_id').'&Itemid='.$field->params->get('params.all_orders_iid', JRequest::getInt('Itemid'))).'">'.$field->params->get('params.all_orders_text', 'My all purchases').'</a></p></div>';
		}

		$statuses = $this->get_statuses();
		$out[] = '<table class="zebra category">';
		$out[] = '<thead>';
		$out[] = '<tr>';

		$out[] = '<th>';
		$out[] = JText::_('ID');
		$out[] = '</th>';

		$out[] = '<th>';
		$out[] = JText::_('CNAME');
		$out[] = '</th>';

		$out[] = '<th>';
		$out[] = JText::_('CDATE');
		$out[] = '</th>';

		$out[] = '<th>';
		$out[] = JText::_('CSTATUS');
		$out[] = '</th>';

		$out[] = '<th>';
		$out[] = JText::_('CAMOUNT');
		$out[] = '</th>';

		$out[] = '</tr>';
		$out[] = '</thead>';

		$out[] = '<tbody>';
		$out[] = '<tr class="cat-list-row0 even">';

		$out[] = '<td>';
		$out[] = $order->id;
		$out[] = '</td>';

		$out[] = '<td>';
		$out[] = $order->name;
		$out[] = '<br /><span class="small">';
		$out[] = $order->gateway.': ';
		$out[] = $order->gateway_id;
		$out[] = '</span>';
		$out[] = ($order->comment ? "<br /><span class=\"small\">{$order->comment}</span>" : NULL);
		$out[] = '</td>';

		$out[] = '<td>';
		$out[] = JFactory::getDate($order->ctime)->toFormat(JText::_('CDATE1'));
		$out[] = '</td>';

		$out[] = '<td>';
		$out[] = $statuses[$order->status];
		$out[] = '</td>';

		$out[] = '<td>';
		$out[] = $order->amount;
		$out[] = $order->currency;
		$out[] = '</td>';

		$out[] = '</tr>';
		$out[] = '</tbody>';

		$out[] = '</table>';

		return implode("\n", $out);
	}

	public function get_statuses()
	{
		return  array(
			1 => JText::_('STAT_CANCEL'),
			2 => JText::_('STAT_FAIL'),
			3 => JText::_('STAT_WAIT'),
			4 => JText::_('STAT_REFUND'),
			5 => JText::_('STAT_CONFIRM'),
		);
	}
	public function count($order_id)
	{
		$db = JFactory::getDbo();
		$db->setQuery("UPDATE #__js_res_sales SET `num` = `num` + 1 WHERE id = {$order_id}");
		$db->query();
	}

	protected function _price($amount, $currency, $tag = 'b')
	{
		return sprintf('<%s>%s %s</%s>', $tag, number_format($amount, 2, '.', ', '), $currency, $tag);
	}
	protected function _hidden($name, $value, $encode = FALSE)
	{
		if(! $value) return NULL;

		return sprintf('<input type="hidden" name="%s" value="%s">', $name, ($encode ? urlencode($value) : $value));
	}
}

?>