<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('mint.resizeimage');

class CCommunityHelper
{

	/**
	 *
	 * Enter description here ...
	 * @return CCommunityCom_cobalt
	 */
    static private function _getClass()
    {
        static $class = null;

        if(!$class)
        {
            $params = JComponentHelper::getParams('com_cobalt');
            $component = str_replace('.php', '', $params->get('community', 'com_cobalt'));

            if($component == 'com_juser')
            {
            	$component = 'com_cobalt';
            }
            if($component == 'index.html')
            {
            	$component = 'com_cobalt';
            }

            if(!JComponentHelper::isEnabled($component))
            {
                $component = 'com_cobalt';
            }
            $file = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_cobalt'.DS.'library'.DS.'php'.DS.'community'.DS.$component.'.php';

            include_once $file;
            $name = 'CCommunity'.ucfirst($component);
            if(!class_exists($name))
            {
                JError::raiseError(404, JText::sprintf('CERR_COMMUNITYCLASSNOTFOUND', $name));
                return false;
            }
            $class = new $name;
        }

        return $class;

    }

    static public function getRegistrationLink($label)
    {
    	return JHtml::link(JRoute::_('index.php?option=com_users&view=registration'), $label);
    }
    static public function getAvatar($user_id, $width, $height)
    {
        static $resizer = null;
        static $url = null;

        if(!$resizer)
        {
            $resizer = new JS_Image_Resizer();
        }
        if(!$url)
        {
            $root = JPath::clean(JPATH_ROOT.DS.JComponentHelper::getParams('com_cobalt')->get('general_upload'));
            $url = str_replace(JPATH_ROOT, '', $root);
            $url = str_replace("\\", '/', $url);
            $url = preg_replace('#^\/#iU', '', $url);
            $url = JURI::root().str_replace("//", "/", $url);
        }

        $class = self::_getClass();

        $file = $class->getAvatar($user_id);

        $ext = JFile::getExt($file);
        $key = md5($file.$width.$height);
        $path = JPATH_ROOT.DS.JComponentHelper::getParams('com_cobalt')->get('general_upload').DS.'avatars'.DS.$user_id.DS;
        if(!JFolder::exists($path))
        {
        	JFolder::create($path, 0777);
        	JFile::write($path.DS.'index.html', $index = ' ');
        }

        $img = $path.$key.'.'.$ext;
        if(!JFile::exists($img))
        {
        	$resizer->stretch_if_smaller = true;
        	$resizer->setImage($file);
        	$resizer->resize_limitwh($width, $height, $img);
        }
        $aurl = $url.'/avatars/'.$user_id.'/'.$key.'.'.$ext;

        if(JComponentHelper::getParams('com_cobalt')->get('gravatar'))
        {
        	$email = JFactory::getUser($user_id)->get('email', 'thisisdefaultavatarforgravatar@nonexist.com');
        	$default = $aurl;
        	$aurl = "http://www.gravatar.com/avatar/" . md5( strtolower( trim( $email ) ) ) . "?s=" . $width;
        }


        return $aurl;
	}

    static public function getName($id, $section, $nohtml = FALSE)
    {
    	static $icons = null;

        if(! is_object($section))
        {
        	$section = ItemsStore::getSection($section);
        }

        $class = self::_getClass();

        $name = JFactory::getUser($id)->get($section->params->get('personalize.author_mode', 'username'), JText::_('CGUEST'));

        $out = $class->getName($id, $name, $section);


        if($section->params->get('personalize.moderator_icon', 0) && $id)
        {
        	if(!isset($icons[$section->id]))
        	{
	        	$db = JFactory::getDbo();
	        	$sql = "SELECT user_id, icon FROM #__js_res_moderators WHERE published = 1 AND section_id = {$section->id}";
	        	$db->setQuery($sql);
	        	$icons[$section->id] = $db->loadObjectList('user_id');
        	}
        	if(isset($icons[$section->id][$id]) && $icons[$section->id][$id]->icon != -1)
        	{
        		$out .= ' <img src="'.JURI::root().'components/com_cobalt/images/moderator/'.$icons[$section->id][$id]->icon.'" alt="" />';
        	}
        }

        if($nohtml)
        {
        	$out = strip_tags($out);
        }

        return $out;
    }

}