<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();

jimport('joomla.html.html');
JHTML::_('behavior.modal', 'a.cob-modal');

require_once JPATH_ROOT.DS.'components/com_cobalt/library/php/fields/cobaltfield.php';
require_once JPATH_ROOT.DS.'components'.DS.'com_cobalt'.DS.'api.php';

class CFormFieldRelate extends CFormField
{

	public function __construct($field, $default)
	{
		parent::__construct($field, $default);


	}
	protected function _render_input($type, $name, $section_id, $types, $multi = TRUE)
	{
		$db = JFactory::getDbo();
		$user = JFactory::getUser();
		$section = ItemsStore::getSection($section_id);

		$attribs = $html = $record_id = '';
		$list = $default = array();

		settype($types, 'array');
		$query = $db->getQuery(TRUE);
		$query->from('#__js_res_record');
		$query->where('published = 1');
		$query->where('hidden = 0');
		$query->where('section_id = '.$section_id);
		$query->where("type_id IN(".implode(',', $types).")");

		if(JRequest::getInt('id'))
		{
			$query->where('id != '.JRequest::getInt('id'));
		}
		if(!in_array($section->params->get('general.show_restrict'), $user->getAuthorisedViewLevels()) && !MECAccess::allowRestricted($user, $section))
		{
			$query->where("(access IN(" . implode(',', $user->getAuthorisedViewLevels()) . ") OR user_id = " . $user->get('id') . ")");
		}

		if(!in_array($section->params->get('general.show_future_records'), $user->getAuthorisedViewLevels()))
		{
			$query->where("ctime < " . $db->quote(JFactory::getDate()->toSql()));
		}

		if(!in_array($section->params->get('general.show_past_records'), $user->getAuthorisedViewLevels()))
		{
			$query->where("(extime = '0000-00-00 00:00:00' OR extime > '" . JFactory::getDate()->toSql() . "')");
		}

		if(!in_array($this->params->get('params.strict_to_user'), $user->getAuthorisedViewLevels()))
		{
			if($this->params->get('params.strict_to_user_mode') > 1 && JRequest::getInt('id'))
			{
				$record = JTable::getInstance('Record', 'CobaltTable');
				$record->load(JRequest::getInt('id'));
				$user_id = $record->user_id;
				if(!$user_id && $this->params->get('params.strict_to_user_mode') == 3)
				{
					$user_id = $user->get('id');
				}
			}
			else
			{
				$user_id = $user->get('id');
			}
			$query->where('user_id = '.($user_id ? $user_id : 1));
		}


		if($this->params->get('params.multi_limit') && $type != 10)
		{
			$html .= '<div class="small">' . JText::sprintf('CSELECTLIMIT', $this->params->get('params.multi_limit')) . '</div>';
		}
		if($multi == FALSE) {
			$this->params->set('params.multi_limit', 1);
		}

		if(JRequest::getInt('id'))
		{
			$record_id = JRequest::getInt('id');
			if($this->type == 'child')
			{
				$default_query = "SELECT field_value FROM #__js_res_record_values WHERE record_id = '{$record_id}' AND field_id = {$this->id}";
			}
			elseif($this->type == 'parent')
			{
				$default_query = "SELECT record_id FROM #__js_res_record_values WHERE field_value = '{$record_id}' AND field_id = ".$this->params->get('params.child_field');
			}
			if(!empty($default_query))
			{
				$db->setQuery($default_query);
				$this->value = $db->loadColumn();
			}
		}

		switch ($type)
		{
			case 2:
			case 1:
				if($type == 1)
				{
					$query->select('id, title as html, title as plain, title as render');
					$db->setQuery($query);
					$list = $db->loadObjectList();
				}

				if($this->value)
				{
					$query = $db->getQuery(TRUE);
					$query->from('#__js_res_record');
					$query->select('id, title as html, null as plain, title as render');
					$query->where('id IN ('.implode(',', $this->value).')');
					$db->setQuery($query);
					$default = $db->loadObjectList();
				}

				$html .= $this->_render_autocomplete($multi, $list, $default,
					($multi ? $this->params->get('params.multi_limit') : 1),
					($type == 2), $name);
				break;

			case 3:
				$query->select('id as value, title as text');
				$db->setQuery($query);
				$list = $db->loadObjectList();

				$html .= $this->_render_checkbox($multi, $list, $this->value, $name);
				break;


			case 4:
				$query->select('id as value, title as text');
				$db->setQuery($query);
				$list = $db->loadObjectList();

				if(!$this->required)
				{
					$select = new stdClass();
					$select->value = '';
					$select->text = JText::_('CSELECT');
					array_unshift($list, $select);
				}

				$html .= $this->_render_select($multi, $list, $this->value, $name);
				break;
			case 5:
				if($this->value)
				{
					$query = $db->getQuery(TRUE);
					$query->from('#__js_res_record');
					$query->select('id, title');
					$query->where('id IN ('.implode(',', $this->value).')');
					$db->setQuery($query);
					$default = $db->loadObjectList();
				}
				$html .= $this->_render_popup($multi, $default, $section_id, $types, $name);
				break;
			case 10:
				if($this->value)
				{
					$query = $db->getQuery(TRUE);
					$query->from('#__js_res_record');
					$query->select('id, title');
					$query->where('id IN ('.implode(',', $this->value).')');
					$db->setQuery($query);
					$default = $db->loadObjectList();
				}
				$html .= $this->_render_display($default, $name);
				break;
		}

		return $html;
	}
	protected function _render_display($default, $name)
	{
		$li = array();
		foreach ($default AS $record)
		{
			$li[] = $record->title."<input type=\"hidden\" value=\"{$record->id}\" name=\"{$name}\">";
		}
		//var_dump($li);
		if(!$li)
		{
			return;
		}

		if(count($li) == 1)
		{
			return implode(" ", $li);
		}
		else
		{
			return '<ul><li>'.implode("</li><li>", $li).'</li></ul>';
		}
	}
	protected function _render_autocomplete($multi, $list, $default, $limit, $ajax, $name)
	{
		if($ajax)
		{
			$options['ajax_url'] = JURI::root().'index.php?option=com_cobalt&task=ajax.field_call&no_html=1';
			$options['ajax_data'] = "field_id:{$this->id},func:'onGetList',field:'{$this->type}',record_id:".JRequest::getInt('id').",section_id:".JRequest::getInt('section_id');
		}
		$options['max_width'] = $this->params->get('params.max_width', 400);
		$options['min_width'] = $this->params->get('params.min_width', 300);
		$options['max_result'] = $this->params->get('params.max_result', 10);
		$options['max_items'] = $limit;
		$options['coma_separate'] = 0;
		$options['only_values'] = 1;
		$options['min_length'] = 1;
		$options['case_sensitive'] = 0;
		$options['highlight'] = 1;
		$options['unique'] = 1;

		$html[] = JHtml::_('mrelements.listautocomplete', $name, "field_".$this->id, $default, $list, $options);

		return implode("\n", $html);
	}
	protected function _render_checkbox($multi, $list, $default, $name)
	{
		$type = 'radio';
		$ch = $html = array();
		$attribs = ($this->required ? ' required="true" ' : '');
		if($multi)
		{
			$type = 'checkbox';
			$name .= '[]';
			$style = ('width:'.$this->params->get('params.elwidth', '48%'));
			$attribs .= ' class="inputpox"';
			$attribs .= ' onchange="countFieldValues(this, '.$this->id.', '.$this->params->get('params.multi_limit', 0).', \'checkbox\');"';
		}

		$patern = '<li style="%s" class="list-element"><input type="%s" %s value="%s" name="%s" %s id="field_%d_%d"/> <label for="field_%d_%d">%s</label></li>';
		foreach ($list AS $k => $item)
		{
			$checked = NULL;
			if(in_array($item->value, $default))
			{
				$checked = ' checked="checked"';
			}
			$ch[] = sprintf($patern, @$style, $type, $checked, $item->value, $name, $attribs, $this->id, $k, $this->id, $k, htmlspecialchars($item->text, ENT_COMPAT, 'UTF-8'));
		}
		$html[] = '<ul class="fliter-list elements-list" id="form_field_list_' . $this->id . '">' . implode("\n", $ch) . '</ul>';

		return implode("\n", $html);
	}
	protected function _render_popup($multi, $default, $section_id, $type_id, $name)
	{
		$name .= ($multi ? '[]' : NULL);

		$width = $this->params->get('params.control_width', 750);
		$height = $this->params->get('params.control_height', 500);
		$onClose = "";
		if(is_array($type_id))
			$type_id = implode(',', $type_id);
		$doTask = JURI::root().'index.php?option=com_cobalt&view=elements&layout=records&tmpl=component&section_id='.
		$section_id.'&filter_type='.$type_id.'&mode=form&field_id='.$this->id;
		if(!in_array($this->params->get('params.strict_to_user'), JFactory::getUser()->getAuthorisedViewLevels()))
		{
			$doTask .= '&user_id='. (JFactory::getUser()->get('id') ? JFactory::getUser()->get('id') : 1);
		}
		$html[] = "<ul id=\"parent_list{$this->id}\" class=\"relation-list\"></ul>";
		$html[] = "<a class=\"cob-modal\" href=\"$doTask\" rel=\"{handler: 'iframe', size: {x: $width, y: $height}, onClose: function(el) {".$onClose."}}\">\n".JText::_($this->params->get('params.control_label'))."</a>\n";
		$html[] = '<script type="text/javascript">
		var elementslist'.$this->id.' = $(\'parent_list'.$this->id.'\');';
		$html[] = "var multi{$this->id} = ".($multi ? 'true' : 'false').';';
		$html[] = "var limit{$this->id} = ".$this->params->get('params.multi_limit', 0).';';
		$html[] = "var name{$this->id} = '{$name}';";
		$html[] = 'var list'.$this->id.' = function(id, title){';

		if(!$multi)
		{
			$html[] = "$('parent_list{$this->id}').set('html', '');";
		}
		else
		{
			$html[] = "lis = elementslist{$this->id}.getElements('li');";
			$html[] = "if(lis.length >= limit{$this->id})
			{alert('". JText::sprintf('CSELECTLIMIT', $this->params->get('params.multi_limit'))."'); return false;}";
			$html[] = "error = 0; lis.each(function(el){
				if(el.get('rel') == id){
					alert('".JText::_('CALREADYSELECTED')."');
					error = 1;
				}})";
			$html[] = "if(error) return false;";
		}
		$html[] = "elementslist{$this->id}.grab(new Element('li', {rel:id}).adopt(
			new Element('a', {'class':'close-relation', href:'javascript:void(0)'}).addEvent('click', function(){this.getParent('li').destroy();}),
			new Element('div').set('html', title),
			new Element('input', {name:'{$name}', type:'hidden', value:id})
			));";
		$html[] = 'return true;}';

		if($default)
		{
			foreach ($default as $item)
			{
				$html[] = "list{$this->id}($item->id, '".htmlspecialchars($item->title, ENT_COMPAT, 'UTF-8')."');";
			}
		}

		$html[] = "var updatelist{$this->id} = function(list){
			var elementslist{$this->id} = $('parent_list{$this->id}');
			elementslist{$this->id}.empty();
			list.each(function(el){elementslist{$this->id}.grab(el);});
		}";
		$html[] = '</script>';

		return implode("\n", $html);

	}
	protected function _render_select($multi, $list, $default, $name)
	{
		$html = array();

		$attribs = ($this->required ? ' required="true" ' : '');
		if($multi)
		{
			$name .= '[]';
			$attribs .= ' class="elements-list"';
			$attribs .= ' multiple="true"';
			$attribs .= ' onchange="countFieldValues(this, '.$this->id.', '.$this->params->get('params.multi_limit', 0).', \'select\');"';
			$attribs .= ' size="'.(count($list) > 20 ? 20 : count($list)).'"';
		}

		$html[] = JHtml::_('select.genericlist', $list, $name, $attribs, 'value', 'text', $default);

		return implode("\n", $html);
	}
	protected function _render($client, $record, $field_id, $type_id, $section_id, $view_what)
	{
		$html = $links = array();


		if(in_array($record->id, $this->_get_skiper()))
		{
			return NULL;
		}


		JRequest::setVar('_rrid', $record->id);
		JRequest::setVar('_rfid', $field_id);
		JRequest::setVar('_rmfid', $record->id);

		$api = new CobaltApi();
		$this->content = $api->records($section_id, $view_what, $this->params->get('params.orderby', 'r.ctime DESC'),
			$type_id, NULL, $this->params->get('params.cat_id', 0), $this->params->get('params.limit_'.$client, 10),
			$this->params->get('params.template_'.$client, 'default')
		);

		$section = ItemsStore::getSection($section_id);
		$type = ItemsStore::getType($type_id);

		$this->show_btn_new = $this->show_btn_exist = $this->show_btn_all = NULL;

		if(in_array($this->params->get('params.add_more_access'), JFactory::getUser()->getAuthorisedViewLevels()))
		{
			$this->show_btn_new = TRUE;
		}
		if($this->params->get('params.add_more_access') == '-1' && JFactory::getUser()->get('id') == $record->user_id && $record->user_id)
		{
			$this->show_btn_new = TRUE;
		}
		if(!$this->params->get('params.add_more_access_'.$client))
		{
			$this->show_btn_new = NULL;
		}

		if(in_array($this->params->get('params.add_existing'), JFactory::getUser()->getAuthorisedViewLevels()))
		{
			$this->show_btn_exist = TRUE;
		}
		if($this->params->get('params.add_existing') == '-1' && JFactory::getUser()->get('id') == $record->user_id && $record->user_id)
		{
			$this->show_btn_exist = TRUE;
		}
		if(!$this->params->get('params.add_existing_access_'.$client))
		{
			$this->show_btn_exist = NULL;
		}

		if($this->content['html'] && ($this->content['total'] == $this->params->get('params.limit_'.$client, 10)) && in_array($this->params->get('params.show_list_all'), JFactory::getUser()->getAuthorisedViewLevels()) && $this->params->get('params.show_list_all_'.$client))
		{
			$this->show_btn_all = true;
			if($this->type == 'parent')
			{
				$field = JTable::getInstance('Field', 'CobaltTable');
				$field->load($this->params->get('params.child_field'));
				$this->relate_field_type_id = $field->type_id;
				$this->field_key = $field->key;
			}
		}


		return $this->_display_output($client, $record, $type, $section);

	}

	public function validate($value, $record, $type, $section)
	{
		if ($this->params->get('params.multi_limit'))
		{
			if($this->params->get('params.input_mode') == 1 || $this->params->get('params.input_mode') == 2)
			{
				$value = explode(',', $value);
			}
			if (count($value) > $this->params->get('params.multi_limit'))
			{
				$this->setError(JText::sprintf('CSELECTLIMITF', $this->params->get('params.multi_limit'), $this->label));
			}
		}

		return parent::validate($value, $record, $type, $section);
	}

	public function onJSValidate()
	{
		$js = '';
		switch ($this->params->get('params.input_mode'))
		{
			case 1:
			case 2:
				$js = "\n\t\tselected = $('field_{$this->id}').value.split(',');";
				break;
			case 3:
				$js = "\n\t\t".'var field = $$("[name^=\"jform[fields]['.$this->id.']\"]");
				selected = 0;
				Array.each(field, function(opt, index){
					if(opt.checked)
					selected ++;
				});';
			break;
			case 5:
				$js = "\n\t\t".'var field = $$("[name^=\"jform[fields]['.$this->id.']\"]");
				selected = 0;
				Array.each(field, function(){
					selected ++;
				});';
				break;

			case 4:
				$js = "\n\t\t".'selected = $$("[name^=\"jform[fields]['.$this->id.']\"]").getSelected().length;';
				break;
		}
		if($this->required)
		{
			$js .= "\n\t\tif(!selected){hfid.push({$this->id}); isValid = false; errorText.push('".addslashes(JText::sprintf('CFIELDREQUIRED', $this->label))."');}";
		}
		if($this->params->get('params.total_limit'))
		{
			$js .= "\n\t\tif(selected > ".$this->params->get('params.total_limit').") {hfid.push({$this->id}); isValid = false; errorText.push('".addslashes(JText::sprintf('CSELECTLIMIT', $this->params->get('params.total_limit')))."');}";
		}
		return $js;
	}

	public function onPrepareSave($value, $record, $type, $section)
	{
		if($this->params->get('params.input_mode') == 1 || $this->params->get('params.input_mode') == 2)
		{
			$value = explode(',', $value);
			JArrayHelper::toInteger($value);
		}
		return $value;
	}

	public function onAttachExisting($params, $record)
	{
		$db = JFactory::getDbo();

		$table = JTable::getInstance('Record_values', 'CobaltTable');

		if($this->type == 'child')
		{
			$save['record_id'] = $params['record_id'];
			$save['field_value'] = $params['attach'];
			$save['field_id'] = $this->id;
		}
		else
		{
			$save['record_id'] = $params['attach'];
			$save['field_value'] = $params['record_id'];
			$save['field_id'] = $this->params->get('params.child_field');
		}
		$save['field_type'] = 'child';

		$table->load($save);

		if($table->id)
		{
			$this->setError('Already attached:'. print_r($save, true));
			return;
		}

		$field = JTable::getInstance('Field', 'CobaltTable');
		$field->load($save['field_id']);

		$save['field_label'] = $field->label;
		$save['field_key'] 	= $field->key;
		$save['user_id'] 	= JFactory::getUser()->get('id');
		$save['section_id'] = $this->_getChildSectionId($save['field_id']);
		$save['type_id'] 	= ($params['field'] == 'child' ?
			$this->type_id : JModel::getInstance('Fields', 'CobaltModel')->getFieldTypeId($save['field_id']));

		if(!$table->save($save))
		{
			$this->setError('Cannot save');
			return;
		}

		CEventsHelper::notify('record', $this->type.'_attached', $record->id, $record->section_id, 0, 0, $this->id, $record, $this->params->get('params.notify_attach'));

		return 1;
	}

	private function _getChildSectionId($field_id)
	{
		$db = JFactory::getDbo();
		$db->setQuery("SELECT section_id from #__js_res_record_values WHERE field_id = {$field_id} AND field_type = 'child'");
		return $db->loadResult();
	}
	public function _get_skiper()
	{
		$app = JFactory::getApplication();
		return $app->getUserState('skipers.all', array());
	}
}
