<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();
include_once dirname(__FILE__) . DS . 'community.php';
jimport('joomla.application.component.model');
jimport('joomla.database.table');

JModel::addIncludePath(JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'models');
JTable::addIncludePath(JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_cobalt' . DS . 'tables');

include_once JPATH_ROOT.DS.'components/com_cobalt/library/php/helpers/statistics.php';

class MECAccess
{

	public static function allowFeatured($record, $type, $section)
	{
		$user = JFactory::getUser();
		if($record->featured)
		{
			return FALSE;
		}
		if(in_array($type->params->get('properties.item_can_moderate'), $user->getAuthorisedViewLevels()))
		{
			return TRUE;
		}
		if($type->params->get('emerald.type_feature_subscription') && $record->user_id && ($record->user_id == $user->get('id')))
		{
			// MJTODO check emirald subscription.
			//if(CEmeraldHelper::allowType('feature', $type, $record->user_id, $section)) 
			return TRUE;
		}
		if(self::allowUserModerate($user, $section, 'allow_featured'))
		{
			return TRUE;
		}
		
		return FALSE;
	}

	public static function allowExtend($record, $type, $section)
	{
		$user = JFactory::getUser();
		
		if(! $record->extime)
		{
			return FALSE;
		}
		if(! is_object($record->extime))
		{
			$record->extime = JFactory::getDate($record->extime);
		}
		
		if($record->extime->toUnix() > time())
		{
			return FALSE;
		}
		
		if(in_array($type->params->get('properties.item_can_moderate'), $user->getAuthorisedViewLevels()))
		{
			return TRUE;
		}
		if($type->params->get('properties.allow_extend') && $record->user_id && ($record->user_id == $user->get('id')))
		{
			// MJTODO check emirald subscription.
			if(CEmeraldHelper::allowType('extend', $type, $record->user_id, $section)) return TRUE;
			return TRUE;
		}
		if(self::allowUserModerate($user, $section, 'allow_extend'))
		{
			return TRUE;
		}
		
		return FALSE;
	}

	public static function allowHide($record, $type, $section)
	{
		$user = JFactory::getUser();
		
		if(in_array($type->params->get('properties.item_can_moderate'), $user->getAuthorisedViewLevels()))
		{
			return TRUE;
		}
		if($type->params->get('properties.allow_hide') && $record->user_id && ($record->user_id == $user->get('id')))
		{
			return TRUE;
		}
		if(self::allowUserModerate($user, $section, 'allow_hide'))
		{
			return TRUE;
		}
		return FALSE;
	}

	public static function allowPublish($record, $type, $section)
	{
		$user = JFactory::getUser();
		
		if(in_array($type->params->get('properties.item_can_moderate'), $user->getAuthorisedViewLevels()))
		{
			return TRUE;
		}
		if(self::allowUserModerate($user, $section, 'allow_publish'))
		{
			return TRUE;
		}
		return FALSE;
	}

	public static function allowArchive($record, $type, $section)
	{
		$user = JFactory::getUser();
		
		if(in_array($type->params->get('properties.item_can_moderate'), $user->getAuthorisedViewLevels()))
		{
			return TRUE;
		}
		if($type->params->get('properties.allow_archive') && $record->user_id && ($record->user_id == $user->get('id')))
		{
			return TRUE;
		}
		if(self::allowUserModerate($user, $section, 'allow_archive'))
		{
			return TRUE;
		}
		return FALSE;
	}

	public static function allowCommentBlock($record, $type, $section)
	{
		$user = JFactory::getUser();
		
		if(in_array($type->params->get('properties.item_can_moderate'), $user->getAuthorisedViewLevels()))
		{
			return TRUE;
		}
		if($type->params->get('comments.comments_author_block') && $record->user_id && ($record->user_id == $user->get('id')))
		{
			return TRUE;
		}
		if(self::allowUserModerate($user, $section, 'allow_disable_comments'))
		{
			return TRUE;
		}
		return FALSE;
	}

	public static function allowDelete($record, $type, $section)
	{
		$user = JFactory::getUser();
		
		if(in_array($type->params->get('properties.item_can_moderate'), $user->getAuthorisedViewLevels()))
		{
			return TRUE;
		}
		if($type->params->get('properties.item_delete') && $record->user_id && ($record->user_id == $user->get('id')))
		{
			return TRUE;
		}
		if(self::allowUserModerate($user, $section, 'allow_delete'))
		{
			return TRUE;
		}
		return FALSE;
	}

	public static function allowEdit($record, $type, $section)
	{
		$user = JFactory::getUser();
		
		if(in_array($type->params->get('properties.item_can_moderate'), $user->getAuthorisedViewLevels()))
		{
			return TRUE;
		}
		if($type->params->get('properties.item_edit') && $record->user_id && ($record->user_id == $user->get('id')))
		{
			return TRUE;
		}
		if(self::allowUserModerate($user, $section, 'allow_edit'))
		{
			return TRUE;
		}
		return FALSE;
	}

	public static function allowModerate($record, $type, $section)
	{
		$user = JFactory::getUser();
		
		// if(in_array($type->params->get('properties.item_can_moderate'),
		// $user->getAuthorisedViewLevels()))
		// {
		// return TRUE;
		// }
		if(self::allowUserModerate($user, $section, 'allow_moderators'))
		{
			return TRUE;
		}
	}

	public static function allowUserModerate($user, $section, $type)
	{
		static $moderators;
		$params = JComponentHelper::getParams('com_cobalt');
		if($params->get('moderator', - 1) == $user->get('id'))
		{
			return true;
		}
		
		if(! $moderators)
		{
			$sql = 'SELECT id, user_id, section_id, params FROM #__js_res_moderators WHERE published = 1';
			$db = JFactory::getDbo();
			$db->setQuery($sql);
			$result = $db->loadObjectList();
			foreach($result as $moder)
			{
				$moderators[$moder->user_id][$moder->section_id] = json_decode($moder->params, true);
			}
			$moderators = new JRegistry($moderators);
		}
		
		if($moderators->get($user->get('id') . '.' . $section->id . '.' . $type))
		{
			return TRUE;
		}
		return FALSE;
	}

	public static function allowRestricted($user, $section)
	{
		if(is_int($user)) $user = JFactory::getUser($user);
		return self::allowUserModerate($user, $section, 'allow_restricted');
	}

	public static function isModerator($user_id, $section_id = 0)
	{
		static $moderators;
		$params = JComponentHelper::getParams('com_cobalt');
		if($params->get('moderator', - 1) == $user_id)
		{
			return true;
		}
		
		if(! $moderators)
		{
			$sql = 'SELECT id, user_id, section_id FROM #__js_res_moderators WHERE is_moderator = 1';
			$db = JFactory::getDbo();
			$db->setQuery($sql);
			$result = $db->loadObjectList();
			foreach($result as $moder)
			{
				$moderators[$moder->user_id][$moder->section_id] = 1;
				$moderators[$moder->user_id][0] = 1;
			}
			$moderators = new JRegistry($moderators);
		}
		
		if($moderators->get($user_id . '.' . $section_id))
		{
			return TRUE;
		}
		
		return FALSE;
	}
}
class CEventsHelper
{

	const _RECORD_NEW = 'record_new';

	const _RECORD_EXPIRED = 'record_expired';

	const _RECORD_FEATURED_EXPIRED = 'record_featured_expired';

	const _RECORD_TAGGED = 'record_tagged';

	const _RECORD_BOOKMARKED = 'record_bookmarked';

	const _RECORD_RATED = 'record_rated';

	const _RECORD_APPROVED = 'record_approved';

	const _RECORD_UNPUBLISHED = 'record_unpublished';

	const _RECORD_FEATURED = 'record_featured';

	const _RECORD_EXTENDED = 'record_extended';

	const _RECORD_DELETED = 'record_deleted';

	const _RECORD_EDITED = 'record_edited';

	const _COMMENT_NEW = 'comment_new';

	const _COMMENT_RATED = 'comment_rated';

	const _COMMENT_DELETED = 'comment_deleted';

	const _COMMENT_APPROVED = 'comment_approved';

	const _COMMENT_REPLY = 'comment_reply';

	const _COMMENT_UNPUBLISHED = 'comment_unpublished';

	const _COMMENT_EDITED = 'comment_edited';

	const _FIELDS_STATUS_CHANGED = 'status_changed';

	const _FIELDS_PARENT_NEW = 'parent_new';

	const _FIELDS_CHILD_NEW = 'child_new';

	const _FIELDS_PARENT_ATTACHED = 'parent_attached';

	const _FIELDS_CHILD_ATTACHED = 'child_arrached';

	const _FIELDS_PAY_STATUS_CHANGE = 'order_updated';

	const _FIELDS_PAY_NEW_SALE = 'new_sale';

	const _FIELDS_PAY_NEW_SALE_MANUAL = 'new_sale_manual';

	/**
	 * Add notifications to all subscribed users
	 * 
	 * @param string $type
	 *        	record|category
	 * @param string $event
	 *        	event type. Use uniquie string.
	 * @param int $record_id        	
	 * @param int $section_id        	
	 * @param int $cat_id        	
	 * @param array $params
	 *        	additional data to be saved as JSON. Later passed to callback
	 *        	function and you can manage what to show.
	 * @param int $who
	 *        	Who can get notifyed as access level ID
	 */
	static public function notify($type, $event, $record_id, $section_id, $cat_id, $comment_id, $field_id, $params, $who = 2, $only_user = 0, $html = '')
	{
		$section = ItemsStore::getSection($section_id);
		
		if(! $section->params->get('events.subscribe_' . $type, 1))
		{
			return;
		}
		
		$user = JFactory::getUser();
		$table = JTable::getInstance('Notification', 'CobaltTable');
		
		if($only_user)
		{
			//$query->where('s.`user_id` = ' . $only_user);
			$list[0] = new stdClass();
			$list[0]->user_id = $only_user;
			$list[0]->options = array();
		}
		else
		{
			$db = JFactory::getDbo();
			$query = $db->getQuery(true);
			$query->select('s.*');
			$query->select('(SELECT params FROM #__js_res_subscription_params WHERE user_id = s.user_id AND section_id = ' . $section_id . ') as `options`');
			$query->from('#__js_res_subscriptions s');
			$query->where('s.`type` = ' . $db->quote($type));
			$query->where('s.`user_id` != ' . $user->get('id'));
			if($type == 'record')
			{
				$query->where('s.`record_id` = ' . $record_id);
			}
			if($type == 'category')
			{
				$query->where('((s.section_id = ' . $section_id . ' AND s.category_id = 0) OR (s.section_id = ' . $section_id . ' AND s.category_id = ' . $cat_id . '))');
			}
			$query->group('user_id');
			$db->setQuery($query);
			$list = $db->loadObjectList(); // echo $db->getQuery(); die;
		}
		
		ArrayHelper::clean_r($list);
		
		if(! $list)
		{
			return;
		}
		
		if($record_id)
		{
			$record = JModel::getInstance('Record', 'CobaltModel');
			$item = $record->getItem($record_id);
			$icats = json_decode($item->categories, TRUE);
			
			if(is_array($params))
			{
				$params['record'] = $item;
			}
			else
			{
				$params->record = $item;
			}
			
			if(!$cat_id && $icats)
			{
				$cat_id = array_shift(array_keys($icats));
			}
		}
		if(is_array($params))
		{
			$params['section'] = $section;
			$params['by'] = $user->get('id');
			$params['on'] = time();
		}
		else
		{
			$params->section = $section;
			$params->by = $user->get('id');
			$params->on = time();
		}
		
		if(is_array($params) || is_object($params))
		{
			$params = json_encode($params);
		}
		
		foreach($list as $subscription)
		{
			if(! in_array($section->params->get('events.' . $type, $who), JFactory::getUser($subscription->user_id)->getAuthorisedViewLevels()))
			{
				continue;
			}

			if(self::_RECORD_NEW == $event && isset($item->access) && !in_array($item->access, JFactory::getUser($subscription->user_id)->getAuthorisedViewLevels()))
			{
				continue;
			}

			$user_params = new JRegistry($subscription->options);
			
			if(! $user_params->get('notyfication.' . $event, 1) && $user_params->get('language'))
			{
				continue;
			}
			
			$array = array(
				'id' => NULL, 
				'ctime' => JFactory::getDate()->toSql(), 
				'type' => $event, 
				'user_id' => $subscription->user_id, 
				'params' => $params, 
				'option' => 'com_cobalt', 
				'ref_1' => $record_id, 
				'ref_2' => $section_id, 
				'ref_3' => $cat_id, 
				'ref_4' => $comment_id, 
				'ref_5' => $field_id, 
				'html' => @$html
			);
			$table->id = NULL;
			$table->reset();
			$table->save($array);
		}
	}

	static public function notification($event)
	{
		$record = ItemsStore::getRecord($event->ref_1);
		$section = ItemsStore::getSection($event->ref_2);
		$type = ItemsStore::getType($record->type_id);
		$params = json_decode($event->params);
		
		$event_author = CCommunityHelper::getName($params->by, $section);
		//$msg = JText::_('EVENT_' . strtoupper($event->type) . '_GEN');
		

		$msg = JText::_('EVENT_' . strtoupper($event->type) . '_PERS');
		
		$record->link = Url::record($record, $type, $section);
		$msg = str_replace(array(
			'[TYPE]', 
			'[TITLE]', 
			'[RECORD]', 
			'[SECTION]', 
			'[USER]',
			'[RATE]'
		), array(
			'<b>' . $type->name . '</b>', 
			$record->title, 
			JHtml::link(JRoute::_(Url::record($record,$type, $section)), $record->title), 
			JHtml::link(JRoute::_(Url::records($section)), $section->name), 
			$event_author,
			@$params->new_vote
		), $msg);
		return $msg;
	}

	static public function get_notification($item)
	{
		
		$html = self::notification($item);
		
		if($item->ref_5)
		{
			$field = JTable::getInstance('Field', 'CobaltTable');
			$field->load($item->ref_5);
			$field->params = new JRegistry($field->params);
			
			include_once JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'fields' . DS . $field->field_type . DS . $field->field_type . '.php';
			
			$class_name = 'JFormFieldC' . ucfirst($field->field_type);
			$class = new $class_name($field, '');
			$html = $class->onNotification($html, $item);
		}
		
		return $html;
	}

	static public function cleanRecord($id)
	{
		$db = Jfactory::getDbo();
		$db->setQuery("DELETE FROM #__js_res_notifications WHERE ref_1 = " . $id . ' AND user_id = ' . JFactory::getUser()->get('id') . ' AND ref_2 = ' . JRequest::getInt('section_id'));
		$db->query();
	}

	static public function getNum($type, $id = 0, $key = 'num')
	{
		$user = JFactory::getUser();
		if(! $user->get('id'))
		{
			return;
		}
		
		static $events = NULL;
		
		if($events === NULL)
		{
			$events = array();
			
			$db = JFactory::getDbo();
			$sql = "SELECT * FROM #__js_res_notifications WHERE user_id = " . $user->get('id');
			$db->setQuery($sql);
			$list = $db->loadObjectList();
			
			if(! empty($list))
			{
				foreach($list as $event)
				{
					$params = json_decode($event->params);
					@$events['total'][0]['num'] ++;
					@$events['record'][$event->ref_1]['num'] ++;
					@$events['record'][$event->ref_1]['text'][] = str_replace(array(
						'[BY]', 
						'[ON]'
					), array(
						CCommunityHelper::getName($params->by, null, TRUE), 
						date('d F Y', $params->on)
					), JText::_(strtoupper('event_' . $event->type)));
					
					@$events['section'][$event->ref_2]['num'] ++;
					@$events['category'][$event->ref_3]['num'] ++;
					@$events['field'][$event->ref_5]['num'] ++;
					
					@$events['comment'][$event->ref_4]['num'] ++;
					@$events['comment'][$event->ref_4]['text'][] = str_replace(array(
						'[BY]', 
						'[ON]'
					), array(
						CCommunityHelper::getName($params->by, null, TRUE), 
						date('d F Y', $params->on)
					), JText::_(strtoupper('event_' . $event->type)));
				}
			}
		}
		$out = 0;
		
		if(! empty($events[$type][$id][$key]))
		{
			$out = $events[$type][$id][$key];
		}
		
		return $out;
	}

	static public function showNum($type, $id = 0, $url = false)
	{
		$num = self::getNum($type, $id);
		if(! $num)
		{
			return;
		}
		
		$text = self::getNum($type, $id, 'text');
		$attr = $class = '';
		
		if(is_array($text))
		{
			$attr = sprintf(' title="%s::%s"', JText::_('EVENT_NEW'), htmlspecialchars(implode('<br>', $text), ENT_COMPAT, 'UTF-8'));
			$class = ' hasTip';
		}
		
		$out = '<span class="event-counter' . $class . '"' . $attr . '><span>' . $num . '</span></span>';
		
		if($url)
		{
			$out = '<a href="' . JRoute::_(Url::user('events')) . '">' . $out . '</a>';
		}
		
		return $out;
	}
}

class CSubscriptionsHelper
{

	static public function unsubscribe_record($id)
	{
		$user = JFactory::getUser();
		
		if(! $user->get('id'))
		{
			return;
		}

		
		$table = JTable::getInstance('Subscription', 'CobaltTable');
		$array = array(
			'type' => 'record', 
			'user_id' => $user->get('id'), 
			'record_id' => $id
		);
		$table->load($array);
		$table->delete();
	
	}

	static public function subscribe_record($id)
	{
		$user = JFactory::getUser();
		
		if(! $user->get('id'))
		{
			return;
		}
		
		$model_record = JModel::getInstance('Record', 'CobaltModel');
		$item = $model_record->getItem($id);
		
		$section = ItemsStore::getSection($item->section_id);
		if (!$section->params->get('events.subscribe_record'))
		{
			return;
		}
		
		$table = JTable::getInstance('Subscription', 'CobaltTable');
		$array = array(
			'type' => 'record', 
			'user_id' => $user->get('id'), 
			'record_id' => $item->id
		);
		$table->load($array);
		
		if(! $table->id)
		{
			$db = JFactory::getDbo();
			$db->setQuery("SELECT `schedule` FROM #__js_res_subscription_params WHERE user_id = " . $user->get('id') . " AND section_id=" . $item->section_id);
			$result = $db->loadResult();
			
			if(!$result)
			{
				$table_subscr_params = JTable::getInstance('Subscription_params', 'CobaltTable');
				$data = array();
				$data['section_id'] = $item->section_id;
				$data['user_id'] = $user->get('id');
				$data['subscribe'] = 1;
				$data['schedule'] = $section->params->get('events.default_schedule', 2);
				
				$params = array();
				$params['subscribe'] = 1; 
				$params['schedule'] = $section->params->get('events.default_schedule', 2); 
				$params['language'] = JFactory::getLanguage()->getDefault(); 
				$params['notyfication']['record_new'] = 'record_new'; 
				$params['notyfication']['record_approved'] = 'record_approved'; 
				$params['notyfication']['record_edited'] = 'record_edited'; 
				$params['notyfication']['record_deleted'] = 'record_deleted'; 
				$params['notyfication']['record_rated'] = 'record_rated'; 
				$params['notyfication']['record_expired'] = 'record_expired'; 
				$params['notyfication']['record_featured_expired'] = 'record_featured_expired'; 
				$params['notyfication']['record_bookmarked'] = 'record_bookmarked'; 
				$params['notyfication']['record_tagged'] = 'record_tagged'; 
				$params['notyfication']['record_unpublished'] = 'record_unpublished'; 
				$params['notyfication']['record_featured'] = 'record_featured'; 
				$params['notyfication']['record_extended'] = 'record_extended'; 
				$params['notyfication']['comment_new'] = 'comment_new'; 
				$params['notyfication']['comment_rated'] = 'comment_rated'; 
				$params['notyfication']['comment_deleted'] = 'comment_deleted'; 
				$params['notyfication']['comment_approved'] = 'comment_approved'; 
				$params['notyfication']['comment_reply'] = 'comment_reply'; 
				$params['notyfication']['comment_unpublished'] = 'comment_unpublished'; 
				$data['params'] = json_encode($params);
				$data['last_send'] = JFactory::getDate()->toMySQL();
				$table_subscr_params->save($data);
				
				$result = $section->params->get('events.default_schedule', 2); 
			}
			
			$array['alert_shedule'] = $result;
			
			$array['id'] = NULL;
			$array['section_id'] = $item->section_id;
			$array['type_id'] = $item->type_id;
			
			$table->reset();
			$table->save($array);
		}
	}
}

class AttachmentHelper
{

	/**
	 *
	 *
	 * Enter description here ...
	 * 
	 * @param array $list
	 *        	list of saved attachments
	 */
	public static function getAttachments($list, $show_hits = FALSE)
	{
		if(! $list)
		{
			return array();
		}
		if(is_string($list))
		{
			$list = json_decode($list);
		}
		
		if($show_hits)
		{
			$in = array();
			foreach($list as $attach)
			{
				settype($attach, 'array');
				$in[] = $attach['id'];
			}
			
			if($in)
			{
				$files = JTable::getInstance('Files', 'CobaltTable');
				$list = $files->getFiles($in, 'id');
			}
		}
		foreach($list as &$file)
		{
			if(is_array($file))
			{
				$file = JArrayHelper::toObject($file);
			}
			$file->url = JURI::root() . 'index.php?option=com_cobalt&task=files.download_attach&no_html=1&id=' . $file->id;
		}
		
		return $list;
	}
}

class FieldHelper
{

	public function __construct($keys, $fields)
	{
		$this->keys = $keys;
		$this->fields = $fields;
	}

	public function isExists($key)
	{
		return isset($this->fields[$key]);
	}

	public function hasIcon($key)
	{
		return $this->fields[$key]->params->get('core.icon', 0);
	}

	public function label($key)
	{
		return $this->fields[$key]->label;
	}

	public function result($key)
	{
		return $this->fields[$key]->result;
	}

	public function icon($key)
	{
		return $this->fields[$key]->params->get('core.icon', 0);
	}

	public static function sortName($field)
	{
		return sprintf('field^%s^%s', $field->key, $field->params->get('params.ordering_mode', 'digits'));
	}
}

class MetaHelper
{

	public static function setMeta($meta = array())
	{
		$doc = JFactory::getDocument();
		
		foreach($meta as $key => $value)
		{
			if($value)
			{
				$doc->setMetaData($key, $value);
			}
		}
	}
}

class FilterHelper
{

	public static function access($field)
	{

	}

	public static function filterLink($name, $value, $text, $type, $tip = NULL, $section = NULL)
	{
		$url = 'task=records.filter';
		if($type && count($section->params->get('general.type')) > 1)
		{
			$url .= '&filter_name[1]=filter_type';
			$url .= '&filter_val[1]=' . $type;
		}
		$url .= '&filter_name[0]=' . $name;
		$url .= '&filter_val[0]=' . urlencode($value);
		
		$url = self::url($url, $section);
		
		if(!$section)
		{
			$section = ItemsStore::getSection(JRequest::getInt('section_id'));
		}
		
		$nofollow = '';
		if(JComponentHelper::getParams('com_cobalt')->get('filter_nofollow', 1))
		{
			$nofollow = 'rel="nofollow"';
		}
		
		$patern = '<a class="filter-link%s" %s href="%s" ' . $nofollow . '>%s</a>';
		return sprintf($patern, ($tip ? ' hasTip' : NULL), ($tip ? 'title="' . JText::_('CFILTER') . '::' . htmlspecialchars($tip, ENT_COMPAT, 'UTF-8') . '"' : NULL), JRoute::_($url), $text);
	}

	public static function filterButton($name, $value, $type, $tip = NULL, $section = NULL, $icon = 'funnel-small.png')
	{
		// $patern = '<img class="img-filter%s" %s onclick="applyFilter(\'%s\',
		// \'%s\', %d)" align="absmiddle" src="media/mint/icons/16/%s" />';
		// return sprintf($patern, ($tip ? ' hasTip' : NULL), ($tip ?
		// 'title="::' . $tip . '"' : NULL), $name, $value, (int)$type, $icon);
		
		if(!$section)
		{
			$section = ItemsStore::getSection(JRequest::getInt('section_id'));
		}

		return self::filterLink($name, $value, JHtml::image(JURI::root() . 'media/mint/icons/16/' . $icon, strip_tags($tip), array(
			'border' => 0, 
			'align' => 'absmiddle'
		)), $type, $tip, $section);
	}

	public static function key()
	{
		static $section = NULL;
		
		if(! $section)
		{
			$section = ItemsStore::getSection(JRequest::getInt('section_id'));
		}
		
		$key = array();
		if($s = JRequest::getInt('section_id'))
		{
			$key[] = $s;
		}
		
		if($section->params->get('general.filter_mode', 0) == 1)
		{
			if($c = JRequest::getInt('cat_id'))
			{
				$key['c'] = $c;
			}
		}
		if($c = JRequest::getInt('ucat_id'))
		{
			$key[] = $c;
		}
		if($u = JRequest::getInt('user_id') && empty($key['c']))
		{
			$key[] = $u;
		}
		if($v = JRequest::getVar('view_what'))
		{
			$key[] = $v;
		}
		
		return implode('_', $key);
	}

	public static function url($url, $section)
	{
		$url = 'index.php?option=com_cobalt&' . $url;
		$url .= '&section_id=' . $section->id;
		
		if(JRequest::getInt('section_id') == $section->id)
		{
			if($c = JRequest::getInt('cat_id'))
			{
				$url .= '&cat_id=' . $c;
			}
			if($c = JRequest::getInt('ucat_id'))
			{
				$url .= '&ucat_id=' . $c;
			}
			if($u = JRequest::getInt('user_id'))
			{
				$url .= '&user_id=' . $u;
			}
		}
		
		if($section->params->get('general.category_itemid'))
		{
			$url .= '&Itemid=' . $section->params->get('general.category_itemid');
		}
		return $url;
	}
}

class WornHelper
{

	public static function getItem($name, $label, $value, $text = NULL)
	{
		$o = new stdClass();
		$o->name = $name;
		$o->label = $label;
		$o->text = ($text ? $text : $value);
		$o->value = $value;
		
		return $o;
	}
}

class Url
{

	static public function add($section, $type, $category)
	{
		$return = urlencode(base64_encode(JFactory::getURI()->toString()));
		$url = 'index.php?option=com_cobalt&view=form&section_id=' . $section->id;
		$url .= '&type_id=' . $type->id . ':' . JApplication::stringURLSafe($type->name);
		if($category->id)
		{
			$url .= '&cat_id=' . $category->id . ':' . JApplication::stringURLSafe($category->title);
		}
		$url .= '&return=' . base64_encode(JFactory::getURI());
		
		return JRoute::_($url);
	}

	static public function edit($record)
	{
		$return = urlencode(base64_encode(JFactory::getURI()->toString()));
		if(!is_object($record))
			$record = ItemsStore::getRecord($record);

		$url = 'index.php?option=com_cobalt&view=form&id=' . $record->id . ':'.$record->alias.'&return=' . $return;
		return JRoute::_($url);
	}

	static public function task($task, $id, $return = false)
	{
		if(! $return)
		{
			$return = JFactory::getURI()->toString();
		}
		$return = urlencode(base64_encode($return));
		$url = 'index.php?option=com_cobalt&task=' . $task . '&id=' . $id . '&return=' . $return;
		return JRoute::_($url);
	}

	static public function _($type, $array = array(), $ignore = array())
	{
		if($s = JRequest::getInt('section_id'))
		{
			$array['section_id'] = $s;
		}
		
		$array['view'] = $type;
		
		if($c = JRequest::getInt('cat_id'))
		{
			$array['cat_id'] = $c;
		}
		if($c = JRequest::getInt('ucat_id'))
		{
			$array['ucat_id'] = $c;
		}
		if($u = JRequest::getInt('user_id'))
		{
			$array['user_id'] = $u;
		}
		return self::build($array);
	}

	static public function user($view_what, $user_id = NULL)
	{
		if(! $id = JFactory::getUser($user_id)->get('id'))
		{
			return null;
		}
		
		$array['view'] = 'records';
		if($s = JRequest::getInt('section_id'))
		{
			$array['section_id'] = $s . ':' . ItemsStore::getSection($s)->alias;
		}
		
		/*
		 * if (($c = JRequest::getInt('ucat_id')) && ($view_what == 'created'))
		 * { $array['ucat_id'] = $c; }
		 */
		
		$array['user_id'] = $id . ':' . JApplication::stringURLSafe(JFactory::getUser($id)->get(ItemsStore::$sections[$s]->params->get('personalize.author_mode')));
		if($view_what) $array['view_what'] = $view_what;
		
		return self::build($array);
	}

	static public function build($array)
	{
		$url = 'index.php?option=com_cobalt';
		
		foreach($array as $key => $val)
		{
			$url .= '&' . $key . '=' . urlencode($val);
		}
		
		return $url;
	}

	static public function record($record, $type = NULL, $section = NULL, $category = null)
	{
		if(empty($category->id) && $category)
		{
			$category = ItemsStore::getCategory($category);
		}
		
		if(! is_object($record))
		{
			$record = ItemsStore::getRecord($record);
		}
		
		if(! $type)
		{
			$type = ItemsStore::getType($record->type_id);
		}
		
		if(! $section)
		{
			$section = ItemsStore::getSection($record->section_id);
		}
		
		$itemid = $type->params->get('properties.item_itemid');
		
		if($category && $category->params->get('category_item_itemid', 0))
		{
			$itemid = $category->params->get('category_item_itemid');
		}
		if(!$itemid) $itemid = JRequest::getInt('Itemid');
		
		$url = 'index.php?option=com_cobalt&view=record';
		
		if($section->params->get('personalize.personalize') && $record->user_id)
		{
			$url .= '&user_id=' . $record->user_id . ':' . JApplication::stringURLSafe(JFactory::getUser($record->user_id)->get($section->params->get('personalize.author_mode')));
		}
		if($category)
		{
			$url .= '&cat_id=' . $category->id . ':' . $category->alias;
		}
		$url .= '&id=' . $record->id . ':' . $record->alias;
		$url .= '&Itemid=' . $itemid;
		
		return $url;
	}

	static public function records($section, $category = null, $user_id = NULL)
	{
		if(! is_object($section))
		{
			$section = ItemsStore::getSection($section);
		}
		if(empty($category->id) && $category)
		{
			$category = ItemsStore::getCategory($category);
		}
		
		$url = 'index.php?option=com_cobalt&view=records&section_id=';
		$url .= $section->id . ':' . $section->alias;
		if($category)
		{
			$url .= '&cat_id=' . $category->id . ':' . $category->alias;
		}
		if($user_id)
		{
			$url .= '&user_id=' . $user_id;
		}
		
		$itemid = $section->params->get('general.category_itemid');
		if($category && $category->params->get('category_itemid', 0))
		{
			$itemid = $category->params->get('category_itemid');
		}
		if(!$itemid) $itemid = JRequest::getInt('Itemid');
		
		$url .= '&Itemid=' .$itemid;
		
		return $url;
	}

	static public function usercategory_records($user_id, $section, $ucategory_id = null)
	{
		$url = 'index.php?option=com_cobalt&view=records';
		$url .= '&section_id=' . $section->id . ':' . $section->alias;
		if($ucategory_id)
		{
			$ucat = ItemsStore::getUserCategory($ucategory_id);
			if(isset($ucat->id)) $url .= '&ucat_id=' . $ucategory_id . ':' . $ucat->alias;
		}
		$itemid = $section->params->get('general.category_itemid');
		if(!$itemid) $itemid = JRequest::getInt('Itemid');

		$url .= '&user_id=' . $user_id . ':' . JApplication::stringURLSafe(JFactory::getUser($user_id)->get($section->params->get('personalize.author_mode')));
		$url .= '&Itemid=' . $itemid;
		return $url;
	}

}

class ItemsStore
{

	public static $categories = array();

	public static $sections = array();

	public static $records = array();

	public static $types = array();

	public static $usercategories = null;

	public static $record_ids = null;

	static public function getSection($section_id)
	{
		if(! isset(self::$sections[$section_id]))
		{
			$section_model = JModel::getInstance('Section', 'CobaltModel');
			self::$sections[$section_id] = $section_model->getItem($section_id);
		}
		return self::$sections[$section_id];
	}

	static public function getRecord($record_id)
	{
		if(! isset(self::$records[$record_id]))
		{
			$rec_mod = JModel::getInstance('Record', 'CobaltModel');
			self::$records[$record_id] = $rec_mod->getItem($record_id);
		}
		return self::$records[$record_id];
	}

	static public function getType($type_id)
	{
		if(! isset(self::$types[$type_id]))
		{
			self::$types[$type_id] = JModel::getInstance('Form', 'CobaltModel')->getRecordType($type_id);
		}
		return self::$types[$type_id];
	}

	static public function getUserCategory($ucategory_id)
	{
		if(! isset(self::$usercategories[$ucategory_id]))
		{
			$usercategory_model = JModel::getInstance('Usercategory', 'CobaltModel');
			self::$usercategories[$ucategory_id] = $usercategory_model->getItem($ucategory_id);
		}
		return self::$usercategories[$ucategory_id];
	}

	static public function getCategory($category_id)
	{
		if(isset(self::$categories[$category_id]))
		{
			return self::$categories[$category_id];
		}
		$db = JFactory::getDbo();
		if(! empty(self::$record_ids))
		{
			$sql = "SELECT id,alias,params,path FROM #__js_res_categories WHERE id IN (SELECT catid FROM #__js_res_record_category WHERE record_id IN (" . implode(',', self::$record_ids) . ")) OR id = " . (int)$category_id;
			self::$record_ids = array();
		}
		else
		{
			$sql = "SELECT id,alias,params,path,title FROM #__js_res_categories WHERE id = " . (int)$category_id;
		
		}
		$db->setQuery($sql);
		$result = $db->loadObjectList('id');
		
		foreach($result as $key => $cat)
		{
			$cat->params = new JRegistry($cat->params);
			$cat->path = str_replace('root/', '', $cat->path);
			self::$categories[$key] = $cat;
		}
		
		return self::$categories[$category_id];
	}
}

class HTMLFormatHelper
{

	public static function follow($record, $section)
	{
		$user = JFactory::getUser();
		
		if(! $user->get('id'))
		{
			return NULL;
		}
		
		if(! $section->params->get('events.subscribe_record'))
		{
			return NULL;
		}
		
		$file = JURI::root() . 'media/mint/icons/16/follow' . (int)($record->subscribed > 0) . '.png';
		$alt = ($record->subscribed ? JText::_('CMSG_CLICKTOUNFOLLOW') : JText::_('CMSG_CLICKTOFOLLOW'));
		$attr = array(
			'title' => '::' . $alt, 
			'width' => 16, 
			'height' => 16, 
			'class' => 'hasTip follow-icon', 
			'id' => 'follow_' . $record->id, 
			'onclick' => "followRecord({$record->id}, {$section->id})"
		);
		$out = JHtml::image($file, $alt, $attr);
		
		return $out;
	}

	public static function bookmark($record, $type, $params)
	{
		$user = JFactory::getUser();
		
		if(! $user->get('id'))
		{
			return NULL;
		}
		
		if(! in_array($type->params->get('properties.item_can_favorite'), $user->getAuthorisedViewLevels()))
		{
			return NULL;
		}
		
		$file = JURI::root() . 'media/mint/icons/bookmarks/' . $params->get('tmpl_core.bookmark_icons', 'star') . '/state' . (int)($record->bookmarked > 0) . '.png';
		$alt = ($record->bookmarked ? JText::_('CMSG_REMOVEBOOKMARK') : JText::_('CMSG_ADDBOOKMARK'));
		$attr = array(
			'title' => '::' . $alt, 
			'width' => 16, 
			'height' => 16, 
			'class' => 'hasTip bookmark-icon', 
			'id' => 'bookmark_' . $record->id, 
			'onclick' => "bookmarkRecord({$record->id}, '" . $params->get('tmpl_core.bookmark_icons', 'star') . "', " . JRequest::getInt('section_id') . ")"
		);
		$out = JHtml::image($file, $alt, $attr);
		
		return $out;
	}

	public static function bb2html($text)
	{
		$bbcode = array(
			"[list]", 
			"[*]", 
			"[/list]", 
			"[img]", 
			"[/img]", 
			"[b]", 
			"[/b]", 
			"[u]", 
			"[/u]", 
			"[i]", 
			"[/i]", 
			'[color="', 
			"[/color]", 
			"[size=\"", 
			"[/size]", 
			"[mail=\"", 
			"[/mail]", 
			"[code]", 
			"[/code]", 
			"[quote]", 
			"[/quote]", 
			'"]'
		);
		$htmlcode = array(
			"<ul>", 
			"<li>", 
			"</ul>", 
			"<img src=\"", 
			"\">", 
			"<b>", 
			"</b>", 
			"<u>", 
			"</u>", 
			"<i>", 
			"</i>", 
			"<span style=\"color:", 
			"</span>", 
			"<font size=\"", 
			"</font>", 
			"<a href=\"mailto:", 
			"</a>", 
			"<code>", 
			"</code>", 
			"<pre>", 
			"</pre>", 
			'">'
		);
		
		$newtext = str_replace($bbcode, $htmlcode, $text);
		
		$regExp = array(
			'/(?:\[url=)([^\]]+)\]([^\[]+)\[\/url\]/', 
			'/(?:\[url\])([^\[]+)\[\/url\]/'
		);
		
		$replace = array(
			'<a href="\1">\2</a>', 
			'<a href="\1">\1</a>'
		);
		
		$newtext = preg_replace($regExp, $replace, $newtext);
		
		// $newtext = nl2br($newtext); //second pass
		

		return $newtext;
	}

	public static function icon($name)
	{
		return ' <img src="' . JURI::root() . 'media/mint/icons/16/' . $name . '" align="absmiddle" /> ';
	}

	public static function formatSize($size)
	{
		
		$kb = 1024;
		$mgb = $kb * 1024;
		$gb = $mgb * 1024;
		$trb = $gb * 1024;
		
		if($size > $trb)
		{
			return number_format($size / $trb, 2, ',', ' ') . " Tb";
		}
		elseif($size > $gb)
		{
			return number_format($size / $gb, 1, ',', ' ') . " Gb";
		}
		elseif($size > $mgb)
		{
			return number_format($size / $mgb, 0, ',', ' ') . " Mb";
		}
		elseif($size > $kb)
		{
			return number_format($size / $kb, 0, ',', ' ') . " Kb";
		}
		else
		{
			return $size . " B";
		}
	}

	public static function cutHTML($txt, $len, $delim = '\s;,.!?:x')
	{
		$txt = preg_replace_callback("#(</?[a-z]+(?:>|\s[^>]*>)|[^<]+)#mi", 
			create_function('$a', 
				'static $len = ' . $len . ';' . '$len1 = $len-1;' . '$delim = \'' . str_replace("#", "\\#", $delim) . '\';' . 'if ("<" == $a[0]{0}) return $a[0];' . 'if ($len<=0) return "";' . '$res = preg_split("#(.{0,$len1}+(?=[$delim]))|(.{0,$len}[^$delim]*)#ms",$a[0],2,PREG_SPLIT_DELIM_CAPTURE);' .
				 'if ($res[1]) { $len -= strlen($res[1])+1; $res = $res[1];}' . 'else         { $len -= strlen($res[2]); $res = $res[2];}' . '$res = rtrim($res);/*preg_replace("#[$delim]+$#m","",$res);*/' . 'return $res;'), $txt);
		
		while(preg_match("#<([a-z]+)[^>]*>\s*</\\1>#mi", $txt))
		{
			$txt = preg_replace("#<([a-z]+)[^>]*>\s*</\\1>#mi", "", $txt);
		}
		while(preg_match("#<br \/>$#isU", $txt))
		{
			$txt = preg_replace("#<br \/>$#isU", "", $txt);
		}
		return $txt;
	}

	static public function substrHTML($string, $length, $addstring = "")
	{
		if(! $length) return $string;
		
		$addstring = " " . $addstring;
		
		if(JString::strlen($string) > $length)
		{
			if(! empty($string) && $length > 0)
			{
				$isText = true;
				$ret = "";
				$i = 0;
				
				$currentChar = "";
				$lastSpacePosition = - 1;
				$lastChar = "";
				
				$tagsArray = array();
				$currentTag = "";
				$tagLevel = 0;
				
				$noTagLength = JString::strlen(strip_tags($string));
				
				// Parser loop
				$strLen = JString::strlen($string);
				for($j = 0; $j < $strLen; $j ++)
				{
					
					$currentChar = JString::substr($string, $j, 1);
					$ret .= $currentChar;
					
					// Lesser than event
					if($currentChar == "<") $isText = false;
					
					// Character handler
					if($isText)
					{
						
						// Memorize last space position
						if($currentChar == " ")
						{
							$lastSpacePosition = $j;
						}
						else
						{
							$lastChar = $currentChar;
						}
						
						$i ++;
					}
					else
					{
						$currentTag .= $currentChar;
					}
					
					// Greater than event
					if($currentChar == ">")
					{
						$isText = true;
						
						// Opening tag handler
						if((JString::strpos($currentTag, "<") !== FALSE) && (JString::strpos($currentTag, "/>") === FALSE) && (JString::strpos($currentTag, "</") === FALSE))
						{
							
							// Tag has attribute(s)
							if(JString::strpos($currentTag, " ") !== FALSE)
							{
								$currentTag = JString::substr($currentTag, 1, JString::strpos($currentTag, " ") - 1);
							}
							else
							{
								// Tag doesn't have attribute(s)
								$currentTag = JString::substr($currentTag, 1, - 1);
							}
							
							array_push($tagsArray, $currentTag);
						
						}
						else 
							if(JString::strpos($currentTag, "</") !== FALSE)
							{
								array_pop($tagsArray);
							}
						
						$currentTag = "";
					}
					
					if($i >= $length)
					{
						break;
					}
				}
				
				// Cut HTML string at last space position
				if($length < $noTagLength)
				{
					if($lastSpacePosition != - 1)
					{
						$ret = JString::substr($string, 0, $lastSpacePosition);
					}
					else
					{
						$ret = JString::substr($string, $j);
					}
				}
				
				// Close broken XHTML elements
				while(sizeof($tagsArray) != 0)
				{
					$aTag = array_pop($tagsArray);
					$ret .= "</" . $aTag . ">\n";
				}
			
			}
			else
			{
				$ret = "";
			}
			
			// only add 'tail' string if text was cut
			if(JString::strlen($string) > $length)
			{
				return ($ret . $addstring);
			}
			else
			{
				return ($res);
			}
		}
		else
		{
			return ($string);
		}
	}

	public static function initJsURLroot()
	{
		JFactory::getDocument()->addScriptDeclaration("URL_ROOT = '" . JURI::root() . "';");
	}
}

class AjaxHelper
{

	public static function send($data)
	{
		echo json_encode($data);
		JFactory::getApplication()->close();

	}
	public static function error($msg)
	{
		$out = array(
			'success' => 0, 
			'error' => $msg
		);
		return json_encode($out);
	}
}
class ArrayHelper
{

	public static function trim_r(&$array)
	{
		if(! is_array($array))
		{
			settype($array, 'array');
		}
		foreach($array as &$val)
		{
			$val = trim($val);
		}
	}

	public static function clean_r(&$array)
	{
		if(! is_array($array))
		{
			settype($array, 'array');
		}
		foreach($array as $k => &$val)
		{
			if(is_array($val))
			{
				self::clean_r($val);
			}
			elseif(is_string($val))
			{
				$val = trim($val);
				$val = str_replace("\r", "", $val);
			}
			if($val != "0" && empty($val)) unset($array[$k]);
		}
		if(! $array) $array = array();
	}

	public static function tolower_r(&$array)
	{
		if(! is_array($array))
		{
			settype($array, 'array');
		}
		foreach($array as $k => &$val)
		{
			$val = JString::strtolower($val);
		}
		if(! $array) $array = array();
	}

	public static function separate_r(&$array, $separator = '^')
	{
		if(! is_array($array))
		{
			settype($array, 'array');
		}
		foreach($array as $k => &$val)
		{
			$val = explode($separator, $val);
			$val = $val[0];
		}
		if(! $array) $array = array();
	}
}

class RatingHelp
{

	public static function loadRecord()
	{
		JFactory::getDocument()->addScriptDeclaration(
			"function ItemRatingCallBack( vote, ident, index )
			{
				var req = new Request.JSON(
				{
					url:'" . JURI::base() . "index.php?option=com_cobalt&task=rate.record&no_html=1',
					method:'post',
					autoCancel:true,
					data:{vote: vote, id: ident, index: index},
					onComplete: function(json)
					{
						if(!json.success)
						{
							alert(json.error);
							return;
						}

						if(json.result)
						{
							fname = eval('newRating' + ident);
							fname.setCurrentStar(json.result);
						}

					}
				}).send();
			}");
	}

	public static function loadFile()
	{
		JFactory::getDocument()->addScriptDeclaration(
			"function FileRatingCallBack( vote, ident )
			{
				var req = new Request.JSON(
				{
					url:'" . JURI::base() . "index.php?option=com_cobalt&task=rate.file&no_html=1',
					method:'post',
					autoCancel:true,
					data:{vote: vote, id: ident},
					onComplete: function(json)
					{
						if(!json.success)
						{
							alert(json.error);
						}
					}
				}).send();
		}");
	}

	public static function canRate($type, $user_id, $id, $accessLevel = 1, $index = 0)
	{
		$user = JFactory::getUser();
		if($accessLevel == - 1)
		{
			if(! $user->get('id') || ! $user_id)
			{
				return false;
			}
			
			if($user_id != $user->get('id'))
			{
				return FALSE;
			}
		}
		else
		{
			if(! in_array($accessLevel, $user->getAuthorisedViewLevels()))
			{
				return FALSE;
			}
			
			if($user_id == $user->get('id') && $user->get('id'))
			{
				return FALSE;
			}
			if($user->get('id') && JRequest::getVar($type . "_rate_{$id}_{$index}", 0, 'COOKIE', 'INT'))
			{
				return FALSE;
			}
			
			$ses = JFactory::getSession();
			if($ses->get($type . "_rate_{$id}_{$index}"))
			{
				return FALSE;
			}
		}
		
		return TRUE;
	}

	public static function loadRating($tmpl_name, $current, $prod_id, $index = 0, $callbackfunction, $rating_active, $record_id = '')
	{
		$vars = new stdClass();
		$vars->img_path = JURI::root() . 'components/com_cobalt/views/rating_tmpls/' . $tmpl_name . '_img/';
		$vars->rating_ident = 'r' . md5($prod_id . '-' . $index);
		$vars->rating_active = (int)$rating_active;
		$vars->callbackfunction = $callbackfunction;
		$vars->rating_current = $current;
		$vars->prod_id = $prod_id;
		$vars->index = $index;
		$vars->rid = $record_id;
		ob_start();
		
		include (JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'views' . DS . 'rating_tmpls' . DS . 'rating_' . $tmpl_name . '.php');
		$content = ob_get_contents();
		
		ob_end_clean();
		
		return $content;
	}

	public static function loadMultiratings($record, $type, $section)
	{
		if(! $type->params->get('properties.rate_access'))
		{
			return FALSE;
		}
		$options = $type->params->get('properties.rate_multirating_options');
		$options = explode("\n", $options);
		ArrayHelper::clean_r($options);
		
		$result = json_decode(stripslashes($record->multirating), true);
		if(count($options) > 1)
		{
			$pat = '<tr class="%s"><td>%s</td><td>%s</td></tr>';
			$out[] = sprintf($pat, 'row-head', JText::_('CGENERAL'), self::loadRating($type->params->get('properties.tmpl_rating'), round(@$record->votes_result), $record->id, 500, 'ItemRatingCallBack', false, $record->id));
			
			foreach($options as $key => $option)
			{
				$parts = explode('::', $option);
				$out[] = sprintf($pat, NULL, JText::_($parts[0]), 
					self::loadRating(isset($parts[1]) ? $parts[1] : $type->params->get('properties.tmpl_rating'), round((int)@$result[$key]['sum']), $record->id, $key, 'ItemRatingCallBack', self::canRate('record', $record->user_id, $record->id, $type->params->get('properties.rate_access'), $key)));
			}
			
			return '<table class="multi-rating">' . implode('', $out) . '</table>';
		}
		else
		{
			return self::loadRating($type->params->get('properties.tmpl_rating'), round(@$record->votes_result), $record->id, 0, 'ItemRatingCallBack', self::canRate('record', $record->user_id, $record->id, $type->params->get('properties.rate_access')));
		}
	}

	public static function loadFormMultiratings($record, $type, $section)
	{
		$options = $type->params->get('properties.rate_multirating_options');
		$options = explode("\n", $options);
		ArrayHelper::clean_r($options);
		
		if(empty($record->multirating))
		{
			$record->multirating = '[]';
		}
		
		$doc = JFactory::getDocument();
		$doc->addScriptDeclaration(
			"
			var mr = JSON.decode('" . $record->multirating . "');
			function FormItemRatingCallBack(vote, ident, index )
			{
				votes_result = 0;
				if(mr[index] == undefined)
				{
					mr[index] = new Object();
				}
				mr[index] = {'sum' : vote, 'num' : 1};
				mr.each(function(item, index)
					{
						votes_result += parseInt(item['sum']);
					}
				);
				rs = Math.round(votes_result / mr.length);
				$('multirating').value = JSON.encode(mr);
				$('votes_result').value = rs;
				fname = eval('newRating' + ident);
				fname.setCurrentStar(rs);
				fname = eval('newRating' + index);
				fname.setCurrentStar(vote);
				fname.rated = false;
			}
		");
		
		$result = json_decode(stripslashes($record->multirating), true);
		if(count($options) > 1)
		{
			$pat = '<tr class="%s"><td>%s</td><td>%s</td></tr>';
			$out[] = sprintf($pat, 'row-head', JText::_('CGENERAL'), self::loadRating($type->params->get('properties.tmpl_rating'), round(@$record->votes_result), $record->id, 500, 'FormItemRatingCallBack', false, $record->id));
			
			foreach($options as $key => $option)
			{
				$parts = explode('::', $option);
				$out[] = sprintf($pat, NULL, JText::_($parts[0]), self::loadRating(isset($parts[1]) ? $parts[1] : $type->params->get('properties.tmpl_rating'), round((int)@$result[$key]['sum']), $record->id, $key, 'FormItemRatingCallBack', true, $key));
			}
			$out[] = '<input id="multirating" type="hidden" name="jform[multirating]" value="' . htmlentities($record->multirating) . '">';
			$out[] = '<input id="votes" type="hidden" name="jform[votes]" value="1">';
			$out[] = '<input id="votes_result" type="hidden" name="jform[votes_result]" value="' . @$record->votes_result . '">';
			return '<table class="multi-rating">' . implode('', $out) . '</table>';
		}
	}
}

class CEmeraldHelper
{

	public static function allowType($method, $type, $item, $section, $redirect = FALSE)
	{
		$em_api = JPATH_ROOT . DS . 'components' . DS . 'com_emerald' . DS . 'api.php';
		if(! JFile::exists($em_api))
		{
			return true;
		}
		$user = JFactory::getUser();
		$params = $type->params;
		
		if(! $params->get('emerald.type_' . $method . '_subscription'))
		{
			return true;
		}
		
		if(in_array($params->get('emerald.subscr_skip', 0), $user->getAuthorisedViewLevels()))
		{
			return true;
		}
		
		if($params->get('emerald.subscr_moderator_skip', 1) && MECAccess::allowRestricted($user, $section))
		{
			return true;
		}
		include_once ($em_api);
		
		$user_id = ($method == 'display') ? $item: $user->id; 
		
		if(EmeraldApi::hasSubscription($params->get('emerald.type_' . $method . '_subscription'), $params->get('emerald.type_' . $method . '_subscription_msg'), $params->get('emerald.subscription_iid'), $redirect, $params->get('emerald.type_' . $method . '_subscription_count'), $user_id))
		{
			return true;
		}
		
		return false;
	}

	public static function allowField($method, $field, $user_id, $section, $redirect = FALSE)
	{
		$em_api = JPATH_ROOT . DS . 'components' . DS . 'com_emerald' . DS . 'api.php';
		if(! JFile::exists($em_api))
		{
			return true;
		}
		$user = JFactory::getUser();
		$params = $field->params;
		if(! $params->get('emerald.field_' . $method . '_subscription'))
		{
			return true;
		}
		if(in_array($params->get('emerald.subscr_skip', 3), $user->getAuthorisedViewLevels()))
		{
			return true;
		}
		
		if(!($method == 'edit' || $method == 'submit') && $params->get('emerald.subscr_skip_author', 1) && $user_id == $user->id && $user_id)
		{
			return true;
		}
		
		if($params->get('emerald.subscr_skip_moderator', 1) && MECAccess::allowRestricted($user, $section))
		{
			return true;
		}
		include_once ($em_api);
		$user_id = ($method == 'display') ? $user_id: $user->id; 
		if(EmeraldApi::hasSubscription($params->get('emerald.field_' . $method . '_subscription'), $params->get('emerald.field_' . $method . '_subscription_msg'), $params->get('emerald.subscr_iid'), $redirect, $params->get('emerald.field_' . $method . '_subscription_count'), $user_id))
		{
			return true;
		}
		
		return false;
	}

	public static function countLimit($func, $method, $type, $user_id)
	{
		$em_api = JPATH_ROOT . DS . 'components' . DS . 'com_emerald' . DS . 'api.php';
		if(! JFile::exists($em_api))
		{
			return true;
		}
		$user = JFactory::getUser();
		$params = $type->params;		
		if(! $params->get('emerald.' . $func . '_' . $method . '_subscription'))
		{
			return true;
		}
		if(! $params->get('emerald.' . $func . '_' . $method . '_subscription_count'))
		{
			return true;
		}
		include_once ($em_api);
		
		EmeraldApi::addCount($params->get('emerald.' . $func . '_' . $method . '_subscription'), $params->get('emerald.' . $func . '_' . $method . '_subscription_count'), $user_id);
	
	}

	public static function getSubscrList($plans, $Itemid)
	{
		$em_api = JPATH_ROOT . DS . 'components' . DS . 'com_emerald' . DS . 'api.php';
		if(! JFile::exists($em_api))
		{
			return true;
		}
		include_once ($em_api);
		$plans = EmeraldApi::getSubscriptions($plans);
		$list = array();
		foreach($plans as $plan)
		{
			$list[] = '<li>' . JHtml::link(JRoute::_('index.php?option=com_emerald&view=plans&layout=form&id=' . $plan->id . '&Itemid=' . $Itemid), $plan->name) . '</li>';
		}
		return $list;
	}

}

class CensorHelper
{

	private static $params;

	private static $bad_words;

	private static $replacer;

	public static function cleanText($str)
	{
		if(empty($str))
		{
			return $str;
		}
		if(! self::$params)
		{
			self::$params = JComponentHelper::getParams('com_cobalt');
			self::$bad_words = explode(',', self::$params->get('censor_words'));
			ArrayHelper::trim_r(self::$bad_words);
			self::$replacer = JText::_(trim(self::$params->get('censor_replace')));
		}
		if(! self::$params->get('censor'))
		{
			return $str;
		}
		if(is_array($str))
		{
			foreach($str as $key => $value)
			{
				if(is_array($value))
				{
					self::cleanText($value);
				}
				$str[$key] = str_ireplace(self::$bad_words, self::$replacer, $value);
			}
			return $str;
		}
		return str_ireplace(self::$bad_words, self::$replacer, $str);
	}
}