<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();
class JHTMLCategories
{
	public static function labels($cats)
	{
		$db = JFactory::getDbo();
		$sql = "SELECT title FROM #__js_res_categories WHERE id IN(".implode(',', $cats).")";
		$db->setQuery($sql);
		$cats = $db->loadResultArray();
		
		return implode(', ', $cats);
	}
	
	public static function form($section, $default = array(), $params = array())
	{
		$db = JFactory::getDbo();
		
		if (! is_array($default) && ! empty($default))
		{
			$default = explode(',', $default);
		}
		ArrayHelper::trim_r($default);
		JArrayHelper::toInteger($default);
		ArrayHelper::clean_r($default);
		settype($default, 'array');
		$reg = new JRegistry();
		$reg->loadArray($params);
		
		if($default)
		{
			$sql = "SELECT id, title as html, title as plain FROM #__js_res_categories WHERE id IN(".implode(',', $default).")";
			$db->setQuery($sql);
			$default = $db->loadObjectList();
		}
		
		$pattern = '<span class="list-element">%s%s<br /><span class="small">%s</span>%s';

		$cats_model = JModel::getInstance('Categories', 'CobaltModel');
		$cats_model->section = $section;
		$cats_model->parent_id = 1;
		$cats_model->order = 'c.lft ASC';
		$cats_model->levels = 1000;
		$cats_model->all = 1;
		$categories = $cats_model->getItems();
		$list = array();
		foreach ($categories as $i => $cat)
		{
			$img = $descr = NULL;
			$list[$i] =  new stdClass();
			$list[$i]->id = $cat->id;
			$list[$i]->plain = $cat->title;
			$list[$i]->html = $cat->title;
			
			if($reg->get('tmpl_params.cat_img', 1) && $cat->image)
			{
				$img = '<img src="'.JURI::root().$cat->image.'" style="max-width:'.$reg->get('tmpl_params.cat_img_width', 50).'px;" hspace="5" align="absmiddle">';
			}
			
			if($reg->get('tmpl_params.cat_descr', 1) && $cat->description)
			{
				$descr = '<br /><span class="small">'.substr(trim(strip_tags($cat->{'descr_'.$reg->get('tmpl_params.cat_descr', 'before')})), 0, $reg->get('tmpl_params.cat_descr_length', 200)).'</span>';
			}
			$list[$i]->render = sprintf($pattern, $img, $cat->title, $cat->path, $descr); 
		}
		
		$options['coma_separate'] = 0;
		$options['only_values'] = 1;
		$options['min_length'] = 1;
		$options['max_result'] = 10;
		$options['case_sensitive'] = 0;
		$options['unique'] = 1;
		$options['highlight'] = 1;
		$options['max_items'] = 100;
		$options['max_width'] = $reg->get('max_width', 400);
		$options['min_width'] = $reg->get('min_width', 300);
		
		return JHtml::_('mrelements.listautocomplete', 'filters[cats]', "categs", $default, $list, $options);
	}
	
	public static function checkboxes($section, $default = array(), $params = array())
	{
		$db = JFactory::getDbo();
		
		if (! is_array($default) && ! empty($default))
		{
			$default = explode(',', $default);
		}
		ArrayHelper::trim_r($default);
		JArrayHelper::toInteger($default);
		ArrayHelper::clean_r($default);
		settype($default, 'array');
		
		$reg = new JRegistry();
		$reg->loadArray($params);
		$columns = $reg->get('columns', 3);
		$pattern = '<span class="list-element">%s%s<br /><span class="small">%s</span>%s';
		
		$cats_model = JModel::getInstance('Categories', 'CobaltModel');
		$cats_model->section = $section;
		$cats_model->parent_id = 1;
		$cats_model->order = 'c.lft ASC';
		$cats_model->levels = 1000;
		$cats_model->all = 1;
		$categories = $cats_model->getItems();
		$list = array();
		$out = '';
		$j = 0;
		if ($categories)
		{
			$out = '<table class="category_filter_checkboxes"><tr>';
			foreach ($categories as $i => $cat)
			{
				if($j == $columns)
				{
					$j = 0;
					$out .= '</tr><tr>';
				}
				$out .= '<td><input name="filters[cats][]" type="checkbox" value="'.$cat->id.'" '.(in_array($cat->id, $default) ? 'checked="checked"' : '').' />'.$cat->title.'</td>';
				$j++;
			}
			$out .= '</tr></table>';
		}
		
		return $out;
	}
	
	public static function select($section, $default = array(), $params = array())
	{
		$db = JFactory::getDbo();
	
		if (! is_array($default) && ! empty($default))
		{
			$default = explode(',', $default);
		}
		ArrayHelper::trim_r($default);
		JArrayHelper::toInteger($default);
		ArrayHelper::clean_r($default);
		settype($default, 'array');
		$reg = new JRegistry();
		$reg->loadArray($params);
		
		$multiple = $reg->get('multiple', 0);
	
		$cats_model = JModel::getInstance('Categories', 'CobaltModel');
		$cats_model->section = $section;
		$cats_model->parent_id = 1;
		$cats_model->order = 'c.lft ASC';
		$cats_model->levels = 1000;
		$cats_model->all = 1;
		$categories = $cats_model->getItems();
		$out = '';
		$attr = array();
		if($multiple)
		{
			$attr['multiple'] = 'multiple';
			$attr['size'] = $reg->get('size', 8);
		}
		if ($categories)
		{
			$out = JHtml::_('select.genericlist', $categories, 'filters[cats]'.($multiple ? '[]' : ''), $attr, 'id', 'title', $default);
		}
		return $out;
	}
	
	public static function smart($section, $default_ids = array(), $params = array())
	{
		$doc = JFactory::getDocument();
		$doc->addStyleSheet(JURI::root() . 'components/com_cobalt/views/form/tmpl/default_category_smart.css');
		
		$cats_model = JModel::getInstance('Categories', 'CobaltModel');
		$cats_model->section = $section;
		$cats_model->parent_id = 1;
		$cats_model->order = 'c.lft ASC';
		$cats_model->levels = 0;
		$cats_model->all = 0;
		$categories = $cats_model->getItems();
		$reg = new JRegistry();
		$reg->loadArray($params);
		if(!$categories)
		{
			echo JText::_('CSECTIONNOCATEGORIES');
			return;
		}
		
		if(!is_array($default_ids))
			settype($default_ids, 'array');
		$default = $cats_model->getCategoriesById($default_ids);
		ob_start();
		?>
		<style>
		<!--
		.select_list {
			max-width: 400px !important;
			max-height: 300px !important;
		}
		-->
		</style>
		<script type="text/javascript"><!--
		var s_icons = [<?php if($default_ids) echo implode(',', $default_ids); ?>];
		var lastid = 0;
		function addCategory(id, title, path)
		{
			s_icons.push(id);
		
		
			out = '<img class="delete_icon" src="<?php	echo JURI::root();?>media/mint/icons/16/cross-button.png" '+ 
				'onclick="removeCategory(' + id + ')">'+
				'<div>' + title + '</div>'+
				'<span class="small">' + path + '</span>'+
				'<input type="hidden" name="filters[cats][]" value="' + id + '" />';
			
				
				var li = new Element('li', {id: 'cat'+ id, class: 'default_category'});
				li.set('html', out);
				$('categories_list').grab(li, 'bottom');
				$('s_icon' + id).setStyle('display', 'none');
		}
		
		function removeCategory(id)
		{
			s_icons.erase(id);
			var myEffect = new Fx.Morph('cat' + id, {
			    duration: 'short',
			    transition: Fx.Transitions.Sine.easeOut
			});
			myEffect.addEvent('complete', function(){$('cat' + id).dispose();});
			myEffect.start({'height': 0});
		
			try{$('s_icon' + id).setStyle('display', 'block');}catch(e){}
		}
		
		function hideIcons()
		{
			Array.each(s_icons, function(id){
				try 
				{
					$('s_icon' + id).setStyle('display', 'none');	
				}
				catch (e){}	
			});
		}
		
		
		function ajax_categoryChilds(id, level)
		{
			for(i=1; i<10; i++)
			{
				try 
				{
					$('select_list' + (i+level)).dispose();			
				}
				catch (e)
				{}
			}
			var req = new Request.JSON({
				url:'<?php echo JURI::base(); ?>index.php?option=com_cobalt&task=ajax.category_childs&no_html=1',
				method:'post',
				autoCancel:true,
				data:{cat_id: id, level: (level + 1), order: '<?php echo 'c.lft ASC';?>' },
		
				onComplete: function(json) {
					if(json.success)
					{				
						if(json.result != '')
						{
							var myFirstElement  = new Element('li', {id: 'select_list'+ (level+1), 'class': 'select_list'});
							var el_ul = 	new Element('ul', {id: 'level'+ (level+1)});
							Array.each(json.result, function(item, index, object){
								var el_li = new Element('li', {id: 'category-'+ item.id, 'class': 'category_element'});
								var html = '';
								if(item.submission)
								{
									html += '<img class="add_icon" id="s_icon'+item.id+'" src="<?php echo JURI::root();?>media/mint/icons/16/plus-button.png" '
										+ 'onclick="addCategory('+item.id+', \''+item.title+'\', \''+item.path+'\')" />';
								}
								html += '<span';
								html += '>';
								if(item.childs_num > 0)	{
									html +=  '<a href="javascript: void(0);" onclick="ajax_categoryChilds(' + item.id +', '+ (level + 1)+')">'+item.title+'</a>';
								}
								else {
									html +=  item.title;
								}
								html += '</span>';
								el_li.set('html', html);
								el_ul.grab(el_li);
								
							});
							
							myFirstElement.grab( el_ul);
							$("select_list"+ level).grab( myFirstElement , 'after');
						}
						hideIcons();
					}
					else
					{
						alert(json.error);
					}		
				}
		    }).send();
		
			var list = $('level'+level).getChildren();
			Array.each(list, function(item, index, object){
				object.removeClass('selected');
			});
		    $('category-'+id).addClass('selected');
		}
		--></script>
		
		<div style="clear: both;"></div>
		<div class="default_categories">
			<ul class="categories_list"  id="categories_list">
				<?php if ($default): ?>
					<?php	foreach ( $default as $cat ):
					?>
					<li id="cat<?php echo $cat->id?>" class="default_category">
						<img class="delete_icon" src="<?php	echo JURI::root();?>media/mint/icons/16/cross-button.png" 
							onclick="removeCategory(<?php echo $cat->id;?>)">
						<div>
							<?php echo $cat->title;?>
						</div>
						<span class="small">(<?php	echo $cat->path;?>)</span>
						<input type="hidden" name="filters[cats][]" value="<?php echo $cat->id;?>" />
					</li>
					<?php endforeach;?>
				<?php endif; ?>
			</ul>	
		</div>
		
		<div id="category_select">
			<ul class="categories_list">
				<li class="select_list" id="select_list1">
					<ul id="level1">
						<?php foreach ( $categories as $cat ): ?>
							<li id="category-<?php echo $cat->id; ?>" class="category_element">
								<img class="add_icon" id="s_icon<?php echo $cat->id;?>" src="<?php echo JURI::root();?>media/mint/icons/16/plus-button.png"
									onclick="addCategory(<?php echo $cat->id;?>, '<?php echo $cat->title;?>', '<?php echo $cat->path;?>')">
								<span>
								<?php if($cat->childs_num):?>
									<a href="javascript: void(0);" onclick="ajax_categoryChilds(<?php echo $cat->id?>, 1)"><?php echo $cat->title ?></a>
								<?php else :?>
									<?php echo $cat->title ?>
								<?php endif;?>
								</span>
							</li>
						<?php endforeach;?>
					</ul>
				</li>
			</ul>
			<div style="clear: both;"></div>
				<p><span class="small"><?php echo JText::sprintf('CCLICKNAVSUBCAT', 
					JHtml::image(JURI::root().'media/mint/icons/16/plus-button.png', JText::_('CADDCAT'), array('align'=>'absmiddle', 'width' => 12)),
					JHtml::image(JURI::root().'media/mint/icons/16/cross-button.png', JText::_('CDELLCAT'), array('align'=>'absmiddle', 'width' => 12)));?></span></p>
		</div>
		<div style="clear: both;"></div>
		<script type="text/javascript">
		<!--
		hideIcons();
		//-->
		</script>
		<?php 
		$content = ob_get_clean();
		
		return $content;
	}
	
	
	
}