<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();
class JHTMLTags
{
	public static function name($id)
	{
		$db = JFactory::getDBO();
		settype($id, 'int');

		$query = $db->getQuery(true);
		$query->select('tag');
		$query->from('#__js_res_tags');
		$query->where("id = {$id}");

		$db->setQuery($query);
		return $db->loadResult();
	}

	public static function tagcheckboxes($section, $default = array())
	{
		$db = JFactory::getDbo();

		$query = $db->getQuery(true);
		$query->select('tag, id');
		$query->from('#__js_res_tags');
		$query->where("id IN(SELECT tag_id FROM #__js_res_tags_history WHERE section_id = {$section->id})");
		$query->order('tag');
		$db->setQuery($query);
		$list = $db->loadObjectList();

		if(!$list) return;

		foreach ($list AS $tag)
		{
			$chekced = (in_array($tag->id, $default) ? ' checked="checked"' : NULL);
			$li[] = sprintf('<li><input type="checkbox" id="ctag-%d" class="inputbox" name="filters[tags][]" value="%d"%s /> <label for="ctag-%d">%s</label></li>', $tag->id, $tag->id, $chekced, $tag->id, $tag->tag);
		}

		return '<ul class="fliter-list">'.implode(' ', $li).'</ul>';
	}

	public static function tagselect($section, $default = array())
	{
		$db = JFactory::getDbo();

		$query = $db->getQuery(true);
		$query->select('tag as text, id as value');
		$query->from('#__js_res_tags');
		$query->where("id IN(SELECT tag_id FROM #__js_res_tags_history WHERE section_id = {$section->id})");
		$query->order('tag');
		$db->setQuery($query);
		$list = $db->loadObjectList();

		if(!$list) return;
		array_unshift($list, JHtml::_('select.option', '', '- '.JText::_('CSELECTTAG').' -'));


		return JHtml::_('select.genericlist', $list, 'filters[tags][]', null, 'value', 'text', $default);
	}

	public static function tagform($section, $default = array(), $params = array())
	{
		$db = JFactory::getDbo();

		if (! is_array($default) && ! empty($default))
		{
			$default = explode(',', $default);
		}
		ArrayHelper::trim_r($default);
		JArrayHelper::toInteger($default);
		ArrayHelper::clean_r($default);
		settype($default, 'array');

		$query = $db->getQuery(true);
		$query->select('tag as plain, tag as html, tag as render, id');
		$query->from('#__js_res_tags');
		$query->where("id IN(SELECT tag_id FROM #__js_res_tags_history WHERE section_id = {$section->id})");
		$query->order('tag');

		$db->setQuery($query);
		$list = $db->loadObjectList();

		$in = array();
		if($default)
		{
			foreach ($list AS $tag)
			{
				if(in_array($tag->id, $default))
				{
					$in[] = $tag;
				}
			}
		}

		$reg = new JRegistry();
		$reg->loadArray($params);

		$options['coma_separate'] = 0;
		$options['only_values'] = 1;
		$options['min_length'] = 1;
		$options['max_result'] = 10;
		$options['case_sensitive'] = 0;
		$options['unique'] = 1;
		$options['highlight'] = 1;
		$options['max_items'] = 100;

		$options['max_width'] = $reg->get('max_width', 400);
		$options['min_width'] = $reg->get('min_width', 300);

		return JHtml::_('mrelements.listautocomplete', 'filters[tags]', "tags", $in, $list, $options);
	}

	public static function tagcloud($section, $html_tags, $relevance)
	{
		$db = JFactory::getDbo();

		$query = $db->getQuery(true);
		$query->select('tag, id');
		$query->from('#__js_res_tags');
		$query->where("id IN(SELECT tag_id FROM #__js_res_tags_history WHERE section_id = {$section->id})");
		$query->order('tag');

		$db->setQuery($query);
		$list = $db->loadObjectList();

		if(!$list) return;

		$out = array();
		$html = explode(",", $html_tags);
		$total_tags = count($html) - 1;
		$step = ceil(count($list) / count($html));
		$html_id = $i = 0;
		$prev_randx = 1;

		foreach ( $list as $id => &$tag )
		{
			$url = FilterHelper::url('task=records.filter&filter_name[0]=filter_tag&filter_val[0]='.$tag->id, $section);
			$tag->tag = JHtml::link(JRoute::_($url), $tag->tag);
			if ($relevance)
			{
				if ($relevance == 3)
				{
					$randx = rand(0, $total_tags);
					if ($randx == $prev_randx || ! $randx)
					{
						if ($prev_randx >= $total_tags)
							$randx = $prev_randx - 2;
						else
							$randx = $prev_randx + 1;
					}
					$t = $html[$randx];
					$prev_randx = $randx;
				}
				else
				{
					if ($i == $step)
					{
						$i = 0;
						$html_id ++;
					}
					$t = $html[$html_id];
				}
				$tag->tag = sprintf('<%s class="tag">%s</%s>', trim($t), $tag->tag, trim($t));
				$i ++;
			}
			$out[] = '<li class="tag_element" id="tag-' . $tag->id . '">' .$tag->tag. '</li>';
		}
		if(!$out) return ;

		return '<ul id="tag-list-filters" class="tag_list">'.implode(' ', $out).'</ul>';

	}
	public static function fetch($list, $record_id, $section_id, $cat_id, $html_tags, $relevance, $show_nums, $max_tags, $remove)
	{
		$out = array();
		if ($remove)
		{
			$document = JFactory::getDocument();
			$script = "
			function ajax_remove_tag(rid, tid)
			{
				if(!confirm('" . JText::_("CSURE") . "')) return;
				$('tag-img-'+tid).set('src', '" . JURI::root() . "components/com_cobalt/images/load.gif');

				var req = new Request.JSON({
					url:'" . JURI::base() . "index.php?option=com_cobalt&task=ajax.remove_tag&no_html=1',
					method:'post',
					autoCancel:true,
					data:{rid: rid, tid: tid },

					onComplete: function(json) {
						if(json.success)
						{
							$('tag-'+tid).destroy();
							if($$('li.tag_element').length < ".$max_tags.")
							{
								$('add-tags-block'+rid).toggleClass('add_tags_hidden');
								$('add-tags-block'+rid).addClass('add_tags_visible');
							}
						}
						else
						{
							alert(json.error);
						}
					}
			    }).send();

			}
			";
			$document->addScriptDeclaration($script);
			$document->addStyleDeclaration('.tag {display: inline;} ');
		}
		$nums = null;
		if(!count($list))
		{
			return NULL;
		}

		if ($show_nums || $relevance)
		{
			switch ($relevance)
			{
				case '1' :
					$order = 'hits DESC';
					break;
				case '2' :
					$order = 'r_usage DESC';
					break;
				default :
					$order = null;
			}

			$db = JFactory::getDBO();
			$query = $db->getQuery(true);
			$query->select('t.tag, t.id');
			$query->select('(SELECT COUNT(*) FROM #__js_res_tags_history WHERE tag_id = t.id) as r_usage');
			$query->select('(SELECT SUM(hits) FROM #__js_res_tags_history WHERE tag_id = t.id) as hits');
			$query->from('#__js_res_tags AS t');
			$query->where('t.id IN (' . implode(', ', array_keys($list)) . ')');
			/*
			echo $query; exit;
			$query->select('t.tag, h.tag_id as id, COUNT(h.record_id) as r_usage, SUM(h.hits) as hits');
			$query->from('#__js_res_tags_history AS H');
			$query->leftJoin('#__js_res_tags as t ON t.id = h.tag_id');
			$query->group('t.id');
			*/
			if ($order)
				$query->order($order);
			$db->setQuery($query);
			$res = $db->loadObjectList();

			if ($order)
				$list = array();

			foreach ( $res as $val )
			{
				if ($order)
					$list[$val->id] = $val->tag;
				switch ($show_nums)
				{
					case '1' :
						$nums[$val->id] = 'class="hasTip" title="' . $list[$val->id] . '::' . JText::_('CTAGHITS') . ': ' . $val->hits . '"';
						break;
					case '2' :
						$nums[$val->id] = 'class="hasTip" title="' . $list[$val->id] . '::' . JText::_('CTAGUSAGE') . ': ' . $val->r_usage . '"';
						break;
					case '3' :
						$nums[$val->id] = 'class="hasTip" title="'.$list[$val->id].'::'.JText::_('CTAGHITS').': '.$val->hits.', '.JText::_('CTAGUSAGE').': '.$val->r_usage.'"';
						break;
				}
			}
			if ($relevance)
			{
				$html = explode(",", $html_tags);
				$total_tags = count($html) - 1;
				$step = ceil(count($list) / count($html));
				$html_id = $i = 0;
				$prev_randx = 1;
				foreach ( $list as $id => $tag )
				{
					if ($relevance == 3)
					{
						$randx = rand(0, $total_tags);
						if ($randx == $prev_randx || ! $randx)
						{
							if ($prev_randx >= $total_tags)
								$randx = $prev_randx - 2;
							else
								$randx = $prev_randx + 1;
						}
						$t = $html[$randx];
						$prev_randx = $randx;
					}
					else
					{
						if ($i == $step)
						{
							$i = 0;
							$html_id ++;
						}
						$t = $html[$html_id];
					}
					$list[$id] = sprintf('<%s class="tag">%s</%s>', trim($t), $tag, trim($t));
					$i ++;
				}
			}
			

		}

		if (!count($list))
		{
			return NULL;
		}

		$indexes = array();
		$i = 0;
		$ids = array_keys($list);
		while ($i < count($ids))
		{
			$randx = rand(0, (count($list) - 1));
			if(!array_key_exists($randx, $indexes))
			{
				$indexes[$randx] = $ids[$randx];
				$i++;
			}
		}
		$link = 'index.php?option=com_cobalt&task=records.filter&section_id='.$section_id.($cat_id ? '&cat_id='.$cat_id : '')
		.'&filter_name[0]=filter_tag';
		foreach ( $indexes as $i => $id)// => &$tag )
		{
			$tag = $list[$id];
			$tag =  JHtml::link(JRoute::_($link.'&filter_val[0]='.$id), $tag, ($nums ? $nums[$id] : NULL));
			if ($remove)
			{
				$tag .= JHtml::image(JURI::root() . 'media/mint/icons/16/cross-small.png', JText::_('CTAGREMOVE'), array('class' => 'tag_remove', 'id' => 'tag-img-' . $id, 'onclick' => 'ajax_remove_tag(' . $record_id . ', ' . $id . ')'));
			}
			$out[] = '<li class="tag_element" id="tag-' . $id . '">' .$tag. '</li>';
		}
		return implode(' ', $out);
	}

	public static function add_button($record_id, $remove, $max_tags)
	{
		$record = JModel::getInstance('Record', 'CobaltModel');
		$record = $record->getItem($record_id);
		$rtags = json_decode($record->tags, 1);
		$document = JFactory::getDocument();
		$script = "
			var record_tags = [" . ($rtags ? implode(',', array_keys($rtags)) : '') . "];
			var max_tags = ".$max_tags.";

			function open_tag_form(rid)
			{
				var count = $$('li.tag_element').length;

				var input = $('add-tags-'+rid);
				if(input.hasClass('add_tags_hidden'))
				{
					input.toggleClass('add_tags_hidden');
					input.addClass('add_tags_visible');
					return;
				}
				if(input.value == '')
				{
					alert('" . JText::_('CTAGSEPARATEBYCOMA') . "');
					return;
				}

				var req = new Request.JSON({
					url:'" . JURI::base() . "index.php?option=com_cobalt&task=ajax.add_tags&no_html=1',
					method:'post',
					autoCancel:true,
					data:{rid: rid, tags: input.value, max: max_tags},

					onComplete: function(json) {
						if(json.success)
						{
							Array.each(json.result, function(item, index, object){

								if(!record_tags.contains(item.id.toInt()) && count < max_tags)
								{
									var el_li = new Element('li', {id: 'tag-'+ item.id, 'class': 'tag_element'});
									var html = '<a href=\"".JRoute::_('index.php?option=com_cobalt&task=records.filter&filter_name[0]=filter_tag&filter_val[0]=')."' + item.id.toInt() + '\">' + item.tag + '</a>';
									" . ($remove ? "html += '<img src=\"" . JURI::root() . "media/mint/icons/16/cross-small-circle.png\" class=\"tag_remove\" '+
										'id=\"tag-img-' + item.id +'\" onclick=\"ajax_remove_tag(" . $record_id . ", '+item.id + ')\">'; " : '') . "
									el_li.set('html', html);
									$('tag-list-" . $record_id . "').grab(el_li, 'bottom');
									count ++;
								}
							});
							input.value = '';
							input.toggleClass('add_tags_visible');
							input.addClass('add_tags_hidden');

							if(count >= max_tags)
							{
								$('add-tags-block'+rid).toggleClass('add_tags_visible');
								$('add-tags-block'+rid).addClass('add_tags_hidden');
							}
						}
						else
						{
							alert(json.error);
						}
					}
			    }).send();
			}
			";
		$document->addScriptDeclaration($script);
		return '
		<input type="text" name="tags' . $record_id . '" value="" id="add-tags-' . $record_id . '"
			class="inputbox hasTip add_tags_hidden" title="' . JText::_('CTAGS') . '::' . JText::_('CTAGSEPARATEBYCOMA') . '"/>
		<button type="button" class="button" onclick="open_tag_form(' . $record_id . ');">
			<img src="' . JURI::root() . 'media/mint/icons/16/price-tag--plus.png" align="absmiddle"> Add tags</button>';
	}
}