<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

jimport('joomla.application.component.modeladmin');

class CobaltModelElements extends JModelAdmin
{

	public function getForm($data = array(), $loadData = true)
	{
		$form = $this->loadForm('com_cobalt.options', 'options', array('control' => 'jform', 'load_data' => $loadData));
		if(empty($form))
		{
			return false;
		}
		return $form;
	}
	
	protected function loadFormData()
	{
		$data = JFactory::getApplication()->getUserState('com_cobalt.edit.options.data', array());
		
		if(empty($data))
		{
			$data = $this->getOptions();
		}
		
		return $data;
	}
	
	public function getOptions()
	{
		static $out = null;
		
		if($out) return $out;
		
		$me = JFactory::getUser();
		
		$table = JTable::getInstance('Subscription_params', 'CobaltTable');
		$table->load(array('user_id' => $me->get('id'), 'section_id' => JRequest::getInt('section_id')));
		
		$out = json_decode($table->params);
		
		return $out;
	}
}