<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die;

jimport('joomla.application.component.modellist');

class CobaltModelFields extends JModelList
{
	public function populateState($ordering = null, $direction = null)
	{
		parent::populateState($ordering = null, $direction = null);
	}
	public function getListQuery()
	{

		$typeId = $this->getState('fields.type_id', JRequest::getInt('type_id'));

		if(!$typeId)
		{
			$this->setError('Fields: Type not set');
			return FALSE;
		}

		$this->setState('list.start', 0);
		$this->setState('list.limit', 1000);
		$db = $this->getDbo();

		$ord  = $db->getQuery(true);
		$ord->select('ordering');
		$ord->from('#__js_res_fields_group');
		$ord->where('id = f.group_id');

		$tlt  = $db->getQuery(true);
		$tlt->select('title');
		$tlt->from('#__js_res_fields_group');
		$tlt->where('id = f.group_id');
		
		$dsc  = $db->getQuery(true);
		$dsc->select('description');
		$dsc->from('#__js_res_fields_group');
		$dsc->where('id = f.group_id');

		$query = $db->getQuery(true);
		$query->select('f.*');
		$query->select('('.$ord.') AS gordering');
		$query->select('('.$tlt.') AS group_title');
		$query->select('('.$dsc.') AS group_descr');
		$query->from('#__js_res_fields AS f');

		//$query->select('g.title AS group_title');
		//$query->join('LEFT', '#__js_res_fields_group AS g ON g.id = f.group_id');

		$query->where('f.type_id = '.$typeId);
		$query->where('f.published = 1');

		/*
		//if($skips = JFactory::getApplication()->getUserState('com_cobalt.fields.skipers'))
		{
			//$query->where('f.id NOT IN ('.implode(',', $skips).')');
		}
		if(JRequest::getVar('skipfield'))
		{
			//$query->where("f.field_type != '".JRequest::getVar('skipfield')."'");
		}
		*/

		$query->order('gordering ASC');
		$query->order('f.ordering ASC');

// 		echo $query;
		return $query;
	}

	public function getFieldTypeId($id)
	{
		static $cache = array();

		if(isset($cache[$id]))
		{
			return $cache[$id];
		}

		$this->_db->setQuery("SELECT type_id FROM #__js_res_fields WHERE id = {$id}");
		$cache[$id] = $this->_db->loadResult();

		return $cache[$id];
	}
	public function getTotal()
	{
		return 100000;
	}
	public function getStoreId($id = NULL)
	{
		/*if(!$id)
		{
			$id	.= ':'.implode(',', JFactory::getApplication()->getUserStateFromRequest('com_cobalt.fields.skipers', 'skip_fields', '', 'array'));
		}*/

		$id .= ':'.$this->getState('fields.type_id');
		$id	.= ':'.$this->getState('list.start');
		$id	.= ':'.$this->getState('list.ordering');
		$id	.= ':'.$this->getState('list.direction');
		if(JRequest::getVar('skipfield'))
		{
			$id	.= ':'.JRequest::getVar('skipfield');
		}


		return md5($this->context.':'.$id);
	}

	// TODO as getRecordFields
	public function getFormFields($typeId = null, $itemId = NULL, $cache = TRUE)
	{

		static $fields = array();


		if(isset($fields[$typeId][$itemId]) && ($cache == TRUE)){
			return $fields[$typeId][$itemId];
		}

		$this->setState('fields.type_id', $typeId);
		$items = $this->getItems();

		$f = $fields = array();

		if($itemId)
		{
			$db = JFactory::getDbo();
			$db->setQuery("SELECT fields FROM `#__js_res_record` WHERE id = $itemId");
			$fields = json_decode($db->loadResult(), true);
		}
		
		$data = JFactory::getApplication()->getUserState('com_cobalt.edit.form.data', array());

		if(!empty($items))
		{
			foreach ($items as $key => $item)
			{
				$file = JPATH_ROOT.DS.'components/com_cobalt/fields/'.$item->field_type.'/'.$item->field_type.'.php';
				if(!JFile::exists($file))
				{
					JError::raiseWarning(404, JText::_("CFIELDNOTFOUND", $item->field_type));
					continue;
				}
				require_once $file;
				
				if(isset($data['fields'][$item->id]))
				{
					$default = $data['fields'][$item->id];
				}
				else
				{
					$default = @$fields[$item->id];
				}

				$name = 'JFormFieldC'.ucfirst($item->field_type);
				$f[$item->id] = new $name($item, $default);
				$f[$item->id]->isnew = ($itemId == null);
			}
		}
		if($cache == TRUE)
		{
			@$fields[$typeId][$itemId] = $f;
		}

		return $f;
	}

	public function getRecordFields($item, $client='full', $cache = TRUE)
	{
		static $fields = array(), $params = array();

		$storeid = $this->getStoreId($item->id);

		if(isset($fields[$storeid]) && ($cache == TRUE)){
			return $fields[$storeid];
		}

		$fields[$storeid] = array();

		$form_model = JModel::getInstance('Form', 'CobaltModel');

		$record_fields = json_decode($item->fields, true);

		$this->setState('fields.type_id', $item->type_id);
		$items = $this->getItems();

		foreach ($items as $key => $field)
		{
			if(!isset($params[$field->id]))
			{
				$params[$field->id] = new JRegistry($field->params);
			}
			if($client == 'feed' && !$params[$field->id]->get('core.show_feed', 0)) continue;
			if($client == 'full' && !$params[$field->id]->get('core.show_full', 0)) continue;
			if($client == 'list' && !$params[$field->id]->get('core.show_intro', 0)) continue;

			require_once JPATH_ROOT.DS.'components/com_cobalt/fields/'.$field->field_type.'/'.$field->field_type.'.php';

			$name = 'JFormFieldC'.ucfirst($field->field_type);
			$fields[$storeid][$field->id] = new $name($field, @$record_fields[$field->id]);
		}

		return $fields[$storeid];
	}

	public function getField($field_id, $type_id, $record_id = NULL)
	{
		$fields = $this->getFormFields($type_id, $record_id);
		return $fields[$field_id];
	}

}
