<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

jimport('joomla.application.component.modeladmin');

class CobaltModelModerator extends JModelAdmin
{
	
	function getTable($name = 'Moderators', $prefix = 'CobaltTable', $options = array())
	{
		return JTable::getInstance($name, $prefix, $options);
	
	}
	
	public function getForm($data = array(), $loadData = true)
	{
	    $app = JFactory::getApplication();
		
		$form = $this->loadForm('com_cobalt.moderator', 'moderator', array('control' => 'jform', 'load_data' => $loadData));
		if(empty($form))
		{
			return false;
		}
		return $form;
	}
	
	public function loadFormData()
	{
	    $data = JFactory::getApplication()->getUserState('com_cobalt.edit.moderator.data', array());
		if(empty($data))
		{
			$data = $this->getItem();
		}
		
		return $data;
	}
	
    protected function populateState($ordering = null, $direction = null)
	{
		// Load state from the request.
		$pk = JRequest::getInt('id');
		JFactory::getApplication()->setUserState('com_cobalt.edit.moderator.id',  $pk);
		$this->setState('com_cobalt.edit.moderator.id', $pk);
	}
	
	public function getItem($id = NULL)
	{
		$id = JRequest::getInt('id', false);
		$row = null;
		if( $id )
		{
    		$row = parent::getItem($id);
		}
		
		if( !$row  )
		{
			$row = $this->getTable();
			$row->load( array('user_id' => JRequest::getInt('user_id'), 'section_id' =>  JRequest::getInt('section_id')) );
			if($row->id)
			{
				$registry = new JRegistry;
				$registry->loadString($row->params);
				$row->params = $registry->toArray();
			}
		}
		if( !$row->id  )
		{
			$row = new stdClass();
			$row->id = null;
			$row->user = JFactory::getUser(JRequest::getInt('user_id'));
			$row->user_id = $row->user->get('id');
			$row->section_id = JRequest::getInt('section_id');
		}
		else
		{
			$row->user = JFactory::getUser($row->user_id);
		}
		
		if(!$id)
		{
			JRequest::setVar('id', $row->id);
			$this->populateState($ordering = null, $direction = null);
		}
		return $row;
	}
	
	public function save($data)
	{
		$data['is_moderator'] = (int)$data['params']['allow_moderators'];
		if(!$data['params'])
			$data['params'] = '';
		return parent::save($data);
	}
}