<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

jimport('joomla.application.component.modeladmin');

class CobaltModelNotification extends JModelAdmin
{

	const TYPE_NEWCOMMENT = 1;
	
	public function getTable($type = 'Notification', $prefix = 'CobaltTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}

	public function getForm($data = array(), $loadData = true)
	{
		return FALSE;
	}

	public function getItem($pk = null)
	{
		return $item;
	}
	
	protected function canDelete($record)
	{
		$user = JFactory::getUser();

		return $user->authorise('core.delete', 'com_cobalt.comment.'.(int) $record->id);
	}
	
	protected function canEditState($record)
	{
		$user = JFactory::getUser();

		return $user->authorise('core.edit.state', 'com_cobalt.comment.'.(int) $record->id);
	}
	
	public function getSections()
	{
		$user = JFactory::getUser();
		$db = $this->getDbo();
		$query = $db->getQuery(true);		
		$query->select('DISTINCT(ref_2)');
		$query->from('#__js_res_notifications');
		$query->where('user_id = ' . $user->id);
		$db->setQuery($query);
		return $db->loadColumn();		
	}
	
	
	
	public function notify($type, $event, $record_id = 0, $section_id = 0, $cat_id = 0, $comment_id = 0, $field_id = 0, $params, $section, $who)
	{
		$table = $this->getTable();
		$user = JFactory::getUser();
		
		$db = $this->_db;
		
		$query = $db->getQuery(true);
		$query->select('*');
		$query->from('#__js_res_subscriptions');
		$query->where('`type` = '.$db->quote('record'));
		$query->where('`user_id` != '.$user->get('id'));
		if($type == 'record')
		{
			$query->where('`record_id` = '.$record_id);
		}		
		if($type == 'category')
		{
			$query->where('(section_id = '.$section_id.' AND category_id = 0) OR (section_id = '.$section_id.' AND category_id = '.$cat_id.')');
		}
		$query->group('user_id');
		$db->setQuery($query);
		$list = $db->loadObjectList();
		if(!$list)
		{
			return;
		}
		
		$record = JModel::getInstance('Record', 'CobaltModel');
		$item = $record->getItem($record_id);
		
		$params['record'] = $item;
		
		if(is_array($params) || is_object($params))
		{
			$params = json_encode($params);
		}
		
		foreach ($list as $subscription)
		{
			if(!in_array($who, JFactory::getUser($subscription->user_id)->getAuthorisedViewLevels()))
			{
				continue;
			}
			// TODO: check user overwrite settings.
			
			$array = array('id' => NULL, 
				'type' => $event, 
				'user_id' => $subscription->user_id, 
				'params' => $params, 
				'option' => 'com_cobalt',
				'ref_1' => $record_id,
				'ref_2' => $section_id,
				'ref_3' => $cat_id,
				'ref_4' => $comment_id,
				'ref_5' => $field_id
			);
			
			
			$table->reset();
			$table->save($array);
		}
	}
	
}