<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

jimport('joomla.application.component.modellist');

class CobaltModelnotifications extends JModelList
{

	protected function populateState($ordering = null, $direction = null)
	{
		$app = JFactory::getApplication();
	
		$section = $app->getUserStateFromRequest($this->context.'.notifications.section_id', 'section_id', JRequest::getInt('section_id'), 'int');
		$this->setState('notifications.section_id', $section);	
		$show_new = $app->getUserStateFromRequest($this->context.'.notifications.show_new', 'show_new', JRequest::getInt('show_new'), 'int');
		$this->setState('notifications.show_new', $show_new);			

		parent::populateState('m.ctime', 'desc');
	}

	public function getTable($type = 'Notification', $prefix = 'CobaltTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}

	public function getListQuery()
	{
		$user = JFactory::getUser();
		$db = $this->getDbo();
		$query = $db->getQuery(true);
		$section_id = $this->state->get('notifications.section_id');
		$show_new = $this->state->get('notifications.show_new');
		
		$query->select('*, TO_DAYS(CURRENT_DATE) - TO_DAYS(ctime) as days');
		$query->from('#__js_res_notifications');
		
		$query->where('user_id = ' . $user->id);
		if($show_new)
			$query->where('notified = 0' );
		if($section_id)
		{
			$query->where('ref_2 = '.$section_id);
		}
		$query->order('ctime DESC');
		

		return $query;
	}
	
}