<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die;

jimport('joomla.application.component.modellist');

class CobaltModelProducts extends JModelList
{
    public $worns = array();
    
	public function getListQuery()
	{
		$user = JFactory::getUser();
		
		$db = $this->getDbo();
		$db->setQuery('SELECT * FROM #__js_res_types WHERE published = 1');
		$all_types = $db->loadObjectList('id');
		if(!$all_types)
		{
			JError::raiseWarning(404, JText::_('You have no types'));
			return false;
		}
		
		$orders_model = JModel::getInstance('Orders', 'CobaltModel');
		$su = $orders_model->isSuperUser($user->get('id'));
		if(!$su)
		{
			foreach ($all_types as $key => $type)
			{
				$type->params = new JRegistry($type->params);
				if(!in_array($type->params->get('submission.submission'), $user->getAuthorisedViewLevels()))
				{
					unset($all_types[$key]);			
				}
			}
		}
		$types_id = array_keys($all_types);
		
		$db->setQuery('SELECT type_id FROM #__js_res_fields WHERE published = 1 AND field_type LIKE "pay%" AND type_id IN('.implode(',', $types_id).')');
		$types = $db->loadResultArray();
		
		foreach ($all_types AS $key => $type)
		{
			if(!in_array($key, $types))
			{
				unset($all_types[$key]);
			}
		}
		
		$this->types = $all_types;
		
		if(empty($types))
		{
			JError::raiseWarning(404, JText::_('You have no types'));
			return false;
		}
		
		$query = $db->getQuery(true);
		
		$query->select('r.*');
		$query->from('#__js_res_record AS r');
		$query->where('r.published = 1');
		$query->where('r.type_id IN ('.implode(',', $types).')');
		if(!$su)
		{
			$query->where('r.user_id = '.$user->get('id'));
		}

		$search = $this->getState ( 'filter.search', 0 );
		if ($search) {
			$this->worns['search'] = WornHelper::getItem('filter_search', JText::_('CSEARCHTEXT'), $search);
			$search = $db->Quote ( '%' . $db->getEscaped ( $search, true ) . '%' );
			$query->where ( '(r.title LIKE ' . $search . ')' );
		}
		
		$filter_type = $this->getState ( 'filter.type', 0 );
		if ($filter_type) {
			$this->worns['type'] = WornHelper::getItem('filter_type', JText::_('CTYPE'), $all_types[$filter_type]->name);
			$query->where ('r.type_id = ' . $filter_type);
		}
		
		$orderCol = $this->state->get('list.ordering');
		$orderDirn = $this->state->get('list.direction');
		$query->order($db->getEscaped($orderCol . ' ' . $orderDirn));

		return $query;
	}
	
	public function getTable($name = '', $prefix = 'Table', $options = array()){
		return JTable::getInstance('Sales', 'CobaltTable');
	}
	
	public function getStoreId($id = NULL)
	{
		$id	.= ':'.$this->getState('list.start');
		$id	.= ':'.$this->getState('list.limit');
		$id	.= ':'.$this->getState('list.ordering');
		$id	.= ':'.$this->getState('list.direction');

		return md5($this->context.':'.$id);
	}
	
    protected function populateState($ordering = null, $direction = null)
	{
		$app = JFactory::getApplication();
		
		$search = $app->getUserStateFromRequest ( $this->context . '.filter.search', 'filter_search' );
		$this->setState ( 'filter.search', $search );
		$type = $app->getUserStateFromRequest ( $this->context . '.filter.type', 'filter_type' );
		$this->setState ( 'filter.type', $type );
		
		parent::populateState('ctime', 'desc');
	}
	
	public function getWorns()
	{
		return $this->worns;
	}
}
