<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

jimport('joomla.application.component.modellist');

class CobaltModelRecords extends JModelList
{

	public $worns = array();

	public $total = 0;

	public $section = NULL;

	private $_showRecords = TRUE;

	public $_filtersWhere = TRUE;

	public $_navigation = TRUE;

	public function __construct($config = array())
	{
		parent::__construct($config);
	}

	public function populateState($ordering = null, $direction = null)
	{
		$app = JFactory::getApplication('administrator');
		$filter = JFilterInput::getInstance();
		$key = FilterHelper::key();

		$section_id = $app->getUserStateFromRequest($this->context . $key . '.filter.section_id', 'section_id', '', 'int');
		$this->setState('records.section_id', $section_id);

		$search = $app->getUserStateFromRequest('com_cobalt.section' . $key . '.filter_search', 'filter_search', '', 'string');
		$this->setState('records.search', trim($search));

		$archive = $app->getUserStateFromRequest('com_cobalt.section' . $key . '.filter_archive', 'filter_archive', '', 'int');
		$this->setState('records.archive', $archive);

		$alpha = $app->getUserStateFromRequest('com_cobalt.section' . $key . '.filter_alpha', 'filter_alpha', '', 'string');
		$this->setState('records.alpha', $alpha);

		$type = $app->getUserStateFromRequest('com_cobalt.section' . $key . '.filter_type', 'filter_type', '', 'array');
		if(isset($type[0]) && strpos($type[0], ','))
		{
			$type = explode(',', $type[0]);
		}
		ArrayHelper::clean_r($type);
		JArrayHelper::toInteger($type);
		$this->setState('records.type', $type);

		$user = $app->getUserStateFromRequest('com_cobalt.section' . $key . '.filter_user', 'filter_user', '', 'array');
		ArrayHelper::clean_r($user);
		JArrayHelper::toInteger($user);
		$this->setState('records.user', $user);

		$tag = $app->getUserStateFromRequest('com_cobalt.section' . $key . '.filter_tag', 'filter_tag', '', 'array');
		ArrayHelper::clean_r($tag);
		JArrayHelper::toInteger($tag);
		$this->setState('records.tag', $tag);

		$cat = $app->getUserStateFromRequest('com_cobalt.section' . $key . '.filter_cat', 'filter_cat', '', 'array');
		settype($cat, 'array');
		ArrayHelper::clean_r($cat);
		JArrayHelper::toInteger($cat);
		$this->setState('records.category', $cat);

		$config['filter_fields'] = array(
			'r.ctime',
			'r.mtime',
			'r.title',
			'name',
			'username',
			'r.hits',
			'r.comments',
			'r.favorite_num',
			'r.votes_result',
			'field_value'
		);
		if($search)
		{
			$config['filter_fields'][] = 'searchresult';
		}


		$order = JRequest::getVar('filter_order');
		if(substr($order, 0, 6) == 'field^')
		{
			$ordervals = explode('^', $order);
			if(count($ordervals) == 3)
			{
				$config['filter_fields'][] = $order;
				$app->setUserState($this->context . '.ordering.vals' . $section_id, $ordervals);
			}
		}
		elseif($order)
		{
			$app->setUserState($this->context . '.ordering.vals' . $section_id, NULL);
		}
		if(is_array($app->getUserState($this->context . '.ordering.vals' . $section_id)))
		{
			if(count($app->getUserState($this->context . '.ordering.vals' . $section_id)) == 3)
			{
				$config['filter_fields'][] = implode('^', $app->getUserState($this->context . '.ordering.vals' . $section_id));
			}
		}

		$this->setProperties($config);

		$context = $this->context;
		$this->context .= JRequest::getInt('section_id');
		JRequest::setVar('limitstart', JRequest::getInt('limitstart', 0));
		$orders = explode(' ', $this->section->params->get('general.orderby'));
		parent::populateState($orders[0], @$orders[1]);

		$this->context = $context;
	}

	protected function getStoreId($id = '')
	{
		$id .= ':' . $this->getState('record.section_id');
		$id .= ':' . $this->getState('list.start');
		$id .= ':' . $this->getState('list.limit');
		$id .= ':' . $this->getState('list.ordering');
		$id .= ':' . $this->getState('list.direction');
		$id .= ':' . $this->getState('records.section_id');
		$id .= ':' . $this->getState('records.search');
		$id .= ':' . $this->getState('records.alpha');
		$id .= ':' . implode(',', (array)$this->getState('records.type'));
		$id .= ':' . implode(',', (array)$this->getState('records.user'));
		$id .= ':' . implode(',', (array)$this->getState('records.tag'));
		$id .= ':' . implode(',', (array)$this->getState('records.category'));

		return parent::getStoreId($id);
	}

	public function getListQuery()
	{
		$db = $this->getDbo();
		$user = JFactory::getUser();
		$total = $this->total;
		$view_what = JRequest::getVar('view_what');

		$section = $this->section;
		$query = $db->getQuery(true);

		$query->from('#__js_res_record AS r');


		if(!$total)
		{
			$query->select('r.*');

			if($user->get('id'))
			{
				if($section->params->get('events.subscribe_record'))
				{
					$query->select('(SELECT id FROM #__js_res_subscriptions WHERE record_id = r.id AND user_id = ' . $user->get('id') . ' LIMIT 1) as subscribed');
				}
				$query->select('(SELECT id FROM #__js_res_favorite WHERE record_id = r.id AND user_id = ' . $user->get('id') . ' LIMIT 1) as bookmarked');
			}

			if($section->params->get('general.marknew'))
			{
				if($user->get('id'))
				{
					$query->select("(SELECT id FROM #__js_res_hits WHERE record_id = r.id AND user_id = " . $user->get('id') . " LIMIT 1) AS `new`");
				}
				else
				{
					$query->select("(SELECT id FROM #__js_res_hits WHERE record_id = r.id AND ip = '" . $_SERVER['REMOTE_ADDR'] . "' LIMIT 1) AS `new`");
				}
			}
			else
			{
				$query->select('0 as `new`');
			}

			$orderCol = $this->state->get('list.ordering');
			$orderDirn = $this->state->get('list.direction');

			if($section->params->get('general.featured_first'))
			{
				$query->order('r.featured DESC');
			}

			$field_orders = JFactory::getApplication()->getUserState($this->context . '.ordering.vals' . $this->section->id);
			if($field_orders)
			{
				$query->select("(SELECT `field_value` FROM #__js_res_record_values WHERE record_id = r.id AND field_key = '{$field_orders[1]}' LIMIT 1) AS field_value");

				if($field_orders[2] == 'digits')
				{
					$query->order("field_value + 0 " . $orderDirn);
				}
				$query->order("field_value " . $orderDirn);
			}
			else
			{
				$query->order($db->getEscaped($orderCol . ' ' . $orderDirn));
			}

			if(($orderCol == 'name' || $orderCol == 'username'))
			{
				$query->select('(SELECT `' . $orderCol . '` FROM  #__users WHERE id = r.user_id) AS ' . $orderCol);
			}
		}
		else
		{
			$query->select('r.id');
		}

		$query = $this->where($query);
		$query = $this->wherefilter($query);
		$query = $this->wherecategory($query);

		if(!$this->_showRecords())
		{
			$query = "SELECT * FROM `#__js_res_record` WHERE FALSE";
		}

		//if($this->getState('list.limit') == 0)
		//{
		//	$this->setState('list.limit', 20);
		//}

		//if(! $total) echo nl2br(str_replace('#__', 'jos_', $query)) . "<br><br>";
		//exit;
		//echo $this->getState('list.limit');
		return $query;
	}

	public function getItems()
	{
		$items = parent::getItems();

		if(!$items)
		{
			return array();
		}

		$ids = array();
		foreach($items as $key => $item)
		{
			$ids[] = $item->id;
		}
		ItemsStore::$record_ids = $ids;
		return $items;
	}

	private function _showRecords()
	{
		$show = FALSE;

		if(!JRequest::getInt('cat_id'))
		{
			if($this->section->categories == 0)
			{
				$show = TRUE;
			}
			if($this->section->params->get('general.section_home_items'))
			{
				$show = TRUE;
			}
			if(JRequest::getVar('view_what', (JRequest::getVar('user_id') ? 'created' : NULL)))
			{
				$show = TRUE;
			}
			if($this->section->params->get('general.filter_mode') == 0 && $this->worns)
			{
				$show = TRUE;
			}
		}
		else
		{
			$show = TRUE;
		}
		if($this->_showRecords == FALSE)
		{
			$show = FALSE;
		}

		return $show;
	}

	private function _getrecordids($sql)
	{
		static $out = array();

		$key = md5($sql);

		if(isset($out[$key]))
		{
			return $out[$key];
		}

		$db = JFactory::getDbo();
		$db->setQuery($sql);
		$ids = $db->loadColumn();
		$ids = array_unique($ids);

		$record_ids = array(
			0
		);

		if($ids)
		{
			$cat_sql = "SELECT record_id FROM `#__js_res_record_category` WHERE catid IN(" . implode(',', $ids) . ")";
			$db->setQuery($cat_sql);
			$ids = $db->loadColumn();

			if($ids)
			{
				$record_ids = array_merge($record_ids, $ids);
			}
		}

		$out[$key] = $record_ids;

		return $out[$key];
	}

	private function wherecategory($query)
	{
		$cat = JRequest::getInt('cat_id', NULL);
		$view_what = JRequest::getVar('view_what');
		$user = JFactory::getUser();
		$db = JFactory::getDbo();

		if(!empty($this->worns['cats'])) {
			$cat = NULL;
		}
		if($view_what) {
			$cat = NULL;
		}
		if($this->section->params->get('general.filter_mode', 0) == 0 && !empty($this->worns)) {
			$cat = NULL;
		}
		if($this->section->params->get('personalize.personalize') && JRequest::getInt('user_id')) {
			$cat = NULL;
		}

		$cat = JRequest::getInt('force_cat_id', $cat);

		if($cat)
		{
			$cat_sql = 'SELECT c.id FROM `#__js_res_categories` AS c WHERE c.id = ' . $cat . '
				AND c.access IN (' . implode(',', $user->getAuthorisedViewLevels()) . ') AND c.published = 1';

			if($this->section->params->get('general.records_mode'))
			{
				$sql = "SELECT lft, rgt FROM `#__js_res_categories` WHERE id = {$cat}";
				$db->setQuery($sql);
				$res = $db->loadObject();

				$cat_sql = "SELECT id FROM `#__js_res_categories`
					WHERE lft >= {$res->lft} AND rgt <= {$res->rgt}
					AND section_id = {$this->section->id}
					AND published = 1
					AND access IN (" . implode(',', $user->getAuthorisedViewLevels()) . ")";

				/*$cat_sql = "SELECT c.id FROM `#__js_res_categories` AS c, `#__js_res_categories` AS parent
					WHERE (
						(
							c.lft BETWEEN parent.lft AND parent.rgt
							AND parent.parent_id = {$cat}
							AND c.level <= 1002
						)
						OR c.id = {$cat}
					)
					AND c.section_id = {$this->section->id}
					AND c.published = 1
					AND c.access IN (" . implode(',', $user->getAuthorisedViewLevels()) . ")";*/
			}
			$record_ids = $this->_getrecordids($cat_sql);
			$query->where("r.id IN(" . implode(',', $record_ids) . ")");
		}

		if($this->section->params->get('general.section_home_items') == 1 && !JRequest::getInt('cat_id', NULL))
		{
			$section_root = TRUE;
			if($view_what) {
				$section_root = FALSE;
			}
			if(!empty($this->worns['cats'])) {
				$section_root = FALSE;
			}
			if($this->section->params->get('general.filter_mode', 0) == 0 && !empty($this->worns)) {
				$section_root = FALSE;
			}
			if($this->section->params->get('personalize.personalize') && JRequest::getInt('user_id')) {
				$section_root = FALSE;
			}

			if($section_root)
			{
				$query->where("r.id NOT IN(SELECT record_id FROM #__js_res_record_category WHERE section_id = {$this->section->id})");
			}
		}

		return $query;
	}

	private function wherefilter($query)
	{
		if(!$this->_filtersWhere)
		{
			return $query;
		}

		$app = JFactory::getApplication();

		$filters = $this->getFilters();
		foreach($filters as $fkey => $filter)
		{
			$state = $app->getUserState('com_cobalt.section' . FilterHelper::key() . '.filter_' . $fkey);
			if($state)
			{
				$condition = $filter->onFilterWhere($this->section, $query);
				if($condition)
				{
					$this->worns[$fkey] = WornHelper::getItem('filter_' . $fkey, $filter->label, $filter->value, $filter->onFilterWornLabel($this->section));
				}
			}
		}
		return $query;
	}

	private function where($query)
	{
		$view_what = JRequest::getVar('view_what');
		$total = $this->total;
		$db = JFactory::getDbo();
		$app = JFactory::getApplication();
		$user = JFactory::getUser();
		$user_id = JRequest::getVar('user_id');
		$filters = TRUE;

		if(!is_null($user_id))
		{
			$user_id = (int)$user_id;
		}

		if($app->getUserState('com_cobalt.skip_record'))
		{
			$query->where("r.id != " . $app->getUserState('com_cobalt.skip_record'));
		}

		$query->where('r.section_id = ' . $this->getState('records.section_id'));

		if($this->section->params->get('personalize.personalize') && $this->section->params->get('personalize.pcat_submit') > 0)
		{
			$query->select('c.name AS ucatname');
			$query->join('LEFT', '#__js_res_category_user AS c on c.id = r.ucatid');
			if(JRequest::getInt('ucat_id'))
			{
				$query->where("r.ucatid = " . JRequest::getInt('ucat_id'));
			}
		}

		if(!in_array($this->section->params->get('general.show_restrict'), $user->getAuthorisedViewLevels()) && !MECAccess::allowRestricted($user, $this->section))
		{
			$query->where("(r.access IN(" . implode(',', $user->getAuthorisedViewLevels()) . ") OR r.user_id = " . $user->get('id') . ")");
		}

		if(!in_array($this->section->params->get('general.show_future_records'), $user->getAuthorisedViewLevels()))
		{
			$query->where("r.ctime < " . $db->quote(JFactory::getDate()->toSql()));
		}

		if($view_what == 'expired')
		{
			$query->where("(r.extime != '0000-00-00 00:00:00' AND r.extime < '" . JFactory::getDate()->toSql() . "')");
			$user_id = $user->get('id');
		}
		elseif(!in_array($this->section->params->get('general.show_past_records'), $user->getAuthorisedViewLevels()))
		{
			$query->where("(r.extime = '0000-00-00 00:00:00' OR r.extime > '" . JFactory::getDate()->toSql() . "')");
		}

		if($this->section->params->get('general.lang_mode'))
		{
			$lang = JFactory::getLanguage();
			$query->where('r.langs = ' . $db->quote($lang->getTag()));
		}

		if($view_what == 'unpublished')
		{
			$query->where('r.published = 0');

			$dummy->params = new JRegistry();

			if(MECAccess::allowPublish(null, $dummy, $this->section))
			{
				$user_id = NULL;
			}
		}
		else
		{
			$query->where('r.published = 1');
		}

		if($view_what == 'hidden')
		{
			$query->where('r.hidden = 1');
			$user_id = $user->get('id');
		}
		else
		{
			$query->where('r.hidden = 0');
		}

		if($view_what == 'featured')
		{
			$query->where('r.featured = 1');
			$user_id = $user->get('id');
		}

		if($view_what == 'events')
		{
			$query->where('r.id IN(SELECT ref_1 FROM #__js_res_notifications WHERE user_id = ' . $user->get('id') . ' AND ref_2 = ' . $this->section->id . ')');
			$user_id = NULL;
		}

		if($view_what == 'follow')
		{
			$query->where('r.id IN(SELECT record_id FROM #__js_res_subscriptions WHERE user_id = ' . $user->get('id') . ' AND section_id = ' . $this->section->id . ')');
			$user_id = NULL;
		}

		if($view_what == 'visited')
		{
			$query->where('r.id IN(SELECT record_id FROM #__js_res_hits WHERE user_id = ' . $user->get('id') . ' AND section_id = ' . $this->section->id . ')');
			$user_id = NULL;
		}

		if($view_what == 'commented')
		{
			$query->where('r.id IN(SELECT record_id FROM #__js_res_comments WHERE user_id = ' . $user->get('id') . ' AND section_id = ' . $this->section->id . ')');
			$user_id = NULL;
		}
		if($view_what == 'rated')
		{
			$query->where('r.id IN(SELECT ref_id FROM #__js_res_vote WHERE user_id = ' . $user->get('id') . ' AND ref_type = \'record\' AND section_id = ' . $this->section->id . ')');
			$user_id = NULL;
		}
		if($view_what == 'favorited')
		{
			$query->where('r.id IN(SELECT record_id FROM #__js_res_favorite WHERE user_id = ' . $user->get('id') . ' AND section_id = ' . $this->section->id . ')');
			$user_id = NULL;
		}

		if($view_what == 'user_follow')
		{
			$query->where('r.id IN(SELECT record_id FROM #__js_res_subscriptions WHERE user_id = ' . JRequest::getInt('user_id') . ' AND section_id = ' . $this->section->id . ')');
			$user_id = NULL;
		}

		if($view_what == 'user_visited')
		{
			$query->where('r.id IN(SELECT record_id FROM #__js_res_hits WHERE user_id = ' . JRequest::getInt('user_id') . ' AND section_id = ' . $this->section->id . ')');
			$user_id = NULL;
		}

		if($view_what == 'user_commented')
		{
			$query->where('r.id IN(SELECT record_id FROM #__js_res_comments WHERE user_id = ' . JRequest::getInt('user_id') . ' AND section_id = ' . $this->section->id . ')');
			$user_id = NULL;
		}
		if($view_what == 'user_rated')
		{
			$query->where('r.id IN(SELECT ref_id FROM #__js_res_vote WHERE user_id = ' . JRequest::getInt('user_id') . ' AND ref_type = \'record\' AND section_id = ' . $this->section->id . ')');
			$user_id = NULL;
		}
		if($view_what == 'user_favorited')
		{
			$query->where('r.id IN(SELECT record_id FROM #__js_res_favorite WHERE user_id = ' . JRequest::getInt('user_id') . ' AND section_id = ' . $this->section->id . ')');
			$user_id = NULL;
		}

		if($view_what == 'only_featured')
		{
			$query->where('r.featured = 1');
			$user_id = NULL;
		}

		if($view_what == 'children')
		{
			$parent_id = JRequest::getInt('parent_id');
			$parent = JRequest::getVar('parent', 'com_cobalt');
			$query->where("r.parent_id = {$parent_id}");
			$query->where("r.parent = '{$parent}'");
		}
		else
		{
			if(!in_array($this->section->params->get('general.show_children'), $user->getAuthorisedViewLevels()))
			{
				$query->where("r.parent_id = 0");
			}
		}

		if($view_what == 'who_comment')
		{
			$comments = 'SELECT user_id FROM #__js_res_comments WHERE user_id > 0 AND record_id = ' . JRequest::getInt('id');
			$sql = "SELECT record_id FROM #__js_res_comments WHERE user_id IN ({$comments}) AND section_id = " . $this->section->id;
			$query->where("r.id IN({$sql})");

			$query->select("(SELECT COUNT(*) FROM #__js_res_comments WHERE user_id IN({$comments}) AND record_id = r.id) AS comments_nums");

			$this->state->set('list.ordering', 'comments_nums');
			$this->state->set('list.direction', 'DESC');
			$user_id = NULL;
			$filters = FALSE;
		}
		if($view_what == 'who_rate')
		{
			$rates = "SELECT user_id FROM #__js_res_vote WHERE user_id > 0 AND ref_type = 'record' AND ref_id = " . JRequest::getInt('id');
			$sql = "SELECT ref_id FROM #__js_res_vote WHERE user_id IN ({$rates}) AND section_id = " . $this->section->id;
			$query->where("r.id IN({$sql})");

			$query->select("(SELECT COUNT(*) FROM #__js_res_vote WHERE user_id IN({$rates}) AND ref_type = 'record' AND ref_id = r.id) AS vote_nums");

			$this->state->set('list.ordering', 'vote_nums');
			$this->state->set('list.direction', 'DESC');
			$user_id = NULL;
			$filters = FALSE;
		}

		if($view_what == 'who_visit')
		{
			$visit_users = 'SELECT user_id FROM #__js_res_hits WHERE  user_id > 0 AND record_id = ' . JRequest::getInt('id');
			$sql = "SELECT record_id FROM #__js_res_hits WHERE user_id IN ({$visit_users}) AND section_id = " . $this->section->id;
			$query->where("r.id IN({$sql})");

			$query->select("(SELECT COUNT(*) FROM #__js_res_hits WHERE user_id IN({$visit_users}) AND record_id = r.id) AS visited_num");

			$this->state->set('list.ordering', 'visited_num');
			$this->state->set('list.direction', 'DESC');
			$user_id = NULL;
			$filters = FALSE;
		}

		if($view_what == 'who_favorite')
		{
			$visit_users = 'SELECT user_id FROM #__js_res_favorite WHERE  user_id > 0 AND record_id = ' . JRequest::getInt('id');
			$sql = "SELECT record_id FROM #__js_res_favorite WHERE user_id IN ({$visit_users}) AND section_id = " . $this->section->id;
			$query->where("r.id IN({$sql})");

			$query->select("(SELECT COUNT(*) FROM #__js_res_favorite WHERE user_id IN({$visit_users}) AND record_id = r.id) AS fav_num");

			$this->state->set('list.ordering', 'fav_num');
			$this->state->set('list.direction', 'DESC');
			$user_id = NULL;
			$filters = FALSE;
		}

		if($view_what == 'author_tag_related' || $view_what == 'tag_related')
		{
			$ids = array();
			$tags = 'SELECT tag_id FROM #__js_res_tags_history WHERE  record_id = ' . JRequest::getInt('id');
			$db->setQuery($tags);
			$ids1 = $db->loadColumn();
			if($ids1)
			{
				$sql = "SELECT record_id FROM #__js_res_tags_history WHERE tag_id IN (" . implode(',', $ids1) . ") AND section_id = " . $this->section->id;
				$db->setQuery($sql);
				$ids = $db->loadColumn();
			}

			$ids[] = 0;
			$ids = array_unique($ids);
			$query->where("r.id IN(" . implode(',', $ids) . ")");

			$query->select("(SELECT COUNT(*) FROM #__js_res_tags_history WHERE tag_id IN({$tags}) AND record_id = r.id) AS count_tags");

			$this->state->set('list.ordering', 'count_tags');
			$this->state->set('list.direction', 'DESC');

			if($view_what == 'tag_related')
			{
				$user_id = NULL;
			}
			$filters = FALSE;
		}

		if($view_what == 'field_data')
		{
			$from_key = JFactory::getApplication()->getUserState('com_cobalt.field.from');
			$in_key = JFactory::getApplication()->getUserState('com_cobalt.field.in');

			if($in_key && $from_key)
			{
				$from_values = "SELECT fv1.field_value FROM #__js_res_record_values fv1 WHERE fv1.field_key = '{$from_key}' AND  fv1.record_id = " . JRequest::getInt('id');
				$sql = "SELECT fv2.record_id FROM #__js_res_record_values AS fv2 WHERE fv2.section_id = {$this->section->id} AND fv2.field_key = '{$in_key}' AND fv2.field_value IN ({$from_values})";
				$db->setQuery($sql);
				$ids = $db->loadColumn();
				$ids[] = 0;

				$query->where("r.id IN(" . implode(',', $ids) . ")");

				$query->select("(SELECT COUNT(*) FROM #__js_res_record_values AS fv3 WHERE fv3.field_value IN({$from_values}) AND fv3.record_id = r.id) AS count_value");

				$this->state->set('list.ordering', 'count_value');
				$this->state->set('list.direction', 'DESC');
				$user_id = NULL;
			}
			else
			{
				$this->_showRecords = FALSE;
			}
			$filters = FALSE;
		}

		if($view_what == 'user_field_data')
		{
			$from_key = JFactory::getApplication()->getUserState('com_cobalt.field.from');
			$in_key = JFactory::getApplication()->getUserState('com_cobalt.field.in');

			if($in_key && $from_key)
			{
				$from_values = "SELECT field_value FROM #__js_res_record_values WHERE field_key = '{$from_key}' AND  record_id = " . JRequest::getInt('id');
				$sql = "SELECT record_id FROM #__js_res_record_values WHERE section_id = {$this->section->id}
					AND field_key = '{$in_key}' AND field_value IN ({$from_values})";
				$db->setQuery($sql);
				$ids = $db->loadColumn();
				$ids[] = 0;

				$query->where("r.id IN(" . implode(',', $ids) . ")");

				$query->select("(SELECT COUNT(*) FROM #__js_res_record_values WHERE field_value IN({$from_values}) AND record_id = r.id) AS count_value");

				$this->state->set('list.ordering', 'count_value');
				$this->state->set('list.direction', 'DESC');
			}
			else
			{
				$this->_showRecords = FALSE;
			}
			$filters = FALSE;
		}

		if($view_what == 'show_parents')
		{
			$record_id = JRequest::getInt('_rrid');
			$field_id = JRequest::getInt('_rfid');
			if($record_id && $field_id)
			{
				$db->setQuery("SELECT field_value FROM #__js_res_record_values WHERE record_id = {$record_id} AND field_id = {$field_id}");
				$ids = $db->loadColumn();
			}
			$ids[] = 0;
			JArrayHelper::toInteger($ids);

			$this->_set_skiper($ids);

			$query->where("r.id IN(" . implode(',', $ids) . ")");
			$filters = FALSE;
		}

		if($view_what == 'show_children')
		{
			$record_id = JRequest::getInt('_rrid');
			$field_id = JRequest::getInt('_rfid');
			if($record_id && $field_id)
			{
				$db->setQuery("SELECT record_id FROM #__js_res_record_values WHERE field_value = '{$record_id}' AND field_id = {$field_id}");
				$ids = $db->loadColumn();
			}
			$ids[] = 0;
			JArrayHelper::toInteger($ids);

			$this->_set_skiper($ids);

			$query->where("r.id IN(" . implode(',', $ids) . ")");
			$filters = FALSE;
		}

		if($view_what == 'show_related')
		{

			$record_id = JRequest::getInt('_rmrid');
			$field_id = JRequest::getInt('_rmfid');
			$strict = JRequest::getInt('_rmstrict');

			$db->setQuery("SELECT field_value FROM #__js_res_record_values WHERE record_id = '{$record_id}' AND field_id = {$field_id}");
			$ids2 = $db->loadColumn();
			$ids2[] = 0;

			if($strict)
			{
				$db->setQuery("SELECT record_id FROM #__js_res_record_values WHERE field_value = '{$record_id}' AND field_id = {$field_id}");
				$ids = $db->loadColumn();
			}
			$ids[] = 0;

			$ids = array_merge($ids, $ids2);
			$ids = array_unique($ids);

			if($record_id && $field_id)
			{
				$query->where("(r.id IN(" . implode(',', $ids) . "))");
			}
			else
			{
				$query->where("r.id IN(0)");
			}
			$filters = FALSE;
		}

		if($user_id || $user_id === 0)
		{
			//$user_id = JFactory::getUser(JRequest::getInt('user_id'))->get('id');
			$query->where('r.user_id = ' . $user_id);

		}

		if($filters === FALSE)
		{
			return $query;
		}

		$search = $this->getState('records.search');
		if($search)
		{
			$this->worns['search'] = WornHelper::getItem('filter_search', 'Search text', $search);

			$search_mode = NULL;
			$scount = explode(" ", $search);
			ArrayHelper::clean_r($scount);

			if($this->section->params->get('more.search_mode') == 1 || ($this->section->params->get('more.search_mode') == 3 && count($scount)))
			{
				$string = "r.fieldsdata LIKE '%" . $db->escape($search) . "%'";
				$query->where($string);
				if(!$total) {
					$query->select("1 AS searchresult");
				}
			}
			else
			{
				if(count($scount) > 2)
				{
					$search_mode = ' IN NATURAL LANGUAGE MODE';
				}
				elseif(count($scount) == 1)
				{
					$search_mode = ' IN BOOLEAN MODE';
				}

				foreach($scount as $word)
				{
					if(in_array(substr($word, 0, 1), array(
						'+',
						'-'
					))
					)
					{
						$search_mode = ' IN BOOLEAN MODE';
						break;
					}
				}

				$search = $db->quote($db->escape($search));
				$query->where("MATCH (fieldsdata) AGAINST ({$search}{$search_mode})");
				if(!$total) {
					$query->select("MATCH (fieldsdata) AGAINST ({$search}{$search_mode}) AS searchresult");
				}
			}
		}

		$alpha = $this->getState('records.alpha');
		if($alpha)
		{
			$this->worns['alpha'] = WornHelper::getItem('filter_alpha', 'Start with', $alpha);
			$query->where("r.title like '{$alpha}%'");
		}

		$archive = $this->getState('records.archive');
		if($archive)
		{
			$this->worns['archive'] = WornHelper::getItem('filter_archive', 'Archived', JText::_('JYES'));
			$query->where("r.archive = 1");
		}
		else
		{
			$query->where("r.archive = 0");
		}

		$tag = $this->getState('records.tag');
		if($tag)
		{
			if(!$total)
			{
				foreach($tag as $t)
				{
					$taglabels[] = JHtml::_('tags.name', $t);
				}
				$this->worns['tags'] = WornHelper::getItem('filter_tag', 'Tag', $tag, implode(', ', $taglabels));
			}

			$sql = "SELECT record_id from #__js_res_tags_history WHERE tag_id IN(" . implode(',', $tag) . ") AND section_id = {$this->section->id}";
			$db->setQuery($sql);
			$ids = $db->loadColumn();
			$ids[] = 0;
			$query->where("r.id IN(" . implode(', ', $ids) . ")");
		}

		$type = $this->getState('records.type');
		ArrayHelper::clean_r($type);
		if($type)
		{
			if(!$total)
			{
				settype($type, 'array');
				$typelabels = array();
				$types = $this->getSubmissionTypes();
				foreach($type as $t)
				{
					if(isset($types[$t]))
					{
						$typelabels[] = $types[$t]->name;
					}
				}
				$this->worns['type'] = WornHelper::getItem('filter_type', 'Of type', $type, implode(', ', $typelabels));
			}
			$query->where("r.type_id IN (" . implode(',', $type) . ")");
		}

		$users = $this->getState('records.user');
		if($users)
		{
			if(!$total)
			{
				foreach($users as $usr)
				{
					$userlabels[] = CCommunityHelper::getName($usr, $this->section, TRUE);
				}
				$this->worns['users'] = WornHelper::getItem('filter_user', 'By author', $users, implode(', ', $userlabels));
			}
			$query->where("r.user_id IN (" . implode(',', $users) . ")");
			//$query->where("r.user_id = ".(int)$user);
		}

		$cats = $this->getState('records.category');
		if($cats)
		{
			if(!$total)
			{
				$catslabels = JHtml::_('categories.labels', $cats);
				$this->worns['cats'] = WornHelper::getItem('filter_cat', 'Categories', $cats, $catslabels);
			}

			$sql = "SELECT record_id FROM #__js_res_record_category WHERE catid IN(" . implode(',', $cats) . ")";
			$db->setQuery($sql);
			$ids = $db->loadColumn();
			$ids[] = 0;

			$query->where("r.id IN(" . implode(',', $ids) . ")");
		}

		return $query;
	}

	public function getResetFilters()
	{
		$types = $this->section->params->get('general.type');
		settype($types, 'array');
		ArrayHelper::clean_r($types);
		JArrayHelper::toInteger($types);

		$query = $this->_db->getQuery(TRUE);
		$query->select('f.*');
		$query->from('#__js_res_fields f');
		$query->where('f.filter = 1');
		$query->where('f.published = 1');
		$query->where('f.type_id IN(' . implode(',', $types) . ')');
		$this->_db->setQuery($query);

		$filters = $this->_db->loadObjectList();

		return $filters;
	}

	public function getFilters()
	{
		static $cache = array();

		$types = $this->getFilterTypes();

		if(!$types) {
			return array();
		}

		$query = $this->_db->getQuery(TRUE);

		$query->select('f.*');
		$query->from('#__js_res_fields f');
		$query->where('f.filter = 1');
		$query->where('f.published = 1');
		$query->where('f.type_id IN(' . implode(',', $types) . ')');
		$query->order('f.ordering ASC');

		if(count($types) > 1)
		{
			$query->select('count(f.id) as nums');
 			$query->having('nums > 1');
			$query->group('f.`key`');
		}
		$key = md5((string)$query);

		if(isset($cache[$key]))
		{
			return $cache[$key];
		}

		$this->_db->setQuery($query);
		$filters = $this->_db->loadObjectList();

		$out = array();
		foreach($filters as $filter)
		{
			require_once JPATH_ROOT . DS . 'components/com_cobalt/fields/' . $filter->field_type . '/' . $filter->field_type . '.php';

			$default = JFactory::getApplication()->getUserState('com_cobalt.section' . FilterHelper::key() . '.filter_' . $filter->key);
			$name = 'JFormFieldC' . ucfirst($filter->field_type);
			$out[$filter->key] = new $name($filter, $default);
		}

		$cache[$key] = $out;
		return $cache[$key];
	}

	/**
	 * get number of types potentially.
	 */
	public function getKeys($section)
	{
		static $out = array();

		if(isset($out[$section->id]))
		{
			return $out[$section->id];
		}

		$query = $this->_db->getQuery(TRUE);
		$query->select('DISTINCT `type_id`');
		$query->from('#__js_res_record');
		$query->where('section_id = ' . $section->id);

		$this->_db->setQuery($query);
		$types = $this->_db->loadColumn();

		if(!$types) {
			return array();
		}

		$query = $this->_db->getQuery(TRUE);
		$query->select('`key`, `id`');
		$query->from('#__js_res_fields');
		$query->where('type_id IN(' . implode(',', $types) . ')');

		$this->_db->setQuery($query);
		$fields = $this->_db->loadObjectList();

		$o = array();
		foreach($fields AS $field)
		{
			$o[$field->id] = $field->key;
		}

		$out[$section->id] = $o;

		return $out[$section->id];
	}

	public function getTypes()
	{
		$types = $this->section->params->get('general.type');
		settype($types, 'array');

		ArrayHelper::clean_r($types);
		JArrayHelper::toInteger($types);

		if(count($types) == 0)
		{
			return $types;
		}

		if(count($types) == 1)
		{
			return $types;
		}

		$query = $this->_db->getQuery(TRUE);
		$query->select('DISTINCT r.type_id');
		$query->from('#__js_res_record r');
		$query->where('r.type_id IN(' . implode(',', $types) . ')');
		$query = $this->wherecategory($query);

		$this->_db->setQuery($query);
		$types = $this->_db->loadResultArray();
		ArrayHelper::clean_r($types);
		JArrayHelper::toInteger($types);

		return $types;
	}

	/*
	 * Get number of types in current search
	 */
	public function getFilterTypes()
	{
		static $cache = NULL;

		if($cache)
		{
			return $cache;
		}

		$types = $this->section->params->get('general.type');
		settype($types, 'array');

		ArrayHelper::clean_r($types);
		JArrayHelper::toInteger($types);

		if(count($types) == 1)
		{
			$cache = $types;
		}
		else
		{
			if(isset($this->worns['type']->value) && count($this->worns['type']->value) == 1)
			{
				$cache = $this->worns['type']->value;
			}
			else
			{
				$cache = $this->getCategoryTypes();
			}
		}

		$cache = array_unique($cache);

		return $cache;
	}

	public function getCategoryTypes()
	{
		static $types = NULL;

		if(is_array($types))
		{
			return $types;
		}

		$query = $this->_db->getQuery(TRUE);
		$query->select('DISTINCT r.type_id');
		$query->from('#__js_res_record r');
		$query = $this->where($query);
		$query = $this->wherecategory($query);
		$this->_db->setQuery($query);

		$types = $this->_db->loadResultArray();

		return $types;
	}

	public function getSubmissionTypes()
	{

		static $out = array();

		$ids = $this->section->params->get('general.type');
		settype($ids, 'array');
		$ids = implode(',', $ids);

		if(!$ids)
		{
			return array();
		}

		if(isset($out[$ids]))
		{
			return $out[$ids];
		}

		$sql = $this->_db->getQuery(TRUE);

		$sql->select('t.id, t.name, t.params');
		$sql->from('#__js_res_types AS t');
		$sql->where('t.id IN(' . $ids . ')');
		$sql->where('t.published = 1');

		$this->_db->setQuery($sql);
		$result = $this->_db->loadObjectList('id');

		$types = $this->getState('records.type');
		settype($types, 'array');
		settype($result, 'array');

		foreach($result as &$type)
		{
			$params = new JRegistry();
			$params->loadString($type->params);
			$type->params = $params;

			$type->filter_checked = null;
			if(in_array($type->id, $types))
			{
				$type->filter_checked = ' checked="checked"';
			}
		}

		$out[$ids] = $result;
		return $result;
	}

	public function getAlphas()
	{
		$db = $this->getDbo();
		$query = $db->getQuery(true);

		$query->select('SUBSTRING(UCASE(r.title),1,1) AS letter');
		$query->from('#__js_res_record AS r');
		$query->where('r.section_id = ' . $this->getState('records.section_id'));
		$query = $this->where($query);
		$query = $this->wherefilter($query);
		$query = $this->wherecategory($query);
		//$query->group('letter');

		$db->setQuery($query);
		$result = $db->loadObjectList();

		return $result;

	}

	public function getWorns()
	{
		return $this->worns;
	}

	public function getTotal()
	{
		if($this->_navigation == FALSE)
		{
			return 0;
		}
		// Get a storage key.
		$store = $this->getStoreId('getTotal');

		// Try to load the data from internal storage.
		if(!empty($this->cache[$store]))
		{
			return $this->cache[$store];
		}

		$this->total = 1;
		// Load the total.
		$query = $this->_getListQuery();
		$total = (int)$this->_getListCount($query);
		$this->total = 0;

		// Check for a database error.
		if($this->_db->getErrorNum())
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Add the total to the internal cache.
		$this->cache[$store] = $total;

		return $this->cache[$store];
	}

	private function _set_skiper($ids)
	{
		$app = JFactory::getApplication();

		$skipers = $app->getUserState('skipers.all', array());
		settype($this->value, 'array');
		//var_dump($this->value);

		foreach($ids AS $id)
		{
			$skipers[] = $id;
		}

		$skipers = array_unique($skipers);
		ArrayHelper::clean_r($skipers);

		$app->setUserState('skipers.all', $skipers);
	}

	protected function _getListQuery()
	{
		// Capture the last store id used.
		static $lastStoreId;

		// Compute the current store id.
		$currentStoreId = $this->getStoreId();

		// If the last store id is different from the current, refresh the query.
		if($lastStoreId != $currentStoreId || empty($this->query) || $this->total)
		{
			$lastStoreId = $currentStoreId;
			$this->query = $this->getListQuery();
		}

		return $this->query;
	}
}
