<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die('Restricted access');

$document = JFactory::getDocument();
$document->addScript(JURI::root().'media/mint/js/moodropmenu/MooDropMenu.js');
$document->addStyleSheet(JURI::root().'media/mint/js/moodropmenu/MooDropMenu_vertical.css');

$cats_model = JModel::getInstance('Categories', 'CobaltModel');
$cats_model->section = $this->section;
$cats_model->parent_id = 1;
$cats_model->order = $this->catsel_params->get('tmpl_params.cat_ordering', 'c.lft ASC');
$cats_model->levels = 1000;
$cats_model->all = 0;
$categories = $cats_model->getItems();
if(!$categories)
{
	echo JText::_('CSECTIONNOCATEGORIES');
	return;
}
$def = new stdClass();
$def->category = array();
$def->allow = 0;
$def->category_limit_mode = 0;
$def->show_restricted = 0;
$category_limit = $this->type->params->get('category_limit', $def);
if(!isset($category_limit->category))
{
	$category_limit->category = array();
	$category_limit->allow = 0;
}
$this->type->excluded_parent_id = array();
$this->type->category_limit_def = $def;

$params = $this->catsel_params;
$default = $cats_model->getCategoriesById($this->default_categories);

?>
<style>
<!--
	    
#catselect.mermoomenu, #catselect.mermoomenu ul  {
	max-width: <?php echo $this->catsel_params->get('tmpl_params.max_width');?>px !important;	
}
-->
</style>
<script type="text/javascript"><!--

var s_icons = [<?php if($this->default_categories) echo implode(',', $this->default_categories); ?>];
var lastid = 0;
function addCategory(id, title, path)
{
	s_icons.push(id);

	out = '<img class="delete_icon" src="<?php	echo JURI::root();?>media/mint/icons/16/cross-button.png" '+ 
		'onclick="removeCategory(' + id + ')">'+
		'<div>' + title + '</div>'+
		'<span class="small">' + path + '</span>'+
		'<input type="hidden" name="jform[category][]" value="' + id + '" />';
	
	<?php if ($this->params->get('submission.multi_category', 0)) {	?>
		var currentlist = $('categories_list').getChildren();
		if(currentlist.length >= <?php echo $this->params->get('submission.multi_max_num', 3) ?>)
		{
			alert('<?php echo JText::_('CCATEGORYREACHMAXLIMIT');?>');
			return;
		}
		var li = new Element('li', {id: 'cat'+ id, class: 'default_category'});
		li.set('html', out);
		$('categories_list').grab(li, 'bottom');
		$('s_icon' + id).setStyle('display', 'none');
	<?php }	else { ?>
	out = '<li id="cat' + id + '" class="default_category">'+out+'</li>'
		$('categories_list').set('html', out);
		$('s_icon' + id).setStyle('display', 'none');
		if(lastid)
		{
			try{
					$('s_icon' + lastid).setStyle('display', 'block');
					}catch(e){}
		}
		lastid = id;
	<?php }	?>
}

function removeCategory(id)
{
	s_icons.erase(id);
	var myEffect = new Fx.Morph('cat' + id, {
	    duration: 'short',
	    transition: Fx.Transitions.Sine.easeOut
	});
	myEffect.addEvent('complete', function(){$('cat' + id).dispose();});
	myEffect.start({'height': 0});

	try{$('s_icon' + id).setStyle('display', 'block');}catch(e){}
}

function hideIcons()
{
	<?php if ($this->params->get('submission.multi_category', 0)): ?>
	Array.each(s_icons, function(id){
		try 
		{
			$('s_icon' + id).setStyle('display', 'none');	
		}
		catch (e){}	
	});
	<?php endif;?>
}



--></script>
<div style="clear: both;"></div>
<div class="default_categories">
	<ul class="categories_list"  id="categories_list">
		<?php if ($default): ?>
			<?php	foreach ( $default as $cat ):
			$descr = preg_split('#<hr\s+id=("|\')system-readmore("|\')\s*\/*>#i', $cat->description, 2);
			$cat->descr_before = @$descr[0];
			$cat->descr_after = @$descr[1];
			$cat->descr_full = implode($descr);
			?>
			<li id="cat<?php echo $cat->id?>" class="default_category">
				<img class="delete_icon" src="<?php	echo JURI::root();?>media/mint/icons/16/cross-button.png" 
					onclick="removeCategory(<?php echo $cat->id;?>)">
				<div <?php if($params->get('tmpl_params.cat_descr', 0) && $cat->description):?>
						<?php echo 'class="hasTip" title="'.$cat->title.'::'.$cat->{'descr_'.$params->get('tmpl_params.cat_descr')}.'"'?>
					<?php endif;?>>
					<?php echo $cat->title;?>
				</div>
				<span class="small">(<?php	echo $cat->path;?>)</span>
				<input type="hidden" name="jform[category][]" value="<?php echo $cat->id;?>" />
			</li>
			<?php endforeach;?>
		<?php endif; ?>
	</ul>	
</div>

<div id="category_select">
	<ul id="catselect" class="mermoomenu">
		<?php foreach ($categories as $cat) :?>
		<?php 
			$category_enable = true;
			if($category_limit->allow && !in_array($cat->id, $category_limit->category))
			{
				$category_enable = false;
			}
			if(!$category_limit->allow && in_array($cat->id, $category_limit->category))
			{
				$category_enable = false;
			}
			if(!$category_limit->allow && in_array($cat->parent_id, $this->type->excluded_parent_id))
			{
				$category_enable = false;
			}
			if( $category_limit->allow && in_array($cat->parent_id, $this->type->excluded_parent_id))
			{
				$category_enable = true;
			}
			if(((!$category_enable && !$category_limit->allow) || ($category_enable && $category_limit->allow)) && $category_limit->category_limit_mode)
			{
				$this->type->excluded_parent_id[] = $cat->id;
			}
			if($category_limit->category_limit_mode && !$category_limit->show_restricted && !$category_enable)
			{
				continue;
			}
		?>
			<li id="category-<?php echo $cat->id; ?>" class="category_element">
				<div class="add_icons">
					<?php if($cat->childs_num && $result = getChilds($cat, $params, $this->type)):?>
						<img class="add_icon" src="<?php echo JURI::root()?>media/mint/icons/16/control-000-small.png" align="absmiddle" />
					<?php endif;?>
					<?php if($cat->params->get('submission', 1) && $category_enable):?>
						<img class="add_icon" id="s_icon<?php echo $cat->id;?>" src="<?php echo JURI::root();?>media/mint/icons/16/plus-button.png"
							onclick="addCategory(<?php echo $cat->id;?>, '<?php echo $cat->title;?>', '<?php echo $cat->path;?>')">
					<?php endif;?>
				</div>
				<span <?php if($params->get('tmpl_params.cat_descr', 0) && $cat->description):?>
					<?php echo 'class="hasTip" title="'.$cat->title.'::'.$cat->{'descr_'.$params->get('tmpl_params.cat_descr')}.'"'?>
				<?php endif;?>>
				<?php echo $cat->title; ?>
				</span>
				<?php if($cat->childs_num && $result):?>
					<?php echo $result;?>
				<?php endif;?>
			</li>
		<?php endforeach;?>
	</ul>
</div>
	<?php if($params->get('tmpl_params.show_hint', 1)):?>
		<p><span class="small"><?php echo JText::sprintf('CCLICKNAVSUBCAT', 
			JHtml::image(JURI::root().'media/mint/icons/16/plus-button.png', JText::_('CADDCAT'), array('align'=>'absmiddle', 'width' => 12)),
			JHtml::image(JURI::root().'media/mint/icons/16/cross-button.png', JText::_('CDELCAT'), array('align'=>'absmiddle', 'width' => 12)));?></span></p>
	<?php endif;?>

<script type="text/javascript">
<!--
hideIcons();
//-->
</script>

<?php function getChilds($category, $params, $type, $level = 1) { ?>
<?php
	$category_limit = $type->params->get('category_limit', $type->category_limit_def);
	if(!isset($category_limit->category))
	{
		$category_limit->category = array();
		$category_limit->allow = 0;
	}
	$excluded_parent_id = array();
?>
	<?php ob_start();?>
	<?php foreach ( $category->children as $cat ): ?>
	<?php 
		$category_enable = true;
		if($category_limit->allow && !in_array($cat->id, $category_limit->category))
		{
			$category_enable = false;
		}
		if(!$category_limit->allow && in_array($cat->id, $category_limit->category))
		{
			$category_enable = false;
		}
		if(!$category_limit->allow && in_array($cat->parent_id, $type->excluded_parent_id))
		{
			$category_enable = false;
		}
		if($category_limit->allow && in_array($cat->parent_id, $type->excluded_parent_id))
		{
			$category_enable = true;
		}
		if(((!$category_enable && !$category_limit->allow) || ($category_enable && $category_limit->allow)) && $category_limit->category_limit_mode)
		{
			$type->excluded_parent_id[] = $cat->id;
		}
		if($category_limit->category_limit_mode && !$category_limit->show_restricted && !$category_enable)
		{
			continue;
		}
	?>
		<li id="category-<?php echo $cat->id; ?>" class="category_element">
			<div class="add_icons">
				<?php if($cat->childs_num):?>
					<img class="add_icon" src="<?php echo JURI::root()?>media/mint/icons/16/control-000-small.png" align="absmiddle" />
				<?php endif;?>
				<?php if($cat->params->get('submission', 1) && $category_enable):?>
					<img class="add_icon" id="s_icon<?php echo $cat->id;?>" src="<?php echo JURI::root();?>media/mint/icons/16/plus-button.png" align="absmiddle"
						onclick="addCategory(<?php echo $cat->id;?>, '<?php echo $cat->title;?>', '<?php echo $cat->path;?>')">
				<?php endif;?>
				
			</div>
			<span <?php if($params->get('tmpl_params.cat_descr', 0) && $cat->description):?>
				<?php echo 'class="hasTip" title="'.$cat->title.'::'.$cat->{'descr_'.$params->get('tmpl_params.cat_descr')}.'"'?>
			<?php endif;?>>
			<?php echo $cat->title ?>
			</span>
			<?php if($cat->childs_num && $result = getChilds($cat, $params, $type)):?>
				<?php echo $result;?>
			<?php endif;?>
		</li>
	<?php endforeach;	?>
	<?php 
		$content = ob_get_clean(); 
		$content = trim($content);
		if(!empty($content))
		{
			return '<ul id="cat-childs-'.$category->id.'">'.$content.'</ul>';
		}
		return false;
	?>
<?php } ?>

<div style="clear: both;"></div>

<script type="text/javascript"><!--
	$("catselect").MooDropMenu({
		onOpen: function(el){
			el.fade('in')
		},
		onClose: function(el){
			el.fade('out');
		},
		onInitialize: function(el){
			el.fade('hide').set('tween', {duration:500});
		}
	});
--></script>