<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

jimport('joomla.application.component.view');

class CobaltViewNotifications extends JView
{

	function display($tpl = null)
	{
		
		$model = JModel::getInstance('Notification', 'CobaltModel');
		$this->state = $this->get('State');
		
		$this->section_id = $this->state->get('notifications.section_id');
		$this->section = ItemsStore::getSection($this->section_id);
		
		$this->items = $this->get('Items');
		
		$this->pagination = $this->get('Pagination');
		
		$today = $yesterday = $thisweek = $lastweek = $older = array();
		
		foreach($this->items as $i => $item)
		{
			$item->params = new JRegistry($item->params);
			$item->html = CEventsHelper::get_notification($item);
			$item->date = JFactory::getDate($item->ctime)->format($this->section->params->get('events.event_date_format', 'd M Y'));
			
			if ($item->days < 0)
				$item->days = 0;
			
			if ($item->days == 0)
			{
				$today[] = $item;
			}
			elseif ($item->days == 1)
			{
				$yesterday[] = $item;
			}
			elseif ($item->days > 1 && $item->days < 7)
			{
				$thisweek[] = $item;
			}
			elseif ($item->days >= 7 && $item->days < 14)
			{
				$lastweek[] = $item;
			}
			else
			{
				$older[] = $item;
			}
		}
		$this->sort_items = array('today' => $today, 'yesterday' => $yesterday, 'thisweek' => $thisweek, 'lastweek' => $lastweek, 'older' => $older);
		
		$this->list['sections'] = '';		
		$sections = $model->getSections();
		
		if (count($sections) > 1)
		{
			$options = array();
			$options[] = JHTML::_('select.option', '0', JText::_('CSELECTSECTION'));
			foreach($sections as $type)
			{
				$type = ItemsStore::getSection($type);
				$options[] = JHTML::_('select.option', $type->id, $type->name);
			
			}
			$this->list['sections'] = JHtml::_('select.genericlist', $options, 'section_id', 'class="inputbox" onchange="this.form.submit();"', 'value', 'text', $this->section_id);
		}
		/*foreach ($sections AS $type):?>
							<li>
								<input id="type-<?php echo $type?>" type="checkbox" name="filters[type][]" value="<?php echo $type?>"<?php echo $this->submission_types[$type]->filter_checked?>>
								<label for="type-<?php echo $type?>"> <?php echo $this->submission_types[$type]->name;?></label>
							</li>
		*/
		$options = array();
		$options[] = JHTML::_('select.option', '0', JText::_('CSHOWALLNTF'));
		$options[] = JHTML::_('select.option', '1', JText::_('CSHOWNEWNTF'));
		
		$this->list['show_new'] = JHtml::_('select.genericlist', $options, 'show_new', 'class="inputbox" onchange="this.form.submit();"', 'value', 'text', $this->state->get('notifications.show_new'));
		
		parent::display($tpl);
	}

}
?>