<?php 
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();
?>
<?php 
$item = $this->item;
$params = $this->tmpl_params['record'];
$icons = array();
$category = array();
$author = array();
$details = array();
$started = FALSE;

$document = JFactory::getDocument();
$document->addScript(JURI::root().'media/mint/js/moodropmenu/MooDropMenu.js');
$document->addStyleSheet(JURI::root().'media/mint/js/moodropmenu/MooDropMenu.css');

if($params->get('tmpl_core.item_categories') && $item->categories_links)
{
	$category[] = sprintf('%s: %s', (count($item->categories_links) > 1 ? JText::_('CCATEGORIES') : JText::_('CCATEGORY')), implode(', ', $item->categories_links));
}
if($params->get('tmpl_core.item_user_categories') && $item->ucatid)
{
	$category[] = sprintf('%s: %s', JText::_('CUCAT'), $item->ucatname_link);
}
if($params->get('tmpl_core.item_author') && $item->user_id)
{
	$author[] = JText::sprintf('CWRITTENBY', CCommunityHelper::getName($item->user_id, $this->section));
}
if($params->get('tmpl_core.item_ctime'))
{
	$author[] = JText::sprintf('CONDATE', JHtml::_('date', $item->ctime, $params->get('tmpl_core.item_time_format')));
}
if($params->get('tmpl_core.item_hits'))
{
	$details[] = sprintf('%s: %s', JText::_('CHITS'), $item->hits);
}
if($params->get('tmpl_core.item_comments_num'))
{
	$details[] = sprintf('%s: %s', JText::_('CCOMMENTS'), $item->comments);
}
if($params->get('tmpl_core.item_favorite_num'))
{
	$details[] = sprintf('%s: %s', JText::_('CFAVORITED'), $item->favorite_num);
}
if($params->get('tmpl_core.item_follow_num'))
{
	$details[] = sprintf('%s: %s', JText::_('CFOLLOWERS'), $item->subscriptions_num);
}
?>
<style type="text/css">
.mermoomenu ul{
	right: 0;
}
</style>
<article class="<?php echo $this->appParams->get('pageclass_sfx')?><?php if($item->featured) echo ' article-featured' ?>">
		<ul id="record-buttons">
			<?php if(!$this->print):?>
				<?php if($item->controls):?>
					<li class="r-burtton menu-container">
						<ul class="mermoomenu">
							<li>
								<img width="16" height="16" alt="<?php echo JText::_('COPTIONS')?>" src="<?php echo JURI::root()?>media/mint/icons/16/gear.png">
								<ul style="visibility: hidden;"><li><?php echo implode('</li><li>', $item->controls);?></li></ul>
							</li>
						</ul>
					</li>
				<?php endif;?>
				
				<?php if($boookmark = HTMLFormatHelper::bookmark($item, $this->type, $params)):?>
					<li class="r-burtton">
						<?php echo $boookmark;?>
					</li>
				<?php endif;?>
				
				<?php if($follow = HTMLFormatHelper::follow($item, $this->section)):?>
					<li class="r-burtton">
						<?php echo $follow;?>
					</li>
				<?php endif;?>
				<?php if($params->get('tmpl_core.item_print')):?>
					<li class="r-burtton">
						<img style="cursor:pointer;" class="hasTip" title="::<?php echo JText::_('CPRINT');?>" alt="<?php echo JText::_('CPRINT');?>" src="<?php echo JURI::root();?>media/mint/icons/16/printer.png" 
							onclick="window.open('<?php echo JRoute::_($this->item->url.'&tmpl=component&print=1');?>','win2','status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no'); return false;"
						/>
					</li>
				<?php endif;?>
			<?php else:?>
				<li class="r-burtton">
					<a href="#" onclick="window.print();return false;"><img style="cursor:pointer;" class="hasTip" title="::<?php echo JText::_('CPRINT');?>" alt="<?php echo JText::_('CPRINT');?>" src="<?php echo JURI::root();?>media/mint/icons/16/printer.png"/></a>
				</li>
			<?php endif;?>
		</ul>
	<?php if($this->appParams->get('show_page_heading') && $this->type->params->get('properties.item_title')): ?>
		<h1 class="title">
			<?php echo $this->escape($this->appParams->get('page_heading')); ?>
		</h1>
	<?php endif; ?>
	<?php if($params->get('tmpl_core.item_title')):?>
		<h1 class="componentheading">
			<?php echo $item->title;?>
			<?php echo CEventsHelper::showNum('record', $item->id);?>
		</h1>
	<?php endif;?>
	
	<dl class="article-info">
		<?php if($params->get('tmpl_core.item_author_avatar')):?>
			<dt class="avatar-box">
			<img src="<?php echo CCommunityHelper::getAvatar($item->user_id, $params->get('tmpl_core.item_author_avatar_width', 70), $params->get('tmpl_core.item_author_avatar_height', 70));?>" />
			</dt>
		<?php endif;?>
		<?php if($category):?>
			<dd class="category-name">
				<?php echo implode(' | ', $category);?>
			</dd>
		<?php endif;?>
		<?php if($author):?>
			<dd class="published">
				<?php echo implode(', ', $author);?>
			</dd>
		<?php endif;?>
		<?php if($details):?>
			<dd class="hits">
				<?php echo implode(', ', $details);?>
			</dd>
		<?php endif;?>
	</dl>

	<?php if($this->item->rating && $params->get('tmpl_core.item_rating')):?>
		<?php echo $this->item->rating;?>
	<?php endif;?>

	<?php if(isset($this->item->fields_by_groups[null])):?>
		<?php foreach ($this->item->fields_by_groups[null] as $field_id => $field):?>
			<div class="formelm <?php echo 'field-'.$field_id; ?>">
				<?php if($field->params->get('core.show_lable') > 1):?>
					<label id="<?php echo $field->id;?>-lbl" for="field_<?php echo $field->id;?>" class="<?php echo $field->class;?>" >
						<?php if($field->params->get('core.icon')):?>
							<img alt="<?php strip_tags($field->label)?>" src="<?php JURI::root()?>media/mint/icons/16/<?php echo $field->params->get('core.icon');?>" align="absmiddle">
						<?php endif;?>
						<?php echo $field->label; ?>
					</label>
					<?php if($field->params->get('core.label_break') > 1):?>
						<div style="clear: both;"></div>
					<?php endif;?>
				<?php endif;?>
				<div class="input-field<?php echo ($field->params->get('core.label_break') > 1 ? '-full' : NULL)?>">	
					<?php echo $field->result; ?>
				</div>
			</div>
		<?php endforeach;?>
		<?php unset($this->item->fields_by_groups[null]);?>
	<?php endif;?>
	
	<?php if(isset($this->item->fields_by_groups)):?>
		<?php foreach ($this->item->fields_by_groups as $group_name => $fields) :?>
			<?php $started = true;?>
			<?php group_start($this, $group_name, 'group'.@$i++);?>
			<?php foreach ($fields as $field_id => $field):?>
				<div class="formelm <?php echo 'field-'.$field_id; ?>">
					<?php if($field->params->get('core.show_lable') > 1):?>
					
						<label id="<?php echo $field->id;?>-lbl" for="field_<?php echo $field->id;?>" class="<?php echo $field->class;?>" >
							<?php if($field->params->get('core.icon')):?>
								<img alt="<?php strip_tags($field->label)?>" src="<?php JURI::root()?>media/mint/icons/16/<?php echo $field->params->get('core.icon');?>" align="absmiddle">
							<?php endif;?>
							<?php echo $field->label; ?>
						</label>
						<?php if($field->params->get('core.label_break') > 1):?>
							<div style="clear: both;"></div>
						<?php endif;?>
					<?php endif;?>
					<div class="input-field<?php echo ($field->params->get('core.label_break') > 1 ? '-full' : NULL)?>">
						<?php echo $field->result; ?>
					</div>
				</div>
			<?php endforeach;?>
			<?php group_end($this);?>
		<?php endforeach;?>
	<?php endif;?>
	
	<?php if($started):?>
		<?php total_end($this);?>
	<?php endif;?>

	<?php if($params->get('tmpl_core.item_mtime')):?>
		<br />
		<br />
		<p class="published">
			<?php echo JText::_('CMTIME')?>: <?php echo $item->mtime->format($params->get('tmpl_core.item_time_format'));?>
		</p>
	<?php endif;?>
	<?php if($params->get('tmpl_core.item_extime') && $item->extime):?>
		<p class="published"><?php echo JText::_('CEXTIME')?>: <?php echo $item->extime->format($params->get('tmpl_core.item_time_format'));?></p>
	<?php endif;?>
	
	<?php echo $this->loadTemplate('tags');?>
</article>

<script type="text/javascript"><!--
	$$(".mermoomenu").each(function(elm){
		elm.addClass("horizontal");
		elm.MooDropMenu({
			onOpen: function(el){
				el.fade('in')
			},
			onClose: function(el){
				el.fade('out');
			},
			onInitialize: function(el){
				el.fade('hide').set('tween', {duration:500});
			}
		});
	});
	
--></script>






































<?php 
function group_start($data, $label, $name)
{
	static $start = false;
	switch ($data->tmpl_params['record']->get('tmpl_params.item_grouping_type', 0))
	{
		//tab
		case 1:
			if(!$start)
			{
				echo JHtml::_('tabs.start','type-sliders', array('useCookie'=>1));
				$start = TRUE;
			}
			echo JHtml::_('tabs.panel', $label, $name);
			break;
		//slider
		case 2:
			if(!$start)
			{
				echo JHtml::_('sliders.start','type-sliders', array('useCookie'=>1));
				$start = TRUE;
			}
			echo JHtml::_('sliders.panel', $label, $name);
			break;
		// fieldset	
		case 3:
			echo "<fieldset><legend>{$label}</legend>";
			break;
		//page	
		case 4:
			break;
		case 5:
			echo "<h2 class=\"contentheading\">{$label}</h2><div class=\"group_panel\">";
			break;
		case 6:
			$plugin = JPluginHelper::getPlugin('system', 'tabber');
			$params = new JRegistry($plugin->params);
			echo "{".$params->get('tag_open', 'tab')."=$label}";
			break;
		case 7:
			$plugin = JPluginHelper::getPlugin('system', 'slider');
			$params = new JRegistry($plugin->params);
			echo "{".$params->get('tag_open', 'slide')."={$label}}";
			break;
		
	}
}

function group_end($data)
{
	switch ($data->tmpl_params['record']->get('tmpl_params.item_grouping_type', 0))
	{
		// fieldset	
		case 3:
			echo '</fieldset>';
			break;
		//page	
		case 4:
			break;
		case 5:
			echo '</div>';
			break;
	}
}

function total_end($data)
{
	switch ($data->tmpl_params['record']->get('tmpl_params.item_grouping_type', 0))
	{
		//tab
		case 1:
			echo JHtml::_('tabs.end');
			break;
		//slider
		case 2:
			echo JHtml::_('sliders.end');
			break;
		
		case 6:
			$plugin = JPluginHelper::getPlugin('system', 'tabber');
			$params = new JRegistry($plugin->params);
			echo "{/".$params->get('tag_close', 'tabs')."}";
			break;
				//nonumber slider
		case 7:
			$plugin = JPluginHelper::getPlugin('system', 'slider');
			$params = new JRegistry($plugin->params);
			echo "{/".$params->get('tag_close', 'slides')."}";
			break;
	}
}
?>