<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license   GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();

jimport('joomla.application.component.view');
JHtml::addIncludePath(JPATH_COMPONENT . DS . 'library' . DS . 'php');

class CobaltViewRecord extends JView
{

	function display($tpl = NULL)
	{
		$doc  = JFactory::getDocument();
		$user = JFactory::getUser();

		$tmpl_params = array();
		$category    = NULL;

		$item    = $this->get('Item');
		$model   = $this->getModel();
		$section = ItemsStore::getSection($item->section_id);

		if(!$this->_checkItemAccess($item, $section))
		{
			return;
		}

		$type = ItemsStore::getType($item->type_id);

		if($type->published == 0)
		{
			JError::raise(E_WARNING, 403, JText::_('CMSG_TYPEUNPUB'));

			return;
		}

		if($section->published == 0)
		{
			JError::raise(E_WARNING, 403, JText::_('CERR_SECTIONUNPUB'));

			return;
		}

		if(!$section->params->get('general.status', 1))
		{
			JError::raise(E_WARNING, 403, JText::_($section->params->get('general.status_msg')));

			return;
		}

		if(!in_array($section->access, $user->getAuthorisedViewLevels()))
		{
			JError::raise(E_WARNING, 403, $section->params->get('CERR_NOPAGEACCESS'));

			return;
		}

		// if(!$this->_checkCategoryAccess($item))
		// {
		// return FALSE;
		// }

		if(!CEmeraldHelper::allowType('display', $type, $item->user_id, $section))
		{
			JError::raise(E_WARNING, 403, JText::_($type->params->get('emerald.type_display_subscription_msg')));

			return FALSE;
		}
		CEmeraldHelper::countLimit('type', 'display', $type, $item->user_id);
		CEmeraldHelper::allowType('view', $type, $user->id, $section, TRUE);
		CEmeraldHelper::countLimit('type', 'view', $type, $user->id);

		$doc->addScript(JURI::root() . 'media/mint/js/mediabox/mediaboxAdv.js');
		$doc->addStyleSheet(JURI::root() . 'media/mint/js/mediabox/mediaboxAdv-Dark.css');

		if($type->params->get('comments.comments') == 2 && !$type->params->get('comments.comment_custom_js'))
		{
			JError::raise(E_NOTICE, 100, JText::_('CMSGCUSTOMJSCODE'));
		}

		RatingHelp::loadRecord();

		$file = JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'views' . DS . 'record' . DS . 'tmpl' . DS . 'default_record_' . $type->params->get('properties.tmpl_article', 'default') . '.json';
		if(JFile::exists($file))
		{
			$file = JFile::read($file);
		}
		else
		{
			$file = array();
			JError::raiseNotice(404, JText::_('CPLSEDITTEMPLATE_R'));
		}
		$params                      = new JRegistry($file);
		$this->tmpl_params['record'] = $params;

		$file = JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'views' . DS . 'record' . DS . 'tmpl' . DS . 'default_record_' . $type->params->get('properties.tmpl_article', 'default') . '.css';
		if(JFile::exists($file))
		{
			$doc->addStyleSheet(JURI::root() . 'components/com_cobalt/views/record/tmpl/default_record_' . $type->params->get('properties.tmpl_article', 'default') . '.css');
		}

		$item                    = $model->_prepareItem($item, 'full');
		$this->fields_keys_by_id = JModel::getInstance('Records', 'CobaltModel')->getKeys($section);

		if($type->params->get('comments.comments') == 1)
		{
			$file = JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'views' . DS . 'record' . DS . 'tmpl' . DS . 'default_comments_' . $type->params->get('properties.tmpl_comment', 'default') . '.css';
			if(JFile::exists($file))
			{
				$doc->addStyleSheet(JURI::root() . 'components/com_cobalt/views/record/tmpl/default_comments_' . $type->params->get('properties.tmpl_comment', 'default') . '.css');
			}
			$comment_model      = JModelAdmin::getInstance('Comment', 'CobaltModel');
			$this->comment_form = $comment_model->getForm(array(), FALSE);

			$file = JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'views' . DS . 'record' . DS . 'tmpl' . DS . 'default_comments_' . $type->params->get('properties.tmpl_comment', 'default') . '.json';
			if(JFile::exists($file))
			{
				$file = JFile::read($file);
			}
			else
			{
				$file = array();
				JError::raiseNotice(404, JText::_('CPLSEDITTEMPLATE_COM'));
			}
			$params                       = new JRegistry($file);
			$this->tmpl_params['comment'] = $params;

			// GET COMMENTS
			$app = JFactory::getApplication();

			$old_limit = $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'uint');

			JRequest::setVar('limit', $this->tmpl_params['comment']->get('tmpl_core.comments_pagination', $app->getCfg('list_limit')));
			$model_comments = JModel::getInstance('Comments', 'CobaltModel');
			$model_comments->setState('record.type', $type);
			$model_comments->setState('record.item', $item);
			$model_comments->setState('record.id', $item->id);

			$this->comments            = $model_comments->getItems();
			$this->comments_pagination = $model_comments->getPagination();

			$app->setUserState('global.list.limit', $old_limit);

			if($type->params->get('comments.comments_rss', 1))
			{
				$link    = Url::record($item, $type, $section) . '&format=feed&limitstart=';
				$attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0');
				$this->document->addHeadLink(JRoute::_($link . '&type=rss'), 'alternate', 'rel', $attribs);
				$attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0');
				$this->document->addHeadLink(JRoute::_($link . '&type=atom'), 'alternate', 'rel', $attribs);
			}
		}

		$cat_model = JModel::getInstance('Category', 'CobaltModel');
		$cat_id    = JRequest::getInt('cat_id', @$item->category_id);
		$category  = $cat_model->getEmpty();
		if($cat_id)
		{
			$category = $cat_model->getItem($cat_id);
		}

		$this->user     = $user;
		$this->item     = $item;
		$this->type     = $type;
		$this->section  = $section;
		$this->category = $category;
		$this->print    = JRequest::getBool('print', FALSE);

		$model->hit($item->id, $section->id);

		$this->_prepareDocument();

		parent::display($tpl);

		CEventsHelper::cleanRecord($item->id);
	}

	private function _checkCategoryAccess($item)
	{
		if(!$item->categories)
		{
			return TRUE;
		}

		$cat_model = JModel::getInstance('Category', 'CobaltModel');
		$user      = JFactory::getUser();

		$categories = json_decode($item->categories, TRUE);
		settype($categories, 'array');

		$category_access = TRUE;
		foreach($categories as $id => $title)
		{
			$category = $cat_model->getItem($id);
			if($category->published == 0)
			{
				unset($categories[$id]);
			}
			elseif(!in_array($category->access, $user->getAuthorisedViewLevels()))
			{
				unset($categories[$id]);
			}
		}

		if(!count($categories) && count(json_decode($item->categories, TRUE)))
		{
			if($item->user_id != $user->get('id'))
			{
				JError::raise(E_WARNING, 403, 'CWARNING_NO_ACCESS');

				return FALSE;
			}
			else
			{
				JError::raise(E_NOTICE, 100, 'CNOTICE_THIS_RECORD_INVISIBLE_IN_UNPUBLISHED_CATEGORY');
			}
		}

		return TRUE;

	}

	private function _checkItemAccess($item, $section)
	{
		$user  = JFactory::getUser();
		$error = TRUE;

		if(!in_array($item->access, $user->getAuthorisedViewLevels()) && !MECAccess::allowRestricted($user, $section) && !($user->get('id') == $item->user_id && $item->user_id))
		{
			JError::raise(E_WARNING, 403, JText::_('CWARNING_NO_ACCESS_ARTICLE'));
			$error = FALSE;
		}

		if($item->hidden == 1)
		{
			if($user->get('id') != $item->user_id)
			{
				JError::raise(E_WARNING, 401, JText::_('CWARNING_RECORD_HIDDEN_BY_AUTHOR'));
				$error = FALSE;
			}
			else
			{
				JError::raise(E_NOTICE, 409, JText::_('CWARNING_RECORD_HIDDEN_BY_YOU'));
			}
		}

		if($item->published == 0)
		{
			JError::raise(E_WARNING, 403, JText::_('CWARNING_RECORD_UNPUBLISHED'));
			$error = FALSE;
		}

		$ctreated = JFactory::getDate($item->ctime)->toUnix();
		$expire   = JFactory::getDate($item->extime)->toUnix();
		$now      = JFactory::getDate()->toUnix();

		if(($now > $expire && ($item->extime != '0000-00-00 00:00:00')) && !MECAccess::allowRestricted($user, $section) && !in_array($section->params->get('general.show_future_records'), $user->getAuthorisedViewLevels()))
		{
			echo JText::_('CWARNING_RECORD_EXPIRED');
			$error = FALSE;
		}

		if($now < $ctreated && !MECAccess::allowRestricted($user, $section) && !in_array($section->params->get('general.show_past_records'), $user->getAuthorisedViewLevels()))
		{
			echo JText::_('CWARNING_RECORD_NOT_YET_PUBLISHED');
			$error = FALSE;
		}

		return $error;
	}

	protected function _prepareDocument()
	{
		$app             = JFactory::getApplication();
		$menus           = $app->getMenu();
		$pathway         = $app->getPathway();
		$title           = NULL;
		$meta            = array();
		$this->appParams = $app->getParams();
		// Because the application sets a default page title,
		// we need to get it from the menu item itself
		$menu = $menus->getActive();
		if($menu)
		{
			$title = $menu->params->get('page_title', $menu->title);
			$this->appParams->def('page_heading', $title);
		}

		if($this->item->title)
		{
			$title = $this->item->title;
		}
		$path = array(array('title' => $this->item->title, 'link' => ''));

		if($this->section->params->get('personalize.personalize', 0))
		{
			if($this->item->ucatid)
			{
				$path[] = array(
					'title' => $this->item->ucatname,
					'link'  => Url::usercategory_records($this->item->user_id, $this->section, $this->item->ucatid)
				);
				$title .= ' - ' . $this->item->ucatname;
			}

			$user   = JFactory::getUser($this->item->user_id);
			$name   = $user->get($this->section->params->get('personalize.author_mode'), JText::_('CGUEST'));
			$path[] = array(
				'title' => $name, 'link' => Url::usercategory_records($this->item->user_id, $this->section)
			);

			$title .= ' - ' . $name;

			$meta['author'] = $user->get('name');
		}
		else
		{
			if($this->category->id)
			{
				$path[] = array(
					'title' => $this->category->title,
					'link'  => JRoute::_(Url::records($this->section, $this->category))
				);
				$title .= ' - ' . $this->category->title;
			}
		}
		if(!JRequest::getInt('Itemid', FALSE))
		{
			$path[] = array('title' => $this->section->name, 'link' => JRoute::_(Url::records($this->section)));
		}
		$path = array_reverse($path);
		foreach($path as $item)
		{
			$pathway->addItem($item['title'], $item['link']);
		}

		$title .= ' - ' . $this->section->name;

		// Check for empty title and add site name if param is set
		if(empty($title))
		{
			$title = $app->getCfg('sitename');
		}
		elseif($app->getCfg('sitename_pagetitles', 0) == 1)
		{
			$title = JText::sprintf('JPAGETITLE', $app->getCfg('sitename'), $title);
		}
		elseif($app->getCfg('sitename_pagetitles', 0) == 2)
		{
			$title = JText::sprintf('JPAGETITLE', $title, $app->getCfg('sitename'));
		}
		if(empty($title))
		{
			$title = $this->item->title;
		}
		$this->document->setTitle($title);

		// META Section
		$meta                = array();
		$meta['description'] = $this->section->params->get('more.metadesc');
		$meta['keywords']    = $this->section->params->get('more.metakey');
		$meta['author']      = $this->section->params->get('more.author');
		$meta['robots']      = $this->section->params->get('more.robots');

		MetaHelper::setMeta($meta);

		// META Category
		if($this->category->id)
		{
			$meta                = array();
			$meta['description'] = $this->category->params->get('metadesc');
			$meta['keywords']    = $this->category->params->get('metakey');
			$meta['author']      = $this->category->params->get('metadata.author');
			$meta['robots']      = $this->category->params->get('metadata.robots');

			MetaHelper::setMeta($meta);
		}

		// META User Category
		if($this->item->ucatid)
		{
			$meta                = array();
			$user_category       = ItemsStore::getUserCategory($this->item->ucatid);
			$meta['description'] = $user_category->params->get('meta_descr');
			$meta['keywords']    = $user_category->params->get('meta_key');

			MetaHelper::setMeta($meta);
		}

		// META Type
		MetaHelper::setMeta(array('robots' => $this->type->params->get('submission.robots')));

		// META Record
		$meta = array();

		if($this->item->meta_descr)
		{
			$meta['description'] = $this->item->meta_descr;
		}
		elseif(!$this->item->meta_descr && $this->appParams->get('menu-meta_description'))
		{
			$meta['description'] = $this->appParams->get('menu-meta_description');
		}

		if($this->item->meta_key)
		{
			$meta['keywords'] = $this->item->meta_key;
		}
		elseif(!$this->item->meta_key && $this->appParams->get('menu-meta_keywords'))
		{
			$meta['keywords'] = $this->appParams->get('menu-meta_keywords');
		}

		$meta['robots'] = $this->item->meta_index;

		if($this->print)
		{
			$meta['robots'] = 'noindex, nofollow';
		}

		MetaHelper::setMeta($meta);

		// If there is a pagebreak heading or title, add it to the page title
		if(!empty($this->item->page_title))
		{
			$this->item->title = $this->item->title . ' - ' . $this->item->page_title;
			$this->document->setTitle($this->item->page_title . ' - ' . JText::sprintf('PLG_CONTENT_PAGEBREAK_PAGE_NUM', $this->state->get('list.offset') + 1));
		}

	}
}

?>