<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die('Restricted access');
if(!class_exists('CarticleHelperBlog'))
{
	class CarticleHelperBlog
	{
		var $k = 0;
		public function isnext($obj)
		{
			return (isset($obj->items[$this->k]));
		}
		public function display(&$obj)
		{
			if(empty($obj->items[$this->k]))
			{
				return;
			}
			$params = $obj->tmpl_params['list'];
			$item = $obj->items[$this->k];
			unset($obj->items[$this->k++]);
			ob_start();
			$bookmark = HTMLFormatHelper::bookmark($item, $obj->submission_types[$item->type_id], $params);
			$follow = HTMLFormatHelper::follow($item, $obj->section);
			?>
			<h2>
				<?php if($item->controls):?>
					<div class="menu-container">
						<ul class="mermoomenu">
							<li>
								<img alt="<?php echo JText::_('COPTIONS')?>" src="<?php echo JURI::root()?>media/mint/icons/16/gear.png">
								<ul style="visibility: hidden;"><li><?php echo implode('</li><li>', $item->controls);?></li></ul>
							</li>
						</ul>
					</div>
				<?php endif;?>
				<?php if($params->get('tmpl_core.item_title')):?>
					<?php if($params->get('tmpl_core.item_link')):?>
					<a <?php echo $item->nofollow ? 'rel="nofollow"' : '';?> href="<?php echo JRoute::_($item->url);?>">
						<?php echo $item->title?>
					</a>
					<?php else :?>
						<?php echo $item->title?>
					<?php endif;?>
				<?php endif;?>
				<?php echo CEventsHelper::showNum('record', $item->id);?>
			</h2>

			<?php if($bookmark || $follow):?>
				<ul class="actions">
					<?php if($bookmark):?>
						<li><?php echo $bookmark?></li>
					<?php endif;?>
					<?php if($follow):?>
						<li><?php echo $follow?></li>
					<?php endif;?>
				</ul>
			<?php endif;?>

			<?php if($params->get('tmpl_core.item_rating')):?>
				<span class="content_rating">
					<?php echo $item->rating;?>
				</span>
			<?php endif;?>
			<?php
			$category = array();
			$author = array();
			$details = array();

			if($params->get('tmpl_core.item_categories') && $item->categories_links)
			{
				$category[] = sprintf('%s: %s', (count($item->categories_links) > 1 ? JText::_('CCATEGORIES') : JText::_('CCATEGORY')), implode(', ', $item->categories_links));
			}
			if($params->get('tmpl_core.item_user_categories') && $item->ucatid)
			{
				$category[] = sprintf('%s: %s', JText::_('CUSERCAT'), $item->ucatname_link);
			}
			if($params->get('tmpl_core.item_author') && $item->user_id)
			{
				$author[] = JText::sprintf('CWRITTENBY', CCommunityHelper::getName($item->user_id, $obj->section));
			}
			if($params->get('tmpl_core.item_author_filter'))
			{
				$author[] = FilterHelper::filterButton('filter_user', $item->user_id, NULL, JText::sprintf('CSHOWALLUSERREC', CCommunityHelper::getName($item->user_id, $obj->section, TRUE)), $obj->section);
			}
			if($params->get('tmpl_core.item_ctime'))
			{
				$author[] = JText::sprintf('CONDATE', $item->ctime->toFormat($params->get('tmpl_core.item_time_format')));
			}

			if($params->get('tmpl_core.item_mtime'))
			{
				$author[] = sprintf('%s: %s', JText::_('CCHANGEON'), $item->mtime->toFormat($params->get('tmpl_core.item_time_format')));
			}

			if($params->get('tmpl_core.item_extime'))
			{
				$author[] = sprintf('%s: %s', JText::_('CEXPIREON'), $item->extime ? $item->extime->toFormat($params->get('tmpl_core.item_time_format')) : JText::_('CNEVER'));
			}

			if($params->get('tmpl_core.item_type'))
			{
				$details[] = sprintf('%s: %s %s', JText::_('CTYPE'), $item->type_name, ($params->get('tmpl_core.item_type_filter') ? FilterHelper::filterButton('filter_type', $item->type_id, NULL, JText::sprintf('CSHOWALLTYPEREC', $item->type_name), $obj->section) : NULL));
			}
			if($params->get('tmpl_core.item_hits'))
			{
				$details[] = sprintf('%s: %s', JText::_('CHITS'), $item->hits);
			}
			if($params->get('tmpl_core.item_comments_num'))
			{
				$details[] = sprintf('%s: %s', JText::_('CCOMMENTS'), $item->comments);
			}
			if($params->get('tmpl_core.item_vote_num'))
			{
				$details[] = sprintf('%s: %s', JText::_('CVOTES'), $item->votes);
			}
			if($params->get('tmpl_core.item_favorite_num'))
			{
				$details[] = sprintf('%s: %s', JText::_('CFAVORITED'), $item->favorite_num);
			}
			if($params->get('tmpl_core.item_follow_num'))
			{
				$details[] = sprintf('%s: %s', JText::_('CFOLLOWERS'), $item->subscriptions_num);
			}
			?>

			<?php if($category || $author || $details): ?>
				<dl class="article-info">
					<?php if($params->get('tmpl_core.item_author_avatar')):?>
						<dt class="avatar-box">
						<img src="<?php echo CCommunityHelper::getAvatar($item->user_id, $params->get('tmpl_core.item_author_avatar_width', 40), $params->get('tmpl_core.item_author_avatar_height', 40));?>" />
						</dt>
					<?php endif;?>
					<?php if($category):?>
						<dd class="category-name">
							<?php echo implode(' | ', $category);?>
						</dd>
					<?php endif;?>
					<?php if($author):?>
						<dd class="published">
							<?php echo implode(', ', $author);?>
						</dd>
					<?php endif;?>
					<?php if($details):?>
						<dd class="hits">
							<?php echo implode(', ', $details);?>
						</dd>
					<?php endif;?>
				</dl>
			<?php endif;?>

			<?php $ll =  array(); foreach ($item->fields_by_id AS $field):?>
				<?php $style = ($field->params->get('core.icon') ? ' style="list-style-image: url(\''.JURI::root().'media/mint/icons/16/'.$field->params->get('core.icon').'\')"' : NULL);?>
				<?php $ll[] = '<li'.$style.' class="'.$field->params->get('core.field_class').'">'.@$field->result.'</li>'; ?>
			<?php endforeach;?>

			<?php if($ll):?>
				<ul class="fields-list"><?php echo implode("\n", $ll);?></ul>
			<?php endif;?>
			<div class="item-separator"></div>
		<?php
			$out = ob_get_contents();
			ob_end_clean();
			return $out;
		}
	}
} ?>

<?php
$k = 0;
$params = $this->tmpl_params['list'];
$leading = $params->get('tmpl_params.leading', 1);
$cols = $params->get('tmpl_params.blog_cols', 2);
$intro = $params->get('tmpl_params.blog_intro', 6);
$links = $params->get('tmpl_params.blog_links', 5);
$l = 0;
$rows = $cols ? ceil($intro / $cols) : 0;
if($rows <= 0) $rows = 0;

$helper = new CarticleHelperBlog();
$helper->k = 0;
?>
<?php if($params->get('tmpl_params.show_title_index')):?>
	<h2><?php echo JText::_('CONTHISPAGE')?></h2>
	<ul>
		<?php foreach ($this->items AS $item):?>
			<li><a href="#record<?php echo $item->id?>"><?php echo $item->title?></a></li>
		<?php endforeach;?>
	</ul>
<?php endif;?>

<div class="blog">
	<?php if($leading && $helper->isnext($this)):?>
		<div class="items-leading">
			<?php for($i = 0; $i < $leading; $i++):?>
				<?php $item = $helper->display($this);?>
				<?php if($item):?>
					<div class="leading-<?php echo $i;?>">
						<?php echo $item;?>
					</div>
				<?php endif;?>
			<?php endfor;?>
		</div>
	<?php endif;?>
	<?php if($intro && $helper->isnext($this)):?>
		<?php for($r = 0; $r < $rows; $r++):?>
			<div class="items-row cols-<?php echo $cols;?> row-<?php echo $r;?>">
				<?php for($c = 0; $c < $cols; $c++):?>
					<?php $item = $helper->display($this);?>
					<?php if($item):?>
						<div class="item column-<?php echo $c + 1;?>">
							<?php echo $item;?>
						</div>
					<?php endif;?>
				<?php endfor;?>
				<span class="row-separator"></span>
			</div>
		<?php endfor;?>
	<?php endif;?>
	<?php if($links && $helper->isnext($this)):?>
	<div class="items-more">
		<h3>More Articles...</h3>
		<ol>
			<?php foreach ($this->items AS $item):?>
				<li>
					<?php if($item->controls):?>
						<div class="menu-container">
							<ul class="mermoomenu">
								<li>
									<img alt="<?php echo JText::_('COPTIONS')?>" src="<?php echo JURI::root()?>media/mint/icons/16/gear.png">
									<ul style="visibility: hidden;"><li><?php echo implode('</li><li>', $item->controls);?></li></ul>
								</li>
							</ul>
						</div>
					<?php endif;?>
					<?php echo HTMLFormatHelper::bookmark($item, $this->submission_types[$item->type_id], $params);?>
					<?php echo HTMLFormatHelper::follow($item, $this->section);?>
					<a <?php echo $item->nofollow ? 'rel="nofollow"' : '';?> href="<?php echo JRoute::_($item->url);?>">
						<?php echo $item->title;?>
					</a>
					<?php echo CEventsHelper::showNum('record', $item->id);?>
				</li>
			<?php endforeach;?>
		</ol>
	</div>
	<?php endif;?>
</div>

<script type="text/javascript"><!--
	$$(".menu-container").each(function(el){
		el.getElements('ul').each(function(mnu){
			mnu.addClass("horizontal");
			mnu.MooDropMenu({
				openEvent: 'click',
				onOpen: function(el){
					el.fade('in')
				},
				onClose: function(el){
					el.fade('out');
				},
				onInitialize: function(el){
					el.fade('hide').set('tween', {duration:500});
				}
			});
		});
	});

--></script>