<?php
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport('joomla.application.component.view');

class CobaltViewRecords extends JView
{

	function display($tpl = null)
	{
		//var_dump(array_shift($a = array(1,2,3)));

		$app = JFactory::getApplication();
		$doc = JFactory::getDocument();
		$user = JFactory::getUser();
		$this->model = $this->getModel();
		$menus = $app->getMenu();

		$tmpl_params = array();
		$category = NULL;

		$this->models['category'] = JModel::getInstance('Category', 'CobaltModel');
		$this->models['categories'] = JModel::getInstance('Categories', 'CobaltModel');
		$this->models['section'] = JModel::getInstance('Section', 'CobaltModel');
		$this->models['record'] = JModel::getInstance('Record', 'CobaltModel');

		if(! JRequest::getInt('section_id'))
		{
			JError::raiseWarning(404, JText::_('CNOSECTION'));
			return;
		}

		// ----- GET SECTION ------
		$section = $this->models['section']->getItem(JRequest::getInt('section_id'));

		if($section->published == 0)
		{
			JError::raise(E_WARNING, 403, JText::_('CERR_SECTIONUNPUB'));
			return;
		}
		if(! $section->params->get('general.status', 1))
		{
			JError::raise(E_WARNING, 403, JText::_($section->params->get('general.status_msg')));
			return;
		}
		if(! in_array($section->access, $user->getAuthorisedViewLevels()))
		{
			JError::raise(E_WARNING, 403, JText::_('CERR_NOPAGEACCESS'));
			return;
		}

		if(JRequest::getVar('view_what') == 'created' && !JRequest::getInt('user_id') && $user->get('id'))
		{
			$app->redirect(JRoute::_(Url::user('created', $user->get('id')), FALSE));
		}

		// --- GET CATEGORY ----
		$category = $this->models['category']->getEmpty();
		if(JRequest::getInt('cat_id'))
		{
			$category = $this->models['category']->getItem(JRequest::getInt('cat_id'));

			if($category->params->get('orderby') !== NULL)
			{
				$section->params->set('general.orderby', $category->params->get('orderby'));
			}
			if(NULL !== ($r = $category->params->get('records_mode')))
			{
				$section->params->set('general.records_mode', $r);
			}
			if($category->params->get('featured_first') !== NULL)
			{
				$section->params->set('general.featured_first', $category->params->get('featured_first'));
			}
			if(NULL !== $category->params->get('tmpl_markup'))
			{
				$section->params->set('general.tmpl_markup', $category->params->get('tmpl_markup'));
			}
			if(NULL !== $category->params->get('tmpl_filters'))
			{
				$section->params->set('general.tmpl_filters', $category->params->get('tmpl_filters'));
			}
			if(NULL !== $category->params->get('tmpl_category'))
			{
				$section->params->set('general.tmpl_category', $category->params->get('tmpl_category'));
			}
			if(NULL !== $category->params->get('tmpl_menu'))
			{
				$section->params->set('general.tmpl_menu', $category->params->get('tmpl_menu'));
			}
			if(NULL !== $category->params->get('tmpl_compare'))
			{
				$section->params->set('general.tmpl_compare', $category->params->get('tmpl_compare'));
			}

			if(! isset($category->id))
			{
				JError::raiseNotice(404, JText::_('CCATNOTFOUND'));
				$category = $this->models['category']->getEmpty();
			}
			if($category->id && ($category->section_id != $section->id))
			{
				JError::raiseNotice(403, JText::_('CCATWRONGSECTION'));
				$category = $this->models['category']->getEmpty();
			}
			if(! in_array($category->access, $user->getAuthorisedViewLevels()))
			{
				JError::raise(E_WARNING, 403, JText::_('CWARNING_NO_ACCESS_CATEGORY'));
				return;
			}
		}

		$itemid = $category->params->get('category_itemid', $section->params->get('general.category_itemid'));
		if($itemid && (int)$itemid != JRequest::getInt('Itemid') && !JRequest::getInt('filter_archive', 0))
		{
			$app->redirect(JRoute::_(Url::records($section, ($category->id ? $category: null)), FALSE));
		}

		$this->section = $section;
		$this->model->section = $section;

		$this->category = $category;

		RatingHelp::loadRecord();

		$this->_setupTemplates();
		$this->_setupLimit($this->tmpl_params['list']);

		$items = $pagination = $worns = NULL;
		$state = $this->get('State');
		$items = $this->get('Items');
		$pagination = $this->get('Pagination');
		$worns = $this->get('Worns');

		foreach($items as &$item)
		{
			$item = $this->models['record']->_prepareItem($item, 'list');
		}
		$this->total_fields_keys = $this->_fieldsSummary($items);
		$this->sortable = CobaltModelRecord::$sortable;


		$field_orders = JFactory::getApplication()->getUserState("com_cobalt.records{$section->id}.ordering.vals{$section->id}");
		if(is_array($field_orders))
		{
			$this->ordering = implode('^', $field_orders);
		}
		else
		{
			$this->ordering = $state->get('list.ordering');
		}
		$this->ordering_dir = $state->get('list.direction');

		$this->worns = $worns;
		$this->items = $items;
		$this->pagination = $pagination;
		$this->total = $this->get('Total');
		$this->state = $state;
		$this->posthere = array();

		$this->submission_types = $this->model->getSubmissionTypes();
		$this->total_types = $this->model->getTypes();
		$this->fields_keys_by_id = $this->model->getKeys($section);

		$this->_prepareAlpha();
		$this->_prepareFilters();
		$this->_showCategoryIndex();
		$this->_personalize();

		$this->isMe = (int)($user->get('id') == JRequest::getInt('user_id'));

		$this->user = $user;
		$this->menu = $menus->getActive();

		$this->_prepareDocument();

		parent::display($tpl);
	}

	private function _personalize()
	{
		if(! ($this->section->params->get('personalize.personalize') && JRequest::getInt('user_id')))
		{
			return;
		}
		$this->user_categories = array();
		$this->user_category = NULL;
		if($this->section->params->get('personalize.pcat_submit'))
		{
			$this->user_categories = JModel::getInstance('Usercategories', 'CobaltModel')->getList(JRequest::getInt('user_id'), $this->section->id);
		}
		if(JRequest::getInt('ucat_id'))
		{
			$this->user_category = $this->user_categories[JRequest::getInt('ucat_id')];
		}
	}

	private function _showFilters()
	{
		$show = FALSE;

		if($this->worns)
		{
			$show = TRUE;
		}
		if($this->items)
		{
			$show = TRUE;
		}
		if($this->section->params->get('general.filter_mode') == 0)
		{
			$show = TRUE;
		}
		if($this->section->params->get('general.filter_mode') == 1 && isset($this->category->id))
		{
			$show = TRUE;
			if($this->section->params->get('general.records_mode') == 1 && ! $this->worns && ! $this->items)
			{
				$show = FALSE;
			}
		}

		$this->show_filters = $show;
		return $show;
	}

	private function _showCategoryIndex()
	{
		$show = TRUE;

		if(! $this->section->params->get('general.tmpl_category'))
		{
			$show = FALSE;
		}
		if($this->section->params->get('general.filter_mode') == 0 && $this->worns)
		{
			$show = FALSE;
		}
		if($this->section->params->get('personalize.personalize') && JRequest::getInt('user_id'))
		{
			$show = FALSE;
		}
		if(JRequest::getVar('view_what') && JRequest::getInt('user_id'))
		{
			$show = FALSE;
		}
		if($this->section->categories == 0)
		{
			$show = FALSE;
		}
		$this->show_category_index = $show;
		return $show;
	}

	private function _prepareHidden()
	{
		if(! $this->worns)
		{
			return null;
		}
		foreach($this->worns as $worn)
		{
			$out .= "<input type=\"hidden\" name=\"close[{$worn->name}\" id=\"{$worn->name}\" value=\"0\">";
		}

	}

	private function _prepareFilters()
	{
		$this->filters = array();

		if(! $this->_showFilters())
		{
			return;
		}
		if(! $this->tmpl_params['markup']->get('tmpl_core.filters'))
		{
			return;
		}
		JHtml::_('behavior.framework');
		$filters = $this->get('Filters');

		$this->filters = $filters;
	}

	private function _prepareAlpha()
	{
		$alpha_sets = $alpha_list = $alpha_totals = array();

		if($this->tmpl_params['markup']->get('tmpl_core.alpha') && $this->tmpl_params['markup']->get('tmpl_core.alpha_text'))
		{
			$alpha_sets = explode("|", $this->tmpl_params['markup']->get('tmpl_core.alpha_text'));
			ArrayHelper::clean_r($alpha_sets);
			ArrayHelper::trim_r($alpha_sets);
			foreach($alpha_sets as &$set)
			{
				$set = explode(' ', JString::strtoupper($set));
				ArrayHelper::clean_r($set);
				ArrayHelper::trim_r($set);
				sort($set);
				$alpha_list = array_merge($alpha_list, $set);
			}

			if($this->tmpl_params['markup']->get('tmpl_core.smart'))
			{
				$alpha_list = array();
				$al = $this->getModel()->getAlphas();
				// settype($al, 'array');
				foreach($al as $l)
				{
					$alpha_list[$l->letter] = $l->letter;
					@$alpha_totals[$l->letter] ++;
				}
			}

			$this->alpha = $alpha_sets;
			$this->alpha_list = $alpha_list;
			$this->alpha_totals = $alpha_totals;
		}
	}

	private function _prepareDocument()
	{
		$app = JFactory::getApplication();
		$doc = JFactory::getDocument();
		$menus = $app->getMenu();
		$menu = $menus->getActive();
		$this->appParams = $app->getParams();
		$pathway = $app->getPathway();
		$markup = $this->tmpl_params['markup'];

		$title = null;
		$t = $path = array();
		$vw = $user_id = $ucat_id = null;
		$user_id = JRequest::getVar('user_id');
		if(! is_null($user_id))
		{
			$user_id = (int)$user_id;
		}
		if($menu)
		{
			$title = $menu->params->get('page_title', $menu->title);
			$this->appParams->def('page_heading', $title);
		}

		if(count($this->worns))
		{
			$search_strings = array();
			foreach($this->worns as $w)
			{
				/*
				 * if(is_array($w->value)) { $u =
				 * JFactory::getUser($w->value[0]); $w->value =
				 * $u->get($this->section->params->get('personalize.author_mode'));
				 * }
				 */
				$search_strings[] = $w->label . ': ' . $w->text;
			}
			$t[] = JText::_('CSEARCHRESULT') . ' (' . implode(',', $search_strings) . ')';
		}
		if($vw = JRequest::getVar('view_what', false))
		{
			$t[] = JText::_('VW_' . strtoupper($vw));
		}

		if($user_id)
		{
			$t[] = CCommunityHelper::getName($user_id, $this->section, TRUE);
		}
		if($user_id === 0)
		{
			$t[] = JText::_('CGUEST');
		}
		if($ucat_id = JRequest::getInt('ucat_id', false))
		{
			$t[] = ItemsStore::getUserCategory($ucat_id)->name;
		}
		if($this->category->id)
		{
			$t[] = $this->category->title;
		}
		$t[] = $this->section->name;
		$head_title = implode(' - ', $t);

		if(empty($title))
		{
			$head_title = $app->getCfg('sitename');
		}
		elseif($app->getCfg('sitename_pagetitles', 0) == 1)
		{
			$head_title = JText::sprintf('JPAGETITLE', $app->getCfg('sitename'), $head_title);
		}
		elseif($app->getCfg('sitename_pagetitles', 0) == 2)
		{
			$head_title = JText::sprintf('JPAGETITLE', $head_title, $app->getCfg('sitename'));
		}

		$doc->setTitle($head_title);

		switch($markup->get('tmpl_core.title_show'))
		{
			case 1:
				$t = array();

				if($this->category->id)
				{
					$t[] = $this->category->title;
				}
				$t[] = $this->section->name;
				$title = implode(' - ', $t);

			break;

			case 3:
				$title = $markup->get('tmpl_core.title_static', 'This is static title in markup template parameters');
			break;
		}
		$this->title = $title;

		$url = JFactory::getURI();
		$url->delVar('filter_order');
		$url->delVar('filter_order_Dir');
		$this->action = $url->toString();

		if($user_id)
		{
			if($ucat_id)
			{
				$path[] = array('title' => ItemsStore::getUserCategory($ucat_id)->name, 'link' => '');
			}
			elseif($vw)
			{
				$path[] = array('title' => JText::_('VW_' . strtoupper($vw)), 'link' => '');
			}
			if($this->section->params->get('personalize.personalize'))
			{
				$path[] = array('title' => CCommunityHelper::getName($user_id, $this->section, TRUE), 'link' => Url::usercategory_records($user_id, $this->section));
			}
		}
		else
		{
			if($this->category->id)
			{
				if($this->category->parent_id == 1)
				{
					$path[] = array('title' => $this->category->title, 'link' => '');
				}
				else
				{
					$categories = $this->models['categories']->getParentsObjectsByChild($this->category->id);
					foreach ($categories as $cat) {
						array_unshift($path, array('title' => $cat->title, 'link' => Url::records($this->section, $cat)));
					}
				}
			}
		}

		if(! JRequest::getInt('Itemid', false))
		{
			$path[] = array('title' => $this->section->name, 'link' => JRoute::_(Url::records($this->section)));
		}
		$path = array_reverse($path);

		foreach($path as $item)
		{
			$pathway->addItem($item['title'], $item['link']);
		}

		$description = null;
		if($markup->get('tmpl_core.description_show') && ! $vw)
		{
			$description = $this->section->{'descr_' . $markup->get('tmpl_core.description_mode', 'full')};

			if(! empty($this->category->id))
			{
				$description = $this->category->{'descr_' . $markup->get('tmpl_core.description_mode', 'full')};
			}

			if($markup->get('tmpl_core.description_html') && $description)
			{
				$description = '<p>' . strip_tags($description) . '</p>';
			}
		}

		$this->description = $description;

		// META Section
		$meta = array();
		$meta['description'] = $this->section->params->get('more.metadesc');
		$meta['keywords'] = $this->section->params->get('more.metakey');
		$meta['author'] = $this->section->params->get('more.author');
		$meta['robots'] = $this->section->params->get('more.robots');

		MetaHelper::setMeta($meta);

		// META Category
		if($this->category->id)
		{
			$meta = array();
			$meta['description'] = $this->category->get('metadesc');
			$meta['keywords'] = $this->category->get('metakey');
			$meta['author'] = $this->category->get('metadata.author');
			$meta['robots'] = $this->category->get('metadata.robots');

			MetaHelper::setMeta($meta);
		}

		if($ucat_id = JRequest::getInt('ucat_id'))
		{
			$meta = array();
			$user_category = ItemsStore::getUserCategory($ucat_id);
			$meta['description'] = $user_category->params->get('meta_descr');
			$meta['keywords'] = $user_category->params->get('meta_key');

			MetaHelper::setMeta($meta);
		}

		if($this->section->params->get('more.feed_link', 1))
		{
			$link = Url::records($this->section, $this->category->id) . '&format=feed'; // &limitstart=
			$attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0');
			$doc->addHeadLink(JRoute::_($link . '&type=rss'), 'alternate', 'rel', $attribs);
		}
		if($this->section->params->get('more.feed_link2', 1))
		{
			$link = Url::records($this->section, $this->category->id) . '&format=feed'; // &limitstart=
			$attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0');
			$doc->addHeadLink(JRoute::_($link . '&type=atom'), 'alternate', 'rel', $attribs);
		}

	}

	public function _fieldsSummary($items)
	{
		$fields = $byid = $sort = array();
		foreach($items as $item)
		{
			foreach($item->fields_by_id as $field)
			{
				$key = $field->key;
				//$field->sortby = sprintf('%d.%d', $field->group_order, $field->ordering);
				$fields[$key] = $field;
				$sort[$key] = floatval(sprintf('%d.%d', $field->group_order, $field->ordering));
				$byid[$field->id] = $key;
			}
		}

		if($sort)
		{
			array_multisort($sort, SORT_ASC, SORT_NUMERIC, $fields);
		}

		return $fields;
	}

	private function _setupLimit($params)
	{
		//echo $app->getUserState('global.list.limit', 'limit');
		$app = JFactory::getApplication();
		$glob_def_limit = JFactory::getConfig()->get('list_limit', 20);

		// If we have blog template the limit have to be acording it's settings.
		$blog_limit  = $params->get('tmpl_params.leading', 0);
		$blog_limit += $params->get('tmpl_params.blog_intro', 0);
		$blog_limit += $params->get('tmpl_params.blog_links', 0);

		if($blog_limit)
		{
			$app->setUserState('global.list.limit', $blog_limit);
			// never anyoone can change limit number
			JRequest::setVar('limit', $blog_limit);
			return;
		}

		$key = sprintf('com_coblat.limit.%s_%d', $this->list_template, $this->section->id);
		$tmpl_default = $params->get('tmpl_core.item_limit_default', $glob_def_limit);

		$limit = $app->getUserStateFromRequest($key, 'limit', $tmpl_default);

		$app->setUserState('global.list.limit', $limit);
		JRequest::setVar('limit', $limit);
	}

	private function _setupTemplates()
	{
		$doc = JFactory::getDocument();
		$app = JFactory::getApplication();
		$sess = JFactory::getSession();
		$dir = JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'views' . DS . 'records' . DS . 'tmpl' . DS;

		if($this->section->params->get('general.tmpl_category'))
		{
			$file = $dir . 'default_cindex_' . $this->section->params->get('general.tmpl_category', 'default') . '.json';
			if(JFile::exists($file))
			{
				$file = JFile::read($file);
			}
			else
			{
				$file = array();
				JError::raiseNotice(404, JText::_('CPLSEDITTEMPLATE_CI'));
			}
			$tparams = new JRegistry($file);
			$tmpl_params['cindex'] = $tparams;

			$file = $dir . 'default_cindex_' . $this->section->params->get('general.tmpl_category', 'default') . '.css';
			if(JFile::exists($file))
			{
				$doc->addStyleSheet(JURI::root() . 'components/com_cobalt/views/records/tmpl/default_cindex_' . $this->section->params->get('general.tmpl_category', 'default') . '.css');
			}
		}

		// setup murckup template
		{
			$name = $this->section->params->get('general.tmpl_markup');
			$file = "{$dir}default_markup_{$name}.json";
			if(JFile::exists($file))
			{
				$file = JFile::read($file);
			}
			else
			{
				$file = array();
				JError::raiseNotice(404, JText::_('CPLSEDITTEMPLATE_MU'));
			}
			$mparams = new JRegistry($file);
			$tmpl_params['markup'] = $mparams;

			$file = "{$dir}default_markup_{$name}.css";
			if(JFile::exists($file))
			{
				$doc->addStyleSheet(JURI::root() . 'components/com_cobalt/views/records/tmpl/default_markup_' . $name . '.css');
			}

		}

		if($this->section->params->get('general.tmpl_menu'))
		{
			$name = $this->section->params->get('general.tmpl_menu');
			$file = "{$dir}default_menu_{$name}.json";
			if(JFile::exists($file))
			{
				$file = JFile::read($file);
			}
			else
			{
				$file = array();
				JError::raiseNotice(404, JText::_('CPLSEDITTEMPLATE_MENU'));
			}
			$tmparams = new JRegistry($file);
			$tmpl_params['menu'] = $tmparams;

			$file = "{$dir}default_menu_{$name}.css";
			if(JFile::exists($file))
			{
				$doc->addStyleSheet(JURI::root() . 'components/com_cobalt/views/records/tmpl/default_menu_' . $name . '.css');
			}

		}
		if($this->section->params->get('general.tmpl_filters'))
		{
			$name = $this->section->params->get('general.tmpl_filters');
			$file = "{$dir}default_filters_{$name}.json";
			if(JFile::exists($file))
			{
				$file = JFile::read($file);
			}
			else
			{
				$file = array();
				JError::raiseNotice(404, JText::_('CPLSEDITTEMPLATE_F'));
			}
			$tmparams = new JRegistry($file);
			$tmpl_params['filters'] = $tmparams;

			$file = "{$dir}default_filters_{$name}.css";
			if(JFile::exists($file))
			{
				$doc->addStyleSheet(JURI::root() . 'components/com_cobalt/views/records/tmpl/default_filters_' . $name . '.css');
			}

		}

		$list_templates = $this->section->params->get('general.tmpl_list', 'default');
		settype($list_templates, 'array');
		$this->list_templates = $this->_getTemplatesNames($list_templates);

		$key = $this->section->id;
		$t = $this->category->params->get('tmpl_list');
		ArrayHelper::clean_r($t);
		if($t)
		{
			$key .= '-' . $this->category->id;
			$list_templates = $t;
			$this->list_templates = $this->_getTemplatesNames($list_templates);
		}
		$name = JFactory::getApplication()->getUserState("com_cobalt.section{$key}.filter_tpl", $list_templates[0]);
		if(! JFile::exists("{$dir}default_list_{$name}.php"))
		{
			$name = 'default';
		}
		$file = "{$dir}default_list_{$name}.json";
		if(JFile::exists($file))
		{
			$file = JFile::read($file);
		}
		else
		{
			$file = array();
			JError::raiseNotice(404, JText::_('CPLSEDITTEMPLATE_LI'));
		}
		$tmpl_params['list'] = new JRegistry($file);

		$file = "{$dir}default_list_{$name}.css";
		if(JFile::exists($file))
		{
			$doc->addStyleSheet(JURI::root() . 'components/com_cobalt/views/records/tmpl/default_list_' . $name . '.css');
		}
		$file = "{$dir}default_list_{$name}.js";
		if(JFile::exists($file))
		{
			$doc->addScript(JURI::root() . 'components/com_cobalt/views/records/tmpl/default_list_' . $name . '.js');
		}

		$this->list_template = $name;
		$this->tmpl_params = $tmpl_params;
	}

	public function _dataShow(&$query)
	{
		$user = JFactory::getUser();
		if(! in_array($this->section->params->get('general.show_restrict'), $user->getAuthorisedViewLevels()))
		{
			$query->where("access IN(" . implode(',', $user->getAuthorisedViewLevels()) . ")");
		}
		if(! in_array($this->section->params->get('general.show_future_records'), $user->getAuthorisedViewLevels()))
		{
			$query->where("ctime < " . JFactory::getDbo()->quote(JFactory::getDate()->toSql()));
		}
		if(! in_array($this->section->params->get('general.show_past_records'), $user->getAuthorisedViewLevels()))
		{
			$query->where("(extime = '0000-00-00 00:00:00' OR extime > '" . JFactory::getDate()->toSql() . "')");
		}
	}

	public function _getUsermenuCounts($params, $user_id = NULL)
	{
		$db = JFactory::getDbo();
		$user = JFactory::getUser($user_id);
		$out = new stdClass();

		$out->created = 0;
		$out->favorited = 0;
		$out->rated = 0;
		$out->commented = 0;
		$out->visited = 0;
		$out->expired = 0;
		$out->hidden = 0;
		$out->featured = 0;
		$out->unpublished = 0;
		$out->categories = 0;
		$out->followed = 0;
		$out->events = 0;

		if(! $params->get('tmpl_core.menu_user_numbers'))
		{
			return $out;
		}

		include_once JPATH_ROOT.DS.'components'.DS.'com_cobalt'.DS.'library'.DS.'php'.DS.'helpers'.DS.'statistics.php';

		if($params->get('tmpl_core.menu_user_evented') && ! $user_id)
		{
			$out->events = CEventsHelper::getNum('section', JRequest::getInt('section_id'));
		}

		if($params->get('tmpl_core.menu_user_expire') && ! $user_id)
		{
			$out->expired = CStatistics::expired($user->id, JRequest::getInt('section_id'));
		}

		if($params->get('tmpl_core.menu_user_hidden') && ! $user_id)
		{
			$out->hidden = CStatistics::hidden($user->id, JRequest::getInt('section_id'));
		}

		if($params->get('tmpl_core.menu_user_feature') && ! $user_id)
		{
			$out->featured = CStatistics::featured($user->id, JRequest::getInt('section_id'));
		}

		if($params->get('tmpl_core.menu_user_unpublished') && ! $user_id)
		{
			$out->unpublished = CStatistics::unpublished($user->id, JRequest::getInt('section_id'));
		}

		if($params->get('tmpl_core.menu_user_my'))
		{
			$out->created = CStatistics::created($user->id, JRequest::getInt('section_id'));
		}

		if($params->get('tmpl_core.menu_user_followed'))
		{
			$out->followed = CStatistics::followed($user->id, JRequest::getInt('section_id'));
		}

		if($params->get('tmpl_core.menu_user_favorite'))
		{
			$out->favorited = CStatistics::favorited($user->id, JRequest::getInt('section_id'));
		}

		if($params->get('tmpl_core.menu_user_rated'))
		{
			$out->rated = CStatistics::rated($user->id, JRequest::getInt('section_id'));
		}
		if($params->get('tmpl_core.menu_user_commented'))
		{
			$out->commented = CStatistics::commented($user->id, JRequest::getInt('section_id'));
		}

		if($params->get('tmpl_core.menu_user_visited'))
		{
			$out->visited = CStatistics::visited($user->id, JRequest::getInt('section_id'));
		}
		if($params->get('tmpl_core.menu_user_cat_manage') && ! $user_id)
		{
			$out->categories = CStatistics::categories($user->id, JRequest::getInt('section_id'));
		}

		return $out;

	}

	private function _getTemplatesNames($list)
	{
		if(count($list) <= 1)
		{
			return FALSE;
		}

		foreach($list as $template)
		{

			$path = JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'views' . DS . 'records' . DS . 'tmpl' . DS . 'default_list_' . $template . '.xml';
			if(!JFile::exists($path))
			{
				JError::raiseNotice(404, 'Template XML file not found: '.$path);
				return;
			}
			$xml = simplexml_load_file($path);
			$out[$template] = $xml->name;
		}

		return $out;
	}
}
?>