<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();
require_once JPATH_ROOT.DS.'components/com_cobalt/library/php/fields/cobaltfield.php';


class JFormFieldCStatus extends CFormField
{

	public function getInput()
	{
		$doc = JFactory::getDocument();
		$params = $this->params;

		$this->user = JFactory::getUser();
		$this->default = !$this->value ? $params->get('params.default', 1) : $this->value;
		
		$statuses = $color = array();
		$statuses[1] = $params->get('params.status1');
		$statuses[2] = $params->get('params.status2');
		$statuses[3] = $params->get('params.status3');
		$statuses[4] = $params->get('params.status4');
		$statuses[5] = $params->get('params.status5');
		$statuses[6] = $params->get('params.status6');
		foreach($statuses as $key => $status)
		{
			$val = explode('^', $status);
			$statuses[$key] = JText::_($val[0]);
			$color[$key] = isset($val[1]) ? $val[1] : false;
		}
		if ($params->get('params.sort') == 2)
			asort($statuses);
		if ($params->get('params.sort') == 3)
			rsort($statuses);
			
		$this->statuses = $statuses;
		
		return $this->_display_input();
	
	}

	public function onJSValidate()
	{
		$js = '';
		if ($this->required)
		{
			$js .= "\n\t\tif($('field_{$this->id}').value == ''){hfid.push({$this->id}); isValid = false; errorText.push('" . addslashes(JText::sprintf('CFIELDREQUIRED', $this->label) ). "');}";
		}
		
		return $js;
	}

	public function validate($value, $record, $type, $section)
	{
		return parent::validate($value, $record, $type, $section);
	}

	public function onPrepareSave($value, $record, $type, $section)
	{
		$value = !$value ? $this->params->get('params.default', 1) : $value;
		return $value;
	}

	public function onStoreValues($record)
	{
		$value = !$this->value ? $this->params->get('params.default', 1) : $this->value;
		return $value;
	}

	public function onFilterWornLabel($section)
	{
		$value = $this->value;
		$label = array();
		settype($value, 'array');
		foreach($value as $val)
		{
			$c = explode('^', $this->params->get('params.status'.$val));
			ArrayHelper::clean_r($c);
			$label[] = (isset($c[1]) ? "<SPAN style=\"color:{$c[1]}\">".JText::_($c[0])."</SPAN>" : JText::_($c[0]));
		}
		$value = implode(', ', $label);
		return $value;
		
		
	}

	public function onFilterWhere($section, &$query)
	{
		$value = $this->value;
		ArrayHelper::trim_r($value);
		ArrayHelper::clean_r($value);
		
		if (!$value)
			return NULL;
		
		foreach($value as $text)
		{
			$sql[] = "field_value = '$text'";
		}
		
		$ids = $this->getIds("SELECT record_id FROM #__js_res_record_values WHERE (" . implode(' OR ', $sql) . ") AND section_id = {$section->id} AND field_key = '{$this->key}'");
		$query->where("r.id IN(".implode(',', $ids).")");
		return true;
	}

	public function onRenderFilter($section, $module = false)
	{
		$db = JFactory::getDbo();
		$params = $this->params;
		$query = $db->getQuery(TRUE);
		
		$query->select('field_value');
		$query->from('#__js_res_record_values');
		$query->where("section_id = {$section->id}");
		$query->where("`field_key` = '{$this->key}'");
		$query->group('field_value');
		
		if ($this->params->get('params.filter_show_number', 1))
		{
			$query->select('count(record_id) as num');
		}
		$db->setQuery($query);

		$this->values = $values = $db->loadObjectList();
		if (!$this->values)	return;			
		
		return $this->_display_filter($section, $module);
	}

	public function onPrepareFullTextSearch($value, $record, $type, $section)
	{
		$value = !$this->value ? $this->params->get('params.default', 1) : $this->value;
		return JText::_($this->params->get('params.status' . $value));
	
	}

	public function onRenderFull($record, $type, $section)
	{
		$user = JFactory::getUser();
		$params = $this->params;
		if ($params->get('params.moderator', 3) && in_array($params->get('params.moderator', 3), $user->getAuthorisedViewLevels()))
		{
			if ($this->value == $params->get('params.default', 1))
			{
				if($params->get('params.change_default', 2))
				{
					$post = array('from' => $this->value, 'to' => $params->get('params.change_default', 2), 'record_id' => $record->id, 'section_id' => $section->id, 'ajax' => false);
					if ($this->_changeStatus($post) == true)
					{
						$this->value = $params->get('params.change_default', 2);
					}
				}
			}
		}
		$out = $this->_getStatusView('full', $record, $type, $section);
		
		return $out;
	}

	public function onRenderList($record, $type, $section)
	{
		return $this->_getStatusView('intro', $record, $type, $section);
	}

	private function _getStatusView($client, $record, $type, $section)
	{
		if(!$this->value) 
			return ;
		$document = JFactory::getDocument();
		$document->addScript(JURI::root() . 'components/com_cobalt/fields/status/status.js');
		$document->addStyleSheet(JURI::root() . 'components/com_cobalt/fields/status/status.css');
		$this->user = JFactory::getUser();
		$params = $this->params;
		$out = array();
		
		$val = explode('^', $params->get('params.status' . $this->value));
		$value = $value_color = JText::_($val[0]);
		if(isset($val[1]))
		{
			$value_color = '<span style="color: '.$val[1].'">'.$value.'</span>';
		}
		$path = JURI::root() . 'components/com_cobalt/fields/status/icons/';
		
		$type_default = $client == 'full' ? 3 : 1;
		
		switch ($params->get('params.' . $client, $type_default))
		{
			case 1 :
				$out[] = JHtml::image($path . $params->get('params.icon' . $this->value), $value, array('class' => 'hasTip', 'title' => $value, 'align' => 'absmiddle'));
				break;
			case 2 :
				$out[] = $value_color;
				break;
			case 3 :
				$out[] = JHtml::image($path . $params->get('params.icon' . $this->value), $value, array('class' => 'hasTip', 'title' => $value, 'align' => 'absmiddle')) . ' ';
				$out[] = $value_color;
				break;
		}
		$this->out = implode($out);
	
		$statuses = $color = array();
		$statuses[1] = $params->get('params.status1');
		$statuses[2] = $params->get('params.status2');
		$statuses[3] = $params->get('params.status3');
		$statuses[4] = $params->get('params.status4');
		$statuses[5] = $params->get('params.status5');
		$statuses[6] = $params->get('params.status6');
		foreach($statuses as $key => $status)
		{
			$val = explode('^', $status);
			$statuses[$key] = JText::_($val[0]);
			$color[$key] = isset($val[1]) ? $val[1] : false;
		}
		
		if ($params->get('params.sort') == 2)
			asort($statuses);
		if ($params->get('params.sort') == 3)
			rsort($statuses);
			
		$this->statuses = $statuses;
		$this->color = $color;
		$this->clienttype = $client;
		$this->type_default = $type_default;
		
		return $this->_display_output(($client == 'intro' ? 'list': 'full'), $record, $type, $section);
	}

	public function _changeStatus($post)
	{
		$to = $post['to'];
		$record_id = $post['record_id'];
		$section_id = $post['section_id'];
		$user = JFactory::getUser();
		$params = $this->params;

		$table_rec = JTable::getInstance('Record', 'CobaltTable');
		$table_rec->load($record_id);
		$rfields = json_decode($table_rec->fields, true);
		$rfields[$this->id] = $to;
		$table_rec->fields = json_encode($rfields);

		if($params->get('core.searchable', 0))
		{
			$table_rec->fieldsdata = str_replace(JText::_($this->params->get('params.status' . $this->value)), JText::_($this->params->get('params.status' . $to)), $table_rec->fieldsdata);
		}
		if($params->get('params.block_comment') == $to)
		{
			$rec_params = new JRegistry($table_rec->params);
			$rec_params->set('comments.comments_access_post', 0);

			$table_rec->params = $rec_params->toString();
		}
		$table_rec->store();

		$table = JTable::getInstance('Record_values', 'CobaltTable');
		$table->load(array('field_id' => $this->id, 'record_id' => $record_id, 'section_id' => $section_id));
		$table->field_value = $to;

		if(!$table->store())
		{
			$this->setError(JText::_('ST_STATUSWASCHANGED'));
			return;
		}

		if($params->get('params.sql_action_s'.$to, false) && $params->get('params.sql_source_s'.$to))
		{
			$db = JFactory::getDbo();
			$queries = explode(";", $params->get('params.sql_source_s'.$to));
			foreach($queries AS $sql)
			{
				$sql = str_replace(array('[ID]', '[RECORD_ID]', '[USER_ID]', '[AUTHOR_ID]'), array($table->id, $record_id, $user->get('id', 0), $table_rec->user_id), $sql);
				$db->setQuery($sql);
				$db->execute();
			}
		}

		if($params->get('params.notified') && $params->get('params.notify') != '' && in_array($to, $params->get('params.notify')))
		{
			$table_rec->status = $to;
			CEventsHelper::notify('record', CEventsHelper::_FIELDS_STATUS_CHANGED, $record_id,	$section_id, JRequest::getInt('cat_id'), 0, $this->id, $table_rec, $params->get('params.notified'), $table_rec->user_id);
		}

		if($post['ajax'])
		{
			$type = $post['view_type'];
			$out = array();
			$value = explode('^', $params->get('params.status' . $to));
			$status = (isset($value[1])) ? '<span style="color: '.$value[1].'">'.$value[0].'</span>' : $value[0];
			$value = $value[0];
			$path = JURI::root().'components/com_cobalt/fields/status/icons/';
			$type_default = $type == 'full' ? 3 : 1;
			switch ($params->get('params.' . $type, $type_default))
			{
				case 1 :
					$out[] = JHtml::image($path . $params->get('params.icon' . $to), $value, array('class' => 'hasTip', 'title' => $value, 'align' => 'absmiddle'));
					break;
				case 2 :
					$out[] = $status;
					break;
				case 3 :
					$out[] = JHtml::image($path . $params->get('params.icon' . $to), $value, array('class' => 'hasTip', 'title' => $value, 'align' => 'absmiddle')) . ' ';
					$out[] = $status;
					break;
			}
			return implode('', $out);
		}
		return true;
	}
	
	public function onComment($record, $section)
	{
		$user = JFactory::getUser();
		$params = $this->params;
		if ($params->get('params.moderator', 3) && in_array($params->get('params.moderator', 3), $user->getAuthorisedViewLevels()))
		{
			if($params->get('params.add_comment', 2))
			{
				$post = array('from' => $this->value, 'to' => $params->get('params.add_comment', 2), 'record_id' => $record->id, 'section_id' => $section->id, 'ajax' => false);
				$this->_changeStatus($post);
			}			
		}
	}

	public function onNotification($text, $event)
	{
		$value = explode('^', $this->params->get('params.status' . $event->params->get('status')));
		$status = (isset($value[1])) ? '<span style="color: '.$value[1].'">'.$value[0].'</span>' : $value[0];
		$text = str_replace('[STATUS]', '<b>"'.$status.'"</b>', $text);

		return $text;
	}
}
