<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die();
require_once JPATH_ROOT.DS.'components/com_cobalt/library/php/fields/cobaltfield.php';


class JFormFieldCTelephone extends CFormField
{
	public function getInput()
	{
		$document = JFactory::getDocument();
		$document->addScript(JURI::root() . 'media/mint/js/autocomplete/mootools-autocompleter-1.2.js');
		$document->addStyleSheet(JURI::root() . 'media/mint/js/autocomplete/autocompleter.css');
		$document->addStyleSheet(JURI::root() . 'components/com_cobalt/fields/telephone/telephone.css');
		$document->addScript(JURI::root() . 'components/com_cobalt/fields/telephone/telephone.js');
		
		
		$value = $this->value ? $this->value : null;
		$this->flag = $this->_getFlag($value);
		
		return $this->_display_input();	
	}
	
	public function onJSValidate()
	{
		$js = "\n\t\t".
		'var c = $("field_'.$this->id.'_cnt").value;
		var r = $("field_'.$this->id.'_reg").value;
		var t = $("field_'.$this->id.'_tel").value;';
		
		if ($this->required)
		{
			$js .= "\n\t\tif(c == '' || r == '' || t == ''){ hfid.push({$this->id}); isValid = false; errorText.push('" . addslashes(JText::sprintf('CFIELDREQUIRED', $this->label)) . "');}";
		}
		
		$js .= "\n\t\t
		if( ((c!='' || r!='') && t=='') || (t!='' && (c=='' || r=='')) ) {hfid.push({$this->id}); isValid = false; errorText.push('" . addslashes(JText::sprintf('CFIELDINCORRECT', $this->label)) . "');}";
		return $js;
	}

	public function validate($value, $record, $type, $section)
	{
		if($this->required && ($value['country'] == '' && $value['region'] == '' && $value['tel'] == ''))
		{
				$this->setError(JText::sprintf('CFIELDREQUIRED', $this->label));
				return FALSE;
		}
		if ( (($value['country'] == '' || $value['region'] == '') && $value['tel'] != '') || ( ($value['country'] != '' || $value['region'] != '') && $value['tel'] == '' ) ) 
		{
			$this->setError(JText::sprintf('CFIELDINCORRECT', $this->label));
			return FALSE;
		}
		return parent::validate($value, $record, $type, $section);
	}

	public function onPrepareSave($value, $record, $type, $section)
	{
		if($value['country'] == "") return; 
		//if($value['ext'] != '') $value['ext'] = '#' . $value['ext'];
		return $value;
	}

	public function onStoreValues($record)
	{
		if(!$this->value) return;
		$v = $this->value;
		if($v['country'] == '' ) return ;
		if ($v['ext'] != '')
		{
			$v['ext'] = '#' . $v['ext'];
		}
		return implode('.', $this->value);
	}

	public function onFilterWornLabel($section)
	{
		$val = explode('.', $this->value);
		if(isset($val[3]) && $val[3] != '')
			$val[3] = "#{$val[3]}";
		$val = JText::sprintf('+%d (%d) %d %s', $val[0], $val[1], $val[2], $val[3]);
		return $val;
	}

	public function onFilterWhere($section, &$query)
	{
		$ids = $this->getIds("SELECT record_id FROM #__js_res_record_values WHERE field_value = '{$this->value}' AND section_id = {$section->id} AND field_key = '{$this->key}'");
		$query->where("r.id IN (".implode(',', $ids).")");
		return true;
	}

	public function onRenderFilter($section, $module = false)
	{
		$document = JFactory::getDocument();
		$document->addScript(JURI::root() . 'media/mint/js/autocomplete/mootools-autocompleter-1.2.js');
		$document->addStyleSheet(JURI::root() . 'media/mint/js/autocomplete/autocompleter.css');
		$document->addStyleSheet(JURI::root() . 'components/com_cobalt/fields/telephone/telephone.css');
		$document->addScript(JURI::root() . 'components/com_cobalt/fields/telephone/telephone.js');
		
		$val = '';
		if ($this->value)
		{
			$val = explode('.', $this->value);
			if(isset($val[3]) && $val[3] != '')
				$val[3] = "#{$val[3]}";
			$val = JText::sprintf('+%d (%d) %d %s', $val[0], $val[1], $val[2], $val[3]);
		}
		$this->formated_value = $val;
		
		return $this->_display_filter($section, $module);
	}

	public function onPrepareFullTextSearch($value, $record, $type, $section)
	{
		$v = $value;
		if($v['country'] == '' ) return ;
		if ($v['ext'] != '')
		{
			$v['ext'] = '#' . $v['ext'];
		}
		return implode('.', $v);
	}

	public function onRenderFull($record, $type, $section)
	{
		return $this->_render('full', $record, $type, $section);
	}

	public function onRenderList($record, $type, $section)
	{
		return $this->_render('list', $record, $type, $section);
	}
	
	private function _render($client, $record, $type, $section )
	{
		if(!$this->value) return ;
		JFactory::getDocument()->addStyleSheet(JURI::root() . 'components/com_cobalt/fields/telephone/telephone.css');
		
		$value = $this->value;
		$f_value = '';
		if (is_array($value))
		{
			$f_value = implode('.', $value);
			if ($value['ext'] != '')
			{
				$value['ext'] = '#' . $value['ext'];
			}
			$this->qrvalue = urlencode(JText::sprintf('+%d%d%d%s', $value['country'], $value['region'], $value['tel'], $value['ext']));
			$value = JText::sprintf('+%d (%d) %d %s', $value['country'], $value['region'], $value['tel'], $value['ext']);
		}
		if ($this->params->get('params.filter_enable'))
		{
			$tip = ($this->params->get('params.filter_tip') ? JText::sprintf($this->params->get('params.filter_tip'), '<b>' . $this->label . '</b>', '<b>' . $value . '</b>') : NULL);
			
			switch ($this->params->get('params.filter_linkage'))
			{
				case 1 :
					$value = FilterHelper::filterLink('filter_' . $this->key, $f_value, $value, $this->type_id, $tip, $section);
					break;
				
				case 2 :
					$value = $value . ' ' . FilterHelper::filterButton('filter_' . $this->key, $f_value, $this->type_id, $tip, $section, $this->params->get('params.filter_icon', 'funnel-small.png'));
					break;
			}
		}
		
		$this->value = $value;
		
		return $this->_display_output($client, $record, $type, $section);
	} 

	private function _getFlag($value)
	{
		if (!$value)
			return;
		$db = JFactory::getDbo();
		$code1 = $value['country'] . '-' . $value['region'];
		$code2 = $value['country'];
		$sql = "SELECT * FROM #__js_res_countries where phone_code = '$code1'";
		$db->setQuery($sql);
		if (!$res = $db->loadObject())
		{
			$sql = "SELECT * FROM #__js_res_countries where phone_code = '$code2'";
			$db->setQuery($sql);
			$res = $db->loadObject();
		}
		return $res;
	}

	public function onGetCountriesCode($post)
	{
		$word = JRequest::getWord('term');
		$code = JRequest::getInt('term');
		if ($code)
			$where = "phone_code like '$code%'";
		if ($word)
			$where = "name like '$word%'";
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select("*");
		$query->from('#__js_res_countries');
		$query->where($where);
		$db->setQuery($query);
		$result = $db->loadObjectList();
		$data = array();
		foreach($result as $k => $val)
		{
			$data[$k]->label = $val->phone_code;
			$data[$k]->value = $val->phone_code;
			$data[$k]->html = '<img src="' . JURI::root() . 'media/mint/icons/flag/16/' . JString::strtolower($val->code2) . '.png" border="0" align="absmiddle" alt="' . JText::_($val->name) . '">
			<span>' . JText::_($val->name) . ' (+' . $val->phone_code . ')</span>';
			$data[$k]->data = '<img src="' . JURI::root() . 'media/mint/icons/flag/16/' . JString::strtolower($val->code2) . '.png" border="0" align="absmiddle" alt="' . JText::_($val->name) . '" title="' . JText::_($val->name) . '">';
		}
		return $data;
	}

	public function onFilterData($post, $record)
	{
		$field = JRequest::getVar('field');
		$phone = JRequest::getVar('term');
		$section = JRequest::getInt('section');
		$where = "REPLACE(field_value, '.', '' ) like '%$phone%' AND type_id = '{$this->type_id}' AND section_id = '$section' AND field_type = '$field'";
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select("*, COUNT(record_id) as num");
		$query->from('#__js_res_record_values');
		$query->where($where);
		$db->setQuery($query);
		$result = $db->loadObjectList();
		$data = array();
		foreach($result as $k => $val)
		{
			//$data[$k]->label = $val->field_value;
			$data[$k]->value = $val->field_value;
			$vals = explode('.', $val->field_value);
			ArrayHelper::clean_r($vals);
			$data[$k]->html = $data[$k]->label = JText::sprintf('+%d (%d) %d %s', $vals[0], $vals[1], $vals[2], (isset($vals[3]) ? "#{$vals[3]}" : '')). ($this->params->get('params.filter_show_number') ? " ({$val->num})" : ''); //str_replace('.', ' ', $val->field_value);				
		}
		return $data;
	}
}
	