<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();
require_once JPATH_ROOT.DS.'components/com_cobalt/library/php/fields/cobaltfield.php';


class JFormFieldCtext extends CFormField
{

	public function getInput()
	{

		$mask = $this->params->get('params.mask', 0);
		if ($mask->mask_type && $this->params->get('params.show_mask', 1) && !$this->value)
		{
			$this->value = $mask->mask;
		}

		if ($mask->mask_type)
		{
			JFactory::getDocument()->addScript(JURI::root() . 'media/mint/js/mask/masks.js');
			JFactory::getDocument()->addScript(JURI::root() . 'components/com_cobalt/fields/text/text.js');
			switch ($mask->mask_type)
			{
				case '(###) ### #######' :
				case '(###) ###-####' :
				case '#####-###' :
				case '#### #### #### ####' :
					$type = 'string';
					break;
				case 'mm/dd/yyyy' :
				case 'hh:ii' :
				case 'mm/dd/yyyy hh:ii' :
					$type = "date";
					break;
				case '#' :
				case '#####.##' :
				case '#,###.##' :
				case '$#,###.##' :
				case '€#,###.##' :
					$type = "number";
					break;
				default :
					$type = $mask->type;
			}
			$this->mask_type = $type;
		}
		return $this->_display_input();
	}

	public function onJSValidate()
	{
		$js = "";
		if ($this->required)
		{
			$js .= "\n\t\tif(!$('field_{$this->id}').value){hfid.push({$this->id}); isValid = false; errorText.push('" . addslashes(JText::sprintf("CFIELDREQUIRED", $this->label)) . "');}";
		}
		return $js;
	}

	public function onFilterWornLabel($section)
	{
		$value = $this->value;
		switch($this->params->get('params.template_filter'))
		{
			case 'like_search.php':
				if(!is_array($value))
					$value = array('val' => $value, 'method' => '');
				if($value['val'] == '') return '';
				switch($value['method'])
				{
					case '1': $like = JText::_('TXT_STARTWITH'); break;
					case '2': $like = JText::_('TXT_ENDWITH'); break;
					case '3': $like = JText::_('TXT_CONTAIN'); break;
					default: $like = '';
				}
				$value = $like.' '.$value['val'];
				break;
			case 'select.php':
			case 'checkboxes.php':
				settype($value, 'array');
				$value = implode(', ', $value);
			case 'autocomplete.php':
				$value = explode(';', $value);
				$value = implode(', ', $value);
				break;
		}

		return $value;
	}

	public function onFilterWhere($section, &$query)
	{
		$value = $this->value;
		$db = JFactory::getDbo();
/*
		settype($value, 'array');
		ArrayHelper::trim_r($value);
		ArrayHelper::clean_r($value);
*/
		if (!$value)
			return NULL;
		switch($this->params->get('params.template_filter'))
		{
			case 'like_search.php':
			if(isset($value['method']))
			{
				if(!isset($value['val'])) return ;
				$like = $db->escape($value['val']);
				switch($value['method'])
				{
					case 1: $like = "%$like"; break;
					case 2: $like = "$like%"; break;
					case 3: $like = "%$like%"; break;
				}
				$sql[] = 'field_value LIKE ' . $db->quote($like);
			}
			break;
			case 'select.php':
			case 'checkboxes.php':
				settype($value, 'array');
				foreach($value as $text)
				{
					$sql[] = 'field_value = ' . $db->quote($db->escape($text));
				}
				break;
			case 'autocomplete.php':
				$value = explode(';', $value);
				foreach($value as $text)
				{
					$sql[] = 'field_value = ' . $db->quote($db->escape($text));
				}
				break;
		}



		$sql = "SELECT record_id FROM #__js_res_record_values WHERE (" . implode(' OR ', $sql) . ") AND section_id = {$section->id} AND field_key = '{$this->key}'";
		$ids = $this->getIds($sql);
		$query->where("r.id IN(".implode(',', $ids).")");
		return true;
	}

	public function onRenderFilter($section, $module = false)
	{
		if($this->params->get('params.template_filter') == 'like_search.php' && $this->value && !is_array($this->value))
		{
			$this->value = array('val' => $this->value);
		}

		return $this->_display_filter($section, $module);
	}

	public function getValues($section)
	{
		$db = JFactory::getDbo();

		$query = $db->getQuery(TRUE);

		$query->select('field_value');
		$query->from('#__js_res_record_values');
		$query->where("section_id = {$section->id}");
		$query->where("`field_key` = '{$this->key}'");
		$query->group('field_value');

		if ($this->params->get('params.filter_show_number', 1))
		{
			$query->select('count(record_id) as num');
		}
		$db->setQuery($query);

		$this->values = $db->loadObjectList();
	}
	public function validate($value, $record, $type, $section)
	{
		$mask = $this->params->get('params.mask', 0);
		if ($mask->mask_type && $this->params->get('params.show_mask', 1))
		{
			if($value == $mask->mask)
				$value = false;
		}
		return parent::validate($value, $record, $type, $section);

	}

	public function onPrepareFullTextSearch($value, $record, $type, $section)
	{
		return $this->onPrepareSave($value, $record, $type, $section);
	}

	public function onPrepareSave($value, $record, $type, $section)
	{
		$mask = $this->params->get('params.mask', 0);
		if ($mask->mask_type && $this->params->get('params.show_mask', 1))
		{
			if($value == $mask->mask)
			return;
		}
		$filter = JFilterInput::getInstance();
		return $filter->clean($value);
	}

	public function onRenderFull($record, $type, $section)
	{
		return $this->_render('full', $record, $type, $section);
	}

	public function onRenderList($record, $type, $section)
	{
		return $this->_render('list', $record, $type, $section);
	}

	private function _render($view, $record, $type, $section)
	{
		if (!$this->value)
			return;
		$readmore = null;
		if($view == 'list' && $this->params->get('params.length', 0) > 0)
		{
			$this->value = HTMLFormatHelper::substrHTML($this->value, $this->params->get('params.length'));
			$readmore = JHtml::link($record->url, $this->params->get('params.seemore', '>>>'), array('title'=> JText::_('TEXT_READMORE')));
		}
		$value = $this->value;
		if ($this->params->get('params.filter_enable'))
		{
			$tip = ($this->params->get('params.filter_tip') ? JText::sprintf($this->params->get('params.filter_tip'), '<b>' . $this->label . '</b>', '<b>' . $value . '</b>') : NULL);

			switch ($this->params->get('params.filter_linkage'))
			{
				case 1 :
					$value = FilterHelper::filterLink('filter_' . $this->key, $value, $value, $this->type_id, $tip, $section);
					break;

				case 2 :
					$value = $value . ' ' . FilterHelper::filterButton('filter_' . $this->key, $value, $this->type_id, $tip, $section, $this->params->get('params.filter_icon', 'funnel-small.png'));
					break;
			}
		}

		$this->value = $value;
		$this->readmore = $readmore;

		return $this->_display_output($view, $record, $type, $section);
	}
	public function onFilterGetValues($post)
	{
		$db = JFactory::getDbo();
		$query = $db->getQuery(TRUE);

		$section = ItemsStore::getSection($post['section_id']);

		$query->select('field_value as text');
		$query->from('#__js_res_record_values');
		$query->where("section_id = {$section->id}");
		$query->where("`field_key` = '{$this->key}'");
		$query->group('field_value');

		if ($this->params->get('params.filter_show_number', 1))
		{
			$query->select('count(record_id) as num');
		}
		$db->setQuery($query);

		$list = $db->loadObjectList();
		foreach ($list as $k => $item)
		{
			$c = explode('^', $item->text);
			ArrayHelper::clean_r($c);
			$label = (isset($c[1]) ? "<span style=\"color:{$c[1]}\">".JText::_($c[0])."</SPAN>" : JText::_($c[0]));
			$label = $this->params->get('params.filter_show_number', 1) ? $label .' ('.$item->num.')' : $label;
			$out[]= array($item->text, $label);//, $text, $text);
		}
		return $out;
	}
}
