<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die('Restricted access'); ?>
<?php
$params = $this->tmpl_params['list'];
JFactory::getDocument()->addScript('http://maps.googleapis.com/maps/api/js?key='.$params->get('tmpl_params.map_key').'&sensor=true');
if($params->get('tmpl_params.map_claster'))
{
	JFactory::getDocument()->addScript('http://google-maps-utility-library-v3.googlecode.com/svn/tags/markerclustererplus/2.0.14/src/markerclusterer_packed.js');
}
?>
<script type="text/javascript">
function drawMarker(mPosition, title, body, icon, width, height)
{
	var msize = new google.maps.Size(width, height);
	var mpoint = new google.maps.Point((width / 2), height);
	var markerIcon = new google.maps.MarkerImage(icon, msize, new google.maps.Point(0,0), mpoint);
	var mOptions = {
		'map' : map, 'position' : mPosition, 'title' : title, icon: markerIcon,
		<?php if($params->get('tmpl_params.map_anim', 1)) "'animation' : google.maps.Animation.DROP," ?>
	};

	var marker = new google.maps.Marker(mOptions);

	google.maps.event.addListener(marker, 'click', function() {
		infowindow.setContent(body);
		infowindow.open(map, marker);
	});

	bounds.extend(mPosition);
	markers.push(marker);
}

</script>
<p>
	<a href="javascript:void(0)" onclick="map.fitBounds(bounds);"><?php echo JText::_('Show all markers')?></a>
</p>
<div id="map_canvas" style="margin-top:15px; margin-bottom:15px; width: <?php echo $params->get('tmpl_params.map_width', '100%') ?>; height: <?php echo $params->get('tmpl_params.map_height', '500px') ?>"></div>
<div id="message"></div>
<script type="text/javascript">
infowindow = new google.maps.InfoWindow();
bounds = new google.maps.LatLngBounds();
markers = [];



var myLatlng = new google.maps.LatLng(<?php echo $params->get('tmpl_params.map_init_lat', '42.293564192170095') ?>, <?php echo $params->get('tmpl_params.map_init_lng', '-33.33983659744263') ?>);
var myOptions = {
    zoom: <?php echo $params->get('tmpl_params.map_init_zoom', 10) ?>,
    center: myLatlng,
    mapTypeId: google.maps.MapTypeId.<?php echo $params->get('tmpl_params.map_view', 'ROADMAP')?>,
    mapTypeControl: <?php echo ($params->get('tmpl_params.map_type') ? '1' : '0')?>,
    mapTypeControlOptions: {
        style: google.maps.MapTypeControlStyle.HORIZONTAL_BAR
    },
    overviewMapControl:<?php echo ($params->get('tmpl_params.map_overview', 1) ? '1' : '0')?>,
    draggable: <?php echo ($params->get('tmpl_params.map_drag', 1) ? '1' : '0')?>,
	panControl: <?php echo ($params->get('tmpl_params.map_pan', 1) ? '1' : '0')?>,
	zoomControl : <?php echo ($params->get('tmpl_params.map_zoom', 1) ? '1' : '0')?>,
	scaleControl : <?php echo ($params->get('tmpl_params.map_scale', 1) ? '1' : '0')?>,
	rotateControl :<?php echo ($params->get('tmpl_params.map_rotate', 1) ? '1' : '0')?>,
	streetViewControl :<?php echo ($params->get('tmpl_params.map_street', 1) ? '1' : '0')?>,
	scrollwheel :<?php echo ($params->get('tmpl_params.map_scroll', 1) ? '1' : '0')?>

}
map = new google.maps.Map($("map_canvas"), myOptions);

<?php if($params->get('tmpl_params.map_style')):?>
var mapStyle = <?php include JPATH_ROOT.DS.'components/com_cobalt/library/js/mapstyles/'.$params->get('tmpl_params.map_style'); ?>;
map.setOptions({styles: mapStyle});
<?php endif;?>

<?php foreach ($this->items AS $item):?>

	<?php
	$body = $b = $ll = array();
	$body[] = '<div class="map-popup">';
	if(!$this->submission_types[$item->type_id]->params->get('properties.item_title'))
	{
		$item->title = null;
	}
	if($params->get('tmpl_core.item_link'))
	{
		$body[] = "<h3><a href=\"".JRoute::_($item->url)."\">{$item->title}</a> ".CEventsHelper::showNum('record', $item->id)."</h3>";
	}
	else
	{
		$body[] = "<h3>{$item->title} ".CEventsHelper::showNum('record', $item->id)."</h3>";
	}
	$category = array();
	$author = array();
	$details = array();

	if($params->get('tmpl_core.item_categories') && $item->categories_links)
	{
		$category[] = sprintf('%s: %s', (count($item->categories_links) > 1 ? JText::_('CCATEGORIES') : JText::_('CCATEGORY')), implode(', ', $item->categories_links));
	}
	if($params->get('tmpl_core.item_user_categories') && $item->ucatid)
	{
		$category[] = sprintf('%s: %s', JText::_('CUSERCAT'), $item->ucatname_link);
	}
	if($params->get('tmpl_core.item_author') && $item->user_id)
	{
		$author[] = JText::sprintf('CWRITTENBY', CCommunityHelper::getName($item->user_id, $this->section));
	}
	if($params->get('tmpl_core.item_author_filter'))
	{
		$author[] = FilterHelper::filterButton('filter_user', $item->user_id, NULL, JText::sprintf('CSHOWALLUSERREC', CCommunityHelper::getName($item->user_id, $this->section, TRUE)), $this->section);
	}
	if($params->get('tmpl_core.item_ctime'))
	{
		$author[] = JText::sprintf('CONDATE', $item->ctime->toFormat($params->get('tmpl_core.item_time_format')));
	}

	if($params->get('tmpl_core.item_mtime'))
	{
		$author[] = sprintf('%s: %s', JText::_('CCHANGEON'), $item->mtime->toFormat($params->get('tmpl_core.item_time_format')));
	}

	if($params->get('tmpl_core.item_extime'))
	{
		$author[] = sprintf('%s: %s', JText::_('CEXPIREON'), $item->extime ? $item->ctime->toFormat($params->get('tmpl_core.item_time_format')) : JText::_('CNEVER'));
	}

	if($params->get('tmpl_core.item_type'))
	{
		$details[] = sprintf('%s: %s %s', JText::_('CTYPE'), $item->type_name, ($params->get('tmpl_core.item_type_filter') ? FilterHelper::filterButton('filter_type', $item->type_id, NULL, JText::sprintf('CSHOWALLTYPEREC', $item->type_name), $this->section) : NULL));
	}
	if($params->get('tmpl_core.item_hits'))
	{
		$details[] = sprintf('%s: %s', JText::_('CHITS'), $item->hits);
	}
	if($params->get('tmpl_core.item_comments_num'))
	{
		$details[] = sprintf('%s: %s', JText::_('CCOMMENTS'), $item->comments);
	}
	if($params->get('tmpl_core.item_favorite_num'))
	{
		$details[] = sprintf('%s: %s', JText::_('CFAVORITED'), $item->favorite_num);
	}
	if($params->get('tmpl_core.item_follow_num'))
	{
		$details[] = sprintf('%s: %s', JText::_('CFOLLOWERS'), $item->subscriptions_num);
	}

	if($params->get('tmpl_core.item_author_avatar'))
	{
		$body[] = '<img style="float:left; margin-right:8px;" class="pop-avatar" src="'.CCommunityHelper::getAvatar($item->user_id, $params->get('tmpl_core.item_author_avatar_width', 40), $params->get('tmpl_core.item_author_avatar_height', 40)).'" />';
	}
	if($category)
	{
		$b[] = '<span class="pop-line">'.implode(' | ', $category).'</span>';
	}
	if($author)
	{
		$b[] = '<span class="pop-line">'.implode(', ', $author).'</span>';
	}
	if($details)
	{
		$b[] = '<span class="pop-line">'.implode(', ', $details).'</span>';
	}
	if($b)
	{
		$body[] = implode('<br />', $b);
	}
	$body[] = '<div style="clear:both"></div>';


	foreach($item->fields_by_id AS $field)
	{
		if(in_array($field->key, $params->get('tmpl_params.exclude', array()))) continue;
		if( $field->type == 'geo' || $field->type == 'child' || $field->type == 'parent' ||
		    $field->type == 'records' || $field->type == 'email' || $field->type == 'readmore' ||
		    $field->type == 'geo' || $field->type == 'geo' || $field->type == 'geo')
		{
		    continue;
		}
		$style = ($field->params->get('core.icon') ? ' style="list-style-image: url(\''.JURI::root().'media/mint/icons/16/'.$field->params->get('core.icon').'\')"' : NULL);
		$result = preg_replace('/<script(.*)<\/script>/isU', ' ', @$field->result);
		$ll[] = '<li'.$style.'>'.$result.'</li>';
	}
	if($ll)
	{
		//var_dump($ll);
		$body[] = '<ul class="fields-list">'.implode("\n", $ll).'</ul>';
	}


	if($params->get('tmpl_core.item_readon'))
	{
		$body[] = "<div><a class=\"a\" href=\"".JRoute::_($item->url)."\">". $params->get('tmpl_core.item_readon_label', JText::_('Read more...'))."</a><div>";
	}
	$body[] = '</div>';

	$body = implode("", $body);
	$body = str_replace(array("\n", "\r"), " ", $body);
	$body = stripslashes($body);
	$body = addslashes($body);
	$body = preg_replace("/>\s+</", "> <", $body);

	foreach ($item->fields_by_id AS $field):
		if($field->type == 'geo'):
			if(empty($field->value['position']['lat']) || empty($field->value['position']['lng'])) continue;
			list($icon_w, $icon_h, $icon) = $field->getMarker();
			?>
			drawMarker(new google.maps.LatLng(<?php echo $field->value['position']['lat'] ?>, <?php echo $field->value['position']['lng'] ?>), '<?php echo htmlentities($item->title, ENT_COMPAT, 'UTF-8')?>', '<?php echo $body;?>', '<?php echo $icon;?>', <?php echo $icon_w?>, <?php echo $icon_h?>);
			<?php
		endif;
	endforeach;
endforeach;?>

<?php if($params->get('tmpl_params.map_claster')):?>
	var markerCluster = new MarkerClusterer(map, markers);
<?php endif;?>
map.fitBounds(bounds);
</script>
<?php if ($params->get('tmpl_params.template')):?>
	<?php
	$dir = JPATH_ROOT . DS . 'components' . DS . 'com_cobalt' . DS . 'views' . DS . 'records' . DS . 'tmpl' . DS;
	$name = $params->get('tmpl_params.template');
	$file = "{$dir}default_list_{$name}.css";
	$doc = JFactory::getDocument();

	if(JFile::exists($file))
	{
		$doc->addStyleSheet(JURI::root() . 'components/com_cobalt/views/records/tmpl/default_list_' . $name . '.css');
	}
	$file = "{$dir}default_list_{$name}.js";
	if(JFile::exists($file))
	{
		$doc->addScript(JURI::root() . 'components/com_cobalt/views/records/tmpl/default_list_' . $name . '.js');
	}

	$this->tmpl_params['list'] = new JRegistry(JFile::read($dir."default_list_{$name}.json"));
	?>
	<?php echo $this->loadTemplate('list_'.$params->get('tmpl_params.template'));?>
<?php endif;?>
