<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();
jimport('mint.recaptchalib');
jimport('joomla.mail.helper');
require_once JPATH_ROOT . DS . 'components/com_cobalt/library/php/fields/cobaltfield.php';

class JFormFieldCUrl extends CFormField
{

	public function getInput()
	{
		$document = JFactory::getDocument();
		$document->addStyleSheet(JURI::root() . 'components/com_cobalt/fields/url/url.css');
		$user = JFactory::getUser();
		$params = $this->params;
		
		$labels = explode("\n", $params->get('params.default_labels', ''));
		
		ArrayHelper::clean_r($labels);
		ArrayHelper::trim_r($labels);
		
		$this->labels = $labels;

		return $this->_display_input();
	}

	public function onJSValidate()
	{
		$js = "\n\t\t" . 'var field = $$("[name^=\"jform[fields][' . $this->id . ']\"]");
		var vals=0;
		Array.each(field, function(item){
			if(item.value != "")
			vals++;
		});
		';
		if ($this->required)
		{
			$js .= "\n\t\tif(!vals){hfid.push({$this->id}); isValid = false; errorText.push('" . addslashes(JText::sprintf('CFIELDREQUIRED', $this->label)) . "');}";
		}
		return $js;
	
	}

	public function validate($value, $record, $type, $section)
	{
		if ($this->required)
		{
			if ($value)
			{
				$vals = 0;
				foreach($value as $i => $val)
				{
					if ($val['url'] != '')
						$vals ++;
				}
				if (!$vals)
				{
					$this->setError(JText::sprintf('CFIELDNOTENTERED', $this->label));
					return FALSE;
				}
			}
		}
		return parent::validate($value, $record, $type, $section);
	}

	public function onPrepareSave($value, $record, $type, $section)
	{
		
		foreach($value as $i => $val)
		{
			if ($val['url'] == '')
			{
				unset($value[$i]);
				continue;
			}
			$value[$i]['url'] = str_replace('http://', '', $val['url']);
			if($this->params->get('params.link_redirect', 0) && !isset($val['hits']))
				$value[$i]['hits'] = 0;
		}
		if (!count($value))
			return array();
		
		foreach($value as $i => $val)
		{
			$array[] = $val;
		}
		return $array;
	}

	public function onFilterWornLabel($section)
	{
		return $this->value;
	}

	public function onFilterWhere($section, &$query)
	{
		$ids = $this->getIds("SELECT record_id FROM #__js_res_record_values WHERE field_value like '%{$this->value}%' AND section_id = {$section->id} AND field_key = '{$this->key}'");
		$query->where("r.id IN(".implode(',', $ids).")");
		return true;
	}

	public function onRenderFilter($section, $module = false)
	{		
		return $this->_display_filter($section, $module);		
	}

	public function onPrepareFullTextSearch($value, $record, $type, $section)
	{
		return $value;
	}

	public function onRenderFull($record, $type, $section)
	{
		return $this->_render('full', $record, $type, $section);
	}

	public function onRenderList($record, $type, $section)
	{
		return $this->_render('list', $record, $type, $section);
	}

	private function _render($client, $record, $type, $section)
	{
		if (!count($this->value))
			return;
		return $this->_display_output($client, $record, $type, $section);
	}

	public function _gettitle($post)
	{
		$url = str_replace('http://', '', $post['url']);
		$file = fopen("http://$url", "r");
		if (!$file)
		{
			return ' ';
		}
		$content = '';
		$title = JText::_('Title Undefined');
		while ( !feof($file) )
		{
			$content .= fgets($file, 1024);
			if(strpos($content, '</title>'))
			{
				preg_match("%.*<title.*>(.*)</title>.*%iU", $content, $out);
				$title = $out[1];
				break;
			}
		}
		fclose($file);
		
		return $title;
	}
	
	public function _redirect($post, $record, $field, $get)
	{
		$rfields = json_decode($record->fields, true);
		
		if(!isset($rfields[$this->id]))
			return;
		$record_table = JTable::getInstance('Record', 'CobaltTable');
		$record_table->load($record->id);
		
		foreach ($rfields[$this->id] as $k => $value)
		{
			if(!isset($value['hits']))
				$rfields[$this->id][$k]['hits'] = 0;
			if($value['url'] == $get['url'])
				$rfields[$this->id][$k]['hits'] ++;
		}
		$record_table->fields = json_encode($rfields);
		$record_table->store();
		JFactory::getApplication()->redirect('http://'.$get['url']);
		
	}

}
	
