<?php
defined('_JEXEC') or die();
require_once JPATH_ROOT . DS . 'components/com_cobalt/library/php/fields/cobaltupload.php';

class JFormFieldCVideo extends CFormFieldUpload
{
	public function __construct($field, $default)
	{
		parent::__construct($field, $default);
		JFactory::getDocument()->addScript(JURI::root() . 'media/mint/jwplayer/jwplayer.js');
		JFactory::getDocument()->addScript(JURI::root() . 'media/mint/js/modernizr.js');
		require_once dirname(__FILE__).DS.'helper.php';
	}
	
	public function getInput()
	{
 		$this->link = @$this->value['link'];
 		$this->embed = @$this->value['embed'];
 		$this->value = @$this->value['files'];
 		
 		if(!$this->link)
 		{
 			$this->link = array('');
 		}
 		if(!$this->embed)
 		{
 			$this->embed = array('');
 		}
		
		$this->only_one = $this->params->get('params.only_one', 0);
		
		if(in_array($this->params->get('params.upload', 1), $this->user->getAuthorisedViewLevels()))
		{
			$params['max_size'] = ($this->params->get('params.max_size', 2000) * 1024);
			$params['method'] = $this->params->get('params.method', 'auto');
			$params['max_count'] = $this->only_one ? 1 : $this->params->get('params.max_count', 0);
			$params['file_formats'] = $this->params->get('params.file_formats', 'avi, mp4, mpeg, flv, ogv');
			$params['allow_edit_title'] = $this->params->get('params.allow_edit_title', 1);
			$params['allow_add_descr'] = $this->params->get('params.allow_add_descr', 1);
			
			$this->options = $params;
			$this->fieldname = '[files]';
			
			$this->upload = parent::getInput();
		}
		
		return $this->_display_input();
	}	


	public function onCopy($value, $record, $type, $section)
	{
		if(!empty($value))
		{
			foreach($value['files'] as $key => $file)
			{
				$value['files'][$key] = $this->copyFile($file);
			}
		}
		return $value;
	}
	
	public function onRenderFull($record, $type, $section)
	{
		return $this->onRenderList($record, $type, $section, 'full');
	}
	
	public function onRenderList($record, $type, $section, $client = 'list')
	{
		ArrayHelper::clean_r($this->value);
		if(!$this->value)
		{
			return;
		}
		
		return $this->_display_output($client, $record, $type, $section);
	}

	public function loadVideo()
	{
		$title = $this->params->get('params.allow_edit_title', 0);
		$record = ItemsStore::getRecord(JRequest::getInt('record_id'));
		
		$client = JRequest::getVar('client');
		$width = JRequest::getInt('width');
		
		$this->link = @$this->value['link'];
		$this->embed = @$this->value['embed'];
		$this->value = @$this->value['files'];
		
		//$width -= (4 - ($width % 4));
		$width -= ($width % 4);
		$height = round(($width / 16) * 9);
		
		$this->params->set('width', $width);
		$this->params->set('height', $height);
		
		$out = array();
		
		if($this->value)
		{
			$videos = $this->getFiles($record);
			ob_start();
			?>
			
				jwplayer("mediaplayer<?php echo $this->id;?>-<?php echo $record->id ?>").setup({
					"width": "<?php echo $this->params->get('width');?>",
					"height": "<?php echo  $this->params->get('height')  + 25 + (count($videos) > 1 ? 200 : 0);?>",
					"controlbar": "bottom",
					"skin": "<?php echo  JURI::root();?>media/mint/jwplayer/skins/<?php echo  $this->params->get('params.skin');?>/<?php echo $this->params->get('params.skin');?>.zip",
					"modes": [
				        { type: "html5" },
				        { type: "flash", src: "<?php echo JURI::root();?>media/mint/jwplayer/player.swf" }
				    ],
					
					<?php
					if(count($videos) > 1)
					{
						?>
						"playlist": [<?php
						$v = array();
						$duration = 10;
						foreach ($videos as $video) 
						{
							$v[] = '{ duration: '.$video->duration.', file: "'.$this->getFileUrl($video).'", title:"'.($title && $video->title ? $video->title : $video->realname).'", description:"'.$video->description.'" }';
						}
						echo implode(',', $v);
						?>],
						"playlist.position": "bottom", 
						"playlist.size": 200

						<?php
					}
					else
					{
						$video = array_pop($videos);
						?>
						"file": "<?php echo $this->getFileUrl($video);?>",
						"duration": "<?php echo $video->duration;?>",
						"title": "<?php echo ($title && $video->title ? $video->title : $video->realname);?>",
						"description": "<?php echo $video->description;?>"
					<?php
					}
					?>
				});
				
				
			<?php
			$temp = ob_get_contents();
			ob_end_clean();
			$out['js'] = str_replace(array("\n","\r","\t"), '', $temp);
		}
		
		$blocks = array();
		if($this->embed)
		{
			foreach ($this->embed AS $embed)
				$blocks[] = CVideoAdapterHelper::constrain($embed, $this->params->get('width'));
		}
		if ($this->link)
		{
			foreach ($this->link as $link)
			{
				$block = CVideoAdapterHelper::getVideoCode($this->params, $link);
				if($block)
				{
					$blocks[] = $block;
				}
			}
		}
		
		if($blocks)
		{
			$out['html'] = '<div class="video-block">'.implode('</div><div class="video-block">', $blocks).'</div>';
		}
		
		return $out;
	}
	
	private function constrain($html)
	{
		preg_match("/width=\"([0-9]{1,3})/iU", $html, $match);
		$width = $match[1];
		preg_match("/height=\"([0-9]{1,3})/iU", $html, $match);
		$height = $match[1];
		
		echo $height, $width; 
	}	
	
	public function onPrepareSave($value, $record, $type, $section)
	{
		if(isset($value['files']))
		{
			$value['files'] = $this->_getPrepared($value['files']);
			$params = JComponentHelper::getParams('com_cobalt');
			
			foreach ($value['files'] as $val)
			{
				$val->duration = 0;
				ob_start();
				passthru( $this->params->get('params.command', 'ffmpeg')." -i \"". JPATH_ROOT.DS.$params->get('general_upload').DS.$this->params->get('params.subfolder').DS.$val->fullpath . "\" 2>&1");
				$duration = ob_get_contents();
				ob_end_clean();
				preg_match('/Duration: (.*?),/', $duration, $matches);
				if(isset($matches[1]))
				{
					$duration = $matches[1];
					$duration_array = explode(':', $duration);
					$duration = $duration_array[0] * 3600 + $duration_array[1] * 60 + $duration_array[2];
					$val->duration = $duration;
				}
			}
		}
		if(isset($value['link']))
		{
			ArrayHelper::clean_r($value['link']);
		}
		if(isset($value['embed']))
		{
			foreach ($value['embed'] AS &$embed)
			{
				$embed = CVideoAdapterHelper::getVideoEmbed($embed);
				
			}
			ArrayHelper::clean_r($value['embed']);
		}
	
		return $value;
	}
	
	public function validate($value, $record, $type, $section)
	{
		$total = 0;
		if(isset($value['files']))
		{
			$total += count($value['files']);
		}
		if(isset($value['link']))
		{
			ArrayHelper::clean_r($value['link']);
			$total += count($value['link']);
			
			if($this->params->get('params.link_max_count', 0) && (count($value['link']) > $this->params->get('params.link_max_count', 0)))
			{
				$this->setError(JText::_('CERRORMAXLINKS'));
			}
		}
		if(isset($value['embed']))
		{
			ArrayHelper::clean_r($value['embed']);
			$total += count($value['embed']);
			
			if($this->params->get('params.embed_max_count', 0) && (count($value['embed']) > $this->params->get('params.embed_max_count', 0)))
			{
				$this->setError(JText::_('CERRORMAXEMBEDS'));
			}
		}
		
		if($this->params->get('params.only_one', 0) && $total > 1)
		{
			$this->setError(JText::_('CERRORMORETHANONE'));
		}
	}
	
	public function onStoreValues($record)
	{
		$value = @$this->value['files'];
		settype($value, 'array');
		$out = $saved = array();
		foreach($value as $file)
		{
			$out[] = $file['realname'];
			$saved[] = $file['filename'];
		}
	
		$files = JTable::getInstance('Files', 'CobaltTable');
		$files->markSaved($saved, $record, $this->id);
	
		return $out;
	}
	
}
